/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#include "lapack.h"
#include "HCL_Arch_d.h"

HCL_FPArch_d::HCL_FPArch_d()
{

#ifdef SINGLE_PRECISION
   eps = F77NAME(slamch)("E");
   sfmin = F77NAME(slamch)("S");
   base = (int)F77NAME(slamch)("B");
   prec = F77NAME(slamch)("P");
   t = (int)F77NAME(slamch)("N");
   rnd = (int)F77NAME(slamch)("R");
   emin = (int)F77NAME(slamch)("M");
   rmin = F77NAME(slamch)("U");
   emax = (int)F77NAME(slamch)("L");
   rmax = F77NAME(slamch)("O");

   large = 1/sfmin;
   small = sfmin;
   F77NAME(slabad)(&small, &large);
#else   
   eps = F77NAME(dlamch)("E");
   sfmin = F77NAME(dlamch)("S");
   base = (int)F77NAME(dlamch)("B");
   prec = F77NAME(dlamch)("P");
   t = (int)F77NAME(dlamch)("N");
   rnd = (int)F77NAME(dlamch)("R");
   emin = (int)F77NAME(dlamch)("M");
   rmin = F77NAME(dlamch)("U");
   emax = (int)F77NAME(dlamch)("L");
   rmax = F77NAME(dlamch)("O");

   large = 1/sfmin;
   small = sfmin;

   F77NAME(dlabad)(&small, &large);
#endif
}

ostream & HCL_FPArch_d::Write( ostream & str ) const
{
   str << "HCL_FPArch_d:" << endl;
   str << "   eps = " << eps << endl;
   str << "   sfmin = " << sfmin << endl;
   str << "   base = " << base << endl;
   str << "   prec = " << prec << endl;
   str << "   t = " << t << endl;
   str << "   rnd = " << rnd << endl;
   str << "   emin = " << emin << endl;
   str << "   rmin = " << rmin << endl;
   str << "   emax = " << emax << endl;
   str << "   rmax = " << rmax << endl;
   str << "   small = " << small << endl;
   str << "   large = " << large << endl;
   return str;
}



