/*********************************************************************
 This file was automatically generated by s2d from
 the file SGFlite_s.C.  Do not edit. 
*********************************************************************/

/*********************************************************************
 This file was automatically generated by d2s from
 the file SGFlite_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                Release 0.8, September 1997                       
                                                                  
       copyright (C) 1995, 1996, 1997 by Mark S. Gockenbach,      
              Matthew Petro, and William W. Symes                 
                                                                  
The source code contained in this file FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "SGFlite_d.H"

int GetDims(AbstractTable * t, int & buflen, double & volfact) {

  int dim=1;

  int i;
  int itmp=1; 
  double ftmp;

  // find the real dimension of the data
  itmp=1;
  i=MAX_DIM;
  while (i>1 && dim == 1) {
    t->GetArrayValue("n",i,itmp);
    if (itmp>1) {
      dim=i;
      break;
    }
    i--;
  }
  // do not override nominal dimension, but if it is not there put it.
  if (t->GetValue("dim",itmp)) {
    if (t->PutValue("dim",dim)) {
      return 1;
    }
  }

  /* check lengths, steps, origins, build up buflen */
  int buflentmp=1;
  volfact=1.0e+00;
  for( i=1;i<=dim;i++ ) {
    itmp=1;
    if (t->GetArrayValue("n",i,itmp)) {
      t->PutArrayValue("n",i,itmp);
    }
    buflentmp=buflentmp*itmp;
    ftmp=0.0e+00;
    if (t->GetArrayValue("o",i,ftmp)) {
      t->PutArrayValue("o",i,ftmp);
    }
    ftmp=1.0e+00;
    if (t->GetArrayValue("d",i,ftmp)) {
      t->PutArrayValue("d",i,ftmp);
    }
    // test - with only one sample, drop dim instead of contributing
    // to volume
    if (itmp>1) {
      volfact=volfact*ftmp;
    }
  }
  if (buflen <= 0) buflen=buflentmp;
  return 0;
}

// virtual constructor
HCL_Vector_d * SGFSpace_d::Member() const {
  return new SGFVector_d( this );
}

SGFSpace_d::SGFSpace_d( const char * srcname, int _buflen) {

  // create header Table
  
  t = new Table((char *)srcname);

  buflen = _buflen;

  if (!t) {
    cerr<<"Error: SGFSpace constructor"<<endl;
    cerr<<"failed to create table of parameter values"<<endl;
  }

  if (GetDims(t,buflen,vol)) {
    cerr<<"Error: SGFSpace constructor"<<endl;
    cerr<<"failed to record dim = number of axes"<<endl;
    exit(1);
  }
}      

SGFSpace_d::SGFSpace_d(const AbstractTable & tbl, int _buflen) {
  t=tbl.Replicate();
  buflen = _buflen;
  if (GetDims(t,buflen,vol)) {
    cerr<<"Error: SGFSpace constructor"<<endl;
    cerr<<"failed to record dim = number of axes"<<endl;
    exit(1);
  }
}

SGFSpace_d::SGFSpace_d(AbstractTable * tbl, int _buflen) {
  t=tbl; t->IncCount();
  buflen=_buflen;
  if (GetDims(t,buflen,vol)) {
    cerr<<"Error: SGFSpace constructor"<<endl;
    cerr<<"failed to record dim = number of axes"<<endl;
    exit(1);
  }
}

SGFSpace_d::SGFSpace_d(const SGFSpace_d & S) {
  t = ((SGFSpace_d &)S).Parameters();
  buflen=S.buflen;
  vol=S.vol;
}

int SGFSpace_d::operator == (const HCL_VectorSpace_d & xx) const {
  if( this == &xx )
     return 1;
  if (GetType() != xx.GetType()) {
    cerr<<"SGFSpace comparitor: input type not same"<<endl;
    cerr<<"this space:"<<endl;
    Write(cerr);
    cerr<<"comparison space:"<<endl;
    xx.Write(cerr);
    return 0;
  }

  SGFSpace_d & x = (SGFSpace_d&)xx;

  double ftmp, xftmp, f1=1.0e+00;
  int dimloc,itmp, xitmp;

  /* check dimensions */
  if(GetValue("dim",itmp)) {
    cerr<<"SGFSpace comparitor: this missing dim"<<endl;
    Write(cerr);
    return 0;
  }
  dimloc=itmp;
  if(x.GetValue("dim",xitmp)) {
    cerr<<"SGFSpace comparitor: input missing dim"<<endl;
    x.Write(cerr);
    return 0;
  }
  if(itmp != xitmp ) {
    cerr<<"SGFSpace comparitor: different dims"<<endl;
    cerr<<"this:"<<endl;
    Write(cerr);
    cerr<<"that:"<<endl;
    x.Write(cerr);
    return 0;
  }

  /* check lengths, steps, origins */
  int i;
  for( i=1;i<=dimloc;i++ ) {
    if(GetArrayValue("n",i,itmp))
      itmp=1;
    if(x.GetArrayValue("n",i,xitmp))
      xitmp=1;
    if( xitmp != itmp ) {
      cerr<<"SGFSpace comparitor: different n"<<i<<endl;
      cerr<<"this:"<<endl;
      Write(cerr);
      cerr<<"that:"<<endl;
      x.Write(cerr);
      return 0;
    }
    if(GetArrayValue("o",i,ftmp))
      ftmp=0.0e+00;
    if(x.GetArrayValue("o",i,xftmp))
      xftmp=0.0e+00;
    if( fabs(ftmp-xftmp)>SPACE_CMP_TOL*
	max( f1,abs(ftmp)) ) {
      cerr<<"SGFSpace comparitor: different o"<<i<<endl;
      cerr<<"this:"<<endl;
      Write(cerr);
      cerr<<"that:"<<endl;
      x.Write(cerr);
      return 0;
    }
    if(GetArrayValue("d",i,ftmp))
      ftmp=1.0e+00;
    if(x.GetArrayValue("d",i,xftmp))
      xftmp=1.0e+00;
    if( fabs(ftmp-xftmp)>SPACE_CMP_TOL*
	max( f1,abs(ftmp)) ) {
      cerr<<"SGFSpace comparitor: different o"<<i<<endl;
      cerr<<"this:"<<endl;
      Write(cerr);
      cerr<<"that:"<<endl;
      x.Write(cerr);
      return 0;
    }
  }
  return 1;
}

// Find the intersection of two SGFSpaces
SGFSpace_d * SGFSpace_d::Intersect( const SGFSpace_d & B ) const {

  // check to see if the spaces have the same dimension
  int dima,dimb;
  if (GetValue("dim",dima)) {
    cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
    cerr<<"failed to read dim for space A"<<endl;
    return NULL;
  }
  if (B.GetValue("dim",dimb)) {
    cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
    cerr<<"failed to read dim for space B"<<endl;
    return NULL;
  }
  
  if( dima != dimb ) {
    cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
    cerr<<"Spaces do not have the same dimension"<<endl;
    cerr<<"Dimension A:"<<endl;
    cerr<<dima<<endl;
    cerr<<"Dimension B:"<<endl;
    cerr<<dimb<<endl;
    return NULL;
  }

  // allocate some memory for the returned space
  AbstractTable * SGFSp = B.Parameters();
  
  // compute the intersection one dimension at a time
  for (int j=0;j<dima;j++) {

    // get the origins
    double oa,ob;
    if (GetArrayValue("o",j+1,oa)) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"failed to read o"<<j+1<<" for space A"<<endl;
      return NULL;
    }
    if (B.GetArrayValue("o",j+1,ob)) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"failed to read o"<<j+1<<" for space B"<<endl;
      return NULL;
    }

    // get the discretizations
    double da,db;
    if (GetArrayValue("d",j+1,da)) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"failed to read d"<<j+1<<" for space A"<<endl;
      return NULL;
    }
    if (B.GetArrayValue("d",j+1,db)) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"failed to read d"<<j+1<<" for space B"<<endl;
      return NULL;
    }

    // get the number of grid points
    int na,nb;
    if (GetArrayValue("n",j+1,na)) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"failed to read n"<<j+1<<" for space A"<<endl;
      return NULL;
    }
    if (B.GetArrayValue("n",j+1,nb)) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"failed to read n"<<j+1<<" for space B"<<endl;
      return NULL;
    }

    // compute and assign the bigger origin
    double oc;
    oc = ob;
    if (oa > ob) {
      oc = oa;
    }
    SGFSp->PutArrayValue("o",j+1,oc);

    // check for compatibilility of the discretizations then assign
    if( abs(da-db) > SPACE_CMP_TOL*abs(da) ) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"Discretizations are not the same"<<endl;
      cerr<<"d"<<j+1<<" for space A:"<<da<<endl;
      cerr<<"d"<<j+1<<" for space B:"<<db<<endl;
      return NULL;
    }
    SGFSp->PutArrayValue("d",j+1,da);

    // check to see if the grids line up
    double nab;
    nab = fmod(abs(oa-ob),abs(da));
    if (nab > SPACE_CMP_TOL) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"grids do not line up: dim = "<<j+1<<endl;
      return NULL;
    }
      
    // find the internal end grid point
    double limita, limitb, limitc;
    limita = oa+(na-1)*da;
    limitb = ob+(nb-1)*da;
    limitc = limita;
    if (limita > limitb) {
      limitc = limitb;
    }

    // compute and assign the number of grid points
    na = (int)((limitc - oc)/da + 1);
    if (na <= 0) {
      cerr<<"Error in SGFSpace_d::Intersect:"<<endl;
      cerr<<"grids do not intersect: dim = "<<j+1<<endl;
      return NULL;
    }
    SGFSp->PutArrayValue("n",j+1,na);
  }
  SGFSpace_d * interSpace = new SGFSpace_d( SGFSp );
  HCL_delete( SGFSp );
  return interSpace;
}

ostream & SGFSpace_d::Write( ostream & str ) const {
  str << "   SGFSpace_d with Table " << endl;
  t->Write(str);
  return str;
}

/* This constructor is for OLD DATASETS - fname must be the name of
   an existing data file in extended SEP format, else a Get will fail */

SGFVector_d::SGFVector_d(char * fname) {

  /* create data space */

  sp = new SGFSpace_d(fname);

  int i;
  hdrfile=new char[strlen(fname)+1];
  for (i=0;i<strlen(fname)+1;i++) {
    hdrfile[i]='\0';
  }
  strcpy( hdrfile,fname);

  datafile=new char[DATAFILENAME_LEN];
  for (i=0;i<DATAFILENAME_LEN;i++) {
    datafile[i]='\0';
  }

  /* this still works despite the fact that the data file is
     no longer "officially" part of the space data. if the 
     space is initialized on a SEP-style file with an "in="
     parameter and using a table class that reads strings,
     then the datafile string will be in the table and
     will be initialized properly by this command. */
  if (sp->GetValue("in",datafile)) {
    cerr<<"Error: SGFVector_d old dataset constructor"<<endl;
    cerr<<"failed to read binary data filename"<<endl;
    cerr<<"from header file "<<fname<<endl;
    exit(1);
  }
  if (!(file_ptr=fopen(datafile,"r+"))) {
    cerr<<"Error: SGFVector old vector constructor"<<endl;
    cerr<<"failed to open data file "<<datafile<<endl;
    exit(1);
  }

  buflen = sp->Dim();
  databuf = new double[buflen];

  if (buflen != fread(databuf,sizeof(double),buflen,file_ptr)) {
    cerr<<"Error: SGFVector old data constructor"<<endl;
    cerr<<"failed to read "<<buflen<<" doubles from data file"<<endl;
    exit(1);
  }

  zero=0.0;

}
  
// This constructor is for NEW DATASETS - the header file fname 
//   and the data file fname@ will be created or overwritten, with
//   geometry information coming from the space s 

SGFVector_d::SGFVector_d( const SGFSpace_d * s, char * fname ) {

  //  cerr<<"SGFVector constructor"<<endl;

  /* this block of code commented out since SGFVectors are no longer
     permitted to alter the parameter tables of their spaces. 
  cerr<<"get parameters"<<endl;
  AbstractTable * tbl = ((SGFSpace_d *)s)->Parameters();
  tbl->Write(cerr);
  */

  sp = (SGFSpace_d *)s; sp->IncCount();

  // assign file names, open file if permanent data

  int i;
  if ( fname ) {
    hdrfile=new char[strlen(fname)+1];
    for (i=0;i<strlen(fname)+1;i++) {
      hdrfile[i]='\0';
    }
    strcpy( hdrfile,fname);
    datafile=new char[strlen(hdrfile)+2];
    for (i=1;i<strlen(hdrfile)+2;i++) {
      datafile[i]='\0';
    }
    strcpy(datafile,hdrfile);
    strcat(datafile,"@");

    /* this block of code commented out since SGFVectors are no longer
       permitted to alter the parameter tables of their spaces. 
    if (tbl->PutValue("in",datafile)) {
      cerr<<"Error: SGFVector new vector constructor"<<endl;
      cerr<<"failed to write datafile = "<<datafile<<" to table"<<endl;
      exit(1);
    }
    */

    if (!(file_ptr=fopen(datafile,"w+"))) {
      cerr<<"Error: SGFVector new vector constructor"<<endl;
      cerr<<"failed to open data file "<<datafile<<endl;
      exit(1);
    }
    ofstream hdrstr(hdrfile);
    sp->Write(hdrstr);
    /* this block of code necessary because SGFVectors are no longer
       permitted ot alter the parameter tables of their spaces -
       so the data file name, if there is one, is no longer a
       space parameter */
    hdrstr<<"in="<<datafile<<endl;
  }
  else {
    //    cerr<<"null files"<<endl;
    hdrfile=NULL;
    datafile=NULL;
    file_ptr=NULL;
  }
  /* this block of code commented out since SGFVectors are no longer
     permitted to alter the parameter tables of their spaces. 
     now copy space pointer!
  //  cerr<<"make space"<<endl;
  sp = new SGFSpace_d(tbl);
  //  cerr<<"delete table"<<endl;
  HCL_delete(tbl);
  */

  buflen = sp->Dim();
  //  cerr<<"new buffer"<<endl;
  databuf = new double[buflen];
  zero=0.0;
  //  cerr<<"end SGFVector constructor: space = "<<endl;
  //  sp->Write(cerr);
  //  cerr<<"bye-bye"<<endl;
}

SGFVector_d::~SGFVector_d() {
  if (file_ptr) {
    rewind(file_ptr);
    if (buflen != fwrite(databuf,sizeof(double),buflen,file_ptr)) {
      cerr<<"Warning: SGFVector destructor"<<endl;
      cerr<<"failed to write "<<buflen<<" words to data file "
	  <<datafile<<endl;
    }
    fclose(file_ptr);
  }
  HCL_delete(sp);
  delete [] databuf;
  if (datafile) delete [] datafile;
  if (hdrfile) delete [] hdrfile;
}

int SGFVector_d::ChangeViewMethod(char * meth) {
  cerr<<"Error: SGFVector::ChangeViewMethod not implemented"<<endl;
  return 1;
}

int SGFVector_d::ChangeViewParameters(char * par) {
  cerr<<"Error: SGFVector::ChangeViewParameters not implemented"<<endl;
  return 1;
}

/* Arithmetic Methods */

void SGFVector_d::Copy( const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Copy: vector does not belong to same space"
      << endl;
    cerr<< "Source space:"<<endl;
    Space().Write(cerr);
    cerr<< "Target space:"<<endl;
    (xx.Space()).Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for (int j=0;j<buflen;j++) {
    databuf[j]=x.databuf[j];
  }
}

void SGFVector_d::Mul( const double & a ) {
  for( int j=0;j<buflen;j++ ) databuf[j] *= a;
}

void SGFVector_d::Mul( const double & a,const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Mul: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  
  for( int j=0;j<buflen;j++ ) databuf[j] = a*x.databuf[j];

}

void SGFVector_d::Neg() {
  for( int j=0;j<buflen;j++ ){
    databuf[j] *= -1;
  }
}

void SGFVector_d::Fill( double a ) {
  for( int j=0;j<buflen;j++ ) databuf[j] = a;
}

void SGFVector_d::Zero() {
  for( int j=0;j<buflen;j++ ) databuf[j] = 0.0;
}

void SGFVector_d::Random() {
  /* choose the pid as the seed for the Unix random number generator;
     generate random numbers, normalize to get quasiuniform distribution
     between -1 and +1, and write records full of them */
  for( int j=0;j<buflen;j++ ) {
    databuf[j] = double(rand())/double(RAND_MAX)-0.5;
  }
}

void SGFVector_d::Add( const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Add: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ) {
    databuf[j] += x.databuf[j];
  }
}

void SGFVector_d::Add( const HCL_Vector_d & xx,
		       const HCL_Vector_d & yy ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Add: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Add: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;
  for( int j=0;j<buflen;j++ ) databuf[j] = x.databuf[j] + y.databuf[j];
}

void SGFVector_d::Sub( const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sub: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ){
    databuf[j] -= x.databuf[j];
  }
}

void SGFVector_d::Sub( const HCL_Vector_d & xx,
		       const HCL_Vector_d & yy ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sub: vector does not belong to same space"
	 << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sub: vector does not belong to same space"
	 << endl;
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;
  for( int j=0;j<buflen;j++ ) databuf[j] = x.databuf[j] - y.databuf[j];
}

void SGFVector_d::ScaleAdd( const double  & a,
			    const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::ScaleAdd: vector does not belong to same space"
	 << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ) databuf[j] = a*databuf[j] + x.databuf[j];
}

void SGFVector_d::AddScale( const double  & a,
			    const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::AddScale: vector does not belong to same space"
	 << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ) databuf[j] += x.databuf[j]*a;
}

void SGFVector_d::AddScale( const double  & a,
			    const HCL_Vector_d & xx,
			    const HCL_Vector_d & yy ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::AddScale: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::AddScale: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;
  for( int j=0;j<buflen;j++ ) databuf[j] = x.databuf[j] + y.databuf[j]*a;
}

double SGFVector_d::Inner( const HCL_Vector_d & xx ) const {
  if( this == &xx ) return Norm2();
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Inner: vector does not belong to same space"
	 << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  double sum = 0.0;
  for( int j=0;j<buflen;j++ ) sum += databuf[j] * x.databuf[j];
  return sum*Vol();
}

double SGFVector_d::Norm2() const {
  double sum = 0.0;
  for( int j=0;j<buflen;j++ ) sum += databuf[j] * databuf[j];
  return sum*Vol();
}

int SGFVector_d::View() const {
  // WWS 110897: experimental interface to CWP graphics
  // note that the filename gets passed to the view command as its first
  // argument, the parameters collectively as a single-quoted string in
  // the second argument - this prevents elimination of double-quoted 
  // string literal values in keyword=value pairs
  char cmd[512];
  char vc[256];
  char vs[256];
  int i;
  for (i=0;i<256;i++) {
    vc[i]='\0';
    vs[i]='\0';
  }
  for (i=0;i<512;i++) {
    cmd[i]='\0';
  }
  if (((SGFSpace_d &)(this->Space())).GetValue("ViewMethod",vc)) {
    cerr<<"Warning: SGF::View"<<endl;
    cerr<<"no view method (keyword ViewMethod) specified"<<endl;
    return(1);
  }
  strcpy(cmd,vc);
  strcat(cmd," ");
  strcat(cmd,hdrfile);
  if (!((SGFSpace_d &)(this->Space())).GetValue("ViewParameters",vs)) {
    strcat(cmd," '");
    strcat(cmd,vs);
    strcat(cmd,"'");
  }
  return system(cmd);
}

/*
SGFRecorder_d::SGFRecorder_d( SGFSpace_d * RecordSpace, 
			      int MaxRecords,
			      char * fname) {
  
  rsp = RecordSpace; rsp->IncCount();
  n = 0;
  tsp = new SGFSpace_d(*rsp);
  int dim;
  tsp->GetValue("dim",dim);
  dim++;
  if (dim>9) {
    cerr<<"Error: SGFRecorder constructor"<<endl;
    cerr<<"sorry, bub, no more than 9 dims, certainly not "<<dim<<endl;
    cerr<<"you no like-a, you speak-a da management"<<endl;
    exit(1);
  }
  (tsp->Parameters()).PutValue("dim",dim);
  (tsp->Parameters()).PutArrayValue("n",dim,MaxRecords);
  tape = new SGFVector_d(*tsp,fname);
  tape->Zero();
  tape->Rewind();
  n=0;
  m=0;
}

SGFRecorder_d::~SGFRecorder_d() {
    HCL_delete(rsp);
    HCL_delete(tsp);
    HCL_delete(tape);
}

/// Record - store input vector

void SGFRecorder_d::Record( HCL_Vector_d & Input ) {

  // make sure input is SGFSpace
  if (rsp->GetType() != Input.Space().GetType()) {
    cerr<<"Error: SGFRecorder::Record"<<endl;
    cerr<<"input vector not SGF"<<endl;
    cerr<<"input vector:"<<endl;
    Input.Write(cerr);
    cerr<<"record space:"<<endl;
    rsp->Write(cerr);
    exit(1);
  }

  SGFVector_d & v = (SGFVector_d &)Input;

  // check key dimensions
  int i1;
  int i2;
  if (v.GetValue("rd",i1)) {
    cerr<<"Error: SGFRecorder::Record"<<endl;
    cerr<<"failed to read rd from input"<<endl;
    cerr<<"input vector:"<<endl;
    Input.Write(cerr);
    exit(1);
  }
  if ((rsp->Parameters()).GetValue("rd",i2)) {
    cerr<<"Error: SGFRecorder::Record"<<endl;
    cerr<<"failed to read rd from record space"<<endl;    
    rsp->Write(cerr);
    exit(1);
  }
  if (i1 != i2) {
    cerr<<"Error: SGFRecorder::Record"<<endl;
    cerr<<"record dimensions of input, tape not equal"<<endl;
    Input.Write(cerr);
    rsp->Write(cerr);
    exit(1);
  }
  if (tape->BufLen() < v.BufLen()) {
    cerr<<"Error: SGFRecorder::Record"<<endl;
    cerr<<"buffer length of tape too short"<<endl;
    Input.Write(cerr);
    rsp->Write(cerr);
    exit(1);
  }    
    
  for (int i=0; i<v.BufLen();i++) {
    (tape->Data())[i] = (v.Data())[i];
  }
  m=max(m,n+1);
  if (tape->Next()) {
    n++;
  }
}

/// Rewind - go to first vector recorded

void SGFRecorder_d::Rewind() {
  tape->Rewind();
  n=0;
}

/// Playback - copy stored data onto vector parameter

void SGFRecorder_d::PlayBack( HCL_Vector_d & Output ) {

  // make sure input is SGFSpace
  if (rsp->GetType() != Output.Space().GetType()) {
    cerr<<"Error: SGFRecorder::PlayBack"<<endl;
    cerr<<"Output vector not SGF"<<endl;
    cerr<<"Output vector:"<<endl;
    Output.Write(cerr);
    cerr<<"record space:"<<endl;
    rsp->Write(cerr);
    exit(1);
  }

  SGFVector_d & v = (SGFVector_d &)Output;

  // check key dimensions
  int i1;
  int i2;
  if (v.GetValue("rd",i1)) {
    cerr<<"Error: SGFRecorder::PlayBack"<<endl;
    cerr<<"failed to read rd from Output"<<endl;
    cerr<<"Output vector:"<<endl;
    Output.Write(cerr);
    exit(1);
  }
  if ((rsp->Parameters()).GetValue("rd",i2)) {
    cerr<<"Error: SGFRecorder::PlayBack"<<endl;
    cerr<<"failed to read rd from record space"<<endl;    
    rsp->Write(cerr);
    exit(1);
  }
  if (i1 != i2) {
    cerr<<"Error: SGFRecorder::PlayBack"<<endl;
    cerr<<"record dimensions of Output, tape not equal"<<endl;
    Output.Write(cerr);
    rsp->Write(cerr);
    exit(1);
  }
  if (tape->BufLen() > v.BufLen()) {
    cerr<<"Error: SGFRecorder::PlayBack"<<endl;
    cerr<<"buffer length of tape too long"<<endl;
    Output.Write(cerr);
    rsp->Write(cerr);
    exit(1);
  }    

  for (int i=0; i<v.BufLen();i++) {
    (v.Data())[i] = (tape->Data())[i];
  }
  if (tape->Next()) {
    n++;
  }
}

/// Next - advance to next recorded vector - returns 0 when at end

int SGFRecorder_d::Next() {
  if (tape->Next()) {
    n++;
    return 1;
  }
  return 0;
}

/// Number - how many vectors currently stored

int SGFRecorder_d::Number() {
  return m;
}

/// Erase - deletes currently stored vectors;

void SGFRecorder_d::Erase() {
  tape->Zero();
  tape->Rewind();
  m=0;
  n=0;
}

*/
  
// scalar argument overloads of Add

void SGFVector_d::Add( double a ) {
  for( int j=0;j<buflen;j++ ) databuf[j] = databuf[j]+a;
}

void SGFVector_d::Add( const HCL_Vector_d & xx, double a ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sub: vector does not belong to same space"
      << endl;
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ) databuf[j] = x.databuf[j]+a;
}

// Diagonal scaling
  
void SGFVector_d::DiagScale( const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::DiagScale"<<endl;
    cerr << "input vector does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ) databuf[j] = databuf[j]*x.databuf[j];
}

void SGFVector_d::DiagScale( const HCL_Vector_d & xx,
			     const HCL_Vector_d & yy ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::DiagScale"<<endl;
    cerr << "input vector does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::DiagScale"<<endl;
    cerr << "input vector yy does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    yy.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;
  for( int j=0;j<buflen;j++ ) databuf[j] = y.databuf[j]*x.databuf[j];
}

void SGFVector_d::DiagRecipScale( const HCL_Vector_d & xx,
				  double tol) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::DiagRecipScale"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  HCL_FPArch_d FP;
  double thistol=max(tol,FP.sfmin);
  for( int j=0;j<buflen;j++ ){
    if (x.databuf[j]>=0.0) {
      databuf[j] = databuf[j]/max(thistol,x.databuf[j]);
    }
    else {
      databuf[j] = databuf[j]/min(-thistol,x.databuf[j]);
    }
  }
}
void SGFVector_d::DiagRecipScale( const HCL_Vector_d & xx,
				  const HCL_Vector_d & yy,
				  double tol) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::DiagRecipScale"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::DiagRecipScale"<<endl;
    cerr << "input vector yy does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    yy.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;

  HCL_FPArch_d FP;
  double thistol=max(tol,FP.sfmin);

  for( int j=0;j<buflen;j++ ){
    if (x.databuf[j]>=0.0) {
      databuf[j] = y.databuf[j]/max(thistol,x.databuf[j]);
    }
    else {
      databuf[j] = y.databuf[j]/min(-thistol,x.databuf[j]);
    }
  }
}

double SGFVector_d::Max() const {
  double m = -FLT_MAX;
  for( int j=0;j<buflen;j++ ) m=max(databuf[j],m);
  return m;
}

double SGFVector_d::Min() const {
  double m = FLT_MAX;
  for( int j=0;j<buflen;j++ ) m=min(databuf[j],m);
  return m;
}

double SGFVector_d::Sum() const {
  double m = 0.0;
  for( int j=0;j<buflen;j++ ) m=m+databuf[j];
  return m;
}

void SGFVector_d::Max( const HCL_Vector_d & xx ) {
  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Max"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ){
    databuf[j] = (databuf[j]<x.databuf[j]?x.databuf[j]:databuf[j]);
  }
}

void SGFVector_d::Max( const HCL_Vector_d & xx,
		       const HCL_Vector_d & yy ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Max"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Max"<<endl;
    cerr << "input vector yy does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    yy.Space().Write(cerr);
    exit(1);
  }

  SGFVector_d & y = (SGFVector_d&)yy;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (y.databuf[j]<x.databuf[j]?x.databuf[j]:y.databuf[j]);
  }
}

void SGFVector_d::Min( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Min"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (databuf[j]>x.databuf[j]?x.databuf[j]:databuf[j]);
  }
}

void SGFVector_d::Min( const HCL_Vector_d & xx,
		    const HCL_Vector_d & yy ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Min"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Min"<<endl;
    cerr << "input vector yy does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    yy.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (y.databuf[j]>x.databuf[j]?x.databuf[j]:y.databuf[j]);
  }
}

void SGFVector_d::Abs(){
  for( int j=0;j<buflen;j++ ) databuf[j]=fabs(databuf[j]);
}

void SGFVector_d::Abs( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Abs"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ) databuf[j] = fabs(x.databuf[j]);
}

void SGFVector_d::Sign() {
  for( int j=0;j<buflen;j++ ){
    databuf[j] = (databuf[j]==0.0?0.0:(databuf[j]>0?1.0:-1.0));
  }
}

void SGFVector_d::Sign( double t ) {
  for( int j=0;j<buflen;j++ ){
    databuf[j] = (databuf[j]==t?0.0:(databuf[j]>t?1.0:-1.0));
  }
}

void SGFVector_d::Sign( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sign"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (x.databuf[j]==0.0?0.0:(x.databuf[j]>0?1.0:-1.0));
  }
}

void SGFVector_d::Sign( const HCL_Vector_d & xx,
		     const HCL_Vector_d & yy ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sign"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sign"<<endl;
    cerr << "input vector yy does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    yy.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (x.databuf[j]==y.databuf[j]?0.0:(x.databuf[j]>y.databuf[j]?1.0:-1.0));
  }
}

void SGFVector_d::Sign( const HCL_Vector_d & xx,double t ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sign"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (x.databuf[j]==t?0.0:(x.databuf[j]>t?1.0:-1.0));
  }
}

void SGFVector_d::Sign( double t,const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sign"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (x.databuf[j]==t?0.0:(x.databuf[j]<t?1.0:-1.0));
  }
}
void SGFVector_d::Greater( double t ){
  for( int j=0;j<buflen;j++ ) databuf[j] = (databuf[j]>t?1.0:0.0);
}

void SGFVector_d::Greater( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Greater"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;
  for( int j=0;j<buflen;j++ ){
    databuf[j] = (databuf[j]>x.databuf[j]?1.0:0.0);
  }
}
void SGFVector_d::Greater( const HCL_Vector_d & xx,
			   const HCL_Vector_d & yy ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Greater"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  if( (yy.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Greater"<<endl;
    cerr << "input vector yy does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    yy.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & y = (SGFVector_d&)yy;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (x.databuf[j]>y.databuf[j]?1.0:0.0);
  }
}

void SGFVector_d::Greater( const HCL_Vector_d & xx,double t ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Greater"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (x.databuf[j]>t?1.0:0.0);
  }
}

void SGFVector_d::Greater( double t,const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Greater"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = (t>x.databuf[j]?1.0:0.0);
  }
}

void SGFVector_d::Power( double p ) {

  for( int j=0;j<buflen;j++ ){
    databuf[j] = pow(databuf[j],p);
  }
}

void SGFVector_d::Power( double p, const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Power"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    databuf[j] = pow(x.databuf[j],p);
  }
}

void SGFVector_d::Sqrt() {

  for( int j=0;j<buflen;j++ ){
    if (databuf[j]<0.0) {
      cerr<<"Error: SGFVector_d::Sqrt"<<endl;
      cerr<<" entry "<<j<<" = "<<databuf[j]<<" negative"<<endl;
      exit(1);
    }
    databuf[j] = sqrt(databuf[j]);
  }
}

void SGFVector_d::Sqrt( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Sqrt"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    if (x.databuf[j]<0.0) {
      cerr<<"Error: SGFVector_d::Sqrt"<<endl;
      cerr<<" entry "<<j<<" = "<<x.databuf[j]<<" negative"<<endl;
      exit(1);
    }
    databuf[j] = sqrt(x.databuf[j]);
  }
}

void SGFVector_d::Exp() {
  for( int j=0;j<buflen;j++ ){
    databuf[j] = exp(databuf[j]);
  }
}

void SGFVector_d::Exp( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Exp"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ) databuf[j] = exp(x.databuf[j]);
}

void SGFVector_d::Log() {
  for( int j=0;j<buflen;j++ ){
    if (databuf[j]<=0.0) {
      cerr<<"Error: SGFVector_d::Log"<<endl;
      cerr<<" entry "<<j<<" = "<<databuf[j]<<" nonpositive"<<endl;
      exit(1);
    }
    databuf[j] = log(databuf[j]);
  }
}

void SGFVector_d::Log( const HCL_Vector_d & xx ) {

  if( (xx.Space()) != (Space()) ) {
    cerr << "Error in SGFVector_d::Log"<<endl;
    cerr << "input vector xx does not belong to same space" << endl;
    cerr << "this space:"<<endl;
    Space().Write(cerr);
    cerr << "space of input vector:"<<endl;
    xx.Space().Write(cerr);
    exit(1);
  }
  SGFVector_d & x = (SGFVector_d&)xx;

  for( int j=0;j<buflen;j++ ){
    if (x.databuf[j]<=0.0) {
      cerr<<"Error: SGFVector_d::Log"<<endl;
      cerr<<" entry "<<j<<" = "<<x.databuf[j]<<" nonpositive"<<endl;
      exit(1);
    }
    databuf[j] = log(x.databuf[j]);
  }
}






