#include "HCL_OpProductDomain_d.h"

void HCL_EvalOpProductDomain_d::PartialDerivImage( int i,
                                    const HCL_Vector_d & dx,
                                          HCL_Vector_d & dy ) const
{
   cerr << "Error: HCL_EvalOpProductDomain_d::PartialDerivImage "
           "not implemented"
        << endl;
   exit(1);
}

void HCL_EvalOpProductDomain_d::PartialDerivAdjImage(  int i,
                                    const HCL_Vector_d & dy,
                                          HCL_Vector_d & dx ) const
{
   cerr << "Error: HCL_EvalOpProductDomain_d::PartialDerivAdjImage "
           "not implemented" << endl;
   exit(1);
}

void HCL_EvalOpProductDomain_d::PartialDerivInvImage( int i,
                                    const HCL_Vector_d & dy,
                                          HCL_Vector_d & dx ) const
{
   cerr << "Error: HCL_EvalOpProductDomain_d::PartialDerivInvImage "
           "not implemented" << endl;
   exit(1);
}

void HCL_EvalOpProductDomain_d::PartialDerivInvAdjImage( int i,
                                    const HCL_Vector_d & dx,
                                          HCL_Vector_d & dy ) const
{
   cerr << "Error: HCL_EvalOpProductDomain_d::PartialDerivInvAdjImage"
           " not implemented" << endl;
   exit(1);
}

void HCL_EvalOpProductDomain_d::SecondPartialDerivImage( int i,int j,
                                            const HCL_Vector_d & dxj,
                                            const HCL_Vector_d & dxi,
                                                  HCL_Vector_d & dy ) const
{
   cerr << "Error: HCL_EvalOpProductDomain_d::SecondPartialDerivImage "
           "not implemented" << endl;
   exit(1);
}

void HCL_EvalOpProductDomain_d::SecondPartialDerivPartialAdjImage( int i,
                                            int j,int flag,
                                            const HCL_Vector_d & dxij,
                                            const HCL_Vector_d & dy,
                                                  HCL_Vector_d & dxji ) const
{
   cerr << "Error: HCL_EvalOpProductDomain_d::"
           "SecondPartialDerivPartialAdjImage "
           "not implemented" << endl;
   exit(1);
}

HCL_EvalOpProductDomain_d::HCL_EvalOpProductDomain_d()
{
}

HCL_EvalOpProductDomain_d::HCL_EvalOpProductDomain_d(
                  const HCL_EvalOpProductDomain_d & )
{
}

HCL_EvalOpProductDomain_d::~HCL_EvalOpProductDomain_d()
{
}

HCL_ProductSpace_d & HCL_EvalOpProductDomain_d::ProductDomain() const
{
   return (HCL_ProductSpace_d&)Domain();
}

HCL_LinearOp_d * HCL_EvalOpProductDomain_d::Deriv() const
{
   HCL_BlockLinearOp_d * DD = new
            HCL_BlockLinearOp_d( &(ProductDomain()),&(Range()),ROWOP ); 
   HCL_BlockLinearOp_d & D = (HCL_BlockLinearOp_d&)*DD;
   int i;
   for( i=1;i<=ProductDomain().Number();i++ )
   {
      HCL_LinearOp_d * B = PartialDeriv( i );
      D.Set( 1,i,B );
      HCL_delete( B );
   }
   return DD;
}

const HCL_LinearOp_d & HCL_EvalOpProductDomain_d::DerivRef() const
{
   int i;
   for( i=1;i<=ProductDomain().Number();i++ )
      PartialDerivRef( i );

   return *SavedDeriv;
}

HCL_LinearOp_d * HCL_EvalOpProductDomain_d::PartialDeriv( int i ) const
{
   return new HCL_OpDefaultPartialDeriv_d( i,this );
}

const HCL_LinearOp_d & HCL_EvalOpProductDomain_d::PartialDerivRef(
                                                  int i ) const
{
   HCL_EvalOpProductDomain_d * t = (HCL_EvalOpProductDomain_d*)this;
   if( !SavedDeriv )
      t->SavedDeriv = new 
                   HCL_BlockLinearOp_d( &(ProductDomain()),&(Range()),ROWOP ); 
   HCL_BlockLinearOp_d & D = (HCL_BlockLinearOp_d&)(*SavedDeriv);
   if( !D.IsSet( 1,i ) )
   {
      HCL_LinearOp_d * B = PartialDeriv( i );
      D.Set( 1,i,B );
      HCL_delete( B );
   }
   return D( 1,i );
}

HCL_BiLinearOp_d * HCL_EvalOpProductDomain_d::SecondDeriv() const
{
   HCL_BlockBiLinearOp_d * BB = new HCL_BlockBiLinearOp_d(
            &(ProductDomain()),&(ProductDomain()),&(Range()) );
   HCL_BlockBiLinearOp_d & B = (HCL_BlockBiLinearOp_d&)*BB;
   int i,j;
   for( i=1;i<=ProductDomain().Number();i++ )
      for( j=1;j<=ProductDomain().Number();j++ )
      {
         HCL_BiLinearOp_d * t = SecondPartialDeriv( i,j );
         B.Set( i,j,t );
         HCL_delete( t );
      }
   return BB;
}

const HCL_BiLinearOp_d &
      HCL_EvalOpProductDomain_d::SecondDerivRef() const

{
   HCL_EvalOpProductDomain_d * t = (HCL_EvalOpProductDomain_d*)this;
   if( !Saved2ndDeriv )
      t->Saved2ndDeriv = new 
                   HCL_BlockBiLinearOp_d( &(ProductDomain()),
                                          &(ProductDomain()),
                                          &(Range()) );
   HCL_BlockBiLinearOp_d & B = (HCL_BlockBiLinearOp_d&)(*Saved2ndDeriv);
   int i,j;
   for( i=1;i<=ProductDomain().Number();i++ )
      for( j=1;j<=ProductDomain().Number();j++ )
      if( !B.IsSet( i,j ) )
      {
         HCL_BiLinearOp_d * Bij = SecondPartialDeriv( i,j );
         B.Set( i,j,Bij );
         HCL_delete( Bij );
      }
   return *Saved2ndDeriv;
}

HCL_BiLinearOp_d * HCL_EvalOpProductDomain_d::SecondPartialDeriv(
                                                    int i,int j ) const
{
   return new HCL_OpDefaultSecondPartialDeriv_d( i,j,this );
}

const HCL_BiLinearOp_d & HCL_EvalOpProductDomain_d::SecondPartialDerivRef(
                                                    int i,int j ) const
{
   HCL_EvalOpProductDomain_d * t = (HCL_EvalOpProductDomain_d*)this;
   if( !Saved2ndDeriv )
      t->Saved2ndDeriv = new 
                   HCL_BlockBiLinearOp_d( &(ProductDomain()),
                                          &(ProductDomain()),
                                          &(Range()) );
   HCL_BlockBiLinearOp_d & B = (HCL_BlockBiLinearOp_d&)(*Saved2ndDeriv);
   if( !B.IsSet( i,j ) )
   {
      HCL_BiLinearOp_d * Bij = SecondPartialDeriv( i,j );
      B.Set( i,j,Bij );
      HCL_delete( Bij );
   }
   return B( i,j );
}

void HCL_OpProductDomain_d::Image1( const HCL_Vector_d & x,
                                          HCL_Vector_d & y ) const
{
   cerr << "Error: HCL_OpProductDomain_d::Image1 not implemented" << endl;
   exit(1);
}

void HCL_OpProductDomain_d::PartialDerivImage( int i,
                           const HCL_Vector_d & x,const HCL_Vector_d & dx,
                                 HCL_Vector_d & dy ) const
{
   cerr << "Error: HCL_OpProductDomain_d::PartialDerivImage not "
           "implemented" << endl;
   exit(1);
}

void HCL_OpProductDomain_d::PartialDerivAdjImage( int i,
                              const HCL_Vector_d & x,const HCL_Vector_d & dy,
                                    HCL_Vector_d & dx ) const
{
   cerr << "Error: HCL_OpProductDomain_d::PartialDerivAdjImage not "
           "implemented" << endl;
   exit(1);
}

void HCL_OpProductDomain_d::PartialDerivInvImage( int i,
                             const HCL_Vector_d & x,const HCL_Vector_d & dy,
                                   HCL_Vector_d & dx ) const
{
   cerr << "Error: HCL_OpProductDomain_d::PartialDerivInvImage not "
           "implemented" << endl;
   exit(1);
}

void HCL_OpProductDomain_d::PartialDerivInvAdjImage( int i,
                                 const HCL_Vector_d & x,
                                 const HCL_Vector_d & dx,
                                       HCL_Vector_d & dy ) const
{
   cerr << "Error: HCL_OpProductDomain_d::PartialDerivInvAdjImage not "
           "implemented" << endl;
   exit(1);
}

HCL_LinearOp_d * HCL_OpProductDomain_d::PartialDeriv1( int i,
                                        const HCL_Vector_d & x ) const
{
   return (HCL_LinearOp_d*)NULL;
}

void HCL_OpProductDomain_d::SecondPartialDerivImage( int i,int j,
                                            const HCL_Vector_d & x,
                                            const HCL_Vector_d & dxj,
                                            const HCL_Vector_d & dxi,
                                                  HCL_Vector_d & dy ) const
{
   cerr << "Error: HCL_OpProductDomain_d::SecondPartialDerivImage "
           "not implemented" << endl;
   exit(1);
}

void HCL_OpProductDomain_d::SecondPartialDerivPartialAdjImage( int i,int j,
                                            int flag,
                                            const HCL_Vector_d & x,
                                            const HCL_Vector_d & dxij,
                                            const HCL_Vector_d & dy,
                                                  HCL_Vector_d & dxji ) const
{
   cerr << "Error: HCL_OpProductDomain_d::SecondPartialDerivPartialAdjImage "
           "not implemented" << endl;
   exit(1);
}

HCL_BiLinearOp_d * HCL_OpProductDomain_d::SecondPartialDeriv1( int i,int j,
                                              const HCL_Vector_d & x ) const
{
   return (HCL_BiLinearOp_d*)NULL;
}

HCL_OpProductDomain_d::HCL_OpProductDomain_d(){}
HCL_OpProductDomain_d::HCL_OpProductDomain_d(const HCL_OpProductDomain_d &){}
HCL_OpProductDomain_d::~HCL_OpProductDomain_d(){}
HCL_ProductSpace_d & HCL_OpProductDomain_d::ProductDomain() const
{
   return (HCL_ProductSpace_d&)Domain();
}

HCL_EvaluateOp_d * HCL_OpProductDomain_d::Evaluate(
                                const HCL_Vector_d & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_OpProductDomain_d::Evaluate: input vector is "
              "not in domain" << endl;
      cerr << "Domain:" << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector:" << endl;
      x.Space().Write( cerr );
      exit(1);
   }
   const HCL_ProductVector_d & y = (const HCL_ProductVector_d&)x;
   return new HCL_OpPDDefaultEval_d( this,y );
}

HCL_LinearOp_d * HCL_OpProductDomain_d::PartialDeriv( int i,
                        const HCL_Vector_d & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_OpProductDomain_d::PartialDeriv: vector is "
              "not in domain" << endl;
      exit(1);
   }
   HCL_EvalOpProductDomain_d * eval = 
             (HCL_EvalOpProductDomain_d*)Evaluate( x );
   HCL_LinearOp_d * D = eval->PartialDeriv( i );
   HCL_delete( eval );
   return D;
}

HCL_BiLinearOp_d * HCL_OpProductDomain_d::SecondPartialDeriv(
                        int i,int j,const HCL_Vector_d & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_OpProductDomain_d::SecondPartialDeriv: vector is "
              "not in domain" << endl;
      exit(1);
   }
   HCL_EvalOpProductDomain_d * eval = 
             (HCL_EvalOpProductDomain_d*)Evaluate( x );
   HCL_BiLinearOp_d * B = eval->SecondPartialDeriv( i,j );
   HCL_delete( eval );
   return B;
}

int HCL_OpProductDomain_d::CheckPartialDerivAdj(int ind,
                            const HCL_Vector_d & y,const HCL_Vector_d & p,
                            ostream & str,int n,double hmin,
                            double hmax ) const
{
   CheckPartialDeriv( ind,y,p,str,n,hmin,hmax );
   HCL_LinearOp_d * L = PartialDeriv( ind,y );
   L->CheckAdj( 2 );
   HCL_delete( L );
   return 0;
}
   
int HCL_OpProductDomain_d::CheckPartialDeriv( int ind,
                            const HCL_Vector_d & y,const HCL_Vector_d & p,
                            ostream & str,int n,double hmin,
                            double hmax ) const
{
   if( ind < 1 || ind > ProductDomain().Number() )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckPartialDeriv: "
               "invalid index" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckPartialDeriv: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( p.Space() != ProductDomain()(ind) )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckPartialDeriv: "
              "vector p is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      double temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   HCL_ProductVector_d * yp = (HCL_ProductVector_d*)ProductDomain().Member();
   yp->Zero();
   (*yp)(ind).Copy( p );
   double hlimit1 = MaxStep( y,*yp );
   yp->Neg();
   double hlimit2 = MaxStep( y,*yp );
   HCL_delete( yp );
   double hlimit = min( hlimit1,hlimit2 );
   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckPartialDeriv: "
              "direction is not feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_ProductVector_d * x1 = (HCL_ProductVector_d*)(Domain().Member());
   HCL_ProductVector_d * x2 = (HCL_ProductVector_d*)(Domain().Member());
   HCL_Vector_d * g1 = Range().Member();
   HCL_Vector_d * g2 = Range().Member();
   HCL_Vector_d * dg = Range().Member();

   HCL_LinearOp_d * DFy = PartialDeriv( ind,y );
   DFy->Image( p,*dg );

   HCL_delete( DFy );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   double dgnorm = dg->Norm();
   int rflag = 1;
   HCL_FPArch_d arch;
   if( dgnorm < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_OpProductDomain_d::CheckPartialDeriv: norm of "
             "first variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << endl;
   int i;
   double hstep = (hmax-hmin)/(n-1);
   for( i=n-1;i>=0;i-- )
   {
      double h = hmin+i*hstep;
      x1->Copy( y );
      (*x1)(ind).AddScale( -h,p );
      Image( *x1,*g1 );
      x2->Copy( y );
      (*x2)(ind).AddScale( h,p );
      Image( *x2,*g2 );
      g2->Sub( *g1 );
      g2->Mul( 1.0/(2.0*h) );
      g2->Sub( *dg );
      double n1 = g2->Norm();
      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << " " << setw(nd+6) << n1/dgnorm << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << endl;
   }
   HCL_delete( dg );
   HCL_delete( g2 );
   HCL_delete( g1 );
   HCL_delete( x2 );
   HCL_delete( x1 );
   str.precision( oldprecision );
   return 0;
}

// This method checks the analytic second derivatives against the
// second order finite-difference formula
//
//     \[D_{ij}F(x)(\delta x_j,\delta x_i) \doteq 
//          F(x+\tilde{\delta x_i}+\tilde{\delta x_j})+
//          F(x-\tilde{\delta x_i}-\tilde{\delta x_j})-
//          F(x+\tilde{\delta x_i})-
//          F(x-\tilde{\delta x_i})-
//          F(x+\tilde{\delta x_j})-
//          F(x-\tilde{\delta x_j})+2F(x)\].
//
//  Here $\tilde{\delta x_i}$ is the vector in the domain of $F$ with every
//  component equal to zero except the $i$th, which equals $\delta x_i$.

int HCL_OpProductDomain_d::CheckSecondPartialDerivAdj( int i,int j,
                            const HCL_Vector_d & y,
                            const HCL_Vector_d & pj,const HCL_Vector_d & pi,
                            ostream & str,int n,double hmin,
                            double hmax ) const
{
   CheckSecondPartialDeriv( i,j,y,pj,pi,str,n,hmin,hmax );
   HCL_BiLinearOp_d * Bij = SecondPartialDeriv( i,j,y );
   Bij->CheckAdj( 2 );
   HCL_delete( Bij );
   return 0;
}

int HCL_OpProductDomain_d::CheckSecondPartialDeriv( int i,int j,
                            const HCL_Vector_d & y,
                            const HCL_Vector_d & pj,const HCL_Vector_d & pi,
                            ostream & str,int n,double hmin,
                            double hmax ) const
{
   if( i==j )
      return CheckSecondPartialDeriv( i,y,pi,str,n,hmin,hmax );
      
   if( i < 1 || i > ProductDomain().Number() || j < 1 ||
       j > ProductDomain().Number() )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
               "invalid index" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( pi.Space() != ProductDomain()(i) )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
              "vector pi is not in Domain" << endl;
      exit(1);
   }
   if( pj.Space() != ProductDomain()(j) )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
              "vector pj is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      double temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   // There are now six directions to check: pi+pj,-pi-pj,pi,-pi,pj,-pj
   HCL_ProductVector_d * yp = (HCL_ProductVector_d*)ProductDomain().Member();
   yp->Zero();
   (*yp)(i).Copy( pi );
   (*yp)(j).Copy( pj );
   double hlimit = MaxStep( y,*yp );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Zero();
   (*yp)(i).Copy( pi );
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Zero();
   (*yp)(j).Copy( pj );
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   HCL_delete( yp );

   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
              "direction is not feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_ProductVector_d * x1 = (HCL_ProductVector_d*)(Domain().Member());
   HCL_Vector_d * g0 = Range().Member();
   HCL_Vector_d * g1 = Range().Member();
   HCL_Vector_d * g2 = Range().Member();
   HCL_Vector_d * dg = Range().Member();

   Image( y,*g0 );
   HCL_BiLinearOp_d * D2Fy = SecondPartialDeriv( i,j,y );
   D2Fy->Image( pj,pi,*dg );
   HCL_delete( D2Fy );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   double dgnorm = dg->Norm();
   int rflag = 1;
   HCL_FPArch_d arch;
   if( dgnorm < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_OpProductDomain_d::CheckSecondPartialDeriv: norm of "
             "second variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << endl;
   int ii;
   double hstep = (hmax-hmin)/(n-1);
   for( ii=n-1;ii>=0;ii-- )
   {
      g2->Mul( 2.0,*g0 );
      double h = hmin+ii*hstep;
      x1->Copy( y );
      (*x1)(i).AddScale( h,pi );
      (*x1)(j).AddScale( h,pj );
      Image( *x1,*g1 );
      g2->Add( *g1 );

      x1->Copy( y );
      (*x1)(i).AddScale( -h,pi );
      (*x1)(j).AddScale( -h,pj );
      Image( *x1,*g1 );
      g2->Add( *g1 );

      x1->Copy( y );
      (*x1)(i).AddScale( h,pi );
      Image( *x1,*g1 );
      g2->Sub( *g1 );

      x1->Copy( y );
      (*x1)(i).AddScale( -h,pi );
      Image( *x1,*g1 );
      g2->Sub( *g1 );

      x1->Copy( y );
      (*x1)(j).AddScale( h,pj );
      Image( *x1,*g1 );
      g2->Sub( *g1 );

      x1->Copy( y );
      (*x1)(j).AddScale( -h,pj );
      Image( *x1,*g1 );
      g2->Sub( *g1 );

      g2->Mul( 1.0/(2.0*h*h) );
      g2->Sub( *dg );
      double n1 = g2->Norm();

      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << " " << setw(nd+6) << n1/dgnorm << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << endl;
   }
   HCL_delete( dg );
   HCL_delete( g2 );
   HCL_delete( g1 );
   HCL_delete( g0 );
   HCL_delete( x1 );
   str.precision( oldprecision );
   return 0;
}

int HCL_OpProductDomain_d::CheckSecondPartialDerivAdj( int i,
                            const HCL_Vector_d & y,
                            const HCL_Vector_d & pi,
                            ostream & str,int n,double hmin,
                            double hmax ) const
{
   CheckSecondPartialDeriv( i,y,pi,str,n,hmin,hmax );
   HCL_BiLinearOp_d * Bii = SecondPartialDeriv( i,i,y );
   Bii->CheckAdj( 2 );
   HCL_delete( Bii );
   return 0;
}

int HCL_OpProductDomain_d::CheckSecondPartialDeriv( int i,
                            const HCL_Vector_d & y,
                            const HCL_Vector_d & pi,
                            ostream & str,int n,double hmin,
                            double hmax ) const
{
   if( i < 1 || i > ProductDomain().Number() )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
               "invalid index" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( pi.Space() != ProductDomain()(i) )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
              "vector pi is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      double temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   HCL_ProductVector_d * yp = (HCL_ProductVector_d*)ProductDomain().Member();
   yp->Zero();
   (*yp)(i).Copy( pi );
   double hlimit = MaxStep( y,*yp );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   HCL_delete( yp );

   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_OpProductDomain_d::CheckSecondPartialDeriv: "
              "direction is not feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_ProductVector_d * x1 = (HCL_ProductVector_d*)(Domain().Member());
   HCL_Vector_d * g0 = Range().Member();
   HCL_Vector_d * g1 = Range().Member();
   HCL_Vector_d * g2 = Range().Member();
   HCL_Vector_d * dg = Range().Member();

   Image( y,*g0 );
   HCL_BiLinearOp_d * D2Fy = SecondPartialDeriv( i,i,y );
   D2Fy->Image( pi,pi,*dg );
   HCL_delete( D2Fy );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   double dgnorm = dg->Norm();
   int rflag = 1;
   HCL_FPArch_d arch;
   if( dgnorm < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_OpProductDomain_d::CheckSecondPartialDeriv: norm of "
             "second variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << endl;
   double hstep = (hmax-hmin)/(n-1);
   int ii;
   for( ii=n-1;ii>=0;ii-- )
   {
      g2->Mul( -2.0,*g0 );
      double h = hmin+ii*hstep;
      x1->Copy( y );
      (*x1)(i).AddScale( h,pi );
      Image( *x1,*g1 );
      g2->Add( *g1 );

      x1->Copy( y );
      (*x1)(i).AddScale( -h,pi );
      Image( *x1,*g1 );
      g2->Add( *g1 );

      g2->Mul( 1.0/(h*h) );
      g2->Sub( *dg );
      double n1 = g2->Norm();

      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << " " << setw(nd+6) << n1/dgnorm << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << endl;
   }
   HCL_delete( dg );
   HCL_delete( g2 );
   HCL_delete( g1 );
   HCL_delete( g0 );
   HCL_delete( x1 );
   str.precision( oldprecision );
   return 0;
}

HCL_OpPDDefaultEval_d::HCL_OpPDDefaultEval_d()
{
   cerr << "Error: HCL_OpPDDefaultEval_d default constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpPDDefaultEval_d::HCL_OpPDDefaultEval_d( const HCL_OpPDDefaultEval_d & L )
{
   cerr << "Error: HCL_OpPDDefaultEval_d copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpPDDefaultEval_d::HCL_OpPDDefaultEval_d(
                       const HCL_OpProductDomain_d * op_,
                       const HCL_ProductVector_d & in )
{
   op = op_;op->IncCount();
   x = (HCL_ProductVector_d*)in.Space().Member();
   x->Copy( in );
}

HCL_OpPDDefaultEval_d::~HCL_OpPDDefaultEval_d()
{
   HCL_delete( x );
   HCL_delete( (HCL_OpProductDomain_d*)op );
}

HCL_LinearOp_d * HCL_OpPDDefaultEval_d::PartialDeriv( int i) const
{
   HCL_LinearOp_d * DFx = op->PartialDeriv1( i,*x );
   if( DFx )
      return DFx;
   else
      return new HCL_OpDefaultPartialDeriv_d( i,this );
}

HCL_BiLinearOp_d * HCL_OpPDDefaultEval_d::SecondPartialDeriv(
                                          int i,int j ) const
{
   HCL_BiLinearOp_d * D2Fx = op->SecondPartialDeriv1( i,j,*x );
   if( D2Fx )
      return D2Fx;
   else
      return new HCL_OpDefaultSecondPartialDeriv_d( i,j,this );
}

ostream & HCL_OpPDDefaultEval_d::Write( ostream & str ) const
{
   str << "HCL_OpPDDefaultEval_d" << endl;
   str << "Underlying operator is: " << endl;
   op->Write( str );
   return str;
}

HCL_OpDefaultPartialDeriv_d::HCL_OpDefaultPartialDeriv_d()
{
   cerr << "Error: HCL_OpDefaultPartialDeriv_d default constructor "
           "not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultPartialDeriv_d::HCL_OpDefaultPartialDeriv_d(
                             const HCL_OpDefaultPartialDeriv_d & L )
{
   cerr << "Error: HCL_OpDefaultPartialDeriv_d copy constructor "
           "not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultPartialDeriv_d::HCL_OpDefaultPartialDeriv_d( int ii,
                             const HCL_EvalOpProductDomain_d * ev )
{
   i = ii;
   eval = ev;ev->IncCount();
}

HCL_OpDefaultPartialDeriv_d::~HCL_OpDefaultPartialDeriv_d()
{
   HCL_delete( (HCL_EvalOpProductDomain_d*)eval );
}

HCL_VectorSpace_d & HCL_OpDefaultPartialDeriv_d::Domain() const
{
   return eval->ProductDomain()(i);
}

HCL_VectorSpace_d & HCL_OpDefaultPartialDeriv_d::Range() const
{
   return eval->Range();
}

void HCL_OpDefaultPartialDeriv_d::Image( const HCL_Vector_d & x,
                                        HCL_Vector_d & y ) const
{
   eval->PartialDerivImage( i,x,y );
}

void HCL_OpDefaultPartialDeriv_d::AdjImage( const HCL_Vector_d & y,
                                           HCL_Vector_d & x ) const
{
   eval->PartialDerivAdjImage( i,y,x );
}

void HCL_OpDefaultPartialDeriv_d::InvImage(const HCL_Vector_d & y,
                                          HCL_Vector_d & x) const
{
   eval->PartialDerivInvImage( i,y,x );
}

void HCL_OpDefaultPartialDeriv_d::InvAdjImage(const HCL_Vector_d & x,
                                             HCL_Vector_d & y) const
{
   eval->PartialDerivInvAdjImage( i,x,y );
}

ostream & HCL_OpDefaultPartialDeriv_d::Write( ostream & str ) const
{
   str << "HCL_OpDefaultPartialDeriv_d (variable " << i
       << ") based on the following evaluation object" << endl;
   return eval->Write( str );
}

void HCL_OpDefaultSecondPartialDeriv_d::PartialAdjImage( int flag,
                                        const HCL_Vector_d & xy,
                                        const HCL_Vector_d & z,
                                              HCL_Vector_d & yx ) const
{
   eval->SecondPartialDerivPartialAdjImage( i,j,flag,xy,z,yx );
}

HCL_OpDefaultSecondPartialDeriv_d::HCL_OpDefaultSecondPartialDeriv_d()
{
   cerr << "Error: HCL_OpDefaultSecondPartialDeriv_d default constructor "
           "not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultSecondPartialDeriv_d::HCL_OpDefaultSecondPartialDeriv_d(
                             const HCL_OpDefaultSecondPartialDeriv_d & L )
{
   cerr << "Error: HCL_OpDefaultSecondPartialDeriv_d copy constructor "
           "not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultSecondPartialDeriv_d::HCL_OpDefaultSecondPartialDeriv_d( int ii,
                          int jj,const HCL_EvalOpProductDomain_d * ev )
{
   i = ii;
   j = jj;
   eval = ev;ev->IncCount();
}

HCL_OpDefaultSecondPartialDeriv_d::~HCL_OpDefaultSecondPartialDeriv_d()
{
   HCL_delete( (HCL_EvalOpProductDomain_d*)eval );
}

HCL_VectorSpace_d & HCL_OpDefaultSecondPartialDeriv_d::Domain1() const
{
   return eval->ProductDomain()(j);
}

HCL_VectorSpace_d & HCL_OpDefaultSecondPartialDeriv_d::Domain2() const
{
   return eval->ProductDomain()(i);
}

HCL_VectorSpace_d & HCL_OpDefaultSecondPartialDeriv_d::Range() const
{
   return eval->Range();
}

ostream & HCL_OpDefaultSecondPartialDeriv_d::Write( ostream & str ) const
{
   str << "HCL_OpDefaultSecondPartialDeriv_d (variables " << i << "," << j
       << ") based on the following evaluation object" << endl;
   return eval->Write( str );
}

