/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_BigMFcnl_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#ifndef HCL_BIGMFCNL_H_
#define HCL_BIGMFCNL_H_

#include "HCL_Functional_s.h"
#include "HCL_GenericProductVector_s.h"
#include "HCL_Rn_s.h"
#include "Table.h"

/** {\bf HCL\_BigMFcnlHessian\_s} implements the Hessian of the big-M
functional represented by {\bf HCL\_BigMFcnl\_s} as an object derived
from {\bf HCL\_LinearOp\_s}.  For more information, see the documentation
for {\bf HCL\_BigMFcnl\_s} and for the base class {\bf HCL\_LinearOp\_s}.
*/

class HCL_BigMFcnlHessian_s: public HCL_LinearOp_s
{
   private:
      HCL_GenericProductSpace_s * dom;
      HCL_LinearOp_s * A;
      float M,msum;
      HCL_Vector_s * Ate;
      HCL_Vector_s * temp;
      HCL_Vector_s * mask;
   public:

  // Default constructor---disabled.
      HCL_BigMFcnlHessian_s();
  // Copy constructor---disabled.
      HCL_BigMFcnlHessian_s( const HCL_BigMFcnlHessian_s & L );
  /** Usual constructor; takes a pointer to the domain, a pointer to the
      linear operator, the parameter $M$, and a "mask" vector (indicates
      which components of the residual are positive). */
      HCL_BigMFcnlHessian_s( HCL_GenericProductSpace_s * d,
                             HCL_LinearOp_s * AA,
                             float MM,HCL_Vector_s * msk );
  // destructor
      virtual ~HCL_BigMFcnlHessian_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is a {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const;
  /** Range space access. Returns a reference to the range of
      the operator, which is a {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;
  /// Image compute the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
  /** Debugging information.*/
      virtual ostream & Write( ostream & str ) const;
};


/** {\bf HCL\_EvalBigMFcnl\_s} is the "evaluation object" for the functional
class {\bf HCL\_BigMFcnl\_s}, which implements a "big-M" functional for the
problem of finding a vector $x$ satisfying $Ax-b+\epsilon\le 0$
(that is, the goal is to find a point $x$ strictly satisfying $Ax-b\le 0$).
The big-M functional is defined by

$f_{\epsilon,M}(x)=\frac{1}{2}\sum_{i=1}^m\max\{(Ax-b)_i-(\tau-\epsilon),0\}^2
                  +\frac{M}{2}\tau^2.$

For a general description of the methods of an evaluation class, see the
documentation for the base class {\bf HCL\_EvaluateFunctional}.  See also
the documentation for {\bf HCL\_BigMFcnl\_s}.
*/

class HCL_EvalBigMFcnl_s: public HCL_EvaluateFunctional_s
{
   private:
      HCL_Vector_s * x;
      float tau;
      HCL_GenericProductSpace_s * dom;
      HCL_LinearOp_s * A;
      float M,eps;

      HCL_Vector_s * res;
      HCL_Vector_s * mask;
   public:

   // Default constructor---disabled.
      HCL_EvalBigMFcnl_s();
   // Copy constructor---disabled.
      HCL_EvalBigMFcnl_s( const HCL_EvalBigMFcnl_s & );
   /** Usual constructor; takes (a reference to) the input vector, a pointer
       to the linear operator, a pointer to the right-hand side vector,
       and the parameters $M$ and $\epsilon$. */
      HCL_EvalBigMFcnl_s( const HCL_GenericProductVector_s & x,
                          HCL_LinearOp_s * AA,HCL_Vector_s * bb,
                          float M,float eps );

   // Destructor.
      virtual ~HCL_EvalBigMFcnl_s();

   /// {\bf Domain} returns a reference to the domain space.
      virtual HCL_VectorSpace_s & Domain() const;

   /// {\bf Value} computes the value of the functional.
      virtual float Value() const;
   /// {\bf Gradient} computes the gradient of the functional.
      virtual void Gradient( HCL_Vector_s & g ) const;
   /** {\bf Hessian} computes the Hessian of the functional.  Note that
       this method creates an instance of {\bf HCL\_LinearOp\_s}, which the
       calling routine must delete using {\bf HCL\_delete}. */
      virtual HCL_LinearOp_s * Hessian() const;
   /// {\bf Write} outputs a description of the object.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_BigMFcnl\_s} implements a "big-M" functional for the
problem of finding a vector $x$ satisfying $Ax-b+\epsilon\le 0$
(that is, the goal is to find a point $x$ strictly satisfying $Ax-b\le 0$).
The big-M functional is defined by

$f_{\epsilon,M}(x,\tau)=
     \frac{1}{2}\sum_{i=1}^m\max\{(Ax-b)_i-(\tau-\epsilon),0\}^2
                  +\frac{M}{2}\tau^2.$

Note that the domain (the space of $(x,\tau)$) is implemented as a product
space using {\bf HCL\_GenericProductSpace\_s}.

For a general description of the methods of a functional class, see the
documentation for the base class {\bf HCL\_Functional}.
*/

class HCL_BigMFcnl_s: public HCL_Functional_s
{
   private:
      HCL_GenericProductSpace_s * dom;
      HCL_LinearOp_s * A;
      HCL_Vector_s * b;
      float M,eps;

   public:  

   // Default constructor---disabled.
      HCL_BigMFcnl_s();
   // Copy constructor---disabled.
      HCL_BigMFcnl_s( const HCL_BigMFcnl_s & );
   /** Usual constructor; takes a pointer to the linear operator, a pointer
       to the right-hand side vector, the scalar $M$, and the scalar
       $\epsilon$. */
      HCL_BigMFcnl_s( HCL_LinearOp_s * AA,
                      HCL_Vector_s * bb,float MM,float eeps );
   // destructor
      virtual ~HCL_BigMFcnl_s();

   /** Domain space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_s} which forms the domain of the functional.*/
      virtual HCL_VectorSpace_s & Domain() const;

   /** {\bf Evaluate} creates an "evaluation" object, which knows how
       to compute the function value, gradient,and Hessian at the given x.*/
      virtual HCL_EvaluateFunctional_s * 
                  Evaluate( const HCL_Vector_s & x ) const;

   /** Debugging information.*/
      virtual ostream & Write( ostream & str ) const;
};

#endif
