/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_DiagFunctional_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#ifndef HCL_DIAGFUNCTIONAL_S_H_
#define HCL_DIAGFUNCTIONAL_S_H_

#include "HCL_ProductVector_s.h"
#include "HCL_LinearOp_s.h"
#include "HCL_FunctionalProductDomain_s.h"
#include "HCL_ScaleLinearOp_s.h"
#include "HCL_BlockOp_s.h"

/** {\bf HCL\_EvalDiagFcnl\_s} is the evaluation object for 
{\bf HCL\_DiagFunctional\_s}, which implements a separable function defined
on a product space.  This class is derived from
{\bf HCL\_EvalFunctionalProductDomain\_s}.

For more information, see the documentation for {\bf HCL\_DiagFunctional\_s}
and {\bf HCL\_EvalFunctionalProductDomain\_s}. */

class HCL_EvalDiagFcnl_s: public HCL_EvalFunctionalProductDomain_s
{
   private:
      int num;
      HCL_ProductSpace_s * dom;
      HCL_EvaluateFunctional_s ** evallist;
      HCL_ZeroLinearOp_s ** Zlist;
   public:

   // Default constructor---disabled.
      HCL_EvalDiagFcnl_s();
   // Copy constructor---disabled.
      HCL_EvalDiagFcnl_s( const HCL_EvalDiagFcnl_s & );
   /** The constructor requires a vector \TEX{$x$} in the domain of the
       functional, as well as the list of functionals defining the sum.
       Note that the constructor makes an independent copy of the input
       vector. */
      HCL_EvalDiagFcnl_s( HCL_ProductVector_s & x,
                          HCL_Functional_s ** flist );
   // Destructor.
      virtual ~HCL_EvalDiagFcnl_s();

   /// Domain returns a reference to the domain of the underlying function.
      HCL_VectorSpace_s & Domain() const { return *dom; }

   /// Value computes the value of the function.
      virtual float Value() const;
   /// PartialGradient computes the gradient of the function.
      virtual void PartialGradient( int i,HCL_Vector_s & g ) const;
   /// Hessian computes the Hessian of the function.
      virtual HCL_LinearOp_s * Hessian() const;
   /** HessianRef computes the Hessian of the function and returns
       a reference to it.  This causes the Evaluation object to manage
       the storage. */
      virtual const HCL_LinearOp_s & HessianRef() const;
   /// HessianBlock computes a block of the Hessian operator of the function.
      virtual HCL_LinearOp_s * HessianBlock( int i,int j ) const;
   /** {\bf HessianBlockRef} returns a reference to the (i,j) block of
       the Hessian. */
      virtual const HCL_LinearOp_s & HessianBlockRef( int i,int j ) const;

   /** {\bf Write} invokes the {\bf Write} methods of the evaluation objects
       of the terms in the sum. */
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_DiagFunctional\_s} implements a separable function defined on a
product space, that is, a function 
\TEX{$f:X\rightarrow {\bf{\rm R}},\ X=X_1\times X_2 \times ... \times X_n$},
of the form \TEX{$f(x)=f_1(x_1)+f_2(x_2)+...+f_n(x_n)$}.
The terms in the sum must be represented by instances of
{\bf HCL\_Functional\_s}; this class then puts the terms together to form
a single, separable, function.  The domain of the functional must be
represented by an instance of {\bf HCL\_ProductSpace\_s}.

For more information about functionals defined on product spaces, see
the documentation for {\bf HCL\_FunctionalProductDomain\_s}. */

class HCL_DiagFunctional_s: public HCL_FunctionalProductDomain_s
{
   private:
      int num;
      HCL_ProductSpace_s * dom;
      HCL_Functional_s ** flist;

   public:

   // Default constructor---disabled.
      HCL_DiagFunctional_s();
   // Copy constructor---disabled.
      HCL_DiagFunctional_s( const HCL_DiagFunctional_s & F );
   /** The constructor requires (a pointer to) the functional's domain,
       which must be a product space.  The terms defining the functional,
       which are functionals defined on the factors of the domain, must
       be specified using the {\bf SetNext} method. */
      HCL_DiagFunctional_s( HCL_ProductSpace_s * d );
   /// Destructor
      virtual ~HCL_DiagFunctional_s();

   /** Domain space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_s} which forms the domain of the functional.
       Note that, in the current design, the domain of a functional
       must be an entire vector space, although many nonlinear functionals
       are only defined on an open subset of a vector space.  This is
       a flaw in the design of HCL which may be corrected in some future
       version of the software.  A partial work-around to this problem
       is provided by the {\bf MaxStep} method. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
    /** {\bf MaxStep} computes the longest vector from x in the direction dir
	that will lie in the domain of definition of the functional, i.e.
        it computes the greatest a such that x + a*dir lies in the domain.
        By default (i.e. unless this virtual function is implemented
        in a derived class), the domain is assumed to be the whole space,
        and MaxStep return the largest floating point number.  This method
        is used in some of the optimization algorithms and provides a partial
        solution to the problem that many functionals are not defined on an
        entire vector space, but rather only on a subset. */
      virtual float MaxStep( const HCL_Vector_s & x, 
                              const HCL_Vector_s &dir) const;

   /** {\bf Initialized} is a boolean method indicating whether the terms
       in the sum have all been set.  The method returns 1 if the terms
       have all been set and 0 otherwise. */
      int Initialized() const;

   /** Access to components.  If {\bf f} is an instance of
       {\bf HCL\_DiagFunctional\_s}, then {\bf f(i)} returns a reference to
       the {\bf HCL\_Functional\_s} representing the ith term in the sum. */
      virtual HCL_Functional_s & operator()( int i ) const;
   /// Number of terms in the sum.
      virtual int Number() const { return num; }

   /** {\bf Evaluate} creates an "evaluation" object, which knows how to
       compute the function value, gradient, and Hessian at the given x. */
      virtual HCL_EvaluateFunctional_s * 
                          Evaluate( const HCL_Vector_s & x ) const;

   /** {\bf SetNext} allows the user to specify the next term in the
       sum defining the funcional.  If the functional has n terms, then
       {\bf SetNext} must be called n times before the functional can be
       used.  The terms must be set in the order they appear in the
       {\bf HCL\_ProductSpace\_s} defining the domain. */
      void SetNext( HCL_Functional_s * f );

   /// {\bf Write} invokes the {\bf Write} method for the terms in the sum.
      virtual ostream & Write( ostream & str ) const;
};

#endif
