/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_FunctionalProductDomain_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#ifndef HCL_FUNCTIONALPRODUCTDOMAIN_S_H_
#define HCL_FUNCTIONALPRODUCTDOMAIN_S_H_

#include "HCL_Functional_s.h"
#include "HCL_ProductVector_s.h"
#include "HCL_BlockOp_s.h"

class HCL_FunctionalDefaultHessianBlock_s;

/** {\bf HCL\_EvalFunctionalProductDomain\_s} is the evaluation object for
   the {\bf HCL\_FunctionalProductDomain\_s} class.  For details, see
   the documentation for {\bf HCL\_EvaluateFunctional\_s} and
   {\bf HCL\_FunctionalProductDomain\_s}. */

class HCL_EvalFunctionalProductDomain_s: public HCL_EvaluateFunctional_s
{
   friend class HCL_FunctionalDefaultHessianBlock_s;
   protected:

   /** {\bf HessianBlockImage} computes the image of the (i,j) block of the
       Hessian on derivative on dxi, giving dxj.  If this method is
       implemented, then the default {\bf HessianBlock}
       method can be used; the block of the Hessian will then be an instance of
       {\bf HCL\_FunctionalDefaultHessianBlock\_s}. */
      virtual void HessianBlockImage( int i,int j,const HCL_Vector_s & dxj,
                                                  HCL_Vector_s & dxi ) const;

      int * PartialGradFlags;
   public:

   // Default constructor.
      HCL_EvalFunctionalProductDomain_s();
   // Copy constructor.
      HCL_EvalFunctionalProductDomain_s(
                        const HCL_EvalFunctionalProductDomain_s & );
   // Destructor.
      virtual ~HCL_EvalFunctionalProductDomain_s();

   /** {\bf Domain} returns a reference to the domain of the underlying
       function. */
      virtual HCL_VectorSpace_s & Domain() const = 0;
   /** {\bf ProductDomain} returns a reference to the domain of the
       underlying function, as an instance of {\bf HCL\_ProductSpace\_s}.
       This method is implemented using {\bf Domain}, and need not be
       re-implemented in a derived class. */
      virtual HCL_ProductSpace_s & ProductDomain() const;

   /** {\bf Value} computes the value of the function.  This function must be
       implemented in each concrete derived class.  It is recommended
       that any calculations that are required for both the value and
       derivatives be done in the constructor; {\bf Value} should then
       complete the computation of the functional value. */
      virtual float Value() const = 0;
   /** {\bf Gradient} computes the gradient of the function. This method is
       implemented in this (the base) class, using {\bf PartialGradient},
       and need not be re-implemented in a derived class. */
      virtual void Gradient( HCL_Vector_s & g ) const;
   /** {\bf GradientRef} computes the gradient of the function and returns
       a reference to it.  This causes the Evaluation object to manage
       the storage. */
      virtual const HCL_Vector_s & GradientRef() const;
   /** {\bf PartialGradient} computes the component of the gradient
       corresponding to the ith component of the independent variable.
       This is a virtual function and must be implemented in any derived
       class. */
      virtual void PartialGradient( int i,HCL_Vector_s & g ) const = 0;
   /** {\bf PartialGradientRef} returns a reference to the component of the
       gradient corresponding to the ith component of the independent
       variable.  This relieves the calling program of the responsibility
       of managing the storage of the gradient.  This method is implemented
       in this (the base) class, and need not be re-implemented in derived
       classes. */
      virtual const HCL_Vector_s & PartialGradientRef( int i ) const;
   /** {\bf Hessian} computes the Hessian of the function. This method is
       implemented in this (the base) class, using {\bf HessianBlock},
       and need not be re-implemented in a derived class. */
      virtual HCL_LinearOp_s * Hessian() const;
   /** {\bf HessianBlock} creates the (i,j) block of the Hessian, as a
       linear operator with adjoint.  The default implementation of this
       method creates an instance of {\tt HCL\_FunctionalDefaultHessianBlock};
       this assumes that the protected method {\tt HessianBlockImage} has
       been implemented.  If it is desired to implement the blocks of the
       Hessian using other HCL or user-defined classes, then this method
       must be re-implemented in the derived class. */
      virtual HCL_LinearOp_s * HessianBlock( int i,int j ) const;

   /** {\bf HessianRef} computes the Hessian of the function and returns
       a reference to it.  This causes the Evaluation object to manage
       the storage. */
      virtual const HCL_LinearOp_s & HessianRef() const;
   /** {\bf HessianBlockRef} returns a reference to the (i,j) block of
       the Hessian.  This method is implemented in this (the base) class,
       and need not be re-implemented in derived classes. */
      virtual const HCL_LinearOp_s & HessianBlockRef( int i,int j ) const;

   /** Debugging information. {\bf Write} must be implemented in derived
       classes, and should print a description of the object that will
       be useful for debugging. */
      virtual ostream & Write( ostream & str ) const = 0;
};

// Look-ahead declaration.
class HCL_FunctionalProductDomainDefaultEval_s;

/** {\bf HCL\_FunctionalProductDomain\_s} is an abstract base class used
to represents functionals defined on product spaces. That is, this class
represents a functional of the form
\TEX{$$
f:X\rightarrow {\bf{\rm R}}
$$}
where
\TEX{$$
X=X_1\times X_2\times\cdots X_n.
$$}
The gradient and Hessian of such a function can be expressed in terms
of partial derivatives; Therefore, the basic methods of this class
are {\bf Value}, {\bf PartialGradient}, and {\bf HessianBlock}.
{\bf Value1} computes $f(x)$, {\bf PartialGradient} computes the gradient
of $f$ with respect to one of the components of $x$, and {\bf HessianBlock}
computes a block of the Hessian corresponding to one of the second
partial derivatives of $f$.  To be precise, the $i$ partial gradient of
$f$ is defined by
       $D_{x_i}f(x)\delta x_i=(\nabla_{x_i}f(x),\delta x_i),$
where $D_{x_i}f(x)$ is the partial derivative of $f$ with respect to the
$i$th component of $x$.  Similarly,
       $D_{x_ix_j}^2f(x)\delta x_j\delta x_i=
            (\nabla_{x_ix_j}^2f(x)\delta x_j,\delta x_i)$
defines the $ij$ block of the Hessian.

{\bf HCL\_FunctionalProductDomain\_s} is derived from {\bf HCL\_Functional\_s}.
As in the case of an ordinary functional represented by a class derived from
{\bf HCL\_Functional\_s}, an evaluation class is defined to represent the
triple $(f(x),\nabla f(x),\nabla^2f(x))$.  The documentation for
{\bf HCL\_Functional\_s}, as well as the report
    "Implementing functionals in HCL", Technical Report 99-24,
    Department of Computational and Applied Mathematics, Rice University,
    PO Box 1892, Houston, TX 77251-1892.
should be consulted for general information about functionals, including the
rationale for the existence of the evaluation class.  The implementor of a
derived class need not implement a separate class to represent the evaluation
object if there is no efficiency gain in doing so.  By implementing the
protected virtual functions {\bf Value1}, {\bf PartialGradient1}, and
{\bf HessianBlock1} or {\bf HessianBlockImage}, the use of the default
evaluation class {\bf HCL\_FunctionalProductDomainDefaultEval\_s} is
enabled.

A forthcoming report, "Implementing HCL functionals and operators on product
spaces", will explain in detail the different models for implementing
derived classes.  This report should be available in early 2000 from
the Rice University address given above. */

class HCL_FunctionalProductDomain_s: public HCL_Functional_s
{
   friend class HCL_FunctionalProductDomainDefaultEval_s;

   protected:

      /** {\bf Value1} computes the value of $f$ at $x$.
          If {\bf Value1}, {\bf PartialGradient1}, and {\bf HessianBlock1}
          or {\bf HessianBlockImage} are implemented, then the default
          implementation of the {\bf Evaluate} method can be used.  This
          creates an instance of
              {\bf HCL\_FunctionProductDomainDefaultEval\_s}. */
      virtual float Value1( const HCL_Vector_s & x ) const;
      /** {\bf PartialGradient1} computes the gradient of $f$ at $x$ with
          respect to the $i$th component of $x$. If {\bf Value1},
          {\bf PartialGradient1}, and {\bf HessianBlock1} or
          {\bf HessianBlockImage} are implemented, then the default
          implementation of the {\bf Evaluate} method can be used.  This
          creates an instance of
              {\bf HCL\_FunctionProductDomainDefaultEval\_s}. */
      virtual void PartialGradient1( int i,const HCL_Vector_s & x,
                                           HCL_Vector_s & y ) const;
      /** {\bf HessianBlock1} computes the $(i,j)$ block of the Hessian of
          $f$ at $x$.  If {\bf Value1}, {\bf PartialGradient1}, and
          {\bf HessianBlock1} or {\bf HessianBlockImage} are implemented,
          then the default implementation of the {\bf Evaluate} method can be
          used.  This creates an instance of
              {\bf HCL\_FunctionProductDomainDefaultEval\_s}. */
      virtual HCL_LinearOp_s * HessianBlock1( int i,int j,
                                              const HCL_Vector_s & x ) const;
      /** {\bf HessianBlockImage} computes the image of the $(i,j)$ block of
          the Hessian of $f$ at $x$, acting on $\delta x$.  If {\bf Value1},
          {\bf PartialGradient1}, and {\bf HessianBlock1} or
          {\bf HessianBlockImage} are implemented, then the default
          implementation of the {\bf Evaluate} method can be
          used.  This creates an instance of
              {\bf HCL\_FunctionProductDomainDefaultEval\_s}. */
      virtual void HessianBlockImage( int i,int j,const HCL_Vector_s & x,
                                      const HCL_Vector_s & dx,
                                            HCL_Vector_s & dy ) const;

   public:  

   // Default constructor.
      HCL_FunctionalProductDomain_s();
   // Copy constructor.
      HCL_FunctionalProductDomain_s(
                    const HCL_FunctionalProductDomain_s & );
   // Destructor.
      virtual ~HCL_FunctionalProductDomain_s();

   /** Domain space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_s} which forms the domain of the functional. */
      virtual HCL_VectorSpace_s & Domain() const = 0;
   /** Access to the domain, explicitly as a product vector space. This
       method is implemented using {\bf Domain}, and need not be
       re-implemented in a derived class. */
      virtual HCL_ProductSpace_s & ProductDomain() const;

   /** {\bf Evaluate} creates an "evaluation" object, which knows how
       to compute the function value, gradient,and Hessian at the given x.
       The purpose of using {\bf Evaluate} rather than {\bf Value},
       {\bf Gradient}, and {\bf Hessian}, is for efficiency; many
       functionals are such that the evaluation of the functional and its
       derivatives require common intermediate calculations.
       The evaluation object mechanism gives the functional class
       implementor a place to store these intermediate results so that
       they do not have to be re-computed if the the gradient is requested
       at some point after the value, for example.  The implementor of
       an optimization algorithm should respect this by using
       {\bf Evaluate} to get a value, gradient, and/or Hessian rather
       than using {\bf Value}, {\bf Gradient}, and/or {\bf Hessian}.  Note
       as explained in the class documentation, if there is no advantage
       in having an evaluation object, then the implementor can simply
       not override {\bf Evaluate} in the derived class, in which case
       the default implementation will create an instance of
       {\bf HCL\_FunctionalProductDomainDefaultEval}.  In this case, the
       implementor must override the virtual protected methods {\bf Value1},
       {\bf PartialGradient1}, and either {\bf HessianBlock1} or
       {\bf HessianBlockImage}. */
      virtual HCL_EvaluateFunctional_s * 
                  Evaluate( const HCL_Vector_s & x ) const;

   /** {\bf PartialGradient} computes the gradient with respect to the
       ith component of the independent variable, at x.  It does so by
       creating an evaluation object with the {\bf Evaluate} method,
       getting the partial gradient from it, and deleting the evaluation
       object. {\bf PartialGradient} is defined in this (the base) class, so
       it need not be redefined in a derived class. */
      virtual void PartialGradient( int i,const HCL_Vector_s & x,
                                                HCL_Vector_s & g ) const;
   /** {\bf HessianBlock} computes the (i,j) block of the Hessian operator.
       It does so by creating an evaluation object with the {\bf Evaluate}
       method, getting the partial gradient from it, and deleting the
       evaluation object. {\bf HessianBlock} is defined in this (the base)
       class, so it need not be redefined in a derived class. */
      virtual HCL_LinearOp_s * HessianBlock( int i,int j,
                                             const HCL_Vector_s & x ) const;

   /** Check correctness of Hessian blocks.  This method computes the
       relative difference between the second directional derivative as
       computed from the analytic Hessian block and the same estimated by
       a central difference formula. This is done at n equally-spaced points
       on the line segment [x+hmin*y,x+hmax*y].  The parameters hmin, hmax,d
       and n are optional and default to 0.1, 1.0, and 10, respectively.
       If the Hessian block  is correctly implemented and the function
       is sufficiently smooth, then these errors will lie on a parabola when
       plotted against the step size. The results are sent to the output
       stream str. */
      int CheckHessianBlock( const HCL_Vector_s &,const HCL_Vector_s &,
                             const HCL_Vector_s &, int i,int j,
                             ostream & str,int n=10,float hmin=0.1,
                             float hmax=1.0 ) const;
   /** This version of {\bf CheckHessianBlock} checks the ``pure'' (not mixed)
       second partial derivative using the usual central difference formula. */
      int CheckHessianBlock( const HCL_Vector_s &,const HCL_Vector_s &,
                             int ind,ostream & str,int n=10,float hmin=0.1,
                             float hmax=1.0 ) const;
   /** {\bf CheckHessianBlockAdj} calls {\bf CheckHessianBlock} to test the
       correctness of the (i,j) block of the Hessian, and then calls
       the {\bf HCL\_LinearOp\_s} method {\bf CheckAdj} to test the correctness
       of the adjoint of the block. */
      int CheckHessianBlockAdj( const HCL_Vector_s &,const HCL_Vector_s &,
                             const HCL_Vector_s &, int i,int j,
                             ostream & str,int n=10,float hmin=0.1,
                             float hmax=1.0 ) const;
   /** Debugging information.  {\bf Write} must be implemented in derived
       classes, and should print a description of the object that will
       be useful for debugging. */
      virtual ostream & Write( ostream & str ) const = 0;
};

/** The purpose of the class {\bf HCL\_FunctionalProductDomainDefaultEval} is
to relieve the implementor of a derived functional class from the necessity
of also defining a derived evaluation class if there is no need to do so.
The purpose of the evaluation class is to represent the triple
$(f(x),\nabla f(x),\nabla^2 f(x))$.  If the implementor of the
derived functional class has overridden the protected methods
{\bf Value1}, {\bf PartialGradient1}, and either {\bf HessianBlock1} or
{\bf HessianBlockImage}, then this default evaluation
class can call those methods to compute the value, gradient, or
Hessian of the functional.  To make this possible, the constructor of
{\bf HCL\_FunctionalProductDomainDefaultEval} saves a copy of {\bf x} and
a pointer to the functional class.

See the documentation for {\bf HCL\_EvaluateFunctional} for more information
about evaluation objects for functionals. */

class HCL_FunctionalProductDomainDefaultEval_s:
                    public HCL_EvalFunctionalProductDomain_s
{
   private:
      HCL_Vector_s * x;
      const HCL_FunctionalProductDomain_s * f;
   protected:

   /** {\bf HessianBlockImage} computes the image of the (i,j) block of
       the Hessian on dxj, yielding dxi.  This method calls the corresponding
       method from the underlying functional class. */
      virtual void HessianBlockImage( int i,int j,const HCL_Vector_s & dxj,
                                                  HCL_Vector_s & dxi ) const
      {
         f->HessianBlockImage( i,j,*x,dxj,dxi );
      }

   public:

   // Default constructor---disabled.
      HCL_FunctionalProductDomainDefaultEval_s();
   // Copy constructor---disabled.
      HCL_FunctionalProductDomainDefaultEval_s(
          const HCL_FunctionalProductDomainDefaultEval_s & );
   /** Usual constructor; requires a pointer to a functional and a reference
       to the input vector. */
      HCL_FunctionalProductDomainDefaultEval_s(
          const HCL_FunctionalProductDomain_s * ff,
          const HCL_Vector_s & in );
   // Destructor
      virtual ~HCL_FunctionalProductDomainDefaultEval_s();

   /** {\bf Domain} returns a reference to the domain of the underlying
       functional. */
      virtual HCL_VectorSpace_s & Domain() const { return f->Domain(); }

   /// {\bf Value} computes the value of the functional at x.
      virtual float Value() const;
   /** {\bf PartialGradient} computes the component of the gradient
       corresponding to the ith component of the independent variable. */
      virtual void PartialGradient( int i,HCL_Vector_s & g ) const;
   /** {\bf HessianBlock} creates the (i,j) block of the Hessian, as a
       linear operator with adjoint.  This method checks to see if
       the functional class has implemented {\bf HessianBlock1} to compute
       this block; otherwise, an instance of
       {\bf HCL\_FunctionalDefaultHessianBlock\_s} is created, which assumes
       that {\bf HessianBlockImage} has been implemented in the functional
       class. */
      virtual HCL_LinearOp_s * HessianBlock( int i,int j ) const;
 
   /** Debugging information. {\bf Write} must be implemented in derived
       classes, and should print a description of the object that will
       be useful for debugging. */
      virtual ostream & Write( ostream & str ) const;
};

/** The purpose of the class {\bf HCL\_FunctionalDefaultHessianBlock} is to
relieve the implementor of a derived functional class from the necessity of
also defining a class to represent blocks of the Hessian if there is no
existing HCL class that can be used for this purpose.  The implementor need
only, in either the derived functional class or the corresponding derived
evaluation class, implement the methods {\bf HessianBlockImage}.
The constructor of {\bf HCL\_FunctionalDefaultHessianBlock}
saves a pointer to the evaluation class, and refers calls to {\bf Image}
back to {\bf HessianBlockImage}. (Note that a Hessian is symmetric, so calls
to the adjoint methods can be handled automatically.) */

class HCL_FunctionalDefaultHessianBlock_s: public HCL_LinearOp_s
{
   private:
       const HCL_EvalFunctionalProductDomain_s * eval;
       int i,j;
   public:  

  // Default constructor---disabled.
      HCL_FunctionalDefaultHessianBlock_s();
  // Copy constructor---disabled.
      HCL_FunctionalDefaultHessianBlock_s(
                    const HCL_FunctionalDefaultHessianBlock_s & L );
  /** Usual constructor; just needs a functional's evaluation object. */
      HCL_FunctionalDefaultHessianBlock_s( int i,int j,
                    const HCL_EvalFunctionalProductDomain_s * ev );
  // Destructor.
      virtual ~HCL_FunctionalDefaultHessianBlock_s();

  /** Domain space access. Returns a reference to the domain of
      the functional, which is a {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const;
  /** Range space access. Returns a reference to the range of
      the functional, which is a {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;
  /// {\bf Image} compute the action of the functional on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /** {\bf InvImage} computes the action of the inverse on y, giving x.
       It is implemented as an error in this class. */
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y.  It is implemented as an error in this class. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /** Debugging information.  {\bf Write} must be implemented in derived
       classes, and should print a description of the object that will
       be useful for debugging. */
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_EvalRestrictedFunctional\_s} is the evaluation class for
    {\bf HCL\_RestrictedFunctional\_s}, which is the concrete class
    which turns a functional defined on a product space into an ordinary
    functional by fixing all but one of the components.  That is, given an
    instance of {\bf HCL\_FunctionalProductDomain\_s} representing
           $f:X_1\times X_2\times\cdots X_n\rightarrow {\bf {\rm R}}$,
    the class {\bf HCL\_RestrictedFunctional\_s} implements
           $g:X_i\rightarrow {\bf {\rm R}}$
    defined by
           $g(x_i)=f(x_1,\ldots,x_i\ldots,x_n$,
    where $x_1,\ldots,x_{i-1},x_{i+1},\ldots,x_n$ are fixed.

    See the documentation for {\bf HCL\_EvaluateFunctional\_s} and
    {\bf HCL\_RestrictedFunctional\_s} for more information.   */

class HCL_EvalRestrictedFunctional_s: public HCL_EvaluateFunctional_s
{
   protected:
      HCL_EvalFunctionalProductDomain_s * eval;
      int i;
   public:

   // Default constructor---disabled.
      HCL_EvalRestrictedFunctional_s();
   // Copy constructor---disabled.
      HCL_EvalRestrictedFunctional_s(
              const HCL_EvalRestrictedFunctional_s & );
   /** Usual constructor; just needs the evaluation object from the
       underlying evaluation object and the index of the free component
       of the independent variable. */
      HCL_EvalRestrictedFunctional_s( int i,
                        HCL_EvalFunctionalProductDomain_s * ev );
   // Destructor.
      virtual ~HCL_EvalRestrictedFunctional_s();

   /** {\bf Domain} returns a reference to the domain of the underlying
       function. */
      virtual HCL_VectorSpace_s & Domain() const;

   /** Access to the evaluation object of the underlying function
       defined on a product space. */
      HCL_EvalFunctionalProductDomain_s & UnrestrictedEval();

   /** {\bf Value} computes the value of the function. */
      virtual float Value() const;
   /** {\bf Gradient} computes the gradient of the function.  */
      virtual void Gradient( HCL_Vector_s & g ) const;
   /** {\bf Hessian} creates the Hessian operator. */
      virtual HCL_LinearOp_s * Hessian() const;

   /** Debugging information. {\bf Write} must be implemented in derived
       classes, and should print a description of the object that will
       be useful for debugging. */
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_RestrictedFunctional\_s} is a concrete class which
    creates a new functional from a functional defined
    on a product space, by fixing all but one of the components of the
    independent variable.  That is, given an instance of
    {\bf HCL\_FunctionalProductDomain\_s} representing
           $f:X_1\times X_2\times\cdots X_n\rightarrow {\bf {\rm R}}$,
    the class {\bf HCL\_RestrictedFunctional\_s} implements
           $g:X_i\rightarrow {\bf {\rm R}}$
    defined by
           $g(x_i)=f(x_1,\ldots,x_i\ldots,x_n$,
    where $x_1,\ldots,x_{i-1},x_{i+1},\ldots,x_n$ are fixed.

    See the documentation of {\bf HCL\_Functional\_s} and
    {\bf HCL\_FunctionalProductDomain\_s} for more information. */

class HCL_RestrictedFunctional_s: public HCL_Functional_s
{
   private:
      HCL_FunctionalProductDomain_s * f;
      HCL_ProductVector_s * y;
      int i;
   public:

   // Default constructor---disabled.
      HCL_RestrictedFunctional_s();
   // Copy constructor---disabled.
      HCL_RestrictedFunctional_s( const HCL_RestrictedFunctional_s & );
   /** Usual constructor; just needs the underlying functional (defined on
       a product space) and the index of the free component of the
       independent variable. (Creates a copy of the vector.) */
      HCL_RestrictedFunctional_s( HCL_FunctionalProductDomain_s * ff,
                                  const HCL_ProductVector_s & x,int i );
   /** Usual constructor; just needs the underlying functional (defined on
       a product space) and the index of the free component of the
       independent variable. (Copies the pointer to the vector.) 
       Note that the ith component of x will be changed when the
       functional is evaluated. */
      HCL_RestrictedFunctional_s( HCL_FunctionalProductDomain_s * ff,
                                  HCL_ProductVector_s * x,int i );
   // Destructor.
      virtual ~HCL_RestrictedFunctional_s();

   /** Domain space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_s} which forms the domain of the functional. */
      virtual HCL_VectorSpace_s & Domain() const;

   /** {\bf Evaluate} creates an "evaluation" object, which knows how
       to compute the function value, gradient and Hessian at the given x. */
      virtual HCL_EvaluateFunctional_s * 
                  Evaluate( const HCL_Vector_s & x ) const;

   /** Debugging information.  {\bf Write} must be implemented in derived
       classes, and should print a description of the object that will
       be useful for debugging. */
      virtual ostream & Write( ostream & str ) const;
};

#endif

