/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_MatrixOps_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#ifndef HCL_MATRIXOPS_S_H_
#define HCL_MATRIXOPS_S_H_

#include "HCL_LinearOp_s.h"
#include "mat_inc_s.H"

// Look-ahead declaration.
class HCL_UpperTriangularMatOp_s;

/** {\bf HCL\_SymMatOp\_s} makes a symmetric matrix into a linear operator
in the HCL sense.  Note that the matrix is an instance of the class
{\bf GenSymMatrix_s}, and it must be provided to the constructor.

The methods of this class are the methods of the base class
{\bf HCL\_LinearOp\_s}, and the documentation for the base class can be
consulted for more information. */

class HCL_SymMatOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
      int DeleteMat;
   public:

   /** {\bf Matrix} is a pointer to the underlying {\bf GenSymMatrix_s},
       which is the matrix representing the linear operator.  The matrix
       is public so that its methods are available.  For instance,
       a {\bf GenSymMatrix_s} knows how to compute its eigenvalues and
       eigenvectors through the method {\bf eig}. */
      GenSymMatrix_s * Matrix;

   // Default constructor---disabled.
      HCL_SymMatOp_s();
   // Copy constructor---disabled.
      HCL_SymMatOp_s( const HCL_SymMatOp_s & );
   /** Usual constructor; requires the matrix and the domain. (The range
       is assumed to equal the domain.)  Also, a flag must be passed to
       indicate whether the matrix is to be deleted upon destruction of
       the operator (nonzero = delete, zero = no delete). */
      HCL_SymMatOp_s( GenSymMatrix_s * AA,int flag,HCL_VectorSpace_s * d );
   /** Usual constructor; requires the matrix, the domain, and the range.
       Note that the dimensions of the domain and range must agree.
       Also, a flag must be passed to indicate whether the matrix is to be
       deleted upon destruction of the operator (nonzero = delete,
       zero = no delete). */
      HCL_SymMatOp_s( GenSymMatrix_s * AA,int flag,HCL_VectorSpace_s * d,
                      HCL_VectorSpace_s * r );
   // Destructor.
      ~HCL_SymMatOp_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *range; }
  /// {\bf Image} computes the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /// {\bf InvImage} computes the action of the inverse on y, giving x.
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;

   /** {\bf Cholesky} creates the linear operator which is 
       represented by the (upper triangular) Cholesky factor of the
       underlying matrix.  The return value is NULL if the matrix
       is not positive definite and therefore does not have
       a Cholesky factorization. */
      HCL_UpperTriangularMatOp_s * Cholesky() const;
   /// Debugging information.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_GeneralMatOp\_s} makes a matrix into a linear operator
in the HCL sense.  Note that the matrix is an instance of the class
{\bf GeneralMatrix_s}, and it must be provided to the constructor.

The methods of this class are the methods of the base class
{\bf HCL\_LinearOp\_s}, and the documentation for the base class can be
consulted for more information. */

class HCL_GeneralMatOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
      int DeleteMat;
   public:


   /** {\bf Matrix} is a pointer to the underlying {\bf GeneralMatrix_s},
       which is the matrix representing the linear operator.  The matrix
       is public so that its methods are available. */
      GeneralMatrix_s * Matrix;

   // Default constructor---disabled.
      HCL_GeneralMatOp_s();
   // Copy constructor---disabled.
      HCL_GeneralMatOp_s( const HCL_GeneralMatOp_s & );
   /** Usual constructor; requires the matrix, the domain, and the range.
       Also, a flag must be passed to indicate whether the matrix is to be
       deleted upon destruction of the operator (nonzero = delete,
       zero = no delete). */
      HCL_GeneralMatOp_s( GeneralMatrix_s * AA,int flag,HCL_VectorSpace_s * d,
                          HCL_VectorSpace_s * r );
   // Destructor.
      ~HCL_GeneralMatOp_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *range; }
  /// {\bf Image} computes the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /** {\bf InvImage} computes the action of the inverse on y, giving x.
       This method will return an error if the matrix is not square. */
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y.  This method will return an error if the matrix is not
       square. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /// Debugging information.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_SymSparseRCSMatOp\_s} makes a sparse symmetric matrix into a
linear operator in the HCL sense.  Note that the matrix is an instance of
the class {\bf SymSparseRCSMatrix_s}, which implements a sparse matrix
in Row Compressed Storage, and it must be provided to the constructor.

The methods of this class are the methods of the base class
{\bf HCL\_LinearOp\_s}, and the documentation for the base class can be
consulted for more information. */

class HCL_SymSparseRCSMatOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
      int DeleteMat;
   public:

   /** {\bf Matrix} is a pointer to the underlying {\bf SymSparseRCSMatrix_s},
       which is the matrix representing the linear operator.  The matrix
       is public so that its methods are available. */
      SymSparseRCSMatrix_s * Matrix;

   // Default constructor---disabled.
      HCL_SymSparseRCSMatOp_s();
   // Copy constructor---disabled.
      HCL_SymSparseRCSMatOp_s( const HCL_SymSparseRCSMatOp_s & );
   /** Usual constructor; requires the matrix and the domain. (The range
       is assumed to equal the domain.)  Also, a flag must be passed to
       indicate whether the matrix is to be deleted upon destruction of
       the operator (nonzero = delete, zero = no delete). */
      HCL_SymSparseRCSMatOp_s( SymSparseRCSMatrix_s * AA,int flag,
                               HCL_VectorSpace_s * d );
   /** Usual constructor; requires the matrix, the domain, and the range.
       Note that the dimensions of the domain and range must agree.
       Also, a flag must be passed to indicate whether the matrix is to be
       deleted upon destruction of the operator (nonzero = delete,
       zero = no delete). */
      HCL_SymSparseRCSMatOp_s( SymSparseRCSMatrix_s * AA,int flag,
                               HCL_VectorSpace_s * d,
                               HCL_VectorSpace_s * r );
   // Destructor.
      ~HCL_SymSparseRCSMatOp_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *range; }
  /// {\bf Image} computes the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /// {\bf InvImage} computes the action of the inverse on y, giving x.
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /// Debugging information.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_SparseRCSMatOp\_s} makes a sparse matrix into a linear operator
in the HCL sense.  Note that the matrix is an instance of the class
{\bf SparseRCSMatrix_s}, and it must be provided to the constructor.

The methods of this class are the methods of the base class
{\bf HCL\_LinearOp\_s}, and the documentation for the base class can be
consulted for more information. */

class HCL_SparseRCSMatOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
      int DeleteMat;
   public:

   /** {\bf Matrix} is a pointer to the underlying {\bf SparseRCSMatrix_s},
       which is the matrix representing the linear operator.  The matrix
       is public so that its methods are available. */
      SparseRCSMatrix_s * Matrix;

   // Default constructor---disabled.
      HCL_SparseRCSMatOp_s();
   // Copy constructor---disabled.
      HCL_SparseRCSMatOp_s( const HCL_SparseRCSMatOp_s & );
   /** Usual constructor; requires the matrix, the domain, and the range.
       Also, a flag must be passed to indicate whether the matrix is to be
       deleted upon destruction of the operator (nonzero = delete,
       zero = no delete). */
      HCL_SparseRCSMatOp_s( SparseRCSMatrix_s * AA,int flag,
                               HCL_VectorSpace_s * d,
                               HCL_VectorSpace_s * r );
   // Destructor.
      ~HCL_SparseRCSMatOp_s();

   /** Domain space access. Returns a reference to the domain of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
   /** Range space access. Returns a reference to the range of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *range; }
   /// {\bf Image} computes the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /** {\bf InvImage} computes the action of the inverse on y, giving x.
       This method will return an error if the matrix is not square. */
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y.  This method will return an error if the matrix is not
       square. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /// Debugging information.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_UpperTriangularMatOp\_s} makes an upper triangular matrix into a
linear operator in the HCL sense.  Note that the matrix is an instance of the
class {\bf UpperTriangle_s}, and it must be provided to the constructor.

The methods of this class are the methods of the base class
{\bf HCL\_LinearOp\_s}, and the documentation for the base class can be
consulted for more information. */

class HCL_UpperTriangularMatOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
      int DeleteMat;
   public:


   /** {\bf Matrix} is a pointer to the underlying {\bf UpperTriangle_s},
       which is the matrix representing the linear operator.  The matrix
       is public so that its methods are available. */
      UpperTriangle_s * Matrix;

   // Default constructor---disabled.
      HCL_UpperTriangularMatOp_s();
   // Copy constructor---disabled.
      HCL_UpperTriangularMatOp_s( const HCL_UpperTriangularMatOp_s & );
   /** Usual constructor; requires the matrix, the domain, and the range.
       Also, a flag must be passed to indicate whether the matrix is to be
       deleted upon destruction of the operator (nonzero = delete,
       zero = no delete). */
      HCL_UpperTriangularMatOp_s( UpperTriangle_s * AA,int flag,
                         HCL_VectorSpace_s * d,HCL_VectorSpace_s * r );
   // Destructor.
      ~HCL_UpperTriangularMatOp_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *range; }
  /// {\bf Image} computes the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /** {\bf InvImage} computes the action of the inverse on y, giving x.
       This method will return an error if the matrix is not square. */
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y.  This method will return an error if the matrix is not
       square. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /// Debugging information.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_LowerTriangularMatOp\_s} makes an lower triangular matrix into a
linear operator in the HCL sense.  Note that the matrix is an instance of the
class {\bf LowerTriangle_s}, and it must be provided to the constructor.

The methods of this class are the methods of the base class
{\bf HCL\_LinearOp\_s}, and the documentation for the base class can be
consulted for more information. */

class HCL_LowerTriangularMatOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
      int DeleteMat;
   public:


   /** {\bf Matrix} is a pointer to the underlying {\bf LowerTriangle_s},
       which is the matrix representing the linear operator.  The matrix
       is public so that its methods are available. */
      LowerTriangle_s * Matrix;

   // Default constructor---disabled.
      HCL_LowerTriangularMatOp_s();
   // Copy constructor---disabled.
      HCL_LowerTriangularMatOp_s( const HCL_LowerTriangularMatOp_s & );
   /** Usual constructor; requires the matrix, the domain, and the range.
       Also, a flag must be passed to indicate whether the matrix is to be
       deleted upon destruction of the operator (nonzero = delete,
       zero = no delete). */
      HCL_LowerTriangularMatOp_s( LowerTriangle_s * AA,int flag,
                         HCL_VectorSpace_s * d,HCL_VectorSpace_s * r );
   // Destructor.
      ~HCL_LowerTriangularMatOp_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *range; }
  /// {\bf Image} computes the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /** {\bf InvImage} computes the action of the inverse on y, giving x.
       This method will return an error if the matrix is not square. */
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y.  This method will return an error if the matrix is not
       square. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /// Debugging information.
      virtual ostream & Write( ostream & str ) const;
};

#endif
