/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_OpProductDomain_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#ifndef HCL_OPPRODUCTDOMAIN_S_H_
#define HCL_OPPRODUCTDOMAIN_S_H_

#include "HCL_Op_s.h"
#include "HCL_ProductVector_s.h"
#include "HCL_BlockOp_s.h"
#include "HCL_BlockBiLinearOp_s.h"

class HCL_OpDefaultPartialDeriv_s;
class HCL_OpDefaultSecondPartialDeriv_s;

/** This class represents an "evaluation" object that will be created
by an {\bf HCL\_OpProductDomain\_s} object to implement the image and
derivatives of the operator at a point.  (The term "ProductDomain" refers
to the fact that the operator in question is defined on a product space).
Thus, if \TEX{$F$} is a nonlinear operator and \TEX{$x$} is a vector in the
domain, then the evaluation object represents the triple
\TEX{
\[
(F(x),DF(x),D^2F(x)).
\]
}
The purpose of having an evaluation object is to deal with the common
situation in which the operator image and derivatives share some intermediate
calculations.  A typical implementation of such an operator involves defining
an evaluation object whose constructor performs these intermediate
calculations.  The {\bf Image} method then completes the computation
of the operator image, while the {\bf PartialDeriv} and
{\bf SecondPartialDeriv} methods complete the calculation of the derivatives.

The difference between {\bf HCL\_EvaluateOp\_s} and
{\bf HCL\_EvalOpProductDomain\_s} is that the partial derivatives of the
operator are available in the second case.  Also, from the point of view
of the implementor of the class, only the partial derivatives need be
implemented; the class puts them together into the full derivative.

The operator image and derivatives should then be accessed through
the {\bf ImageRef}, {\bf DerivRef} (or {\bf PartialDerivRef}), and
{\bf SecondDerivRef} (or {\bf SecondPartialDerivRef}) methods.
These are methods implemented in the base class (i.e. they do not need to
be redefined in a derived class).  The {\bf ImageRef} method invokes
{\bf Image} to get the image and returns a reference to it.  On subsequent
calls, {\bf ImageRef} merely references the stored value.  The other
"reference" methods work in a similar fashion.

Here is a summary of the primary methods of this class:
\begin{itemize}
\item {\bf Domain} Returns a reference to the domain of the underlying
operator.
\item {\bf Range} Returns a reference to the range of the underlying
operator.
\item {\bf Image} Computes the image of the operator at the point
at which this object was created.  Must be implemented by the creator
of a concrete class.
\item {\bf ImageRef} Calls {\bf Image}, if necessary, to compute
the operator image, saves it, and returns it.  Implemented in the
base class.
\item {\bf ImageAdd} Adds the image of the operator to the output
(as opposed to {\bf Image}, which overwrites the output with the image).
\item {\bf Deriv} Computes the derivative of the operator, at the point
at which this object was created, as an {\bf HCL\_LinearOp\_s}.
Must be implemented by the creator of a concrete class.
\item {\bf DerivRef} Calls {\bf Deriv}, if necessary, to compute
the derivatives, saves it, and returns a reference to it.
Implemented in the base class.
\item {\bf PartialDeriv} Computes a partial derivative of the operator, at
the point at which this object was created, as an {\bf HCL\_LinearOp\_s}.
Must be implemented by the creator of a concrete class.
\item {\bf PartialDerivRef} Calls {\bf PartialDeriv}, if necessary, to compute
a partial derivative, saves it, and returns a reference to it.
Implemented in the base class.
\item {\bf SecondDeriv} Computes the second derivative of the operator,
at the point at which this object was created, as a
{\bf HCL\_BiLinearOp\_s}.  Must be implemented by the creator of a
concrete class.
\item {\bf SecondDerivRef} Calls {\bf SecondDeriv}, if necessary, to
compute the second derivative, saves it, and returns a reference to it.
Implemented in the base class.
\item {\bf SecondPartialDeriv} Computes a second partial derivative of the
operator, at the point at which this object was created, as a
{\bf HCL\_BiLinearOp\_s}.  Must be implemented by the creator of a
concrete class.
\item {\bf SecondPartialDerivRef} Calls {\bf SecondPartialDeriv}, if
necessary, to compute the second derivative, saves it, and returns a
reference to it.  Implemented in the base class.
\end{itemize}

In addition to the above methods, {\bf HCL\_EvaluateOp\_s} has a number of
protected virtual functions that allow the user to avoid writing
distinct derivative classes if desired.  If these methods, which
include {\bf PartialDerivImage}, {\bf SecondPartialDerivImage}, and others,
are over-ridden in a derived class, then the default {\bf PartialDeriv} and
{\bf SecondPartialDeriv} methods can be used, which create instances of
{\bf HCL\_OpDefaultPartialDeriv\_s} and
{\bf HCL\_OpDefaultSecondPartialDeriv\_s}.

The following report describes the implementation of operators in detail:

   "Implementing operators in HCL", Technical Report 99-22, Department of
   Computational and Applied Mathematics, Rice University, Houston, TX
   77251-1892.

A forthcoming report, "Implementing HCL functionals and operators on product
spaces", will provide similar details about implementing operators on
product spaces.  This report should be available from the same source
in early 2000.
*/

class HCL_EvalOpProductDomain_s: public HCL_EvaluateOp_s
{
   friend class HCL_OpDefaultPartialDeriv_s;
   friend class HCL_OpDefaultSecondPartialDeriv_s;
   protected:

   /** {\bf PartialDerivImage} computes the image of the derivative on dx,
       yielding dy.  If this method, and the related image methods for
       the derivative, are implemented, then the default {\bf PartialDeriv}
       method can be used; the derivative will then be an instance of
       {\bf HCL\_OpDefaultPartialDeriv\_s}. */
      virtual void PartialDerivImage( int i,const HCL_Vector_s & dx,
                                          HCL_Vector_s & dy ) const;
   /** {\bf PartialDerivAdjImage} computes the image of the adjoint of
       the derivative on dy, yielding dx.  If this method, and the
       related image methods for the derivative, are implemented, then the
       default {\bf PartialDeriv} method can be used; the derivative will
       then be an instance of {\bf HCL\_OpDefaultPartialDeriv\_s}. */
      virtual void PartialDerivAdjImage( int i,const HCL_Vector_s & dy,
                                         HCL_Vector_s & dx ) const;
   /** {\bf PartialDerivInvImage} computes the image of the inverse of
       the derivative on dy, yielding dx.  If this method, and the
       related image methods for the derivative, are implemented, then the
       default {\bf PartialDeriv} method can be used; the derivative will
       then be an instance of {\bf HCL\_OpDefaultPartialDeriv\_s}. */
      virtual void PartialDerivInvImage( int i,const HCL_Vector_s & dy,
                                             HCL_Vector_s & dx ) const;
   /** {\bf PartialDerivInvAdjImage} computes the image of the inverse of the
       adjoint of the derivative on dx, yielding dy.  If this method, and the
       related image methods for the derivative, are implemented, then the
       default {\bf PartialDeriv} method can be used; the derivative will
       then be an instance of {\bf HCL\_OpDefaultPartialDeriv\_s}. */
      virtual void PartialDerivInvAdjImage( int i,const HCL_Vector_s & dx,
                                                HCL_Vector_s & dy ) const;
   /** This method computes $D_{ij}^2F(x)(\delta x_j,\delta x_i)$.
       If this method and {\bf SecondPartialDerivPartialAdjImage} are
       implemented, then the default {\bf SecondPartialDeriv} method
       can be used; the second derivative will then be an instance of
       {\bf HCL\_OpDefaultSecondPartialDeriv\_s}.   */
      virtual void SecondPartialDerivImage( int i,int j,
                                            const HCL_Vector_s & dxj,
                                            const HCL_Vector_s & dxi,
                                                  HCL_Vector_s & dy ) const;
      
   /** This method computes $(D_{ij}^2F(x)(\delta x_j,\cdot))^*dy$
       (flag==1) or $(D_{ij}^2F(x)(\cdot,\delta x_i))^*dy$
       (flag==2).  If this method and {\bf SecondPartialDerivImage} are
       implemented, then the default {\bf SecondPartialDeriv} method
       can be used; the second derivative will then be an instance of
       {\bf HCL\_OpDefaultSecondPartialDeriv\_s}.   */
      virtual void SecondPartialDerivPartialAdjImage( int i,int j,int flag,
                                            const HCL_Vector_s & dxij,
                                            const HCL_Vector_s & dy,
                                                  HCL_Vector_s & dxji ) const;
   public:

   // Default constructor.
      HCL_EvalOpProductDomain_s();
   // Copy constructor.
      HCL_EvalOpProductDomain_s( const HCL_EvalOpProductDomain_s & );
   // Destructor.
      virtual ~HCL_EvalOpProductDomain_s();

   /** {\bf Domain} returns a reference to the domain of the underlying
       operator.*/
      virtual HCL_VectorSpace_s & Domain() const = 0;
   /** {\bf ProductDomain} returns a reference to the domain as a product
       vector space.  It is implemented in the base class and need not
       be re-implemented in a derived class. */
      HCL_ProductSpace_s & ProductDomain() const;
   /// {\bf Range} returns a reference to the range of the underlying operator.
      virtual HCL_VectorSpace_s & Range() const = 0;

   /** {\bf Image} computes the image of the operator and assigns the result
       to y. */
      virtual void Image( HCL_Vector_s & y ) const = 0;
   /** {\bf Deriv} computes the derivative of the operator.  Note that this
       method constructs an {\bf HCL\_LinearOp\_s}, which the calling program
       is responsible for deleting with {\bf HCL\_delete}. {\bf Deriv} is
       implemented in this (the base) class (using the partial derivatives),
       so it need not be re-defined in derived classes. */
      virtual HCL_LinearOp_s * Deriv() const;
   /** {\bf DerivRef} returns a reference to the derivative at this point.
       The programmer has a choice of calling {\bf Deriv}, in which case the
       calling routine is responsible for managing the storage,
       or calling {\bf DerivRef}, in which case the Evaluation object does.
       {\bf DerivRef} is implemented in the base class and need not be
       re-implemented in a derived class. */
      virtual const HCL_LinearOp_s & DerivRef() const;
   /** {\bf PartialDeriv} computes the partial derivative, with respect
       to the ith variable, as a linear operator.  */
      virtual HCL_LinearOp_s * PartialDeriv( int i ) const;
   /** {\bf PartialDerivRef} returns a reference to the partial derivative
       with respect to the ith variable. {\bf PartialDerivRef} is implemented
       in the base class and need not be re-implemented in a derived class. */
      virtual const HCL_LinearOp_s & PartialDerivRef( int i ) const;

   /** {\bf SecondDeriv} computes the second derivative of the operator.
       The second derivative is a bilinear operator which knows how to
       compute all relevant adjoints.  {\bf SecondDeriv} is implemented in
       the base class and need not be re-implemented in a derived class. */
      virtual HCL_BiLinearOp_s * SecondDeriv() const;
   /** {\bf SecondDerivRef} returns a reference to the second derivative
       at this point. The programmer has a choice of calling {\bf SecondDeriv},
       in which case the calling routine is responsible for managing the
       storage, or calling {\bf SecondDerivRef}, in which case the Evaluation
       object does.  {\bf SecondDeriv} is implemented in the base class and
       need not be re-implemented in a derived class.*/
      virtual const HCL_BiLinearOp_s & SecondDerivRef() const;
   /** {\bf SecondPartialDeriv} computes the second partial derivative,
       with respect to the ith and jth variables, as a bilinear operator. */
      virtual HCL_BiLinearOp_s * SecondPartialDeriv( int i,int j ) const;
   /** {\bf SecondPartialDerivRef} returns a reference to the second
       partial derivative, with respect to the ith and jth variables. 
       {\bf SecondDeriv} is implemented in the base class and need not be
       re-implemented in a derived class.*/
      virtual const HCL_BiLinearOp_s &
                    SecondPartialDerivRef( int i,int j ) const;

   /** Debugging information.  {\bf Write} should be implemented to
       print a description of the object that will be useful
       for debugging.  If a complete description is lengthy,
       an implementor should consider just printing out a useful
       subset.  This method will likely be used to send information
       to the screen when a error condition is encountered. */
      virtual ostream & Write( ostream & str ) const = 0;
};

// "Look-ahead" declaration.
class HCL_OpPDDefaultEval_s;

/** {\bf HCL\_OpProductDomain\_s} is the base class for (presumably
nonlinear) operators. Such an operator maps one vector space into another, say 
\TEX{
\[
F:X\rightarrow Y.
\]
}
The term "ProductDomain" refers to the fact that the domain is a product
space:
\TEX{
\[
X=X_1\times X_2\times\cdots X_n.
\]}

The primary methods of this class are:
\begin{itemize}
\item {\bf Domain} Returns a reference to the domain of the operator.
This is used primarily for error-checking.
\item {\bf Range} Returns a reference to the range of the operator.
This is used primarily for error-checking.
\item {\bf Image} Computes the action of the operator on a vector.
Here is an example illustrating the use of {\bf Domain}, {\bf Range},
and {\bf Image}:
\begin{verbatim}
   void fcn( HCL_Op_s & F,HCL_Vector_s & x,HCL_Vector_s & y )
   {
      if( x.Space() != F.Domain() || y.Space() != F.Range() )
         // Error condition
      .
      .
      .
      F.Image( x,y ); // y <-- F(x)
      .
      .
      .
   }
\end{verbatim}
\item {\bf ImageAdd} Adds the image of the operator to the output vector.
\item {\bf Deriv} Creates the derivative of the operator at a point.
This derivative is a linear operator
\TEX{
\[
DF(x):X\rightarrow Y,
\]}
and this method constructs it as an {\bf HCL\_LinearOp\_s}.
\item {\bf PartialDeriv} creates a partial derivative of the operator
as an {\bf HCL\_LinearOp\_s}.
\item {\bf SecondDeriv} Creates the second derivative of the operator at a
point.  This derivative is a bilinear operator
\TEX{
\[
D^2F(x):X\times X\rightarrow Y,
\]}
and this method constructs it as an {\bf HCL\_BiLinearOp\_s}.
\item {\bf SecondPartialDeriv} creates a second partial derivative of the
operator as an {\bf HCL\_BiLinearOp\_s}.
\item {\bf Evaluate} Creates an "evaluation object" which knows the
image and derivatives of the operator at a given point.  The purpose of
the evaluation object is to accommodate the common situation in which
the computation of the image and derivatives involve some common
intermediate calculations.  The implementor of the operator can
put these intermediate calculations in the evaluation object, so
that they need only be done once at each point.  The implementor of
optimization algorithms should respect this by using {\bf Evaluate}
to get the image and/or derivatives instead of using {\bf Image},
{\bf Deriv}, and/or {\bf SecondDeriv}.
\end{itemize}

In addition to the above methods, {\bf HCL\_OpProductDomain\_s} has a number of
protected virtual functions that allow the user to avoid writing
a distinct evaluation class if desired.  If these methods, which
include {\bf Image1}, {\bf PartialDerivImage}, etc. (or {\bf PartialDeriv1}),
{\bf SecondPartialDerivImage}, etc. (or {\bf SecondPartialDeriv1}),
are over-ridden in a derived class, then the default {\bf Evaluate} method
can be used, which creates an instance of {\bf HCL\_OpPDDefaultEval\_s}.

Defining operators is expected to be one of the main activities of users
of HCL, since the many optimization problems involve operators in the 
definition of the objective function or constraints.  As the last paragraph
suggests, there are a number of ways to implement operators.  These are
described in detail in the report

   "Implementing operators in HCL", Technical Report 99-22, Department of
   Computational and Applied Mathematics, Rice University, Houston, TX
   77251-1892.

A forthcoming report, "Implementing HCL functionals and operators on product
spaces", will provide similar details about implementing operators on
product spaces.  This report should be available from the same source
in early 2000.
*/
class HCL_OpProductDomain_s: public HCL_Op_s
{
   friend class HCL_OpPDDefaultEval_s;
   protected:

   /** {\bf Image1} computes the image of the operator on x, yielding y.
       If this and the related protected methods for derivatives are
       implemented, then the default implementation of {\bf Evaluate} can
       be used.  In that case, the evaluation object will be an instance of
       {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual void Image1( const HCL_Vector_s & x,HCL_Vector_s & y ) const;
   /** {\bf PartialDerivImage} computes the image of the derivative on dx,
       yielding dy.  If this method, and the related protected methods
       are implemented, then the default evaluation class
       can be used; the {\bf Evaluate} method will then return an instance of
       {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual void PartialDerivImage( int i,const HCL_Vector_s & x,
                                    const HCL_Vector_s & dx,
                                          HCL_Vector_s & dy ) const;
   /** {\bf PartialDerivAdjImage} computes the image of the adjoint of the
       derivative on dy, yielding dx.  If this method, and the related
       protected methods are implemented, then the default evaluation class
       can be used; the {\bf Evaluate} method will then return an instance of
       {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual void PartialDerivAdjImage( int i,const HCL_Vector_s & x,
                                       const HCL_Vector_s & dy,
                                             HCL_Vector_s & dx ) const;
   /** {\bf PartialDerivInvImage} computes the image of the inverse of the
       derivative on dy, yielding dx.  If this method, and the related
       protected methods are implemented, then the default evaluation class
       can be used; the {\bf Evaluate} method will then return an instance of
       {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual void PartialDerivInvImage( int i,const HCL_Vector_s & x,
                                       const HCL_Vector_s & dy,
                                             HCL_Vector_s & dx ) const;
   /** {\bf PartialDerivInvAdjImage} computes the image of the inverse of the
       adjoint on dx, yielding dy.  If this method, and the related
       protected methods are implemented, then the default evaluation class
       can be used; the {\bf Evaluate} method will then return an instance of
       {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual void PartialDerivInvAdjImage( int i,const HCL_Vector_s & x,
                                          const HCL_Vector_s & dx,
                                                HCL_Vector_s & dy ) const;
   /** {\bf PartialDeriv1} computes a partial derivative of the operator.
       Note that only one of {\bf PartialDeriv1} and the image methods
       {\bf PartialDerivImage}, {\bf PartialDerivAdjImage}, etc. need be
       implemented to enable the use of {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual HCL_LinearOp_s * PartialDeriv1( int i,
                                              const HCL_Vector_s & x ) const;
   /** This method computes $D_{ij}^2F(x)(\delta x_j,\delta x_i)$. 
       If this method and {\bf SecondPartialDerivPartialAdjImage} are
       implemented in a derived class, then {\bf HCL\_OpPDDefaultEval\_s}
       will be able to compute second partial derivatives.  */
      virtual void SecondPartialDerivImage( int i,int j,const HCL_Vector_s & x,
                                            const HCL_Vector_s & dxj,
                                            const HCL_Vector_s & dxi,
                                                  HCL_Vector_s & dy ) const;
      /** This method computes $(D_{ij}^2F(x)(\delta x_j,\cdot))^*dy$
          (flag==1) or $(D_{ij}^2F(x)(\cdot,\delta x_i))^*dy$
          (flag==2). */
      virtual void SecondPartialDerivPartialAdjImage( int i,int j,int flag,
                                            const HCL_Vector_s & x,
                                            const HCL_Vector_s & dxij,
                                            const HCL_Vector_s & dy,
                                                  HCL_Vector_s & dxji ) const;
   /** {\bf SecondPartialDeriv1} computes a second partial derivative of
       the operator as a bilinear operator.  This method can be implemented
       instead of the pair {\bf SecondPartialDerivImage},
       {\bf SecondPartialDerivPartialAdjImage} to enable the use of second
       partial derivatives with {\bf HCL\_OpPDDefaultEval\_s}. */
      virtual HCL_BiLinearOp_s * SecondPartialDeriv1( int i,int j,
                                              const HCL_Vector_s & x ) const;
   public:

   // Default constructor.
      HCL_OpProductDomain_s();
   // Copy constructor.
      HCL_OpProductDomain_s( const HCL_OpProductDomain_s & );
   // Destructor.
      virtual ~HCL_OpProductDomain_s();

   /** Domain space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_s} which forms the domain of the operator.*/
      virtual HCL_VectorSpace_s & Domain() const = 0;
   /** Access to the domain, explicitly as a product vector space. */
      virtual HCL_ProductSpace_s & ProductDomain() const;
   /** Range space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_s} which forms the range of the operator.*/
      virtual HCL_VectorSpace_s & Range() const = 0;

   /** {\bf Evaluate} creates an evaluation object which knows how to
        compute the image and the derivative (as a linear operator with
        adjoint) at a point. The purpose of using an evaluation object
        in place of getting the image or derivative directly is that,
        for many operators, the computation of the image and derivative
        involve some common intermediate calculations.  These calculations
        can be done once (at each point) in the evaluation object.*/
      virtual HCL_EvaluateOp_s *
              Evaluate( const HCL_Vector_s & x ) const;

   /** {\bf PartialDeriv} computes the partial derivative of the
       operator, with respect to the ith component of the independent
       variable.  It does this by constructing an evaluation object,
       extracting the partial derivative, and then deleting the
       evaluation object. {\bf PartialDeriv} is defined in this
       (the base) class, and need not be redefined in a derived class. */
      virtual HCL_LinearOp_s * PartialDeriv( int i,
                                             const HCL_Vector_s & x ) const;
   /** {\bf SecondPartialDeriv} computes the second partial derivative of the
       operator, with respect to the ith and jth components of the independent
       variable.  It does this by constructing an evaluation object,
       extracting the partial derivative, and then deleting the
       evaluation object. {\bf SecondPartialDeriv} is defined in this
       (the base) class, and need not be redefined in a derived class. */
      virtual HCL_BiLinearOp_s * SecondPartialDeriv( int i,int j,
                                       const HCL_Vector_s & x ) const;

   /** Check partial derivatives.  This method computes the relative difference
       between the directional derivative as computed from the analytic
       partial derivative and the same estimated by a central difference
       formula. This is done at n equally-spaced points on the line segment
       [x+hmin*y,x+hmax*y].  The parameters hmin, hmax, and n are optional
       and default to 0.1, 1.0, and 10, respectively.
       If the partial derivative  is correctly implemented and the function
       is sufficiently smooth, then these errors will lie on a parabola when
       plotted against the step size. The results are sent to the output
       stream str. */
      int CheckPartialDeriv( int ind,const HCL_Vector_s &,const HCL_Vector_s &,
                             ostream & str,int n=10,float hmin=0.1,
                             float hmax=1.0 ) const;
   /** {\bf CheckPartialDerivAdj} calls {\bf CheckPartialDeriv} to test the
       correctness of the partial derivative, then calls the
       {\bf HCL\_LinearOp\_s} method {\bf CheckAdj} to test the correctness of
       the adjoint. */
      int CheckPartialDerivAdj( int ind,const HCL_Vector_s &,
                                const HCL_Vector_s &,
                                ostream & str,int n=10,float hmin=0.1,
                                float hmax=1.0 ) const;
   /** Check second partial derivatives.  This method computes the relative
       difference between the directional derivative as computed from the
       analytic second partial derivative and the same estimated by a central
       difference formula. This is done at n equally-spaced points on the
       line segment [x+hmin*y,x+hmax*y].  The parameters hmin, hmax, and n
       are optional and default to 0.1, 1.0, and 10, respectively.
       If the partial derivative  is correctly implemented and the function
       is sufficiently smooth, then these errors will lie on a parabola when
       plotted against the step size. The results are sent to the output
       stream str. If i==j, only the variable dxi is used. */
      int CheckSecondPartialDeriv( int i,int j,const HCL_Vector_s & x,
                                   const HCL_Vector_s & dxj,
                                   const HCL_Vector_s & dxi,
                                   ostream & str,int n=10,
                                   float hmin=0.1,float hmax=1.0 ) const;
   /** {\bf CheckSecondPartialDerivAdj} calls {\bf CheckSecondPartialDeriv}
       to test the correctness of the second partial derivative, then calls the
       {\bf HCL\_BiLinearOp\_s} method {\bf CheckAdj} to test the correctness
       of the various adjoints. */
      int CheckSecondPartialDerivAdj( int i,int j,const HCL_Vector_s & x,
                                      const HCL_Vector_s & dxj,
                                      const HCL_Vector_s & dxi,
                                      ostream & str,int n=10,
                                      float hmin=0.1,float hmax=1.0 ) const;
   /** This version of {\bf CheckSecondPartialDeriv} checks the ``pure''
       (not mixed) second partial derivative. */
      int CheckSecondPartialDeriv( int i,const HCL_Vector_s & x,
                                   const HCL_Vector_s & dxi,
                                   ostream & str,int n=10,
                                   float hmin=0.1,float hmax=1.0 ) const;
   /** This version of {\bf CheckSecondPartialDerivAdj} checks the ``pure''
       (not mixed) second partial derivative. */
      int CheckSecondPartialDerivAdj( int i,const HCL_Vector_s & x,
                                      const HCL_Vector_s & dxi,
                                      ostream & str,int n=10,
                                      float hmin=0.1,float hmax=1.0 ) const;

   /** Debugging information.  {\bf Write} should be implemented to
       print a description of the object that will be useful
       for debugging.  If a complete description is lengthy,
       an implementor should consider just printing out a useful
       subset.  This method will likely be used to send information
       to the screen when a error condition is encountered. */
      virtual ostream & Write( ostream & str ) const = 0;
};

/** {\bf HCL\_OpPDDefaultEval\_s} is the default "evaluation" class for
nonlinear operators defined on product spaces.  If
\TEX{
\[
F:X\rightarrow Y
\]}
is a nonlinear operator represented by an instance of
{\bf HCL\_OpProductDomain\_s} (and X is a product space), then the
corresponding evaluation class represents the triple
\TEX{
\[
(F(x),DF(x),D^2F(x)).
\]}
In many cases, there is a significant efficiency advantage to creating
a specific evaluation class for a given operator, since then intermediate
calculations that are common to the image, derivative, and second derivative
can be re-used.  However, if there is no such efficiency advantage to be
gained, then the default evaluation class {\bf HCL\_OpPDDefaultEval\_s} can
be used.  This requires that certain protected virtual functions from
{\bf HCL\_OpProductDomain\_s} be implemented in the derived operator class.

The various mechanisms for implementing evaluation classes are explained in
detail, with concrete examples, in the report

   "Implementing operators in HCL", Technical Report 99-22, Department of
   Computational and Applied Mathematics, Rice University, Houston, TX
   77251-1892.

A forthcoming report, "Implementing HCL functionals and operators on product
spaces", will provide similar details about implementing operators on
product spaces.  This report should be available from the same source
in early 2000.
*/
class HCL_OpPDDefaultEval_s: public HCL_EvalOpProductDomain_s
{
   private:
      HCL_ProductVector_s * x;
      const HCL_OpProductDomain_s * op;
   protected:

   /** {\bf DerivImage} computes the image of the derivative on dx,
       yielding dy.  This and the other protected methods call the
       corresponding methods from the underlying operator. */
      virtual void PartialDerivImage( int i,const HCL_Vector_s & dx,
                                     HCL_Vector_s & dy ) const
      {
         op->PartialDerivImage( i,*x,dx,dy );
      }
   /** {\bf DerivAdjImage} computes the image of the adjoint on dy,
       yielding dx.  This and the other protected methods call the
       corresponding methods from the underlying operator. */
      virtual void PartialDerivAdjImage( int i,const HCL_Vector_s & dy,
                                        HCL_Vector_s & dx ) const
      {
         op->PartialDerivAdjImage( i,*x,dy,dx );
      }
   /** {\bf DerivInvImage} computes the image of the inverse on dy,
       yielding dx.  This and the other protected methods call the
       corresponding methods from the underlying operator. */
      virtual void PartialDerivInvImage( int i,const HCL_Vector_s & dy,
                                        HCL_Vector_s & dx ) const
      {
         op->PartialDerivInvImage( i,*x,dy,dx );
      }
   /** {\bf DerivInvAdjImage} computes the image of the inverse of the
       adjoint on dx, yielding dy.  This and the other protected methods
       call the corresponding methods from the underlying operator. */
      virtual void PartialDerivInvAdjImage( int i,const HCL_Vector_s & dx,
                                           HCL_Vector_s & dy ) const
      {
         op->PartialDerivInvAdjImage( i,*x,dx,dy );
      }
   /** {\bf SecondPartialDerivImage} computes the image of the second
       partial derivative on (dxi,dxj), yielding dy.  This and the other
       protected methods call the corresponding methods from the underlying
       operator. */
      virtual void SecondPartialDerivImage( int i,int j,
                                            const HCL_Vector_s & dxj,
                                            const HCL_Vector_s & dxi,
                                                  HCL_Vector_s & dy ) const
      {
         op->SecondPartialDerivImage( i,j,*x,dxj,dxi,dy );
      }
   /** {\bf SecondPartialDerivPartialAdjImage} computes the action of the
       so-called "partial adjoint" of the second partial derivative acting
       This and the other protected methods call the corresponding methods
       from the underlying operator. */
      virtual void SecondPartialDerivPartialAdjImage( int i,int j,int flag,
                                            const HCL_Vector_s & dxij,
                                            const HCL_Vector_s & dy,
                                                  HCL_Vector_s & dxji ) const
      {
         op->SecondPartialDerivPartialAdjImage( i,j,flag,*x,dxij,dy,dxji );
      }
      
   public:

   // Default constructor---disabled.
      HCL_OpPDDefaultEval_s();
   // Copy constructor---disabled.
      HCL_OpPDDefaultEval_s( const HCL_OpPDDefaultEval_s & );
   /** Usual constructor; requires a pointer to an operator and a reference
       to the input vector.  An independent copy of the input vector is
       made. */
      HCL_OpPDDefaultEval_s( const HCL_OpProductDomain_s * op,
                             const HCL_ProductVector_s & in );
   // Destructor
      virtual ~HCL_OpPDDefaultEval_s();

   /** {\bf Domain} returns a reference to the domain of the underlying
       operator. */
      virtual HCL_VectorSpace_s & Domain() const { return op->Domain(); }
   /// {\bf Range} returns a reference to the range of the underlying operator.
      virtual HCL_VectorSpace_s & Range() const { return op->Range(); }

   /// {\bf Image} computes the image of the operator and assigns it to y.
      virtual void Image( HCL_Vector_s & y ) const { op->Image1( *x,y ); }
   /** {\bf PartialDeriv} computes a partial derivative of the operator.
       Note that this method constructs an {\bf HCL\_LinearOp\_s}, which the
       calling program is responsible for deleting with {\bf HCL\_delete}. */
      virtual HCL_LinearOp_s * PartialDeriv( int i ) const;
   /** {\bf SecondPartialDeriv} computes a second partial derivative of the
       operator. Note that this method constructs an {\bf HCL\_LinearOp\_s},
       which the calling program is responsible for deleting with
       {\bf HCL\_delete}. */
      virtual HCL_BiLinearOp_s * SecondPartialDeriv( int i,int j ) const;
 
   /** Debugging information.  {\bf Write} prints a description of the
       object.*/
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_OpDefaultPartialDeriv\_s} is a linear operator class implementing
a partial derivative of a nonlinear operator.  It exists to relieve the
implementor of an operator class from the necessity of creating a distinct
class to represent the derivative if there is no (efficiency) advantage
gained by creating such a class.  In order to use this default derivative
class, the implementor of the operator class must implement the protected
virtual functions {\bf PartialDerivImage}, {\bf PartialDerivAdjImage}, etc.

The various mechanisms for implementing operator classes are explained in
detail, with concrete examples, in the report

   "Implementing operators in HCL", Technical Report 99-22, Department of
   Computational and Applied Mathematics, Rice University, Houston, TX
   77251-1892.

A forthcoming report, "Implementing HCL functionals and operators on product
spaces", will provide similar details about implementing operators on
product spaces.  This report should be available from the same source
in early 2000.
*/
class HCL_OpDefaultPartialDeriv_s: public HCL_LinearOp_s
{
   private:
       int i;
       const HCL_EvalOpProductDomain_s * eval;
   public:  

  // Default constructor---disabled.
      HCL_OpDefaultPartialDeriv_s();
  // Copy constructor---disabled.
      HCL_OpDefaultPartialDeriv_s( const HCL_OpDefaultPartialDeriv_s & L );
  /** Usual constructor; just need an operator's evaluation object and an
      integer indicating which partial derivative is desired. */
      HCL_OpDefaultPartialDeriv_s( int i,
                                   const HCL_EvalOpProductDomain_s * ev );
  // destructor
      virtual ~HCL_OpDefaultPartialDeriv_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const;
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;
  /// {\bf Image} compute the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes the action of the adjoint on y, giving x.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;

   /// {\bf InvImage} computes the action of the inverse on y, giving x.
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;
   /** {\bf Write} prints a description of the object. */
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_OpDefaultSecondPartialDeriv\_s} is a linear operator class
implementing a second partial derivative of a nonlinear operator.  It exists to
relieve the implementor of an operator class from the necessity of creating
a distinct class to represent the derivative if there is no (efficiency)
advantage gained by creating such a class.  In order to use this default
derivative class, the implementor of the operator class must implement the
protected virtual functions {\bf SecondPartialDerivImage} and
{\bf SecondPartialDerivPartialAdjImage}.

The various mechanisms for implementing operator classes are explained in
detail, with concrete examples, in the report

   "Implementing operators in HCL", Technical Report 99-22, Department of
   Computational and Applied Mathematics, Rice University, Houston, TX
   77251-1892.

A forthcoming report, "Implementing HCL functionals and operators on product
spaces", will provide similar details about implementing operators on
product spaces.  This report should be available from the same source
in early 2000.
*/
class HCL_OpDefaultSecondPartialDeriv_s: public HCL_BiLinearOp_s
{
   private:
       int i,j;
       const HCL_EvalOpProductDomain_s * eval;
   protected:
   /** {\bf PartialAdjImage} computes the action of the so-called "partial
       adjoint" of the bilinear operator.  If B represents the operator,
       then this method computes \TEX{$(B(xy,\cdot))^*z$} (if flag==1)
       or \TEX{$(B(\cdot,xy))^*z$} (if flag==2). */
      virtual void PartialAdjImage( int flag,const HCL_Vector_s & xy,
                                             const HCL_Vector_s & z,
                                                   HCL_Vector_s & yx ) const;
   public:

  // Default constructor---disabled.
      HCL_OpDefaultSecondPartialDeriv_s();
  // Copy constructor---disabled.
      HCL_OpDefaultSecondPartialDeriv_s(
         const HCL_OpDefaultSecondPartialDeriv_s & L );
  /** Usual constructor; just need an operator's evaluation object. */
      HCL_OpDefaultSecondPartialDeriv_s( int i,int j,
                                   const HCL_EvalOpProductDomain_s * ev );
  // destructor
      virtual ~HCL_OpDefaultSecondPartialDeriv_s();

   /** Access to the domain of the first argument.  Returns a reference
       to an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain1() const;
   /** Access to the domain of the second argument.  Returns a reference
       to an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain2() const;
   /** Access to the range.  Returns a reference to a
       {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;

   /// Image computes the action of the operator on the pair (x,y), giving z.
      virtual void Image( const HCL_Vector_s & x,const HCL_Vector_s & y,
                                HCL_Vector_s & z ) const
      {
         eval->SecondPartialDerivImage( i,j,x,y,z );
      }

   /** {\bf Write} prints a description of the object. */
      virtual ostream & Write( ostream & str ) const;
};

#endif
