/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_PartitionedRnVector_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#ifndef __HCL_PartitionedRnVector_s
#define __HCL_PartitionedRnVector_s

#include "HCL_Rn_s.h"
#include "HCL_ProductVector_s.h"

class HCL_PartitionedRnVector_s;

/** {\bf HCL\_PartitionedRnSpace\_s} represents a product vector space,
in which each factor is an instance of {\bf HCL\_RnSpace\_s}.  The
corresponding vector class, {\bf HCL\_PartitionedRnVector\_s},
implements the product vector as a "long vector"; that is, the components
are stored in a single array. 

See {\bf HCL\_RnSpace\_s} and {\bf HCL\_ProductSpace\_s} for more details. */
class HCL_PartitionedRnSpace_s: public HCL_ProductSpace_s
{

   private:

      static char Type;
      int n,numinit;
      int IdenticalFlag;
      HCL_RnSpace_s ** rnsp;

   public:

   // Default constructor---disabled.
      HCL_PartitionedRnSpace_s();
   /// Copy constructor.
      HCL_PartitionedRnSpace_s(const HCL_PartitionedRnSpace_s & x);

   /** This constructor creates a space of n identical factors, each
       of dimension m. */
      HCL_PartitionedRnSpace_s( int m, int n );
   /** This constructor creates a space of n factors.  The dimension of each
       factor must be specified with the {\bf SetNext} method. */
      HCL_PartitionedRnSpace_s( int n );
   // Destructor.
      virtual ~HCL_PartitionedRnSpace_s();

   /** Get type of vector space for comparison.
       {\bf GetType} makes it possible to check that two vector spaces
       are of the same derived class before comparing them.  {\bf GetType} just
       returns the address of the static member {\bf Type}, cast to void*.
       This is a primitive form of Run Time Type Information. */
      virtual void * GetType() const ;

   /** Virtual constructor.  This method constructs a vector belonging to
       this vector space and returns a pointer to it.  Note that the
       calling routine is responsible for deleting the vector when it
       is no longer needed.  {\bf Member} is used to create temporary vectors
       "abstractly", i.e. without knowing the exact type of the vector
       desired.  */
      virtual HCL_Vector_s * Member() const ;

   /** Virtual copy constructor.  This method constructs a copy of this
       vector space and returns a pointer to it. */
      virtual HCL_VectorSpace_s * Replicate() const ;

   /// {\bf Number} returns the number of factors in the product.
      virtual int Number() const ;

   /// The () operator returns a reference to the ith factor in the product.
      virtual HCL_VectorSpace_s & operator()( int i ) const ;

   /** {\bf SetNext} is used to specify the dimension of the factors in
       the product.  (Note that if all of the factors have the same
       dimension, then a special constructor can be used, in which case
       {\bf SetNext} need not be called.) */
      void SetNext( int m );
   /** {\bf SetNext} is used to specify the next factor in
       the product.  (Note that if all of the factors have the same
       dimension, then a special constructor can be used, in which case
       {\bf SetNext} need not be called.) */
      void SetNext( HCL_RnSpace_s * s );
};

/** {\bf HCL\_PartitionedRnVector\_s} represents a vector from a product space
in which each factor is an instance of {\bf HCL\_RnSpace\_s}.  The product
vector is implemented as a "long vector"; that is, the components
are stored in a single array.  The purpose of the class is to make it
convenient to view the vector as a product (and hence convenient to
manipulate the factors), but also to enable the use of direct linear algebra
techniques on the long vector.

See {\bf HCL\_RnVector\_s} and {\bf HCL\_ProductVector\_s} for more details. */
class HCL_PartitionedRnVector_s: public HCL_ProductVector_s
{
   private:
      int n,dim;
      HCL_RnVector_s ** rnvec;
      HCL_PartitionedRnSpace_s * sp;
      float * data;

   public:

   // Default constructor---disabled.
      HCL_PartitionedRnVector_s();
   // Copy constructor---disabled.
      HCL_PartitionedRnVector_s(const HCL_PartitionedRnVector_s & p);
   /** Special constructor for the case of n identical factors, each with
       dimension m. */
      HCL_PartitionedRnVector_s(int m, int n);
   /** Special constructor; reads the vector from an ASCII file.  The format of
       the file is as follows:  The first entry is an integer n, the
       number of factors.  Subsequent entries consist of n blocks, each
       having the dimension of the factor followed by its components. */
      HCL_PartitionedRnVector_s( char * fname );
   /** General constructor; constructs a vector based on an instance of
       {\bf HCL\_PartitionedRnVector\_s}. */
      HCL_PartitionedRnVector_s( HCL_PartitionedRnSpace_s * s );
   // Destructor.
      virtual ~HCL_PartitionedRnVector_s();

   /** Return the dimension of the vector space. */
      virtual int Dim() const { return dim; }
   /** The () operator returns a reference to the ith factor.  The result
       can be safely cast to type {\bf HCL\_RnVector\_s}. */
      virtual HCL_Vector_s & operator()(int i) const ; 

   /** {\bf Data} returns a pointer to the (long) array of components. */
      virtual float * Data() { return data; }

   /// {\bf Space} returns a reference to the underlying vector space.
      virtual HCL_VectorSpace_s & Space() const ;

   /** {\bf Save} stores the vector in an ASCII file, in the following format:
       The first entry is an integer n, the number of factors.  Subsequent
       entries consist of n blocks, each having the dimension of the factor
       followed by its components. */
      void Save( char * fname ) const;
};

#endif
