/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_Recorder_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#ifndef _RECORDER_S_
#define _RECORDER_S_

#include "Std_includes.h"
#include "HCL_Base.h"

/** HCL\_Recorder defines an interface for "recorder" objects, used
principally for recording intermediate results during an iterative
process. Its {\tt Record} method takes a vector argument; any derived
class will impement a storage method appropriate to a concrete vector
type. Disk image of the recorded data might be created on the fly, or
during destruction of the Recorder object.

Usage: instantiate a recorder object corresponding to the concrete
vector class used in the iteration. Pass this object to the
constructor of the iterative method (this of course presumes that the
iterative method is set up to record intermediate results, and so taks
a Recorder object as an argument to its constructor). Then use the
{\tt PlayBack} method to extract intermediate iterates after
termination of the iteration. */

class HCL_Recorder_s: public HCL_Base {

public:

  // Constructors
  HCL_Recorder_s() {}

  HCL_Recorder_s( const HCL_Recorder_s & R ) {}

  ~HCL_Recorder_s() {}

  /// {\bf Record} - copy input vector
  virtual void Record( const HCL_Vector_s & Input ) = 0;

  /// {\bf Rewind} - go to first vector recorded
  virtual void Rewind() const = 0;

  /// {\bf PlayBack} - copy current stored vector onto vector parameter
  virtual void PlayBack( HCL_Vector_s & Output ) const = 0;

  /// {\bf Next} - advance to next recorded vector - returns 0 when at end
  virtual int Next() const = 0;

  /// {\bf Number} - how many vectors currently stored
  virtual int Number() const = 0;

  /// {\bf Erase} - deletes currently stored vectors;
  virtual void Erase() = 0;

};

#endif
