/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_ScaleLinearOp_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#ifndef HCL_SCALELINEAROP_S_H
#define HCL_SCALELINEAROP_S_H

#include "HCL_LinearOp_s.h"
#include "HCL_Vector_s.h"
#include "Table.h"
#include "HCL_Arch_s.h"

/** {\bf HCL\_ScaleLinearOp\_s} implementing the linear operator
\TEX{\[
x\mapsto ax,
\]}
where a is a scalar.  In addition to the {\bf HCL\_LinearOp\_s} methods,
this class has a {\bf Parameters} method, which returns a reference to
a {\bf Table} object.  The table contains the single parameter "Scale",
which is the scalar \TEX{$a$}.  This scalar can be accessed using
\begin{verbatim}
L.Parameters().GetValue( "Scale",a );
\end{verbatim}
and modified using
\begin{verbatim}
L.Parameters().PutValue( "Scale",a );
\end{verbatim}
*/
class HCL_ScaleLinearOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * sp;
      Table * ParamTable;
   public:

   // Default constructor---disabled.
      HCL_ScaleLinearOp_s();
   // Copy constructor---disabled.
      HCL_ScaleLinearOp_s( const HCL_ScaleLinearOp_s & L );
   /// Usual constructor; needs the domain and the scalar.
      HCL_ScaleLinearOp_s( HCL_VectorSpace_s * SP,float mu );
   // Destructor
      virtual ~HCL_ScaleLinearOp_s();

   /** Domain space access. Returns a reference to the domain of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const;
   /** Range space access. Returns a reference to the range of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;
   /** Access to the Parameter table. The scalar defining the linear operator
       can be accessed through Parameters().GetValue( "Scale",val ) or
       changed by Parameters().PutValue( "Scale",val ). */
      Table & Parameters();

   /// {\bf Image} computes y = a*x.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} calls {\bf Image} (the operator is self-adjoint).
      virtual void AdjImage( const HCL_Vector_s & x,
                                   HCL_Vector_s & y ) const;
   /// {\bf NormalImage} computes $y = a^2x$.
      virtual void NormalImage( const HCL_Vector_s & x,
                                   HCL_Vector_s & y ) const;
   /// {\bf InvImage} computes the action of the inverse on y, giving x.
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;

   /** {\tt ImageAdd} implements \TEX{$y = a A x + b z$}. */
       virtual void ImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt AdjImageAdd} implements \TEX{$y = a A^* x + b z$}. */
       virtual void AdjImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt NormalImageAdd} implements \TEX{$y = a A^*A x + b z$}.  */
       virtual void NormalImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvImageAdd} implements \TEX{$y = a A^{-1} x + b z$}. */
       virtual void InvImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvAdjImageAdd} implements \TEX{$y = a A^{-*} x + b z$}.  */
       virtual void InvAdjImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt ImageAdd} implements \TEX{$y = a A x + b y$}. */
       virtual void ImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt AdjImageAdd} implements \TEX{$y = a A^* x + b y$}. */
       virtual void AdjImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt NormalImageAdd} implements \TEX{$y = a A^*A x + b y$}. */
       virtual void NormalImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvImageAdd} implements \TEX{$y = a A^{-1} x + b y$}. */
       virtual void InvImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvAdjImageAdd} implements \TEX{$y = a A^{-*} x + b y$}. */
       virtual void InvAdjImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;

   /// Write prints out the domain and scale.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_DiagScaleLinearOp\_s} is a class implementing the linear operator
mapping x to a*x, where x and a are vectors and 
the multiplication is done componentwise (in "Matlab notation", this
operation is a.*x).
*/
class HCL_DiagScaleLinearOp_s: public HCL_LinearOp_s
{
   private:
      HCL_Vector_s * diag;
   public:

   // Default constructor---disabled.
      HCL_DiagScaleLinearOp_s();
   // Copy constructor---disabled.
      HCL_DiagScaleLinearOp_s( const HCL_DiagScaleLinearOp_s & L );
   /** Usual constructor; just needs the scaling vector (which also defines
       the domain).  This version makes an independent copy of the scaling
       vector. */
      HCL_DiagScaleLinearOp_s( const HCL_Vector_s & d );
   /** Usual constructor; just needs the scaling vector (which also defines
       the domain).  This version copies a pointer to the scaling
       vector. */
      HCL_DiagScaleLinearOp_s( HCL_Vector_s * d );
   // Destructor.
      virtual ~HCL_DiagScaleLinearOp_s();

   /** Domain space access. Returns a reference to the domain of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const;
   /** Range space access. Returns a reference to the range of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;

   /// {\bf Image} computes y = a.*x.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} calls {\bf Image} (the operator is self-adjoint).
      virtual void AdjImage( const HCL_Vector_s & x,
                                   HCL_Vector_s & y ) const;
   /// {\bf NormalImage} computes y = a.*a.*x.
      virtual void NormalImage( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf InvImage} computes the action of the inverse on y, giving x.
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} computes the action of the inverse adjoint on x,
       giving y. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;

   /// Write prints out the domain and scale.
      virtual ostream & Write( ostream & str ) const;
};

/** {\bf HCL\_ZeroLinearOp\_s} is a class implementing the zero linear
   operator mapping one vector space to another. */
class HCL_ZeroLinearOp_s: public HCL_LinearOp_s
{
   private:
      HCL_VectorSpace_s * dom;
      HCL_VectorSpace_s * range;
   public:

   // Default constructor---disabled.
      HCL_ZeroLinearOp_s();
   // Copy constructor---disabled.
      HCL_ZeroLinearOp_s( const HCL_ZeroLinearOp_s & L );
   /// Usual constructor; needs the domain and range
      HCL_ZeroLinearOp_s( HCL_VectorSpace_s * d,HCL_VectorSpace_s * r );
   // Destructor
      virtual ~HCL_ZeroLinearOp_s();

   /** Domain space access. Returns a reference to the domain of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const;
   /** Range space access. Returns a reference to the range of
       the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const;

   /// {\bf Image} computes $y = 0$.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
   /// {\bf AdjImage} computes $x = 0$.
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;
   /// {\bf NormalImage} computes $y = 0$.
      virtual void NormalImage( const HCL_Vector_s & x,
                                   HCL_Vector_s & y ) const;
   /** {\bf InvImage} returns an error message, since the zero operator
       is obviously not invertible. */
      virtual void InvImage(const HCL_Vector_s & y,
                                  HCL_Vector_s & x) const;
   /** {\bf InvAdjImage} returns an error message, since the zero operator
       is obviously not invertible. */
      virtual void InvAdjImage(const HCL_Vector_s & x,
                                     HCL_Vector_s & y) const;

   /** {\tt ImageAdd} implements \TEX{$y = a A x + b z$}. */
       virtual void ImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt AdjImageAdd} implements \TEX{$y = a A^* x + b z$}. */
       virtual void AdjImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt NormalImageAdd} implements \TEX{$y = a A^*A x + b z$}.  */
       virtual void NormalImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvImageAdd} implements \TEX{$y = a A^{-1} x + b z$}. */
       virtual void InvImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvAdjImageAdd} implements \TEX{$y = a A^{-*} x + b z$}.  */
       virtual void InvAdjImageAdd(const HCL_Vector_s & x,
                             const HCL_Vector_s & z,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt ImageAdd} implements \TEX{$y = a A x + b y$}. */
       virtual void ImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt AdjImageAdd} implements \TEX{$y = a A^* x + b y$}. */
       virtual void AdjImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt NormalImageAdd} implements \TEX{$y = a A^*A x + b y$}. */
       virtual void NormalImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvImageAdd} implements \TEX{$y = a A^{-1} x + b y$}. */
       virtual void InvImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;
   /** {\tt InvAdjImageAdd} implements \TEX{$y = a A^{-*} x + b y$}. */
       virtual void InvAdjImageAdd(const HCL_Vector_s & x,
			     HCL_Vector_s & y,
                             float a=1.0,
                             float b=1.0) const;

   /// Write prints out the domain and range
      virtual ostream & Write( ostream & str ) const;
};

#endif
