/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_SubProductProjector_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

#ifndef HCL_SUBPRODUCTPROJECTOR_S_H_
#define HCL_SUBPRODUCTPROJECTOR_S_H_

#include "HCL_ProductVector_s.h"
#include "HCL_GenericProductVector_s.h"
#include "HCL_LinearOp_s.h"

/** The class {\bf HCL\_SubProductProjector\_s} implements a linear operator
which maps a product space
\TEX{\[
X = X_1\times X_2\times\cdots X_n
\]}
into the "sub-product"
\TEX{\[
Y = X_{i_1}\times X_{i_2}\times\cdots X_{i_k}.
\]}
The operator is defined to be simple projection, i.e.
\TEX{\[
x \mapsto (x_{i_1},x_{i_2},\ldots,x_{i_k}).
\]}
The integers \TEX{$i_1,i_2,\ldots,i_k$} are defined by an iArray object.
The special case of
\TEX{\[
x \mapsto x_j
\]}
is handled by a special constructor which takes a single integer in place
of an iArray object.

Thus, an object of this type is constructed via
\begin{verbatim}
HCL_SubProductProjector_s L( &dom,&indices );
\end{verbatim}
where {\tt dom} is an instance of {\bf HCL\_ProductSpace\_s} and indices is
an instance of {\bf iArray}, or
\begin{verbatim}
HCL_SubProductProjector_s L( &dom,j );
\end{verbatim}
where {\tt j} is a positive integer.  In the first case, the range of the
operator is an instance of {\bf HCL\_GenericProductSpace\_s}, while in the
second case, it is an instance of {\bf HCL\_VectorSpace\_s}.
*/

class HCL_SubProductProjector_s: public HCL_LinearOp_s
{
   private:
      HCL_ProductSpace_s * dom;
      HCL_GenericProductSpace_s * rng;
      HCL_VectorSpace_s * rng1;
      iArray * ind;
      int j;
   public:

   // Default constructor---disabled.
      HCL_SubProductProjector_s();
   // Copy constructor---disabled.
      HCL_SubProductProjector_s( const HCL_SubProductProjector_s & );
   /** This constructor creates a projector whose range is an instance
       of {\bf HCL\_GenericProductSpace\_s}.  The arguments are the domain
       and an {\bf iArray} object specifying the factors of the range. */
      HCL_SubProductProjector_s( HCL_ProductSpace_s * d,iArray * indices );
   /** This constructor creates a projector whose range is an instance
       of {\bf HCL\_VectorSpace\_s}.  The arguments are the domain
       and an integer specifying the range. */
      HCL_SubProductProjector_s( HCL_ProductSpace_s * d,int jj );
   // Destructor.
      ~HCL_SubProductProjector_s();

  /** Domain space access. Returns a reference to the domain of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain() const { return *dom; }
  /** Range space access. Returns a reference to the range of
      the operator, which is an {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const
      {
         if( rng ) return *rng;
         else return *rng1;
      }

  /// {\bf Image} compute the action of the operator on x, giving y.
      virtual void Image( const HCL_Vector_s & x,
                                HCL_Vector_s & y ) const;
  /** {\bf AdjImage} computes the action of the adjoint on y, giving x.
      This method is implemented in the base class to return an 
       error message. */
      virtual void AdjImage( const HCL_Vector_s & y,
                                   HCL_Vector_s & x ) const;
   /** Debugging information. */
      virtual ostream & Write( ostream & str ) const;
};

#endif


