/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_TensorBiLinearOp_d.h.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#ifndef HCL_TENSORBILINEAROP_S_H_
#define HCL_TENSORBILINEAROP_S_H_

#include "HCL_BiLinearOp_s.h"
#include "tensor_s.h"
#include "HCL_MatrixOps_s.h"

/** {\bf HCL\_TensorBiLinearOp\_s} represents a bilinear operator that is
implemented using an explicit 3-tensor.  This class is therefore based
on the class {\bf General3Tensor\_s}, and all of the image methods are
implemented in the obvious way (explicit tensor multiplication).  The
operators defined by {\bf Op1}, {\bf Op2}, and {\bf Op3} are computed as
explicit matrices.

See {\bf HCL\_BiLinearOp\_s} and {\bf General3Tensor\_s} for more information
about bilinear operators and tensors. */

class HCL_TensorBiLinearOp_s: public HCL_BiLinearOp_s
{
   private:
      int d1,d2,d3;
      General3Tensor_s * T;
      int DeleteTensor;
      HCL_VectorSpace_s * dom1;
      HCL_VectorSpace_s * dom2;
      HCL_VectorSpace_s * rng;
   public:  

   // Default constructor---disabled.
      HCL_TensorBiLinearOp_s();
   // Copy constructor---disabled.
      HCL_TensorBiLinearOp_s( const HCL_TensorBiLinearOp_s & L );
   /** Constructor: requires pointers to the domain and range spaces, and
       a pointer to the tensor on which the class is based.  In addition,
       a flag indicates whether the tensor is to be deleted upon
       destruction.  */
      HCL_TensorBiLinearOp_s( HCL_VectorSpace_s * D1,HCL_VectorSpace_s * D2,
                              HCL_VectorSpace_s * R,General3Tensor_s * t,
                              int deleteflag = 0 );
   // Destructor.
      virtual ~HCL_TensorBiLinearOp_s();

   /** Access to the domain of the first argument.  Returns a reference
       to a {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain1() const { return *dom1; }
   /** Access to the domain of the second argument.  Returns a reference
       to a {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Domain2() const { return *dom2; }
   /** Access to the range.  Returns a reference to a
       {\bf HCL\_VectorSpace\_s}. */
      virtual HCL_VectorSpace_s & Range() const { return *rng; }

   /// Image computes the action of the operator on the pair (x,y), giving z.
      virtual void Image( const HCL_Vector_s & x,const HCL_Vector_s & y,
                                HCL_Vector_s & z ) const;
   /// Op1 creates the linear operator B(x,.)
      virtual HCL_LinearOp_s * Op1( const HCL_Vector_s & x ) const;
   /// Op2 creates the linear operator B(x,.)
      virtual HCL_LinearOp_s * Op2( const HCL_Vector_s & y ) const;
   /** Access to the "partial adjoint" of the bilinear operator.
       Assume B:XxY --> Z is the bilinear operator.
       Then Op3 returns the operator x |---> (B(x))'z.
       Its adjoint is the operator y |---> (B(.)y)'z */
      virtual HCL_LinearOp_s * Op3( const HCL_Vector_s & z ) const;

  /** {\bf Write} prints out a description of the object. */
      virtual ostream & Write( ostream & str ) const;
};

#endif
