/*
                 THE HILBERT CLASS LIBRARY                        
                Release 0.8, September 1997                       
                                                                  
       copyright (C) 1995, 1996, 1997 by Mark S. Gockenbach,      
              Matthew Petro, and William W. Symes                 
                                                                  
The source code contained in this file FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#ifndef LAPACK_H
#define LAPACK_H

#include "Std_includes.h"

//
// Defines C prototypes for many LAPACK and BLAS routines
//


// double precision

extern "C" double F77NAME(dlanhs)(char*,int*,double*,int*,double*);
extern "C" double F77NAME(dlange)(char*,int*,int*,double*,int*,double*);
extern "C" double F77NAME(dlamch)(char*);
extern "C" void F77NAME(dlabad)(double*,double*);
extern "C" void F77NAME(dlarnv)(int*,int*,int*,double*);
extern "C" double F77NAME(ddot)(int*,double*,int*,double*,int*);
extern "C" double F77NAME(dlapy2)(double*,double*);

extern "C" void F77NAME(dgbtrf)( int*,int*,int*,int*,double*,int*,int*,int* );
extern "C" void F77NAME(dgbtrs)( char*,int*,int*,int*,int*,double*,int*,int*,
                                 double*,int*,int* );
extern "C" void F77NAME(dgetrf)( int *,int *,double *,int *,int *,int * );
extern "C" void F77NAME(dgetrs)( char *,int *,int *,double *,int *,int *,
                                 double *,int *,int * );
extern "C" void F77NAME(dscal)(int*,const double*,double*,int*);
extern "C" void F77NAME(dgeqr2)(int*,int*,double*,int*,double*,double*,int*);
extern "C" void F77NAME(dtrsen)(char*,char*,int*,int*,double*,int*,double*,
                        int*,double*,double*,int*,double*,int*,double*,int*,
                        int*,int*,int*);
extern "C" void F77NAME(dlahqr)(int*,int*,int*,int*,int*,double*,int*,double*,
                        double*,int*,int*,double*,int*,int*);
extern "C" void F77NAME(dcopy)(int*,double*,int*,double*,int*);
extern "C" void F77NAME(dlaset)(char*,int*,int*,double*,double*,double*,int*);

extern "C" void F77NAME(dtrevc)(char*,char*,int*,int*,double*,int*,double*,
                        int*,double*,int*,int*,int*,double*,int*);
extern "C" double F77NAME(dnrm2)(int*,double*,int*);
extern "C" void F77NAME(dgemv)(char*,int*,int*,double*,double*,int*,double*,int*,
                        double*,double*,int*);
extern "C" void F77NAME(daxpy)(const int*,const double*,double*,int*,double*,int*);

extern "C" void F77NAME(dgttrf)(int*,double*,double*,double*,double*,int*,int*);
extern "C" void F77NAME(dgttrs)(char*,int*,int*,double*,double*,double*,
			double*,int*,double*,int*,int*);
extern "C" void F77NAME(dspev)(char*,char*,int*,double*,double*,double*,
                               int*,double*,int*);
extern "C" void F77NAME(dpptrf)(char*,int*,double*,int*);
extern "C" void F77NAME(dpptrs)(char*,int*,int*,double*,double*,int*,int*);
extern "C" void F77NAME(dtptrs)(char*,char*,char*,int*,int*,double*,double*,
                                int*,int*);
extern "C" void F77NAME(dtpmv)(char*,char*,char*,int*,double*,double*,int*);

// single precision

extern "C" float F77NAME(slanhs)(char*,int*,float*,int*,float*);
extern "C" float F77NAME(slange)(char*,int*,int*,float*,int*,float*);
extern "C" float F77NAME(slamch)(char*);
extern "C" void F77NAME(slabad)(float*,float*);
extern "C" void F77NAME(slarnv)(int*,int*,int*,float*);
extern "C" float F77NAME(sdot)(int*,float*,int*,float*,int*);
extern "C" float F77NAME(slapy2)(float*,float*);

extern "C" void F77NAME(sscal)(int*,const float*,float*,int*);
extern "C" void F77NAME(sgeqr2)(int*,int*,float*,int*,float*,float*,int*);
extern "C" void F77NAME(strsen)(char*,char*,int*,int*,float*,int*,float*,
                        int*,float*,float*,int*,float*,int*,float*,int*,
                        int*,int*,int*);
extern "C" void F77NAME(slahqr)(int*,int*,int*,int*,int*,float*,int*,float*,
                        float*,int*,int*,float*,int*,int*);
extern "C" void F77NAME(scopy)(int*,float*,int*,float*,int*);
extern "C" void F77NAME(slaset)(char*,int*,int*,float*,float*,float*,int*);

extern "C" void F77NAME(strevc)(char*,char*,int*,int*,float*,int*,float*,
                        int*,float*,int*,int*,int*,float*,int*);
extern "C" float F77NAME(snrm2)(int*,float*,int*);
extern "C" void F77NAME(sgemv)(char*,int*,int*,float*,float*,int*,float*,int*,
                        float*,float*,int*);
extern "C" void F77NAME(saxpy)(const int*,const float*,float*,int*,float*,int*);

extern "C" void F77NAME(sgttrf)(int*,float*,float*,float*,float*,int*,int*);
extern "C" void F77NAME(sgttrs)(char*,int*,int*,float*,float*,float*,
			float*,int*,float*,int*,int*);
extern "C" void F77NAME(sgbtrf)( int*,int*,int*,int*,float*,int*,int*,int* );
extern "C" void F77NAME(sgbtrs)( char*,int*,int*,int*,int*,float*,int*,int*,
                                 float*,int*,int* );

extern "C" void F77NAME(sgetrf)( int *,int *,float *,int *,int *,int * );
extern "C" void F77NAME(sgetrs)( char *,int *,int *,float *,int *,int *,
                                 float *,int *,int * );
extern "C" void F77NAME(sspev)(char*,char*,int*,float*,float*,float*,
                               int*,float*,int*);		       
extern "C" void F77NAME(spptrf)(char*,int*,float*,int*);
extern "C" void F77NAME(spptrs)(char*,int*,int*,float*,float*,int*,int*);
extern "C" void F77NAME(stptrs)(char*,char*,char*,int*,int*,float*,float*,
                                int*,int*);
extern "C" void F77NAME(stpmv)(char*,char*,char*,int*,float*,float*,int*);

#endif
