/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_LnSrchFl_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include <iostream.h>
#include <stdio.h>
#include <float.h>
#include "maxmin_s.h"
#include "HCL_LineSearch_s.h"

//
// Line search algorithm from Fletcher [1987]
//

HCL_LineSearch_Fl_s::HCL_LineSearch_Fl_s( const HCL_LineSearch_s & x )
{
   cerr << "Error: HCL_LineSearch_Fl_s copy constructor called" << endl;
   exit(1);
}

HCL_LineSearch_Fl_s::HCL_LineSearch_Fl_s( char *fname )
{
   if( fname != NULL )
      ParamTable = new Table( fname,"LineSearchFl LineSearch",20 );
   else
      ParamTable = new Table;
   dump = NULL;
   S = NULL;
   LastMu = -1.0;
}

HCL_LineSearch_Fl_s::~HCL_LineSearch_Fl_s()
{
   if( DumpFlag && dump != NULL )
      delete dump;
   HCL_delete( S );
   HCL_delete( ParamTable );
}

void HCL_LineSearch_Fl_s::Initialize( HCL_VectorSpace_s & dom )
{
   int MinFlag = ParamTable->GetValue( "MinStep",MinStep );
   int MaxFlag = ParamTable->GetValue( "MaxStep",MaxStep );
   if( MinFlag && MaxFlag || (!MinFlag && !MaxFlag && MinStep >= MaxStep) )
   {
      MaxStep = 1.0e20;
      MinStep = 1.0e-20;
   }
   else if( MinFlag && !MaxFlag )
      MinStep = 1.0e-40*MaxStep;
   else if (MaxFlag && !MinFlag )
      MaxStep = 1.0e40*MinStep;
#ifdef SINGLE_PRECISION
   HCL_FPArch_s arch;
#else
   HCL_FPArch_s arch;
#endif
   if( ParamTable->GetValue( "IntervalTol",IntervalTol ) )
      IntervalTol = sqrt(arch.eps);
   if( ParamTable->GetValue( "FcnDecreaseTol",FcnDecreaseTol ) )
      FcnDecreaseTol = 1.0e-4;
   if( ParamTable->GetValue( "SlopeDecreaseTol",SlopeDecreaseTol ) )
      SlopeDecreaseTol = 0.1;
   if( ParamTable->GetValue( "MaxSample",MaxSample ) )
      MaxSample = 8;
   if( ParamTable->GetValue( "MinValue",MinValue ) )
      MinValue = 0;
   if( ParamTable->GetValue( "ZeroDivideTol",ZeroDivideTol ) )
      ZeroDivideTol = 0.0;
   if( ParamTable->GetValue( "DispFlag",DispFlag ) )
      DispFlag = 0;
   if( ParamTable->GetValue( "DumpFlag",DumpFlag ) )
      DumpFlag = 0;
   if( ParamTable->GetValue( "DispPrecision",DispPrecision ) )
      DispPrecision = 6;
   OldDispPrec = cout.precision( DispPrecision );
   if( ParamTable->GetValue( "DumpPrecision",DumpPrecision ) )
      DumpPrecision = DispPrecision;
   if( DumpFlag && dump == NULL )
   {
      if( ParamTable->GetValue( "DumpFile",DumpFile ) )
         strcpy( DumpFile,"HCL_LineSearch_Fl_s.DumpFile" );
      dump = new ofstream( DumpFile,ios::out );
      dump->precision( DumpPrecision );
   }
   else
      dump = NULL;

   if( ParamTable->GetValue( "BracketIncrease",BracketIncrease ) )
      BracketIncrease = 9;
   if( ParamTable->GetValue( "tau2",tau2 ) )
      tau2 = 0.1;
   if( ParamTable->GetValue( "tau3",tau3 ) )
      tau3 = 0.5;
   if( ParamTable->GetValue( "LineStepFlag",LineStepFlag ) )
      LineStepFlag = 0;

   // check consistancy of S
   if( S != NULL )
   {
      if( S->Domain() != dom )
      {
         cerr << "Error in HCL_LineSearch_Fl_s::Initialize: domain does "
                 "not match preconditioner" << endl;
         exit(1);
      }
      tmpvec = dom.Member();
   }
   else
      tmpvec = NULL;

   // allocate vectors
   g = dom.Member();
}



// Deallocate vectors and fill in the output parameters
void HCL_LineSearch_Fl_s::Clean()
{
   cout.precision( OldDispPrec );
   HCL_delete( g );
   HCL_delete( tmpvec );
   
   ParamTable->PutValue("TermCode", TermCode);
   ParamTable->PutValue("MaxTkn", MaxTkn);
}

void HCL_LineSearch_Fl_s::SetScaling( const HCL_LinearOp_s * SS )
{
   HCL_delete( S );
   S = (HCL_LinearOp_s*)SS;
   S->IncCount();
}

void HCL_LineSearch_Fl_s::UnSetScaling()
{
   HCL_delete( S );
   S = NULL;
}

HCL_EvaluateFunctional_s *
HCL_LineSearch_Fl_s::Search(HCL_Functional_s & f,
                            const HCL_Vector_s & xcur,HCL_Vector_s & xnext,
                            HCL_Vector_s & pdir,
                            HCL_EvaluateFunctional_s * xcur_eval)
{
   HCL_EvaluateFunctional_s * eval = NULL;
   float f_x0;
   
   TermCode = NoErr;
   MaxTkn = 0;

   Initialize(f.Domain());

   if (DispFlag)
       cout << "===============HCL_LineSearch_Fl_s===============" << endl;
   if (DumpFlag && dump != NULL)
       (*dump) << "===============HCL_LineSearch_Fl_s===============" << endl;

   f_x0 = xcur_eval->ValueRef();

   // Compute the length of the step, and scale
   // the search direction (if necessary)

   float dirnorm;
   if( S != NULL )
   {
      S->Image( pdir,*tmpvec );
      dirnorm = sqrt(pdir.Inner( *tmpvec ));
   }
   else
      dirnorm = pdir.Norm();

   float scale;
   float t = f.MaxStep( xcur,pdir ),fmaxs;
   if( t <= 0.0 )
   {
      if( DispFlag )
         cout << "Error in HCL_LineSearch_Fl_s: vector not in domain"
                 " (fmaxs == 0.0)" << endl;
      if( DumpFlag && dump != NULL )
         (*dump) << "Error in HCL_LineSearch_Fl_s: vector not in domain"
                 " (fmaxs == 0.0)" << endl;
      TermCode = NoReduction;
      Clean();
      LastMu = -1.0;
      return NULL;
   }
   HCL_FPArch_s arch;
   if( t == arch.large )
      fmaxs = t;
   else
      fmaxs = 0.99*dirnorm*t;
   float fcnmaxstep = min( fmaxs,MaxStep );
   
   if( dirnorm > fcnmaxstep )    // ||dir|| > min(MaxStep, fcnmaxstep)
   {
      if( ProtectedDivision( fcnmaxstep,dirnorm,scale,ZeroDivideTol ) )
      {
         if( DispFlag > 1 )
            cout << "ProtectedDivision error: dirnorm too small" 
                 << "   " << fcnmaxstep << "/" << dirnorm << endl;
         if( DumpFlag > 1 && dump != NULL )
            (*dump) << "ProtectedDivision error: dirnorm too small"
                    << "   " << fcnmaxstep << "/" << dirnorm << endl;

         TermCode = NoReduction;
         Clean();
         LastMu = -1.0;
         return NULL;
      }         
      dirnorm = fcnmaxstep;
      pdir.Mul( scale );
      if( DispFlag )
         cout << "Vector dir is too long; multiply by " << scale << endl;
      if( DumpFlag  && dump != NULL )
         (*dump) << "Vector dir is too long; multiply by " << scale << endl;
   }

   // Compute the initial slope; exit if not negative

   float initslope = xcur_eval->GradientRef().Inner( pdir );
   if( initslope >= 0.0 )
   {
      if( DispFlag )
      {
         cout << "Initial slope nonnegative; returning" << endl;
         cout << "initslope: " << initslope << endl;
      }
      if( DumpFlag && dump != NULL )
      {
         (*dump) << "Initial slope nonnegative; returning" << endl;
         (*dump) << "initslope: " << initslope << endl;
      }

      TermCode = InitialSlopePositive;
      Clean();
      LastMu = -1.0;
      return NULL;
   }
   float minmu,maxmu;
   if( ProtectedDivision( MinStep,dirnorm,minmu,ZeroDivideTol ) ||
       ProtectedDivision( fcnmaxstep,dirnorm,maxmu,ZeroDivideTol ) )
   {
      if( DispFlag > 1 )
         cout << "Protected division failed (computing minmu and maxmu)"
              << "   " << MinStep << "/" << dirnorm << ", "
              << fcnmaxstep << "/" << dirnorm << endl;
      if( DumpFlag && dump != NULL )
         (*dump) << "Protected division failed (computing minmu and maxmu)"
                 << "   " << MinStep << "/" << dirnorm << ", "
                 << fcnmaxstep << "/" << dirnorm << endl;
      TermCode = NoReduction;
      Clean();
      return NULL;
   }

   if (DispFlag > 1 || (DumpFlag > 1 && dump != NULL))
   {
      float xnorm;
      
      if( S != NULL )
      {
         S->Image( xcur,*tmpvec );
         xnorm = sqrt(xcur.Inner( *tmpvec ));
      }
      else 
         xnorm = xcur.Norm();
      if( DispFlag > 1)
      {
         cout << "f = " << f_x0 << endl;
         cout << "||x|| = " << xnorm << endl;
         cout << "||dir|| = " << dirnorm << endl;
         cout << "Initial slope = " << initslope << endl;
         cout << "Maximum step to boundary: " << fmaxs << endl;
         cout << "Maximum mu: " << maxmu << endl;
         cout << "Minimum mu: " << minmu << endl;
      }
      if( DumpFlag > 1 && dump != NULL ) {
         (*dump) << "f = " << f_x0 << endl;
         (*dump) << "||x|| = " << xnorm << endl;
         (*dump) << "||dir|| = " << dirnorm << endl;
         (*dump) << "Initial slope = " << initslope << endl;
         (*dump) << "Maximum step to boundary: " << fmaxs << endl;
         (*dump) << "Maximum mu: " << maxmu << endl;
         (*dump) << "Minimum mu: " << minmu << endl;
      }
   }


   // Bracketing phase

   float mu;
   if( LineStepFlag && LastMu > 0.0 )
      mu = LastMu;
   else
      mu = 1.0;
   mu = max( mu,minmu );
   mu = min( mu,maxmu );
   int laststep = 0;
   if( mu >= maxmu )
      laststep = 1;
   float f_x;
   float prevf_x = f_x0;
   float prevslope = initslope;
   float prevmu = 0;
   float nextmu;
   float a, b, af_x, bf_x, aslope, bslope;
   int computed_bslope = 0;
   int samplecount = 0;
  
   while (samplecount < MaxSample)
   {
      xnext.AddScale( mu,xcur,pdir );

      HCL_delete( eval );      // Note: First iteration, eval == NULL
      eval = f.Evaluate(xnext);
      samplecount++;
      f_x = eval->ValueRef();
      
      if (f_x <= MinValue)
      {
	 
         if( DispFlag )
	    cout << "f below minimum function value (f(x) = " << f_x
	         << ") ; returning." << endl;
         if( DumpFlag && dump != NULL )
	    (*dump) << "f below minimum function value (f(x) = " << f_x
	         << ") ; returning." << endl;

	 TermCode = Succeed;
	 if( mu > 0.99*maxmu )
	     MaxTkn = 1;
	 Clean();
         LastMu = mu;
	 return eval;
      }
      if (f_x > f_x0 + mu*FcnDecreaseTol*initslope || f_x >= prevf_x) {
         if( DispFlag > 1 ) {
	    cout << "Found bracket [" << mu << "," 
		  << prevmu << "]" << endl;
	 }
         if( DumpFlag > 1 && dump != NULL ) {
	    (*dump) << "Found bracket [" << mu << "," 
		    << prevmu << "]" << endl;
	 }
	 b = mu;
	 a = prevmu;
	 bf_x = f_x;
	 af_x = prevf_x;
	 computed_bslope = 0;
	 aslope = prevslope;
	 break;
      }
      float slope = eval->GradientRef().Inner(pdir);
      if( DispFlag > 1 )
         cout << samplecount << " mu = " << mu << " f = " << f_x 
              << " slope = " << slope << endl;
      if (abs(slope) <= -SlopeDecreaseTol*initslope)
      {
         if( DispFlag )
            cout << "Minimum found: mu = " << mu << " f_x = " << f_x 
                 << " slope = " << slope<< endl;
         if( DumpFlag && dump != NULL )
            (*dump) << "Minimum found: mu = " << mu << " f_x = " << f_x 
                    << " slope = " << slope<< endl;
	 TermCode = Succeed;
	 if( mu > 0.99*maxmu )
	    MaxTkn = 1;
	 Clean();
         LastMu = mu;
	 return eval;
      }
      if (slope >= 0)
      {
         if( DispFlag > 1 )
	    cout << "Found bracket [" << mu << "," 
		 << prevmu << "]" << endl;
         if( DumpFlag > 1 && dump != NULL )
	    (*dump) << "Found bracket [" << mu << "," 
		    << prevmu << "]" << endl;
	 b = prevmu;
	 a = mu;
	 bf_x = prevf_x;
	 af_x = f_x;
	 bslope = prevslope;
	 computed_bslope = 1;
	 aslope = slope;
	 break;
      }
      if (laststep)
      {
         if( DispFlag )
	    cout << "Maximum step reached without finding bracket; "
		    "returning" << endl;
         if( DumpFlag && dump != NULL )
	    (*dump) << "Maximum step reached without finding bracket; "
		    "returning" << endl;
         TermCode = Fail;
         MaxTkn = 1;
         Clean();
         LastMu = -1.0;
         return eval;
      }

      if (maxmu <= 2*mu - prevmu)
      {
	 nextmu = maxmu;
	 laststep = 1;
      }
      else   // do a simple enlargement of the interval
	nextmu = min(maxmu, mu+BracketIncrease*(mu-prevmu));

      if( DispFlag > 1 )
         cout << "   Bracketing [" << mu << "," 
	      << nextmu << "]" << endl;
      if( DumpFlag > 1 && dump != NULL )
	 (*dump) << "   Bracketing [" << mu << "," 
	         << nextmu << "]" << endl;
      
      prevmu = mu;
      mu = nextmu;
      prevf_x = f_x; 
      prevslope = slope;
   }

   if( max( a,b ) <= minmu || abs(b-a) <= IntervalTol*max(a,b) )
   {
      if( DispFlag )
         if( max( a,b ) <= minmu )
            cout << "Minimum  step length reached without finding an "
                    "acceptable point" << endl;
         else
            cout << "Length of interval of uncertainty is below tolerance"
                 << endl;
      if ( DumpFlag && dump != NULL )
         if( max( a,b ) <= minmu )
            (*dump) << "Minimum  step length reached without finding an "
                       "acceptable point" << endl;
         else
            (*dump) << "Length of interval of uncertainty is below "
                       "tolerance" << endl;
      if( f_x < f_x0 )
      {
         TermCode = Fail;
         if( mu > 0.99*maxmu )
            MaxTkn = 1;
         if( DispFlag )
            cout << "   Function value reduced by " << f_x0-f_x << endl;
         if( DumpFlag && dump != NULL )
            (*dump) << "   Function value reduced by " << f_x0-f_x << endl;
         Clean();
         LastMu = mu;
         return eval;
      }
      else
      {
         TermCode = NoReduction;
         if( DispFlag )
            cout << "   Function value not reduced." << endl;
         if( DumpFlag && dump != NULL )
            (*dump) << "   Function value not reduced." << endl;
         Clean();
         HCL_delete( eval );
         LastMu = -1.0;
         return NULL;
      }
   }         

   //
   // Sectioning Phase
   //
   
   while (samplecount <= MaxSample) {
      
      if (computed_bslope)
         mu = CubicInterpMin(a, af_x, aslope, b, bf_x, bslope,
				 a+tau2*(b - a), b-tau3*(b - a));
      else
         mu = QuadInterpMin(a, af_x, aslope, b, bf_x,
				 a+tau2*(b - a), b-tau3*(b - a));

      mu = max( mu,minmu );

      xnext.AddScale(mu, xcur, pdir);

      HCL_delete( eval );
      eval = f.Evaluate(xnext);
      samplecount++;
      f_x = eval->ValueRef();
      
      if (f_x <= MinValue)
      {
	 
         if( DispFlag )
	    cout << "f below minimum function value (f(x) = " << f_x
	         << ") ; returning." << endl;
         if( DumpFlag && dump != NULL )
	    (*dump) << "f below minimum function value (f(x) = " << f_x
	         << ") ; returning." << endl;

	 TermCode = Succeed;
	 if( mu > 0.99*maxmu )
	     MaxTkn = 1;
	 Clean();
         LastMu = mu;
	 return eval;
      }

      if (f_x > f_x0 + mu*FcnDecreaseTol*initslope || f_x >= af_x) {
         if( DispFlag > 1 )
            cout << samplecount << " mu = " << mu << " f = " << f_x 
                 << endl;
         if( DumpFlag > 1 && dump != NULL )
            (*dump) << samplecount << " mu = " << mu << " f = " << f_x 
                    << endl;
         b = mu;
         bf_x = f_x;
         computed_bslope = 0;
      } 
      else
      {
         float slope = eval->GradientRef().Inner(pdir);
         
         if( DispFlag > 1 )
            cout << samplecount << " mu = " << mu << " f = " << f_x 
                 << " slope = " << slope << endl;
         if (abs(slope) <= -SlopeDecreaseTol*initslope)
         {
            if( DispFlag )
               cout << "Minimum found: mu = " << mu << " f_x = " << f_x 
                    << " slope = " << slope<< endl;
            if( DumpFlag && dump != NULL )
               (*dump) << "Minimum found: mu = " << mu << " f_x = " << f_x 
                       << " slope = " << slope<< endl;
	    TermCode = Succeed;
	    if( mu > 0.99*maxmu )
	       MaxTkn = 1;
	    Clean();
            LastMu = mu;
	    return eval;
         }
         
         if ((b - a)*slope >= 0)
         {
            b = a;
            bslope = aslope;
            bf_x = af_x;
	    computed_bslope = 1;
         }
         a = mu;
         af_x = f_x;
         aslope = slope;
                     
      }

      if( max( a,b ) <= minmu || abs(b-a) <= IntervalTol*max(a,b) )
      {
         if( DispFlag )
            if( max( a,b ) <= minmu )
               cout << "Minimum  step length reached without finding an "
                       "acceptable point" << endl;
            else
               cout << "Length of interval of uncertainty is below tolerance"
                    << endl;
         if ( DumpFlag && dump != NULL )
            if( max( a,b ) <= minmu )
               (*dump) << "Minimum  step length reached without finding an "
                          "acceptable point" << endl;
            else
               (*dump) << "Length of interval of uncertainty is below "
                          "tolerance" << endl;
         if( f_x < f_x0 )
         {
            TermCode = Fail;
            if( mu > 0.99*maxmu )
               MaxTkn = 1;
            if( DispFlag )
               cout << "   Function value reduced by " << f_x0-f_x << endl;
            if( DumpFlag && dump != NULL )
               (*dump) << "   Function value reduced by " << f_x0-f_x << endl;
            Clean();
            LastMu = mu;
            return eval;
         }
         else
         {
            TermCode = NoReduction;
            if( DispFlag )
               cout << "   Function value not reduced." << endl;
            if( DumpFlag && dump != NULL )
               (*dump) << "   Function value not reduced." << endl;
            Clean();
            HCL_delete( eval );
            LastMu = -1.0;
            return NULL;
         }
      }         

      if( DispFlag > 1 )
         cout << "   Sectioning [" << a<< "," << b<< "]" << endl;
      if( DumpFlag > 1&& dump != NULL )
         (*dump) << "   Sectioning [" << a<< "," << b<< "]" << endl;
   }

   if( DispFlag )
      cout << "Too many function evaluations; returning" << endl;
   if ( DumpFlag && dump != NULL )
      (*dump) << "Too many function evaluations; returning" << endl;

   if( f_x < f_x0 )
   {
      TermCode = TooManyFunctionEvals;
      if( DispFlag )
         cout << "   Function value reduced by " << f_x0-f_x << endl;
      if( DumpFlag && dump != NULL )
         (*dump) << "   Function value reduced by " << f_x0-f_x << endl;
      Clean();
      LastMu = mu;
      return eval;
   }
   else
   {
      TermCode = NoReduction;
      if( DispFlag )
         cout << "   Function value not reduced." << endl;
      if( DumpFlag && dump != NULL )
         (*dump) << "   Function value not reduced." << endl;
      HCL_delete( eval );
      Clean();
      LastMu = mu;
      return NULL;
   }
}

float 
HCL_LineSearch_Fl_s::CubicInterpMin(float ap, float apf_x, float apslope, 
		  float bp, float bpf_x, float bpslope, float cp, float dp)
{
   // ensure that a<b and c<d

   float c = min(cp,dp), d = max(cp,dp);
   float crit;

   float a, fa, faa, b, fb, fbb;
   if (ap < bp) {
      a = ap; fa = apf_x; faa = apslope;
      b = bp; fb = bpf_x; fbb = bpslope;
   }
   else {
      a = bp; fa = bpf_x; faa = bpslope;
      b = ap; fb = apf_x; fbb = apslope;
   }

   HCL_FPArch_s FP;
   float bma = b-a;
   float fab,faab,fabb,faabb;
   if( ProtectedDivision( fb-fa,bma,fab,ZeroDivideTol ) || 
       ProtectedDivision( fab-faa,bma,faab,ZeroDivideTol ) ||
       ProtectedDivision( fbb-fab,bma,fabb,ZeroDivideTol ) ||
       ProtectedDivision( fabb-faab,bma,faabb,ZeroDivideTol ) )
   {
    if( DispFlag > 1 )
     cout << "Protected division failed while computing divided differences"
          << endl << "   numerators are " << fb-fa << "," << fab-faa
          << "," << fbb-fab << "," << fabb-faab << ", denominator is "
          << bma << endl;
    if( DumpFlag > 1 && dump != NULL )
     (*dump) << "Protected division failed while computing divided differences"
             << endl << "   numerators are " << fb-fa << "," << fab-faa
             << "," << fbb-fab << "," << fabb-faab << ", denominator is "
             << bma << endl;
    float midpt = 0.5*(a+b);
    if( c <= midpt && midpt <= d ) return midpt;
    else return d;
   }
   float maxcoeff = max(max(abs(fa),abs(faa)),max(abs(faab),abs(faabb)));

   // Cubic is really quadratic.

   if( abs(faabb) < 100*FP.eps*maxcoeff )

      // Quadratic is really linear

      if( abs(faab) < 100*FP.eps*maxcoeff )
      {
         if( faa >= 0.0 )
            return c;
         else
            return d;
      }

      // True quadratic

      else
      {
         crit = a - faa/(2.0*faab);

         // Convex quadratic

         if( faab > 0.0 )
            if( crit < c )
               return c;
            else if( crit > d )
               return d;
            else
               return crit;

         // Concave quadratic

         else
         {
            float cma = c-a;
            float dma = d-a;
            float fc = (faab*cma+faa)*cma+fa;
            float fd = (faab*dma+faa)*dma+fa;
            if( fc < fd )
               return c;
            else
               return d;
         }
      }

   // True cubic.

   else
   {
                
      float A = 3.0*faabb;
      float B = faab-(2*a+b)*faabb;
      float C = faa-2*a*faab+(2*a*b+a*a)*faabb;
      float disc = B*B-A*C;

      // Cubic has no extrema.

      if( disc <= 0 )

         // Everywhere decreasing

         if( faabb < 0 )
            return d;

         // Everywhere increasing

         else
            return c;

      // Cubic has both maximum and minimum.

      else
      {
         // Minimizer is the stationary point corresponding to the positive
         // square root

         crit = (-B+sqrt(disc))/A;
         if( c < crit && crit < d )
            return crit;
         else
         {
            float cma = c-a;
            float dma = d-a;
            float fc = ((faabb*(c-b)+faab)*cma+faa)*cma+fa;
            float fd = ((faabb*(d-b)+faab)*dma+faa)*dma+fa;
            if( fc < fd )
               return c;
            else
               return d;
         }
      }
   }
}

float 
HCL_LineSearch_Fl_s::QuadInterpMin(float a, float fa, float faa,
	 float b, float fb, float cp, float dp)
{
   float c = min(cp,dp), d = max(cp,dp);
   float crit;

   HCL_FPArch_s FP;
   float bma = b-a;
   float fab,faab;
   if( ProtectedDivision( fb-fa,bma,fab,ZeroDivideTol ) || 
       ProtectedDivision( fab-faa,bma,faab,ZeroDivideTol ) )
   {
    if( DispFlag > 1 )
     cout << "Protected division failed while computing divided differences"
          << endl << "   numerators are " << fb-fa << "," << fab-faa
          << ", denominator is " << bma << endl;
    if( DumpFlag > 1 && dump != NULL )
     (*dump) << "Protected division failed while computing divided differences"
             << endl << "   numerators are " << fb-fa << "," << fab-faa
             << ", denominator is " << bma << endl;
    float midpt = 0.5*(a+b);
    if( c <= midpt && midpt <= d ) return midpt;
    else return d;
   }
   float maxcoeff = max(max(abs(fa),abs(faa)),faab);

   // Quadratic is really linear

   if( abs(faab) < 100*FP.eps*maxcoeff )
   {
      if( faa >= 0.0 )
         return c;
      else
         return d;
   }

   // True quadratic

   else
   {
      crit = a - faa/(2.0*faab);

      // Convex quadratic

      if( faab > 0.0 )
         if( crit < c )
            return c;
         else if( crit > d )
            return d;
         else
            return crit;

      // Concave quadratic

      else
      {
         float cma = c-a;
         float dma = d-a;
         float fc = (faab*cma+faa)*cma+fa;
         float fd = (faab*dma+faa)*dma+fa;
         if( fc < fd )
            return c;
         else
            return d;
      }
   }
}

ostream & HCL_LineSearch_Fl_s::Write( ostream & str ) const
{
   str << "HCL_LineSearch_Fl_s Fletcher line search algorithm"
       << endl;
   str << "Parameter table:" << endl;
   return Parameters().Write( str );
}
