/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_LnSrch_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#include <iostream.h>
#include <stdio.h>
#include <float.h>
#include "maxmin_s.h"

#include "HCL_LineSearch_s.h"

HCL_LineSearch_DS_s::HCL_LineSearch_DS_s( const HCL_LineSearch_s & x )
{
   cerr << "Error: HCL_LineSearch_DS_s copy constructor called" << endl;
   exit(1);
}

HCL_LineSearch_DS_s::HCL_LineSearch_DS_s( char *fname ) 
{
   if( fname != NULL )
      ParamTable = new Table( fname,"LineSearchDS LineSearch",20 );
   else
      ParamTable = new Table;
   S = NULL;
   dump = NULL;
}

HCL_LineSearch_DS_s::~HCL_LineSearch_DS_s()
{
   if( DumpFlag && dump != NULL )
      delete dump;
   HCL_delete( S );
   HCL_delete( ParamTable );
}

void HCL_LineSearch_DS_s::Initialize( HCL_VectorSpace_s & dom )
{

   // Read the parameters

   int MinFlag = ParamTable->GetValue( "MinStep",MinStep );
   int MaxFlag = ParamTable->GetValue( "MaxStep",MaxStep );
   if( MinFlag && MaxFlag || (!MinFlag && !MaxFlag && MinStep >= MaxStep) )
   {
      MaxStep = 1.0e20;
      MinStep = 1.0e-20;
   }
   else if( MinFlag && !MaxFlag )
      MinStep = 1.0e-40*MaxStep;
   else if (MaxFlag && !MinFlag )
      MaxStep = 1.0e40*MinStep;
   if( ParamTable->GetValue( "MaxSample",MaxSample ) )
      MaxSample = 8;
   if( ParamTable->GetValue( "FcnDecreaseTol",FcnDecreaseTol ) )
      FcnDecreaseTol = 1.0e-4;
   if( ParamTable->GetValue( "SlopeDecreaseTol",SlopeDecreaseTol ) )
      SlopeDecreaseTol = 0.9;
   if( ParamTable->GetValue( "BracketIncrease",BracketIncrease ) )
      BracketIncrease = 2.0;
   if( ParamTable->GetValue( "ZeroDivideTol",ZeroDivideTol ) )
      ZeroDivideTol = 0.0;
   if( ParamTable->GetValue( "DispFlag",DispFlag ) )
      DispFlag = 0;
   if( ParamTable->GetValue( "DumpFlag",DumpFlag ) )
      DumpFlag = 0;
   if( ParamTable->GetValue( "DispPrecision",DispPrecision ) )
      DispPrecision = 6;
   OldDispPrec = cout.precision( DispPrecision );
   if( ParamTable->GetValue( "DumpPrecision",DumpPrecision ) )
      DumpPrecision = DispPrecision;
   if( DumpFlag && dump == NULL )
   {
      if( ParamTable->GetValue( "DumpFile",DumpFile ) )
         strcpy( DumpFile,"HCL_LineSearch_DS_s.DumpFile" );
      dump = new ofstream( DumpFile,ios::out );
      dump->precision( DumpPrecision );
   }
   else
      dump = NULL;

   // Check that S is consistent

   if( S != NULL )
   {
      if( S->Domain() != dom )
      {
         cerr << "Error in HCL_LineSearch_DS_s::Initialize: domain does "
                 "not match preconditioner" << endl;
         exit(1);
      }
      tmpvec = dom.Member();
   }
   else
      tmpvec = NULL;

   // allocate vectors

   Itn = 0;
}

// Deallocate vectors and fill in the output parameters
void HCL_LineSearch_DS_s::Clean()
{
   cout.precision( OldDispPrec );
   if( S != NULL )
      HCL_delete( tmpvec );
   
   ParamTable->PutValue("TermCode", TermCode);
   ParamTable->PutValue("MaxTkn", MaxTkn);
}

void HCL_LineSearch_DS_s::SetScaling( const HCL_LinearOp_s * SS )
{
   HCL_delete( S );
   S = (HCL_LinearOp_s*)SS;
   S->IncCount();
}

void HCL_LineSearch_DS_s::UnSetScaling()
{
   HCL_delete( S );
   S = NULL;
}

HCL_EvaluateFunctional_s *
HCL_LineSearch_DS_s::Search(HCL_Functional_s & f,
                            const HCL_Vector_s & xcur,HCL_Vector_s & xnext,
                            HCL_Vector_s & pdir,
                            HCL_EvaluateFunctional_s * xcur_eval )
{

   HCL_EvaluateFunctional_s * eval=NULL;
   int NumFcnSampled = 0;

   TermCode = NoErr;
   MaxTkn = 0;
   Initialize(f.Domain());

   if( DispFlag )
       cout << "===============HCL_LineSearch_DS_s===============" << endl;
   if( DumpFlag && dump != NULL )
       (*dump) << "===============HCL_LineSearch_DS_s===============" << endl;

   // Compute the length of the Newton step, and scale
   // the search direction (if necessary)

   float newtlen;
   if( S != NULL )
   {
      S->Image( pdir,*tmpvec );
      newtlen = sqrt(pdir.Inner( *tmpvec ));
   }
   else
      newtlen = pdir.Norm();

   float t = f.MaxStep( xcur,pdir ),fmaxs;
   if( t <= 0.0 )
   {
      cerr << "Error in HCL_LineSearch_DS_s: vector not in domain"
              " (fmaxs == 0.0)" << endl;
      exit(1);
   }
   HCL_FPArch_s arch;
   if( t == arch.large )
      fmaxs = t;
   else
      fmaxs = 0.99*newtlen*t;
   float fcnmaxstep = min( fmaxs,MaxStep );
   if( newtlen > fcnmaxstep )    // ||dir|| > MaxStep
   {
      float scale;
      if( ProtectedDivision( fcnmaxstep,newtlen,scale,ZeroDivideTol ) )
      {
         if( DispFlag > 1 )
            cout << "ProtectedDivision error: newtlen too small" 
                 << "   " << fcnmaxstep << "/" << newtlen << endl;
         if( DumpFlag > 1 && dump != NULL )
            (*dump) << "ProtectedDivision error: newtlen too small"
                    << "   " << fcnmaxstep << "/" << newtlen << endl;

         TermCode = NoReduction;
         Clean();
         return NULL;
      }
      pdir.Mul( scale );
      newtlen = fcnmaxstep;
      if( DispFlag > 1 )
         cout << "Vector dir is too long; multiply by " << scale << endl;
      if( DumpFlag > 1 && dump != NULL )
         (*dump) << "Vector dir is too long; multiply by " << scale << endl;
   }

   // Compute the initial slope; exit if not negative

   f_x = xcur_eval->ValueRef();
   float initslope = xcur_eval->GradientRef().Inner( pdir );
   
   if( initslope >= 0.0 )
   {
      if( DispFlag )
      {
         cout << "Initial slope nonnegative in line search" << endl;
         cout << "initslope: " << initslope << endl;
      }
      if( DumpFlag && dump != NULL )
      {
         (*dump) << "Initial slope nonnegative in line search" << endl;
         (*dump) << "initslope: " << initslope << endl;
      }
      TermCode = InitialSlopePositive;
      Clean();
      return NULL;
   }
   float minmu,maxmu;
   if( ProtectedDivision( MinStep,newtlen,minmu,ZeroDivideTol ) ||
       ProtectedDivision( fcnmaxstep,newtlen,maxmu,ZeroDivideTol ) )
   {
      if( DispFlag > 1 )
         cout << "Protected division failed (computing minmu and maxmu)"
              << "   " << MinStep << "/" << newtlen << ", "
              << fcnmaxstep << "/" << newtlen << endl;
      if( DumpFlag && dump != NULL )
         (*dump) << "Protected division failed (computing minmu and maxmu)"
                 << "   " << MinStep << "/" << newtlen << ", "
                 << fcnmaxstep << "/" << newtlen << endl;
      TermCode = NoReduction;
      Clean();
      return NULL;
   }
   
   float xnorm;
   
   if (DispFlag > 1 || (DumpFlag && dump != NULL))
      if( S != NULL )
      {
         S->Image( xcur,*tmpvec );
         xnorm = sqrt(xcur.Inner( *tmpvec ));
      }
      else 
         xnorm = xcur.Norm();

   if( DispFlag > 1 )
   {
      cout << "f = " << f_x << endl;
      cout << "||x|| = " << xnorm << endl;
      cout << "||dir|| = " << newtlen << endl;
      cout << "Initial slope = " << initslope << endl;
      cout << "Maximum step to boundary: " << fmaxs << endl;
      cout << "Minimum mu: " << minmu << endl;
      cout << "Maximum mu: " << maxmu << endl;
   }
   if( DumpFlag > 1 && dump != NULL )
   {
      (*dump) << "f = " << f_x << endl;
      (*dump) << "||x|| = " << xnorm << endl;
      (*dump) << "||dir|| = " << newtlen << endl;
      (*dump) << "Initial slope: " << initslope << endl;
      (*dump) << "Maximum step to boundary: " << fmaxs << endl;
      (*dump) << "Minimum mu: " << minmu << endl;
      (*dump) << "Maximum mu: " << maxmu << endl;
   }

   // Initialize mu and enter the main loop

   float mu = 1.0;
   mu = min( mu,maxmu );
   mu = max( mu,minmu );
   float mu0 = mu;
   int First = 1;
   do
   {

      // Declare some variables used in the iteration

      float muprev,mudiff,muincr,mutemp,mulo;
      float fhi,flo,fprev;
      float newslope;
      float t1,t2,t3,a,b,disc;

      // Compute xnext and fnext

      if( DispFlag > 1 ) cout << "mu = " << mu << endl;
      if( DumpFlag > 1 && dump != NULL ) (*dump) << "mu = " << mu << endl;

      xnext.AddScale( mu,xcur,pdir );
      if( !First )
         HCL_delete( eval );
      eval = f.Evaluate( xnext );
      First = 0;
      f_xnext = eval->ValueRef();
      NumFcnSampled++;

      // Check for sufficient decrease in the function value

      if( f_xnext <= f_x + FcnDecreaseTol*mu*initslope )
      {  
         // xnext satisfactory

         if( DispFlag > 1 )
            cout << NumFcnSampled << " Sufficient decrease in f; f+ = "
                 << f_xnext << endl;
         if( DumpFlag > 1 && dump != NULL )
            (*dump) << NumFcnSampled << " Sufficient decrease in f; f+ = "
                    << f_xnext << endl;

         // The function value has decreased sufficiently; compute
         // the gradient and check to see if the
         // slope in the search direction has increased
         // sufficiently (this prevents very short steps)

         newslope = eval->GradientRef().Inner( pdir );

         if( newslope < SlopeDecreaseTol*initslope )
         {
           // The slope in the search direction has not increased
           // sufficiently.


           if( DispFlag > 1 )
              cout << "Insufficient decrease in slope; new slope = "
                   << newslope << endl;
           if( DumpFlag > 1 && dump != NULL )
              (*dump) << "Insufficient decrease in slope; new slope = "
                   << newslope << endl;

            if( mu == mu0 && mu < maxmu )
            {

               // This is the first step.  Keep increasing the step 
               // length until there is simultaneously sufficient
               // decrease in the function and sufficient increase
               // in the gradient, or until the maximum step length
               // is reached or until there is no longer sufficient
               // decrease in the function.

               do
               {
                  muprev = mu;
                  fprev = f_xnext;
                  if( BracketIncrease*mu >= maxmu )
                     mu = 0.99*maxmu;
                  else
                     mu *= BracketIncrease;
                  xnext.AddScale( mu,xcur,pdir );

                  HCL_delete( eval );
                  eval = f.Evaluate( xnext );
                  f_xnext = eval->ValueRef();
                  NumFcnSampled++;


                  if( DispFlag > 1 )
                     cout << NumFcnSampled << " Increase mu to " << mu 
                          << " f+ = " << f_xnext << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << NumFcnSampled << " Increase mu to " << mu
                             << " f+ = " << f_xnext << endl;

                  if (f_xnext <= f_x + FcnDecreaseTol*mu*initslope)
                  {
                     newslope = eval->GradientRef().Inner( pdir );
                     if( DispFlag > 1 )
                        cout << "Sufficient decrease in function value; "
                                "new slope = " << newslope << endl;
                     if( DumpFlag > 1 && dump != NULL )
                        (*dump) << "Sufficient decrease in function value; "
                                "new slope = " << newslope << endl;
                  }
               }while( (f_xnext <= f_x+FcnDecreaseTol*mu*initslope &&
                        newslope < SlopeDecreaseTol*initslope &&
                        mu < 0.99*maxmu && NumFcnSampled < MaxSample )
                       || f_xnext == FLT_MAX );
            }
               
            if( mu < mu0 || (mu > mu0 &&
                f_xnext > f_x+FcnDecreaseTol*mu*initslope) )
            {

               // There is an acceptable step length
               // between mulo and the muhi; find it by using successive
               // quadratic interpolation.

               mulo = min( mu,muprev );
               mudiff = abs( mu-muprev );
               if( mu < mulo )
               {
                  flo = f_xnext;
                  fhi = fprev;
               }
               else
               {
                  flo = fprev;
                  fhi = f_xnext;
               }

               if( DispFlag > 1 )
                  cout << "An acceptable step length has been bracketed: ["
                       << mulo << "," << mulo+mudiff << "]" << endl;
               if( DumpFlag > 1 )
                  (*dump) << "An acceptable step length has been bracketed: ["
                       << mulo << "," << mulo+mudiff << "]" << endl;

               do
               {
                  if( ProtectedDivision( -newslope*mudiff*mudiff,
                                         2.0*(fhi-(flo+newslope*mudiff)),
                                         muincr,ZeroDivideTol ) )
                  {
                     if( DispFlag > 1 )
                        cout << "Protected division failed: searching "
                             << "within bracket" << endl
                             << "   " << -newslope*mudiff*mudiff << "/"
                             << 2.0*(fhi-(flo+newslope*mudiff)) << endl;
                     if( DumpFlag > 1 && dump != NULL )
                        (*dump) << "Protected division failed: searching "
                                << "within bracket" << endl
                                << "   " << -newslope*mudiff*mudiff << "/"
                                << 2.0*(fhi-(flo+newslope*mudiff)) << endl;
                     muincr = 0.2*mudiff;
                  }
                     
                  if (muincr < 0.2*mudiff)
                     muincr = 0.2*mudiff;

                  mu = mulo + muincr;
                  xnext.AddScale( mu,xcur,pdir );
                  HCL_delete( eval );
                  eval = f.Evaluate( xnext );
                  f_xnext = eval->ValueRef();
                  NumFcnSampled++;

                  if( DispFlag > 1 )
                     cout << NumFcnSampled 
                          << " Quadratic interpolation: mu = " << mu 
                          << " f+ = " << f_xnext << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << NumFcnSampled
                             << " Quadratic interpolation: mu = " << mu 
                             << " f+ = " << f_xnext << endl;

                  if (f_xnext > f_x+FcnDecreaseTol*mu*initslope)
                  {
                     mudiff = muincr;
                     fhi = f_xnext;
                     if( DispFlag > 1 )
                        cout << " Insufficient decrease in function value" 
                             << endl;
                     if( DumpFlag > 1 && dump != NULL )
                        (*dump) << " Insufficient decrease in function value" 
                                << endl;
                  }
                  else
                  {
                     if( DispFlag > 1 )
                        cout << "Sufficient decrease in function value "
                             << endl;
                     if( DumpFlag > 1 && dump != NULL )
                        (*dump) << "Sufficient decrease in function value "
                             << endl;

                     newslope = eval->GradientRef().Inner( pdir );

                     if( DispFlag > 1 )
                        cout << "new slope = " << newslope << endl;
                     if( DumpFlag > 1 && dump != NULL )
                        (*dump) << "new slope = " << newslope << endl;

                     if (newslope < SlopeDecreaseTol*initslope)
                     {
                        mulo = mu;
                        mudiff = mudiff - muincr;
                        flo = f_xnext;
                        if( DispFlag > 1 )
                           cout << "Insufficient decrease in slope; "
                                   "mudiff = " << mudiff << endl;
                        if( DumpFlag > 1 && dump != NULL )
                           (*dump) << "Insufficient decrease in slope; "
                                      "mudiff = " << mudiff << endl;
                     }
                  }
               }while( newslope < SlopeDecreaseTol*initslope 
                       && mudiff >= minmu && 
                       NumFcnSampled < MaxSample );
            }
            if( newslope < SlopeDecreaseTol*initslope )
            {
               TermCode = Fail;
               if( DispFlag )
               {
                  cout << NumFcnSampled << " mu = " << mu << endl;
                  cout << "Failed to satisfy SlopeDecreaseTol condition"
                       << endl;
               }
               if( DumpFlag && dump != NULL )
                  (*dump) << "Failed to satisfy SlopeDecreaseTol condition"
                          <<endl;
               if( mu*newtlen > 0.99*MaxStep )
                  MaxTkn = 1;
               Clean();
               return eval;
            }
            else
            {
               if( DispFlag > 1 )
                  cout << "Sufficient decrease in gradient; newslope = "
                       << newslope << endl;
               if( DumpFlag > 1 && dump != NULL )
                  (*dump) << "Sufficient decrease in gradient" << endl;
            }
         }
         else
         {
            if( DispFlag > 1 )
               cout << "Sufficient decrease in gradient; newslope = " 
                       << newslope << endl;
            if( DumpFlag > 1 && dump != NULL )
               (*dump) << "Sufficient decrease in gradient" << endl;
         }
         if( mu*newtlen > 0.99*MaxStep )
            MaxTkn = 1;
         
         // The line search was successful, so return xnext
         Clean();
         if( DispFlag )
            cout << NumFcnSampled << " mu = " << mu << endl;

         return eval;
      }
      else
      {
         // Failed to decrease function value sufficiently

         if( DispFlag > 1 )
            cout << NumFcnSampled
                 << " Insufficient decrease in function value" 
                 << " f+ = " << f_xnext << endl;
         if( DumpFlag > 1 && dump != NULL )
            (*dump) << NumFcnSampled
                    << " Insufficient decrease in function value"
                    << " f+ = " << f_xnext << endl;

         // Check to see if mu is too small

         if( mu <= minmu )
         {
            if( f_xnext < f_x )
            {
               TermCode = Fail;
               if( DispFlag )
               {
                  cout << NumFcnSampled << " mu = " << mu << endl;
                  cout << "Failed to make sufficient progress (mu too small)"
                       << endl;
               }
               if( DumpFlag && dump != NULL )
                (*dump) << "Failed to make sufficient progress (mu too small)"
                        << endl;
               Clean();
               return eval;
            }
            else
            {
               TermCode = NoReduction;
               if( DispFlag )
               {
                  cout << NumFcnSampled << " mu = " << mu << endl;
                  cout << "Failed to make progress (mu too small) " << endl;
               }
               if( DumpFlag && dump != NULL )
                  (*dump) << "Failed to make progress (mu too small) " << endl;
               Clean();
               if( !First ) HCL_delete( eval );
               return NULL;
            }
         }

         // Otherwise, perform cubic backtrack (quadratic on
         // first step).

         else
         {
            if( mu == mu0 )
            {
               if( ProtectedDivision( -initslope,
                                      2.0*(f_xnext-f_x-mu*initslope),
                                      mutemp,ZeroDivideTol ) )
               {
                     if( DispFlag > 1 )
                        cout << "Protected division failed: quadratic "
                             << "interpolation" << endl
                             << "   " << -newslope*mudiff*mudiff << "/"
                             << 2.0*(fhi-(flo+newslope*mudiff)) << endl;
                     if( DumpFlag > 1 && dump != NULL )
                        (*dump) << "Protected division failed: quadratic "
                                << "interpolation" << endl
                                << "   " << -newslope*mudiff*mudiff << "/"
                                << 2.0*(fhi-(flo+newslope*mudiff)) << endl;
                  mutemp = 0.5*mu;
               }
               if( DispFlag > 1 )
                  cout << "Quadratic backtrack: mutemp = " << mutemp << endl;
               if( DumpFlag > 1 && dump != NULL )
                  (*dump) << "Quadratic backtrack: mutemp = " << mutemp 
                          << endl;
            }
            else
            {
               t1 = f_xnext-f_x-mu*initslope;
               t2 = fprev-f_x-muprev*initslope;
               int FPErr = 0;
               if(FPErr = ProtectedDivision(1.0,mu-muprev,t3,ZeroDivideTol))
               {
                  if( DispFlag > 1 )
                     cout << "Protected division failed: cubic "
                             "interpolation (t3)" << endl
                          << 1.0 << "/" << mu-muprev << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << "Protected division failed: cubic "
                                "interpolation (t3)" << endl
                             << 1.0 << "/" << mu-muprev << endl;
                  goto FPErrTarget;
               }
               float v1,v2;
               if( FPErr = ProtectedDivision( t1,mu*mu,v1,ZeroDivideTol ) )
               {
                  if( DispFlag > 1 )
                     cout << "Protected division failed: cubic "
                             "interpolation (v1)" << endl
                          << t1 << "/" << mu*mu << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << "Protected division failed: cubic "
                                "interpolation (v1)" << endl
                             << t1 << "/" << mu*mu << endl;
                  goto FPErrTarget;
               }
               if(FPErr=ProtectedDivision(t2,muprev*muprev,v2,ZeroDivideTol))
               {
                  if( DispFlag > 1 )
                     cout << "Protected division failed: cubic "
                             "interpolation (v2)" << endl
                          << t2 << "/" << muprev*muprev << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << "Protected division failed: cubic "
                                "interpolation (v2)" << endl
                             << t2 << "/" << muprev*muprev << endl;
                  goto FPErrTarget;
               }
               a = t3*(v1-v2);
               b = t3*(mu*t2/(muprev*muprev)-muprev*t1/(mu*mu));
               disc = b*b-3.0*a*initslope;
               float w1,w2;
               if(FPErr=ProtectedDivision(-initslope,2.0*b,w1,ZeroDivideTol))
               {
                  if( DispFlag > 1 )
                     cout << "Protected division failed: cubic "
                             "interpolation (w1)" << endl
                          << -initslope << "/" << 2.0*b << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << "Protected division failed: cubic "
                                "interpolation (w1)" << endl
                             << -initslope << "/" << 2.0*b << endl;
                  goto FPErrTarget;
               }
               if(FPErr=ProtectedDivision(sqrt(disc)-b,3.0*a,w2,ZeroDivideTol))
               {
                  if( DispFlag > 1 )
                     cout << "Protected division failed: cubic "
                             "interpolation (w2)" << endl
                          << sqrt(disc)-b << "/" << 3.0*a << endl;
                  if( DumpFlag > 1 && dump != NULL )
                     (*dump) << "Protected division failed: cubic "
                                "interpolation (w2)" << endl
                             << sqrt(disc)-b << "/" << 3.0*a << endl;
                  goto FPErrTarget;
               }
FPErrTarget:   if( FPErr )
                  mutemp = 0.5*mu;
               else
                  mutemp=(a==0.0?w1:w2);
               if( DispFlag > 1 )
                  cout << "Cubic backtrack: mutemp = " << mutemp << endl;
               if( DumpFlag > 1 && dump != NULL )
                  (*dump) << "Cubic backtrack: mutemp = " << mutemp 
                          << endl;
            }
            mutemp = max( minmu,min( (float)0.5*mu,(float)mutemp ) );
         }
         muprev = mu;
         fprev = f_xnext;
         mu = max( (float)0.1*mu,(float)mutemp );
      }
   }while( NumFcnSampled < MaxSample );
   if( f_xnext < f_x )
   {
      TermCode = TooManyFunctionEvals;
      Clean();
      if( DispFlag )
         cout << NumFcnSampled << " mu = " << mu << endl;
      return eval;
   }
   else
   {
      TermCode = NoReduction;
      Clean();
      if( !First ) HCL_delete( eval );
      if( DispFlag )
         cout << NumFcnSampled << " mu = " << mu << endl;
      return NULL;
   }
}

ostream & HCL_LineSearch_DS_s::Write( ostream & str ) const
{
   str << "HCL_LineSearch_DS_s Dennis-Schnabel line search algorithm"
       << endl;
   str << "Parameter table:" << endl;
   return Parameters().Write( str );
}
