/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_UMinNLCG_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#include <iostream.h>
#include <stdio.h>
#include <float.h>
#include "maxmin_s.h"

#include "HCL_UMinNLCG_s.h"

extern ofstream fileout;

HCL_UMinNLCG_s::HCL_UMinNLCG_s( const HCL_UMinNLCG_s & um )
{
   cerr << "Error: HCL_UMinNLCG_s copy constructor called" << endl;
   exit(1);
}

HCL_UMinNLCG_s::HCL_UMinNLCG_s( HCL_LineSearch_s * linesearch,char *fname )
{
   if( fname != NULL )
      ParamTable = new Table( fname,"UMinNLCG UMin" );
   else
      ParamTable = new Table;
   if( linesearch )
   {
      lsearch = linesearch;
      linesearch->IncCount();
   }
   else
      lsearch = new HCL_LineSearch_Fl_s( fname );
   S = NULL;
   lsolver = NULL;
   dump = NULL;
   Steps = NULL;
   eval = NULL;
   fevalFlag = 0;
}

HCL_UMinNLCG_s::~HCL_UMinNLCG_s()
{
   if( fevalFlag ) HCL_delete( eval );
   HCL_delete( lsolver );
   HCL_delete( S );
   HCL_delete( lsearch );
   HCL_delete( ParamTable );
}


void HCL_UMinNLCG_s::Initialize( HCL_VectorSpace_s & dom )
{
   if( ParamTable->GetValue( "MaxItn",MaxItn ) )
   {
      MaxItn = 100;
      ParamTable->PutValue( "MaxItn",MaxItn );
   }
   if( ParamTable->GetValue( "Typf",Typf ) )
   {
      Typf = 1.0;
      ParamTable->PutValue( "Typf",Typf );
   }
   if( ParamTable->GetValue( "TypxNorm",TypxNorm ) )
   {
      TypxNorm = 1.0;
      ParamTable->PutValue( "TypxNorm",TypxNorm );
   }
   if( ParamTable->GetValue( "GradTol",GradTol ) )
   {
      GradTol = 1.0e-2;
      ParamTable->PutValue( "GradTol",GradTol );
   }
   int MinFlag = ParamTable->GetValue( "MinStep",MinStep );
   int MaxFlag = ParamTable->GetValue( "MaxStep",MaxStep );
   if( MinFlag && MaxFlag || (!MinFlag && !MaxFlag && MinStep >= MaxStep) )
   {
      MaxStep = 1.0e20;
      MinStep = 1.0e-20;
      ParamTable->PutValue( "MaxStep",MaxStep );
      ParamTable->PutValue( "MinStep",MinStep );
   }
   else if( MinFlag && !MaxFlag )
   {
      MinStep = 1.0e-40*MaxStep;
      ParamTable->PutValue( "MinStep",MinStep );
   }
   else if (MaxFlag && !MinFlag )
   {
      MaxStep = 1.0e40*MinStep;
      ParamTable->PutValue( "MaxStep",MaxStep );
   }
   if( ParamTable->GetValue( "CscMaxLimit",CscMaxLimit ) )
   {
      CscMaxLimit = 5;
      ParamTable->PutValue( "CscMaxLimit",CscMaxLimit );
   }
   if( ParamTable->GetValue( "DispFlag",DispFlag ) )
   {
      DispFlag = 0;
      ParamTable->PutValue( "DispFlag",DispFlag );
   }
   if( ParamTable->GetValue( "DumpFlag",DumpFlag ) )
   {
      DumpFlag = 0;
      ParamTable->PutValue( "DumpFlag",DumpFlag );
   }
   if( ParamTable->GetValue( "DispPrecision",DispPrecision ) )
   {
      DispPrecision = 6;
      ParamTable->PutValue( "DispPrecision",DispPrecision );
   }
   OldDispPrec = cout.precision( DispPrecision );
   if( ParamTable->GetValue( "DumpPrecision",DumpPrecision ) )
   {
      DumpPrecision = DispPrecision;
      ParamTable->PutValue( "DumpPrecision",DumpPrecision );
   }
   if( DumpFlag )
   {
      if( ParamTable->GetValue( "DumpFile",DumpFile ) )
      {
         strcpy( DumpFile,"HCL_UMinNLCG.DumpFile" );
         ParamTable->PutValue( "DumpFile",DumpFile );
      }
      dump = new ofstream( DumpFile,ios::out );
      dump->precision( DumpPrecision );
   }
   else
      dump = NULL;
   if( ParamTable->GetValue( "TraceSteps",TraceSteps ) )
   {
      TraceSteps = 0;
      ParamTable->PutValue( "TraceSteps",TraceSteps );
   }
   if( TraceSteps )
   {
      if( ParamTable->GetValue( "StepFile",StepFile ) )
      {
         strcpy( StepFile,"HCL_UMinNLCG_s.StepFile" );
         ParamTable->PutValue( "StepFile",StepFile );
      }
      Steps = new ofstream( StepFile,ios::out );
   }
   else
      Steps = NULL;

   if( S )
   {
      if( S->Domain() != dom )
      {
         cerr << "Error in HCL_UMinNLCG_s::Initialize: domain does not match"
                 " preconditioner" << endl;
         exit(1);
      }
      tmpvec1 = dom.Member();
      lsearch->SetScaling( S );
   }
   else
   {
      tmpvec1 = NULL;
      lsearch->UnSetScaling();
   }

   xnext = dom.Member();
   tmpvec = dom.Member();
   dir = dom.Member();
   step = dom.Member();
   Itn = 0;
   CscMax = 0;
}

void HCL_UMinNLCG_s::Clean()
{
   cout.precision( OldDispPrec );
   HCL_delete( step );
   HCL_delete( dir );
   HCL_delete( tmpvec1 );
   HCL_delete( tmpvec );
   HCL_delete( xnext );
   if( TraceSteps )
      delete Steps;
   if( DumpFlag )
      delete dump;

   ParamTable->PutValue( "TermCode",TermCode );
}

void HCL_UMinNLCG_s::SetScaling( HCL_LinearOp_s * SS,
                                   HCL_LinearSolver_s * ls )
{
   HCL_delete( S );
   HCL_delete( lsolver );
   S = SS;SS->IncCount();
   lsolver = ls;ls->IncCount();
}
   
void HCL_UMinNLCG_s::UnSetScaling()
{
   HCL_delete( S );
   HCL_delete( lsolver );
   S = NULL;
   lsolver = NULL;
}

int HCL_UMinNLCG_s::Minimize( HCL_Functional_s & f,HCL_Vector_s & x)
{
   //
   // Initialization
   //

   if( x.Space() != f.Domain() )
   {
      cerr << "Error in HCL_UMinNLCG_s::Minimize: vector is not in domain"
           << endl;
      exit(1);
   }
   
   // initialize parameters and temporary vectors

   Initialize( f.Domain() );

   TermCode = 0;
   int MaxTkn = 0;

   HCL_EvaluateFunctional_s * new_eval;

   if( fevalFlag ) HCL_delete( eval );
   eval = f.Evaluate( x );
   fevalFlag = 1;

   f_xcur = eval->ValueRef();

   dir->Mul( -1.0,eval->GradientRef() );

   // Check to see if initial point is stationary

   StDescDir = 1;
   TermCode = StoppingTest( x,*eval,0, 0 );
   gnorm = gnorm_next;

   // Main loop
   
   while( !TermCode )
   {      
      Display( f,x );

      // Line Search in the direction of 'dir'

      int ls_result;
      lsearch->Parameters().PutValue( "MaxStep",MaxStep*max(xnorm,TypxNorm) );
      lsearch->Parameters().PutValue( "MinStep",MinStep*max(xnorm,TypxNorm) );
      new_eval = lsearch->Search(f,x,*xnext,*dir,eval);
      if( new_eval == NULL )
         new_eval = eval;
      if( (lsearch->Parameters()).GetValue("TermCode", ls_result) )
      {
         cerr << "Error in HCL_UMinNLCG_s::Minimize: line search failed "
                 "to set LineSearch::TermCode" << endl;
         exit(1);
      }
      if( (lsearch->Parameters()).GetValue("MaxTkn", MaxTkn) )
      {
         cerr << "Error in HCL_UMinNLCG_s::Minimize: line search failed "
                 "to set LineSearch::MaxTkn" << endl;
         exit(1);
      }

      Itn++;
      TermCode = StoppingTest(x,*new_eval,ls_result, MaxTkn);

      if( TermCode )
      {      
         if ( ls_result >= 0 )
         {
            HCL_delete( eval );
            eval = new_eval;
            f_xcur = eval->ValueRef();
            gnorm = gnorm_next;
         }
         if( !ls_result ) StDescDir = 0;
         Display( f,x );
         Clean();
         return TermCode;
      }

      // Update search direction

      if ( ls_result )
      {
         // reset with neg. gradient as the search direction

         if( ls_result < 0 )
            dir->Mul( -1.0,eval->GradientRef() );
         else
            dir->Mul( -1.0,new_eval->GradientRef() );
         StDescDir = 1;
      }
      else
      {
         // update search direction with the Polak and Ribiere formula

         gnorm2 = gnorm*gnorm;
         tmpvec->Sub( new_eval->GradientRef(),eval->GradientRef() );
         float tmp1;
         if( lsolver )
         {
            lsolver->Solve( *S,new_eval->GradientRef(),*tmpvec1 );
            tmp1 = tmpvec->Inner( *tmpvec1 );
            float beta = tmp1/gnorm2;
            dir->Mul(beta);
            dir->Sub( *tmpvec1 );
         }
         else if( S )
         {
            S->InvImage( new_eval->GradientRef(),*tmpvec1 );
            tmp1 = tmpvec->Inner( *tmpvec1 );
            float beta = tmp1/gnorm2;
            dir->Mul(beta);
            dir->Sub( *tmpvec1 );
         }
         else
         {
            tmp1 = tmpvec->Inner( new_eval->GradientRef() );
            float beta = tmp1/gnorm2;
            dir->Mul(beta);
            dir->Sub( new_eval->GradientRef() );
         }

         StDescDir = 0;
      }

      // Prepare for next iteration

      if( ls_result >= 0 )
      {
         HCL_delete( eval );
         eval = new_eval;
         x.Copy( *xnext );
         f_xcur = eval->ValueRef();
         gnorm = gnorm_next;
      }
   }

   Clean();
   return TermCode;
}


void HCL_UMinNLCG_s::Display( const HCL_Functional_s & f,
                              const HCL_Vector_s & x )
{
   if( DispFlag > 1 || (DispFlag && TermCode) )
   {
      cout << endl << "===========HCL_UMinNLCG_s===============" << endl;
      cout << "iteration: " << Itn << endl;
      if (StDescDir)
	 cout << "Reset to steepest decent direction" << endl;;
      cout << " f = " << f_xcur << endl;
      cout << "||g|| = " << gnorm << endl;
      cout << endl << "========================================" << endl;
   }
   if( (DumpFlag > 1 || (DumpFlag && TermCode)) && dump != NULL )
   {
      if( Itn == 0 )
      {
         *dump << "Summary of HCL_UMinNLCG_s run" << endl;
         *dump << "-------------------------" << endl << endl;
         *dump << "f = " << endl;
         f.Write( *dump );
         *dump << endl << "ParamTable = " << endl;
         Parameters().Write( *dump );
         *dump << endl << endl;
      }
      (*dump) << endl << "======================" << endl;
      if (StDescDir)
          *dump << "Reset to steepest decent direction" << endl;
      (*dump) << "iteration: " << Itn << endl;
      (*dump) << " f = " << f_xcur << endl;
      (*dump) << "||g|| = " << gnorm << endl;
      (*dump) << endl << "======================" << endl;
   }
   if( TermCode )
   {
      if( DispFlag )
      {
         switch( TermCode )
         {
            case PossibleMinimizer:
               cout << "HCL_UMinNLCG_s terminated: Possible minimizer" 
                    << endl;
               break;
            case PossibleConvergence:
               cout << "HCL_UMinNLCG_s terminated: Possible convergence"
                    << endl;
               break;
            case LineSearchFailed:
               cout << "HCL_UMinNLCG_s terminated: Line search failed"
                    << endl;
               break;
            case PossibleDivergence:
               cout << "HCL_UMinNLCG_s terminated: Possible divergence"
                    << endl;
               break;
            case IterationLimit:
               cout << "HCL_UMinNLCG_s terminated: Iteration limit reached"
                    << endl;
               break;
            case InaccurateGradient:
               cout << "HCL_UMinNLCG_s terminated: Line search failed "
                       "because of inaccurate gradient" << endl;
               break;
            default:
               cout << "HCL_UMinNLCG_s terminated: Unknown termination code"
                    << endl;
               break;
         }
      }
      if( DumpFlag && dump != NULL )
      {
         switch( TermCode )
         {
            case PossibleMinimizer:
               (*dump) << "Terminated: Possible minimizer" << endl;
               break;
            case PossibleConvergence:
               (*dump) << "Terminated: Possible convergence" << endl;
               break;
            case LineSearchFailed:
               (*dump) << "Terminated: Line search failed" << endl;
               break;
            case PossibleDivergence:
               (*dump) << "Terminated: Possible divergence" << endl;
               break;
            case IterationLimit:
               (*dump) << "Terminated: Iteration limit reached" << endl;
               break;
            case InaccurateGradient:
               (*dump) << "Terminated: Line search failed due to "
                          "inaccurate gradient" << endl;
               break;
            default:
               (*dump) << "Terminated: Unknown termination code" << endl;
               break;
         }
      }
   }
   if( TraceSteps && Steps != NULL )
      x.Write( *Steps );
}

int HCL_UMinNLCG_s::StoppingTest( const HCL_Vector_s & x,
                                  HCL_EvaluateFunctional_s & eval0,
                                  int ls_result,int MaxTkn )
{
   if( StDescDir && ls_result == HCL_LineSearch_s::InitialSlopePositive )
      return InaccurateGradient;
   else if( StDescDir && ls_result < 0 )
      return LineSearchFailed;
   else if( ls_result < 0 )
      return 0;

   // Compute the norm of the gradient

   if( lsolver )
   {
      lsolver->Solve( *S,eval0.GradientRef(),*tmpvec1 );
      gnorm_next = sqrt( eval0.GradientRef().Inner( *tmpvec1 ) );
   }
   else if( S )
   {
      S->InvImage( eval0.GradientRef(),*tmpvec1 );
      gnorm_next = sqrt( eval0.GradientRef().Inner( *tmpvec1 ) );
   }
   else
     gnorm_next = eval0.GradientRef().Norm();

   // Check for an approximate stationary point
   

   if( S )
   {
      S->Image( x,*tmpvec1 );
      xnorm = sqrt( x.Inner( *tmpvec1 ) );
   }
   else
      xnorm = x.Norm();

   float RelGradNorm = max( xnorm,TypxNorm )*gnorm_next/
                        max( abs(eval0.ValueRef()),Typf );

   if( Itn == 0 )
      if( RelGradNorm < GradTol/1000.0 )
         return PossibleMinimizer;
      else if( Itn >= MaxItn )
         return IterationLimit;
      else
         return 0;

   if( RelGradNorm < GradTol )
      return PossibleMinimizer;

   // Compute the norm of the step

   step->Sub( *xnext,x );
   if( S )
   {
      S->Image( *step,*tmpvec1 );
      snorm = sqrt(step->Inner( *tmpvec1 ));
   }
   else
      snorm = step->Norm();

   // Check for convergence

   if( snorm/max( TypxNorm,xnorm ) < MinStep )
      return PossibleConvergence;

   // Check for iteration limit

   if( Itn >= MaxItn )
      return IterationLimit;

   // Check for divergence

   if( MaxTkn )
   {
      CscMax++;
      if( CscMax == CscMaxLimit )
         return PossibleDivergence;
   }
   else
      CscMax = 0;

   // No stopping criterion satisfied

   return 0;
}

HCL_EvaluateFunctional_s & HCL_UMinNLCG_s::LastEval() const
{
   if( !fevalFlag )
   {
      cerr << "Error in HCL_UMinNLCG_s::LastEval: evaluation object "
              "not set" << endl;
      exit(1);
   }
   return *eval;
}

ostream & HCL_UMinNLCG_s::Write( ostream & str ) const
{
   str << "HCL_UMinNLCG_s nonlinear conjugate gradient algorithm"
       << endl;
   str << "Parameter table:" << endl;
   return Parameters().Write( str );
}
