/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_Rn_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_Rn_s.h"

#ifndef RAND_MAX
#define RAND_MAX 32767
#endif

HCL_RnSpace_s::HCL_RnSpace_s()
{
   cerr << "Error: HCL_RnSpace_s default constructor called" << endl;
   exit(1);
}

int HCL_RnSpace_s::operator == ( const HCL_VectorSpace_s & xx ) const
{
   if( GetType() != xx.GetType() )
      return 0;
   HCL_RnSpace_s & x = (HCL_RnSpace_s&)xx;
   return (Dim() == x.Dim());
}

int HCL_RnSpace_s::operator != ( const HCL_VectorSpace_s & x ) const
{
   return !operator==( x );
}

HCL_Vector_s * HCL_RnSpace_s::Member() const { 
   return new HCL_RnVector_s( this->Dim() );
}

HCL_VectorSpace_s * HCL_RnSpace_s::Replicate() const
{
   return new HCL_RnSpace_s( this->Dim() );
}

ostream & HCL_RnSpace_s::Write( ostream & str ) const 
{
   str << "HCL_RnSpace_s with dimension " << dimension << endl;
   return str;
}

HCL_RnVector_s::HCL_RnVector_s()
{
   cerr << "Error: HCL_RnVector_s default constructor called" << endl;
   exit(1);
}

HCL_RnVector_s::HCL_RnVector_s( const HCL_RnVector_s & x )
{
  // no automatic save
  savename = NULL;
   sp = x.sp;sp->IncCount();
   int dim = sp->Dim();
   data = new float[dim];
   for( int i=0;i<dim;i++ ) data[i] = x.data[i];
   newdata=1;
}

HCL_RnVector_s::HCL_RnVector_s( HCL_RnSpace_s * s )
{
  // no automatic save
  savename = NULL;
   sp = s;s->IncCount();
   data = new float[s->Dim()];
   newdata=1;
}

HCL_RnVector_s::HCL_RnVector_s( const HCL_RnSpace_s & s, char * fname )
{
  sp = new HCL_RnSpace_s(s);
  data = new float[sp->Dim()];
   newdata=1;
  if ( fname != NULL ) {
    savename = new char[strlen(fname)+1];
    int i;
    for (i=0;i<strlen(fname)+1;i++) {
      savename[i]='\0';
    }
    strcpy(savename,fname);
  }
  else {
    savename = NULL;
  }
}

HCL_RnVector_s::HCL_RnVector_s( int n , float *d)
{
  // no automatic save
  savename = NULL;
   sp = new HCL_RnSpace_s( n );
   if (d) {
     data = d;
     newdata=0;
   }
   else {
     data = new float[n];
     newdata=1;
   }
}

HCL_RnVector_s::HCL_RnVector_s( char * fname,int save )
{
   ifstream filein( fname,ios::in | ios::nocreate );
   if( filein == NULL )
   {
      cerr << "Error in HCL_RnVector_s constructor: file " << fname
           << " does not exist" << endl;
      exit(1);
   }

   // NOTE BENE: automatic save feature added!
   int i;
   if (save) {
      savename = new char[strlen(fname)+1];
      for (i=0;i<strlen(fname)+1;i++) {
        savename[i]='\0';
      }
      strcpy(savename,fname);
   }
   else
     savename = NULL;

   int n;
   filein >> n;
   sp = new HCL_RnSpace_s( n );
   data = new float[n];
   newdata=1;
   for( i=0;i<n;i++ ) filein >> data[i];
}

HCL_RnVector_s::~HCL_RnVector_s()
{
  // automatic save feature
  if ( savename != NULL ) {
    Save(savename);
  }
  if (newdata) delete[] data;
  HCL_delete( sp );
}

void HCL_RnVector_s::Copy( const HCL_Vector_s & xx )
{
   // Check to verify that vectors belong to the same space

   if( Space() != xx.Space() )
   {
      cerr << "Error in HCL_RnVector_s::Copy: "
              "vectors do not belong to the same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;

   // copy the data

   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = x.data[i];
}

void HCL_RnVector_s::Neg()
{
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = -data[i];
}

void HCL_RnVector_s::Mul( const float & a )
{
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] *= a;
}

void HCL_RnVector_s::Mul( const float & a,const HCL_Vector_s & xx )
{
 if( Space() != xx.Space() )
 {
   cerr << "Error in HCL_RnVector_s::Mul: vectors are not from the same space"
        << endl;
   exit(1);
 }
 HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
 int n = Dim();
 for( int i=0;i<n;i++ ) data[i] = x.data[i]*a;
}

void HCL_RnVector_s::Add( const HCL_Vector_s & xx )
{
   if( Space() != xx.Space() )
   {
      cerr << "Error in HCL_RnVector_s::Add: vectors are not from the "
              "same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] += x.data[i];
}

void HCL_RnVector_s::Add( const HCL_Vector_s & xx,const HCL_Vector_s & yy )
{
   if( Space() != xx.Space() )
   {
     cerr<<"Error in HCL_RnVector_s::Add: vectors are not from the same space" 
         << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
   if( Space() != yy.Space() )
   {
      cerr <<"Error in HCL_RnVector_s::Add: vectors are not from the same space"
          << endl;
      exit(1);
   }
   HCL_RnVector_s & y = (HCL_RnVector_s&)yy;
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = x.data[i] + y.data[i];
}

float HCL_RnVector_s::Inner( const HCL_Vector_s & xx ) const
{
   if( Space() != xx.Space() )
   {
      cerr << "Error in HCL_RnVector_s::Inner: vectors are not from the "
               "same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
   int n = Dim();
   float a = 0.0;
   for( int i=0;i<n;i++ ) a += data[i]*x.data[i];
   return a;
}

void HCL_RnVector_s::Sub( const HCL_Vector_s & xx )
{
  if( Space() != xx.Space() )
  {
    cerr << "Error in HCL_RnVector_s::Sub: vectors are not from the same space"
         << endl;
     exit(1);
  }
  HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
  int n = Dim();
  for( int i=0;i<n;i++ ) data[i] -= x.data[i];
}

void HCL_RnVector_s::Sub( const HCL_Vector_s & xx,
                    const HCL_Vector_s & yy )
{
  if( Space() != xx.Space() )
  {
    cerr << "Error in HCL_RnVector_s::Sub: vectors are not from the same space"
         << endl;
     exit(1);
  }
  HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
  if( Space() != yy.Space() )
  {
    cerr << "Error in HCL_RnVector_s::Sub: vectors are not from the same space"
         << endl;
     exit(1);
  }
  HCL_RnVector_s & y = (HCL_RnVector_s&)yy;
  int n = Dim();
  for( int i=0;i<n;i++ ) data[i] = x.data[i] - y.data[i];
}

void HCL_RnVector_s::ScaleAdd( const float  & a,
                         const HCL_Vector_s & xx )
{
   if( Space() != xx.Space() )
   {
      cerr << "Error in HCL_RnVector_s::ScaleAdd: "
              "vectors are not from the same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = a*data[i] + x.data[i];
}

void HCL_RnVector_s::AddScale( const float  & a,
                         const HCL_Vector_s & xx )
{
   if( Space() != xx.Space() )
   {
      cerr << "Error in HCL_RnVector_s::AddScale: "
              "vectors are not from the same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = data[i] + x.data[i]*a;
}

void HCL_RnVector_s::AddScale( const float  & a,
                         const HCL_Vector_s & xx,
                         const HCL_Vector_s & yy )
{
   if( Space() != xx.Space() )
   {
      cerr << "Error in HCL_RnVector_s::AddScale: "
              "vectors are not from the same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & x = (HCL_RnVector_s&)xx;
   if( Space() != yy.Space() )
   {
      cerr << "Error in HCL_RnVector_s::AddScale: "
              "vectors are not from the same space" << endl;
      exit(1);
   }
   HCL_RnVector_s & y = (HCL_RnVector_s&)yy;
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = x.data[i] + y.data[i]*a;
}

float HCL_RnVector_s::Norm() const
{
   float a = 0.0;
   int n = Dim();
   for( int i=0;i<n;i++ ) a += data[i]*data[i];
   return sqrt(a);
}

float HCL_RnVector_s::Norm2() const
{
   int n = Dim();
   float a = 0.0;
   for( int i=0;i<n;i++ ) a += data[i]*data[i];
   return a;
}

void HCL_RnVector_s::Fill( float a )
{
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = a;
}

void HCL_RnVector_s::Zero()
{
   int n = Dim();
   for( int i=0;i<n;i++ ) data[i] = 0.0;
}

void HCL_RnVector_s::Random()
{
   int d = Dim();

   int DIST = 2;  // uniform distribution in (-1,1)
#ifdef SINGLE_PRECISION
   F77NAME(slarnv)(&DIST, rnd_seed, &d, data);
#else
   F77NAME(dlarnv)(&DIST, rnd_seed, &d, data);
#endif

#if 0
   float imax = 1.0/(float)RAND_MAX;
   for( int i=0;i<d;i++ )
   {
      float rn = (float)(rand());
      data[i] = rn*imax - 0.5;
   }
#endif
}

void HCL_RnVector_s::Save( char * fname )
{
   ofstream str( fname,ios::out );
   int n = Dim();
   str << n << endl;
   str << setprecision(16);
   for( int i=0;i<n;i++ ) str << "      " << data[i] << endl;
}

void HCL_RnVector_s::DiagScale( const HCL_Vector_s & x ) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagScale"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  int i;
  for (i=0;i<Dim();i++ ) {
    data[i] *= xx.data[i];
  }
}

void HCL_RnVector_s::DiagScale( const HCL_Vector_s & x,
			  const HCL_Vector_s & y) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagScale"<<endl;
    cerr<<"first parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"first parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }
  if (Space() != y.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagScale"<<endl;
    cerr<<"second parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"second parameter vector:"<<endl;
    y.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_RnVector_s & yy = (HCL_RnVector_s &)y;
  int i;
  for (i=0;i<Dim();i++ ) {
    data[i] = xx.data[i]*yy.data[i];
  }
}

void HCL_RnVector_s::DiagRecipScale( const HCL_Vector_s & x,
			       float tol) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagRecipScale"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  int i;
  HCL_FPArch_s FP;
  float thistol=max(tol,FP.sfmin);
  
  for (i=0;i<Dim();i++ ) {
    if (xx.data[i] >= 0.0) {
      data[i] = data[i]/max(xx.data[i],thistol);
    }
    else {
      data[i] = data[i]/min(xx.data[i],-thistol);
    }
  }
}

void HCL_RnVector_s::DiagRecipScale( const HCL_Vector_s & x,
			       const HCL_Vector_s & y,
			       float tol) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagRecipScale"<<endl;
    cerr<<"first parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"first parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }
  if (Space() != y.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagRecipScale"<<endl;
    cerr<<"second parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"second parameter vector:"<<endl;
    y.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_RnVector_s & yy = (HCL_RnVector_s &)y;
  int i;
  HCL_FPArch_s FP;
  float thistol=max(tol,FP.sfmin);
  
  for (i=0;i<Dim();i++ ) {
    if (xx.data[i] >= 0.0) {
      data[i] = yy.data[i]/max(xx.data[i],thistol);
    }
    else {
      data[i] = yy.data[i]/min(xx.data[i],-thistol);
    }
  }
}

float HCL_RnVector_s::Max() const {
  float M = -FLT_MAX;
  int i;
   
  for (i=0;i<Dim();i++ )
    M = (data[i]>M?data[i]:M);
  return M;
}

void HCL_RnVector_s::Max( const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Max"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;

  int i;
  for (i=0;i<Dim();i++ )

    data[i] = (data[i]<xx.data[i]?xx.data[i]:data[i]);
}

void HCL_RnVector_s::Max( const HCL_Vector_s & x,
		    const HCL_Vector_s & y ) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Max"<<endl;
    cerr<<"first parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"first parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }
  if (Space() != y.Space()) {
    cerr<<"Error: HCL_RnVector_s::Max"<<endl;
    cerr<<"second parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"second parameter vector:"<<endl;
    y.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_RnVector_s & yy = (HCL_RnVector_s &)y;

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (yy.data[i]<xx.data[i]?xx.data[i]:yy.data[i]);
}

float HCL_RnVector_s::Min() const {
  float M = FLT_MAX;
  int i;
   
  for (i=0;i<Dim();i++ )
    M = (data[i]<M?data[i]:M);
  return M;
}


void HCL_RnVector_s::Min( const HCL_Vector_s & x ) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Min"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (data[i]>xx.data[i]?xx.data[i]:data[i]);
}

void HCL_RnVector_s::Min( const HCL_Vector_s & x,
		    const HCL_Vector_s & y ) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Min"<<endl;
    cerr<<"first parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"first parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }
  if (Space() != y.Space()) {
    cerr<<"Error: HCL_RnVector_s::Min"<<endl;
    cerr<<"second parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"second parameter vector:"<<endl;
    y.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_RnVector_s & yy = (HCL_RnVector_s &)y;

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (yy.data[i]>xx.data[i]?xx.data[i]:yy.data[i]);
}

void HCL_RnVector_s::Greater( float t ) {
  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (data[i]>t?1.0:0.0);
}

void HCL_RnVector_s::Greater( const HCL_Vector_s & x ) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Greater"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (data[i]>xx.data[i]?1.0:0.0);
}

void HCL_RnVector_s::Greater( const HCL_Vector_s & x,
			const HCL_Vector_s & y )
{
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Greater"<<endl;
    cerr<<"first parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"first parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }
  if (Space() != y.Space()) {
    cerr<<"Error: HCL_RnVector_s::Greater"<<endl;
    cerr<<"second parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"second parameter vector:"<<endl;
    y.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_RnVector_s & yy = (HCL_RnVector_s &)y;

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]>yy.data[i]?1.0:0.0);
}

void HCL_RnVector_s::Greater( const HCL_Vector_s & x,
			float t ) {
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Greater"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]>t?1.0:0.0);
}

void HCL_RnVector_s::Greater( float t,const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Greater"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = (t>xx.data[i]?1.0:0.0);
}

float HCL_RnVector_s::Sum() const {

  float S = 0.0;
  int i;
   
  for (i=0;i<Dim();i++ )
    S += data[i];
  return S;
}

void HCL_RnVector_s::Add( float a ) {

  int i;

  for (i=0;i<Dim();i++ )
    data[i] += a;
}

void HCL_RnVector_s::Add( const HCL_Vector_s & x, float a ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Add"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  HCL_RnVector_s xx = (HCL_RnVector_s &)x;
  int i;

  for (i=0;i<Dim();i++ )
    data[i] = xx.data[i]+a;
}

void HCL_RnVector_s::Abs() {

  int i;
   
  for (i=0;i<Dim();i++ )
    data[i] = (data[i]>=0?data[i]:-data[i]);
}

void HCL_RnVector_s::Abs( const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Abs"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
   
  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]>=0.0?xx.data[i]:-xx.data[i]);
}

void HCL_RnVector_s::Sign() {

  int i;
   
  for (i=0;i<Dim();i++ )
    data[i] = (data[i]==0.0?0.0:(data[i]>0?1.0:-1.0));
}

void HCL_RnVector_s::Sign( float t ) {
  int i;
   
  for (i=0;i<Dim();i++ )
    data[i] = (data[i]==t?0.0:(data[i]>t?1.0:-1.0));
}

void HCL_RnVector_s::Sign( const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Sign"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
   
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;

  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]==data[i]?0.0:(data[i]>xx.data[i]?1.0:-1.0));
}

void HCL_RnVector_s::Sign( const HCL_Vector_s & x,
		     const HCL_Vector_s & y ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Sign"<<endl;
    cerr<<"first parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"first parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }
  if (Space() != y.Space()) {
    cerr<<"Error: HCL_RnVector_s::DiagRecipScale"<<endl;
    cerr<<"second parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    y.Write(cerr);
    exit(1);
  }

  int i;
   
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_RnVector_s & yy = (HCL_RnVector_s &)y;

  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]==yy.data[i]?0.0:(xx.data[i]>yy.data[i]?1.0:-1.0));
}

void HCL_RnVector_s::Sign( const HCL_Vector_s & x,
		     float t )
{
  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Sign"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
   
  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]==t?0.0:(xx.data[i]>t?1.0:-1.0));
}

void HCL_RnVector_s::Sign( float t,const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Sign"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
   
  for (i=0;i<Dim();i++ )
    data[i] = (xx.data[i]==t?0.0:(xx.data[i]<t?1.0:-1.0));
}

void HCL_RnVector_s::Power( float p ) {

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = pow( data[i],p );
}

void HCL_RnVector_s::Power( float p, const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Power"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  
  for (i=0; i<Dim(); i++) {
    data[i] = pow( xx.data[i], p );
  }
}

void HCL_RnVector_s::Sqrt() {

  int i;

  for (i=0; i<Dim(); i++) {
    if (data[i] < 0.0) {
      cerr<<"Error: HCL_RnVector_s::Sqrt"<<endl;
      cerr<<"entry "<<i<<" = "<<data[i]<<" negative"<<endl;
      exit(1);
    }
    data[i] = sqrt( data[i] );
  }
}

void HCL_RnVector_s::Sqrt( const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Sqrt"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  
  for (i=0; i<Dim(); i++) {
    if (xx.data[i] < 0.0) {
      cerr<<"Error: HCL_RnVector_s::Sqrt"<<endl;
      cerr<<"entry "<<i<<" = "<<xx.data[i]<<" negative"<<endl;
      exit(1);
    }
    data[i] = sqrt( xx.data[i] );
  }
}

void HCL_RnVector_s::Exp() {

  int i;
  for (i=0;i<Dim();i++ )
    data[i] = exp( data[i] );
}

void HCL_RnVector_s::Exp( const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Exp"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  
  for (i=0; i<Dim(); i++) {
    data[i] = exp( xx.data[i] );
  }
}

void HCL_RnVector_s::Log() {

  int i;

  HCL_FPArch_s FP;
  for (i=0; i<Dim(); i++) {
    if (data[i] <= FP.sfmin) {
      cerr<<"Error: HCL_RnVector_s::Log"<<endl;
      cerr<<"entry "<<i<<" = "<<data[i]<<" too small to take log"<<endl;
      exit(1);
    }
    data[i] = log( data[i] );
  }
}

void HCL_RnVector_s::Log( const HCL_Vector_s & x ) {

  if (Space() != x.Space()) {
    cerr<<"Error: HCL_RnVector_s::Log"<<endl;
    cerr<<"parameter HCL_Vector not in same space as object"<<endl;
    cerr<<"This HCL_RnVector_s:"<<endl;
    Write(cerr);
    cerr<<"parameter vector:"<<endl;
    x.Write(cerr);
    exit(1);
  }

  int i;
  HCL_RnVector_s & xx = (HCL_RnVector_s &)x;
  HCL_FPArch_s FP;

  for (i=0; i<Dim(); i++) {
    if (xx.data[i] <= FP.sfmin) {
      cerr<<"Error: HCL_RnVector_s::Log"<<endl;
      cerr<<"entry "<<i<<" = "<<xx.data[i]<<" too small to take log"<<endl;
      exit(1);
    }
    data[i] = log( xx.data[i] );
  }
}

ostream & HCL_RnVector_s::Write( ostream & str ) const {
  int n = Dim();
  str << setprecision(16);
  if( n<=10 )
  {
     str << "HCL_RnSpace_s with dimension " << n << endl;
     str << "Components are" << endl;
     for( int i=0;i<n;i++ ) str << "      " << data[i] << endl;
  }
  else
  {
     str << "HCL_RnSpace_s with dimension " << n << endl;
     str << "First 10 components are" << endl;
     for( int i=0;i<10;i++ ) str << "      " << data[i] << endl;
  }
  return str;
}

