/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_Fcnl_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_Functional_s.h"

HCL_EvaluateFunctional_s::HCL_EvaluateFunctional_s()
{
   valFlag = 0;
   SavedGradient = NULL;
   SavedHessian = NULL;
}

HCL_EvaluateFunctional_s::HCL_EvaluateFunctional_s(
                        const HCL_EvaluateFunctional_s & x )
{
   valFlag = x.valFlag;
   SavedValue = x.SavedValue;
   SavedGradient = x.SavedGradient;
   if( SavedGradient != NULL ) SavedGradient->IncCount();
   SavedHessian = x.SavedHessian;
   if( SavedHessian != NULL ) SavedHessian->IncCount();
}

HCL_EvaluateFunctional_s::~HCL_EvaluateFunctional_s()
{
   HCL_delete( SavedHessian );
   HCL_delete( SavedGradient );
}

void HCL_EvaluateFunctional_s::HessianImage( const HCL_Vector_s & dx,
                                             HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_EvaluateFunctional_s::HessianImage is not "
           "implemented" << endl;
   exit(1);
}

void HCL_EvaluateFunctional_s::HessianInvImage( const HCL_Vector_s & dy,
                                                HCL_Vector_s & dx ) const
{
   cerr << "Error: HCL_EvaluateFunctional_s::HessianInvImage is not "
           "implemented" << endl;
   exit(1);
}

float HCL_EvaluateFunctional_s::ValueRef() const
{
   if( !valFlag )
   {
      // Casting away const
      HCL_EvaluateFunctional_s * t = (HCL_EvaluateFunctional_s*)this;
      t->SavedValue = Value();
      t->valFlag = 1;
   }
   return SavedValue;
}

const HCL_Vector_s & HCL_EvaluateFunctional_s::GradientRef() const
{
   if( !SavedGradient )
   {
      // Casting away const
      HCL_EvaluateFunctional_s * t = (HCL_EvaluateFunctional_s*)this;
      t->SavedGradient = Domain().Member();
      Gradient( *(t->SavedGradient) );
   }
   return *SavedGradient;
}

HCL_LinearOp_s * HCL_EvaluateFunctional_s::Hessian() const
{
   return new HCL_FunctionalDefaultHessian_s( this );
}


const HCL_LinearOp_s & HCL_EvaluateFunctional_s::HessianRef() const
{
   if( SavedHessian == NULL )
   {
      // Casting away const
      HCL_EvaluateFunctional_s * t = (HCL_EvaluateFunctional_s*)this;
      t->SavedHessian = Hessian();
   }
   return *SavedHessian;
}
float HCL_Functional_s::Value1( const HCL_Vector_s & x ) const
{
   cerr << "Error: HCL_Functional_s::Value1 is not implemented" << endl;
   exit(1);
   return 0;
}

void HCL_Functional_s::Gradient1( const HCL_Vector_s & x,
                                        HCL_Vector_s & g ) const
{
   cerr << "Error: HCL_Functional_s::Gradient1 is not implemented" << endl;
   exit(1);
}

void HCL_Functional_s::HessianImage( const HCL_Vector_s & x,
                                     const HCL_Vector_s & dx,
                                           HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_Functional_s::HessianImage is not implemented" << endl;
   exit(1);
}

void HCL_Functional_s::HessianInvImage( const HCL_Vector_s & x,
                                        const HCL_Vector_s & dy,
                                              HCL_Vector_s & dx ) const
{
   cerr << "Error: HCL_Functional_s::HessianInvImage is not implemented"
        << endl;
   exit(1);
}

HCL_LinearOp_s * HCL_Functional_s::Hessian1( const HCL_Vector_s & x ) const
{
   return (HCL_LinearOp_s*)NULL;
}

HCL_EvaluateFunctional_s * HCL_Functional_s::Evaluate(
                           const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Functional_s::Evaluate: input vector "
              "is not in domain" << endl;
      cerr << "Domain:" << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector:" << endl;
      x.Space().Write( cerr );
      exit(1);
   }
   return new HCL_FunctionalDefaultEval_s( this,x );
}

float HCL_Functional_s::Value( const HCL_Vector_s & x ) const
{
   HCL_EvaluateFunctional_s * eval = Evaluate( x );
   float v = eval->Value();
   HCL_delete( eval );
   return v;
}

void HCL_Functional_s::Gradient( const HCL_Vector_s & x,
                                       HCL_Vector_s & g ) const
{
   HCL_EvaluateFunctional_s * eval = Evaluate( x );
   eval->Gradient( g );
   HCL_delete( eval );
}

HCL_LinearOp_s * HCL_Functional_s::Hessian( const HCL_Vector_s & x ) const
{
   HCL_EvaluateFunctional_s * eval = Evaluate( x );
   HCL_LinearOp_s * H = eval->Hessian();
   HCL_delete( eval );
   return H;
}

int HCL_Functional_s::CheckGrad( const HCL_Vector_s & y,
                                 const HCL_Vector_s & p,ostream & str,int n,
                                 float hmin,float hmax )
{
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_Functional_s::CheckGrad: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( p.Space() != Domain() )
   {
      cerr << "Error in HCL_Functional_s::CheckGrad: "
              "vector p is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      float temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   float hlimit1 = MaxStep( y,p );
   HCL_Vector_s * ptemp = p.Space().Member();
   ptemp->Mul( -1.0,p );
   float hlimit2 = MaxStep( y,*ptemp );
   HCL_delete( ptemp );
   float hlimit = min( hlimit1,hlimit2 );
   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_Functional_s::CheckGrad: direction is not "
              "feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_Vector_s * x = Domain().Member();
   HCL_Vector_s * g = Domain().Member();
   Gradient( y,*g );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   float d2 = g->Inner( p );
   float ad2 = abs( d2 );
   int rflag = 1;
   HCL_FPArch_s arch;
   if( ad2 < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_FunctionalHess_s::CheckGrad: norm of gradient is too "
          << endl << "small; displaying absolute error" << endl;
   }

   int i;
   float hstep = (hmax-hmin)/(n-1);
   if( rflag )
      str << setw(5) << "h" << setw(nd+1) << "slope" << setw(nd+11)
           << "cent. diff." << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+1) << "slope" << setw(nd+11)
           << "cent. diff." << setw(nd+4) << "Error" << endl;

   for( i=n-1;i>=0;i-- )
   {
      float h = hmin+i*hstep;
      x->Copy( y );
      x->AddScale( -h,p );
      float f1 = Value( *x );
      x->Copy( y );
      x->AddScale( h,p );
      float f2 = Value( *x );
      float d1 = (f2-f1)/(2.0*h);
      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << d2 << " " << setw(nd+6)
             << d1 << " " << setw(nd+6) << abs( d1-d2 )/ad2 << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << d2 << " " << setw(nd+6)
             << d1 << " " << setw(nd+6) << abs( d1-d2 ) << endl;
   }
   HCL_delete( g );
   HCL_delete( x );
   str.precision( oldprecision );
   return 0;
}

int HCL_Functional_s::CheckHess( const HCL_Vector_s & y,
                                 const HCL_Vector_s & p,ostream & str,
                                 int n,float hmin,float hmax )
{
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_Functional_s::CheckHess: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( p.Space() != Domain() )
   {
      cerr << "Error in HCL_Functional_s::CheckHess: "
              "vector p is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      float temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   float hlimit1 = MaxStep( y,p );
   HCL_Vector_s * ptemp = p.Space().Member();
   ptemp->Mul( -1.0,p );
   float hlimit2 = MaxStep( y,*ptemp );
   HCL_delete( ptemp );
   float hlimit = min( hlimit1,hlimit2 );
   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_Functional_s::CheckHess: direction is not "
              "feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_Vector_s * x1 = Domain().Member();
   HCL_Vector_s * x2 = Domain().Member();
   HCL_Vector_s * g1 = Domain().Member();
   HCL_Vector_s * g2 = Domain().Member();
   HCL_Vector_s * dg = Domain().Member();

   HCL_EvaluateFunctional_s * eval = Evaluate( y );
   HCL_LinearOp_s * hess = eval->Hessian();
   eval->Gradient( *dg );
   hess->Image( p,*dg );
   HCL_delete( hess );
   HCL_delete( eval );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   float dgnorm = dg->Norm();
   int rflag = 1;
   HCL_FPArch_s arch;
   if( dgnorm < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_Functional_s::CheckHess: norm of gradient is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+5) << "norm of diff." << setw(nd+6)
           << "norm" << setw(nd+6) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+5) << "norm of diff." << setw(nd+6)
           << "norm" << endl;
   int i;
   float hstep = (hmax-hmin)/(n-1);
   for( i=n-1;i>=0;i-- )
   {
      float h = hmin+i*hstep;
      x1->AddScale( -h,y,p );
      Gradient( *x1,*g1 );
      x2->AddScale( h,y,p );
      Gradient( *x2,*g2 );
      g2->Sub( *g1 );
      g2->Mul( 1.0/(2.0*h) );
      g2->Sub( *dg );
      float n1 = g2->Norm();
      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " 
             << setw(nd+6) << dgnorm << " " << setw(nd+6) << n1/dgnorm << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " 
             << setw(nd+6) << dgnorm << " " << endl;
   }
   HCL_delete( dg );
   HCL_delete( g2 );
   HCL_delete( g1 );
   HCL_delete( x2 );
   HCL_delete( x1 );
   str.precision( oldprecision );
   return 0;
}

void HCL_Functional_s::Scan( const HCL_Vector_s & x,const HCL_Vector_s & dx,
                             int N, float hmin, float hmax,
                             char * fname)
{
   if (x.Space() != Domain())
   {
      cerr<<"Error: HCL_Functional_s::Scan"<<endl;
      cerr<<"1st arg not member of domain"<<endl;
      cerr<<"Domain space:"<<endl;
      Domain().Write(cerr);
      cerr<<"input vector space:"<<endl;
      (x.Space()).Write(cerr);
      exit(1);
   }

   if (dx.Space() != Domain())
   {
      cerr<<"Error: HCL_Functional_s::Scan"<<endl;
      cerr<<"2nd arg not member of domain"<<endl;
      cerr<<"Domain space:"<<endl;
      Domain().Write(cerr);
      cerr<<"input vector space:"<<endl;
      (dx.Space()).Write(cerr);
      exit(1);
   }

   if (N <= 0)
   {
      cerr<<"Error: HCL_Functional_s::Scan"<<endl;
      cerr<<"Requested number of scan points = "<<N<<" not positive"<<endl;
      exit(1);
   }

    ostream * str;
    if( fname )
    {
       str = new ofstream(fname);
// The following command commented out because it won't compile
// under CC (SC5.0)
//       (*str)<<setiosflags(ios::showpoint);
    }
    else
       str = &cout;

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
    int oldprecision = str->precision( nd );

    if( hmax <= hmin )
    {
       float temp = hmax;
       hmax = hmin;
       hmin = temp;
    }
    if( hmax > 0.0 )
    {
       float hlimit = MaxStep( x,dx );
       if( hlimit <= 0.0 )
       {
          cerr << "Error in HCL_Functional_s::Scan: direction is not "
                  "feasible" << endl;
          exit(1);
       }       
       if( hmax >= hlimit )
       {
          hmax = 0.99*hlimit;
          if( hmin >= hmax )
             hmin = hmax/N;
       }
    }
    if( hmin < 0.0 )
    {
       HCL_Vector_s * ptemp = dx.Space().Member();
       ptemp->Mul( -1.0,dx );
       float hlimit = MaxStep( x,*ptemp );
       HCL_delete( ptemp );
       if( hlimit <= 0.0 )
       {
          cerr << "Error in HCL_Functional_s::Scan: direction is not "
                  "feasible" << endl;
          exit(1);
       }       
       if( hmin <= -hlimit )
       {
          hmin = -0.99*hlimit;
          if( hmin >= hmax )
             hmax = hmin/N;
       }
    }

    float dh;
    if (N == 1)
      dh=1.0;
    else
      dh=(hmax-hmin)/(N-1);
    float h = hmin;
    float v = 0.0;
    int i;

    HCL_Vector_s * z = Domain().Member();

    (*str)<<endl;
    (*str)<<"/////////////////////////////////////////////////////"<<endl;
    (*str)<<"//////////// HCL_Functional_s: SCAN RECORD ////////////"<<endl;
    (*str)<<"/////////////////////////////////////////////////////"<<endl;
    (*str)<<endl;

    for (i=0;i<N;i++) {
      h = hmin + i*dh;
      z->AddScale(h,x,dx);
      v = Value(*z);
      (*str) << setprecision(6) << setw(8) << h
             << "      " << setprecision(nd) << v << endl;
    }
    HCL_delete( z );
    if( fname ) delete str;
    str->precision( oldprecision );
}

float HCL_Functional_s::MaxStep( const HCL_Vector_s & x,
                                  const HCL_Vector_s & dir) const
{
   HCL_FPArch_s arch;
   return arch.large;
}

HCL_FunctionalDefaultEval_s::HCL_FunctionalDefaultEval_s()
{
   cerr << "Error: HCL_FunctionalDefaultEval_s default constructor "
           "not implemented" << endl;
   exit(1);
}

HCL_FunctionalDefaultEval_s::HCL_FunctionalDefaultEval_s(
                             const HCL_FunctionalDefaultEval_s & )
{
   cerr << "Error: HCL_FunctionalDefaultEval_s copy constructor "
           "not implemented" << endl;
   exit(1);
}

HCL_FunctionalDefaultEval_s::HCL_FunctionalDefaultEval_s(
                             const HCL_Functional_s * ff,
                             const HCL_Vector_s & in )
{
   f = ff;f->IncCount();
   x = in.Space().Member();
   x->Copy( in );
}

HCL_FunctionalDefaultEval_s::~HCL_FunctionalDefaultEval_s()
{
   HCL_delete( x );
   HCL_delete( (HCL_Functional_s*)f );
}

float HCL_FunctionalDefaultEval_s::Value() const
{
   return f->Value1( *x );
}

void HCL_FunctionalDefaultEval_s::Gradient( HCL_Vector_s & y ) const
{
   f->Gradient1( *x,y );
}

HCL_LinearOp_s * HCL_FunctionalDefaultEval_s::Hessian() const
{
   HCL_LinearOp_s * H = f->Hessian1( *x );
   if( H )
      return H;
   else
      return new HCL_FunctionalDefaultHessian_s( this );
}

ostream & HCL_FunctionalDefaultEval_s::Write( ostream & str ) const
{
   str << "HCL_FunctionalDefaultEval_s based on the following "
          "functional" << endl;
   return f->Write( str );
}

HCL_FunctionalDefaultHessian_s::HCL_FunctionalDefaultHessian_s()
{
   cerr << "Error: HCL_FunctionalDefaultHessian_s default "
           "constructor not implemented"
        << endl;
   exit(1);
}

HCL_FunctionalDefaultHessian_s::HCL_FunctionalDefaultHessian_s(
              const HCL_FunctionalDefaultHessian_s & L )
{
   cerr << "Error: HCL_FunctionalDefaultHessian_s copy "
           "constructor not implemented"
        << endl;
   exit(1);
}

HCL_FunctionalDefaultHessian_s::HCL_FunctionalDefaultHessian_s(
                     const HCL_EvaluateFunctional_s * ev )
{
   eval = ev;ev->IncCount();
}

HCL_FunctionalDefaultHessian_s::~HCL_FunctionalDefaultHessian_s()
{
   HCL_delete( (HCL_EvaluateFunctional_s*)eval );
}

HCL_VectorSpace_s & HCL_FunctionalDefaultHessian_s::Domain() const
{
   return eval->Domain();
}

HCL_VectorSpace_s & HCL_FunctionalDefaultHessian_s::Range() const
{
   return eval->Domain();
}

void HCL_FunctionalDefaultHessian_s::Image( const HCL_Vector_s & x,
                                                  HCL_Vector_s & y ) const
{
   eval->HessianImage( x,y );
}

void HCL_FunctionalDefaultHessian_s::AdjImage( const HCL_Vector_s & y,
                                                     HCL_Vector_s & x ) const
{
   eval->HessianImage( y,x );
}

void HCL_FunctionalDefaultHessian_s::InvImage(const HCL_Vector_s & y,
                                                    HCL_Vector_s & x) const
{
   eval->HessianInvImage( y,x );
}

void HCL_FunctionalDefaultHessian_s::InvAdjImage(const HCL_Vector_s & x,
                                                 HCL_Vector_s & y) const
{
   eval->HessianInvImage( x,y );
}

ostream & HCL_FunctionalDefaultHessian_s::Write( ostream & str ) const
{
   str << "HCL_FunctionalDefaultHessian_s based on the following "
          "evaluation object"
       << endl;
   return eval->Write( str );
}
