/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_Op_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_Op_s.h"

HCL_EvaluateOp_s::HCL_EvaluateOp_s()
{
   SavedImage = NULL;
   SavedDeriv = NULL;
   Saved2ndDeriv = NULL;
}

HCL_EvaluateOp_s::HCL_EvaluateOp_s(
             const HCL_EvaluateOp_s & e )
{
   if( e.SavedImage )
   {
      SavedImage = e.SavedImage;
      SavedImage->IncCount();
   }
   if( e.SavedDeriv )
   {
      SavedDeriv = e.SavedDeriv;
      SavedDeriv->IncCount();
   }
   if( e.Saved2ndDeriv )
   {
      Saved2ndDeriv = e.Saved2ndDeriv;
      Saved2ndDeriv->IncCount();
   }
}

HCL_EvaluateOp_s::~HCL_EvaluateOp_s()
{
   HCL_delete( Saved2ndDeriv );
   HCL_delete( SavedDeriv );
   HCL_delete( SavedImage );
}

const HCL_Vector_s & HCL_EvaluateOp_s::ImageRef() const
{
   HCL_EvaluateOp_s * t = (HCL_EvaluateOp_s*)this;
   if( SavedImage == NULL )
   {
      t->SavedImage = Range().Member();
      Image( *(t->SavedImage) );
   }
   return *SavedImage;
}

HCL_LinearOp_s * HCL_EvaluateOp_s::Deriv() const
{
   return new HCL_OpDefaultDeriv_s( this );
}

HCL_BiLinearOp_s * HCL_EvaluateOp_s::SecondDeriv() const
{
   return new HCL_OpDefaultSecondDeriv_s( this );
}

void HCL_EvaluateOp_s::DerivImage( const HCL_Vector_s & dx,
                                         HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_EvaluateOp_s::DerivImage not implemented" << endl;
   exit(1);
}

void HCL_EvaluateOp_s::DerivAdjImage( const HCL_Vector_s & dy,
                                            HCL_Vector_s & dx ) const
{
   cerr << "Error: HCL_EvaluateOp_s::DerivAdjImage not implemented" << endl;
   exit(1);
}

void HCL_EvaluateOp_s::DerivInvImage( const HCL_Vector_s & dy,
                                            HCL_Vector_s & dx ) const
{
   cerr << "Error: HCL_EvaluateOp_s::DerivInvImage not implemented" << endl;
   exit(1);
}

void HCL_EvaluateOp_s::DerivInvAdjImage( const HCL_Vector_s & dx,
                                             HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_EvaluateOp_s::DerivInvAdjImage not implemented" << endl;
   exit(1);
}

void HCL_EvaluateOp_s::SecondDerivImage( const HCL_Vector_s & dx1,
                                         const HCL_Vector_s & dx2,
                                               HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_EvaluateOp_s::SecondDerivImage not implemented" << endl;
   exit(1);
}

void HCL_EvaluateOp_s::SecondDerivPartialAdjImage( const HCL_Vector_s & dx1,
                                         const HCL_Vector_s & dy,
                                               HCL_Vector_s & dx2 ) const
{
   cerr << "Error: HCL_EvaluateOp_s::SecondDerivPartialAdjImage not "
           "implemented" << endl;
   exit(1);
}

void HCL_EvaluateOp_s::ImageAdd( HCL_Vector_s & y,float a,float b ) const
{
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_EvaluateOp_s::ImageAdd: " << endl
           << "output vector is not in range" << endl;
      cerr << "Space of output vector:" << endl;
      y.Space().Write( cerr );
      cerr << "Range:" << endl;
      Range().Write( cerr );
      exit(1);
   }
   HCL_FPArch_s arch;
   HCL_Vector_s * z = Range().Member();
   Image( *z );
   if( fabs(a-1.0) > arch.eps )
      z->Mul( a );
   if( fabs(b-1.0) > arch.eps )
      y.ScaleAdd( b,*z );
   else
      y.Add( *z );
   HCL_delete( z );
}

void HCL_EvaluateOp_s::ImageAdd( const HCL_Vector_s & z,
                                 HCL_Vector_s & y,float a,float b ) const
{
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_EvaluateOp_s::ImageAdd: " << endl
           << "output vector is not in range" << endl;
      cerr << "Space of output vector:" << endl;
      y.Space().Write( cerr );
      cerr << "Range:" << endl;
      Range().Write( cerr );
      exit(1);
   }
   if( z.Space() != Range() )
   {
      cerr << "Error in HCL_EvaluateOp_s::ImageAdd: " << endl
           << "input vector is not in range" << endl;
      cerr << "Space of input vector:" << endl;
      z.Space().Write( cerr );
      cerr << "Range:" << endl;
      Range().Write( cerr );
      exit(1);
   }
   HCL_FPArch_s arch;
   Image( y );
   if( fabs(a-1.0) > arch.eps )
      y.Mul( a );
   if( fabs(b-1.0) > arch.eps )
      y.ScaleAdd( b,z );
   else
      y.Add( z );
}

const HCL_LinearOp_s & HCL_EvaluateOp_s::DerivRef() const
{
   HCL_EvaluateOp_s * t = (HCL_EvaluateOp_s*)this;
   if( SavedDeriv == NULL )
      t->SavedDeriv = Deriv();
   return *SavedDeriv;
}

const HCL_BiLinearOp_s & HCL_EvaluateOp_s::SecondDerivRef() const
{
   HCL_EvaluateOp_s * t = (HCL_EvaluateOp_s*)this;
   if( Saved2ndDeriv == NULL )
      t->Saved2ndDeriv = SecondDeriv();
   return *Saved2ndDeriv;
}

HCL_Op_s::HCL_Op_s(){}
HCL_Op_s::HCL_Op_s( const HCL_Op_s & ){}
HCL_Op_s::~HCL_Op_s(){}

float HCL_Op_s::MaxStep( const HCL_Vector_s & x, 
                          const HCL_Vector_s &dir) const
{
   HCL_FPArch_s arch;
   return arch.large;
}

void HCL_Op_s::Image( const HCL_Vector_s & x,HCL_Vector_s & y ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in domain"
           << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   HCL_EvaluateOp_s * eval = Evaluate( x );
   eval->Image( y );
   HCL_delete( eval );
}

void HCL_Op_s::ImageAdd( const HCL_Vector_s & x,HCL_Vector_s & y,
                         float a,float b ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in domain"
           << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   HCL_EvaluateOp_s * eval = Evaluate( x );
   eval->ImageAdd( y,a,b );
   HCL_delete( eval );
}

void HCL_Op_s::ImageAdd( const HCL_Vector_s & x,const HCL_Vector_s & z,
                         HCL_Vector_s & y,
                         float a,float b ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in domain"
           << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   if( z.Space() != Range() )
   {
      cerr << "Error in HCL_Op_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   HCL_EvaluateOp_s * eval = Evaluate( x );
   eval->ImageAdd( z,y,a,b );
   HCL_delete( eval );
}

HCL_LinearOp_s * HCL_Op_s::Deriv( const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::Deriv: vector is not in domain" << endl;
      exit(1);
   }
   HCL_EvaluateOp_s * eval = Evaluate( x );
   HCL_LinearOp_s * D = eval->Deriv();
   HCL_delete( eval );
   return D;
}

int HCL_Op_s::CheckDeriv( const HCL_Vector_s & y,
                               const HCL_Vector_s & p,ostream & str,
                               int n,float hmin,float hmax ) const
{
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::CheckDeriv: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( p.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::CheckDeriv: "
              "vector p is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      float temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   float hlimit1 = MaxStep( y,p );
   HCL_Vector_s * ptemp = p.Space().Member();
   ptemp->Mul( -1.0,p );
   float hlimit2 = MaxStep( y,*ptemp );
   HCL_delete( ptemp );
   float hlimit = min( hlimit1,hlimit2 );
   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_Op_s::CheckDeriv: direction is not "
              "feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_Vector_s * x1 = Domain().Member();
   HCL_Vector_s * x2 = Domain().Member();
   HCL_Vector_s * g1 = Range().Member();
   HCL_Vector_s * g2 = Range().Member();
   HCL_Vector_s * dg = Range().Member();

   HCL_LinearOp_s * DFy = Deriv( y );
   DFy->Image( p,*dg );
   HCL_delete( DFy );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   float dgnorm = dg->Norm();
   int rflag = 1;
   HCL_FPArch_s arch;
   if( dgnorm < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_Op_s::CheckDeriv: norm of first variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << endl;
   int i;
   float hstep = (hmax-hmin)/(n-1);
   for( i=n-1;i>=0;i-- )
   {
      float h = hmin+i*hstep;
      x1->AddScale( -h,y,p );
      Image( *x1,*g1 );
      x2->AddScale( h,y,p );
      Image( *x2,*g2 );
      g2->Sub( *g1 );
      g2->Mul( 1.0/(2.0*h) );
      g2->Sub( *dg );
      float n1 = g2->Norm();
      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << " " << setw(nd+6) << n1/dgnorm << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << dgnorm << endl;
   }
   HCL_delete( dg );
   HCL_delete( g2 );
   HCL_delete( g1 );
   HCL_delete( x2 );
   HCL_delete( x1 );
   str.precision( oldprecision );
   return 0;
}

int HCL_Op_s::CheckDerivAdj( const HCL_Vector_s & y,
                             const HCL_Vector_s & p,ostream & str,
                             int n,float hmin,float hmax ) const
{
   CheckDeriv( y,p,str,n,hmin,hmax );
   HCL_LinearOp_s * D = Deriv( y );
   D->CheckAdj( 2 );
   HCL_delete( D );
   return 0;
}

int HCL_Op_s::CheckSecondDeriv( const HCL_Vector_s & y,
                               const HCL_Vector_s & p,ostream & str,
                               int n,float hmin,float hmax ) const
{
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::CheckSecondDeriv: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( p.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::CheckSecondDeriv: "
              "vector p is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      float temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   float hlimit1 = MaxStep( y,p );
   HCL_Vector_s * ptemp = p.Space().Member();
   ptemp->Mul( -1.0,p );
   float hlimit2 = MaxStep( y,*ptemp );
   HCL_delete( ptemp );
   float hlimit = min( hlimit1,hlimit2 );
   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_Op_s::CheckSecondDeriv: direction is not "
              "feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_Vector_s * x1 = Domain().Member();
   HCL_Vector_s * x2 = Domain().Member();
   HCL_Vector_s * g0 = Range().Member();
   HCL_Vector_s * g1 = Range().Member();
   HCL_Vector_s * g2 = Range().Member();
   HCL_Vector_s * d2g = Range().Member();

   HCL_BiLinearOp_s * D2Fy = SecondDeriv( y );
   D2Fy->Image( p,p,*d2g );
   HCL_delete( D2Fy );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   float d2gnorm = d2g->Norm();
   int rflag = 1;
   HCL_FPArch_s arch;
   if( d2gnorm < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_Op_s::CheckSecondDeriv: norm of second variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+1) << " norm of diff." << setw(nd+11)
           << "norm" << endl;
   int i;
   float hstep = (hmax-hmin)/(n-1);
   Image( y,*g0 );
   for( i=n-1;i>=0;i-- )
   {
      float h = hmin+i*hstep;
      x1->AddScale( -h,y,p );
      Image( *x1,*g1 );
      x2->AddScale( h,y,p );
      Image( *x2,*g2 );
      g2->Add( *g1 );
      g2->AddScale( -2.0,*g0 );
      g2->Mul( 1.0/(h*h) );
      g2->Sub( *d2g );
      float n1 = g2->Norm();
      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << d2gnorm << " " << setw(nd+6) << n1/d2gnorm << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << n1 << " " << setw(nd+6)
             << d2gnorm << endl;
   }
   HCL_delete( d2g );
   HCL_delete( g2 );
   HCL_delete( g1 );
   HCL_delete( g0 );
   HCL_delete( x2 );
   HCL_delete( x1 );
   str.precision( oldprecision );
   return 0;
}

int HCL_Op_s::CheckSecondDerivAdj( const HCL_Vector_s & y,
                                   const HCL_Vector_s & p,ostream & str,
                                   int n,float hmin,float hmax ) const
{
   CheckSecondDeriv( y,p,str,n,hmin,hmax );
   HCL_BiLinearOp_s * B = SecondDeriv( y );
   B->CheckAdj( 2 );
   HCL_delete( B );
   return 0;
}

HCL_BiLinearOp_s * HCL_Op_s::SecondDeriv( const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::SecondDeriv: vector is not in "
              "domain" << endl;
      exit(1);
   }
   HCL_EvaluateOp_s * eval = Evaluate( x );
   HCL_BiLinearOp_s * d = eval->SecondDeriv();
   HCL_delete( eval );
   return d;
}

void HCL_Op_s::DerivImage( const HCL_Vector_s & x,const HCL_Vector_s & dx,
                                 HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_Op_s::DerivImage not implemented" << endl;
   exit(1);
}

void HCL_Op_s::DerivAdjImage( const HCL_Vector_s & x,const HCL_Vector_s & dy,
                                    HCL_Vector_s & dx ) const
{
   cerr << "Error: HCL_Op_s::DerivAdjImage not implemented" << endl;
   exit(1);
}

void HCL_Op_s::DerivInvImage( const HCL_Vector_s & x,const HCL_Vector_s & dy,
                                            HCL_Vector_s & dx ) const
{
   cerr << "Error: HCL_Op_s::DerivInvImage not implemented" << endl;
   exit(1);
}

void HCL_Op_s::DerivInvAdjImage( const HCL_Vector_s & x,
                                 const HCL_Vector_s & dx,
                                       HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_Op_s::DerivInvAdjImage not implemented" << endl;
   exit(1);
}

void HCL_Op_s::SecondDerivImage( const HCL_Vector_s & x,
                                 const HCL_Vector_s & dx1,
                                 const HCL_Vector_s & dx2,
                                       HCL_Vector_s & dy ) const
{
   cerr << "Error: HCL_Op_s::SecondDerivImage not implemented" << endl;
   exit(1);
}

void HCL_Op_s::SecondDerivPartialAdjImage( const HCL_Vector_s & x,
                                           const HCL_Vector_s & dx1,
                                           const HCL_Vector_s & dy,
                                                 HCL_Vector_s & dx2 ) const
{
   cerr << "Error: HCL_Op_s::SecondDerivPartialAdjImage not implemented"
        << endl;
   exit(1);
}

HCL_EvaluateOp_s * HCL_Op_s::Evaluate( const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_Op_s::Evaluate: input vector is not in domain"
           << endl;
      cerr << "Domain:" << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector:" << endl;
      x.Space().Write( cerr );
      exit(1);
   }
   return new HCL_OpDefaultEval_s( this,x );
}

void HCL_Op_s::Image1( const HCL_Vector_s & x,HCL_Vector_s & y ) const
{
   cerr << "Error: HCL_Op_s::Image1 not implemented" << endl;
   exit(1);
}

HCL_LinearOp_s * HCL_Op_s::Deriv1( const HCL_Vector_s & x ) const
{
   return (HCL_LinearOp_s*)NULL;
}

HCL_BiLinearOp_s * HCL_Op_s::SecondDeriv1( const HCL_Vector_s & x ) const
{
   return (HCL_BiLinearOp_s*)NULL;
}

HCL_OpDefaultEval_s::HCL_OpDefaultEval_s()
{
   cerr << "Error: HCL_OpDefaultEval_s default constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultEval_s::HCL_OpDefaultEval_s( const HCL_OpDefaultEval_s & L )
{
   cerr << "Error: HCL_OpDefaultEval_s copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultEval_s::HCL_OpDefaultEval_s( const HCL_Op_s * op_,
                                          const HCL_Vector_s & in )
{
   op = op_;op->IncCount();
   x = in.Space().Member();
   x->Copy( in );
}

HCL_OpDefaultEval_s::~HCL_OpDefaultEval_s()
{
   HCL_delete( x );
   HCL_delete( (HCL_Op_s*)op );
}

HCL_LinearOp_s * HCL_OpDefaultEval_s::Deriv() const
{
   HCL_LinearOp_s * DFx = op->Deriv1( *x );
   if( DFx )
      return DFx;
   else
      return new HCL_OpDefaultDeriv_s( this );
}

HCL_BiLinearOp_s * HCL_OpDefaultEval_s::SecondDeriv() const
{
   HCL_BiLinearOp_s * D2Fx = op->SecondDeriv1( *x );
   if( D2Fx )
      return D2Fx;
   else
      return new HCL_OpDefaultSecondDeriv_s( this );
}

ostream & HCL_OpDefaultEval_s::Write( ostream & str ) const
{
   str << "HCL_OpPDDefaultEval_s" << endl;
   str << "Underlying operator is: " << endl;
   op->Write( str );
   return str;
}

HCL_OpDefaultDeriv_s::HCL_OpDefaultDeriv_s()
{
   cerr << "Error: HCL_OpDefaultDeriv_s default constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultDeriv_s::HCL_OpDefaultDeriv_s( const HCL_OpDefaultDeriv_s & L )
{
   cerr << "Error: HCL_OpDefaultDeriv_s copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultDeriv_s::HCL_OpDefaultDeriv_s( const HCL_EvaluateOp_s * ev )
{
   eval = ev;ev->IncCount();
}

HCL_OpDefaultDeriv_s::~HCL_OpDefaultDeriv_s()
{
   HCL_delete( (HCL_EvaluateOp_s*)eval );
}

HCL_VectorSpace_s & HCL_OpDefaultDeriv_s::Domain() const
{
   return eval->Domain();
}

HCL_VectorSpace_s & HCL_OpDefaultDeriv_s::Range() const
{
   return eval->Range();
}

void HCL_OpDefaultDeriv_s::Image( const HCL_Vector_s & x,
                                        HCL_Vector_s & y ) const
{
   eval->DerivImage( x,y );
}

void HCL_OpDefaultDeriv_s::AdjImage( const HCL_Vector_s & y,
                                           HCL_Vector_s & x ) const
{
   eval->DerivAdjImage( y,x );
}

void HCL_OpDefaultDeriv_s::InvImage(const HCL_Vector_s & y,
                                          HCL_Vector_s & x) const
{
   eval->DerivInvImage( y,x );
}

void HCL_OpDefaultDeriv_s::InvAdjImage(const HCL_Vector_s & x,
                                             HCL_Vector_s & y) const
{
   eval->DerivInvAdjImage( x,y );
}

ostream & HCL_OpDefaultDeriv_s::Write( ostream & str ) const
{
   str << "HCL_OpDefaultDeriv_s based on the following evaluation object"
       << endl;
   return eval->Write( str );
}

HCL_OpDefaultSecondDeriv_s::HCL_OpDefaultSecondDeriv_s()
{
   cerr << "Error: HCL_OpDefaultSecondDeriv_s default constructor not "
           "implemented" << endl;
   exit(1);
}

HCL_OpDefaultSecondDeriv_s::HCL_OpDefaultSecondDeriv_s(
                            const HCL_OpDefaultSecondDeriv_s & L )
{
   cerr << "Error: HCL_OpDefaultSecondDeriv_s copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_OpDefaultSecondDeriv_s::HCL_OpDefaultSecondDeriv_s(
                            const HCL_EvaluateOp_s * ev )
{
   eval = ev;ev->IncCount();
}

HCL_OpDefaultSecondDeriv_s::~HCL_OpDefaultSecondDeriv_s()
{
   HCL_delete( (HCL_EvaluateOp_s*)eval );
}

void HCL_OpDefaultSecondDeriv_s::Image( const HCL_Vector_s & dx1,
                                        const HCL_Vector_s & dx2,
                                              HCL_Vector_s & dy ) const
{
   eval->SecondDerivImage( dx1,dx2,dy );
}

void HCL_OpDefaultSecondDeriv_s::PartialAdjImage( int i,
                                              const HCL_Vector_s & xy,
                                              const HCL_Vector_s & z,
                                                    HCL_Vector_s & yx ) const
{
   eval->SecondDerivPartialAdjImage( xy,z,yx );
}

ostream & HCL_OpDefaultSecondDeriv_s::Write( ostream & str ) const
{
   str << "HCL_OpDefaultSecondDeriv_s based on the following evaluation object"
       << endl;
   return eval->Write( str );
}
