/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_BigMFcnl_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_BigMFcnl_s.h"

HCL_BigMFcnlHessian_s::HCL_BigMFcnlHessian_s()
{
   cerr << "Error: HCL_BigMFcnlHessian_s default constructor called" << endl;
   exit(1);
}

HCL_BigMFcnlHessian_s::HCL_BigMFcnlHessian_s(
                       const HCL_BigMFcnlHessian_s & L )
{
   cerr << "Error: HCL_BigMFcnlHessian_s copy constructor called" << endl;
   exit(1);
}

HCL_BigMFcnlHessian_s::HCL_BigMFcnlHessian_s( HCL_GenericProductSpace_s * d,
                                              HCL_LinearOp_s * AA,
                                              float MM,
                                              HCL_Vector_s * msk )
{
   dom = d;dom->IncCount();
   M = MM;
   A = AA;A->IncCount();
   mask = msk;mask->IncCount();
   msum = mask->Sum();
   temp = (A->Range().Member());
   Ate = A->Domain().Member();
   A->AdjImage( *mask,*Ate );
}

HCL_BigMFcnlHessian_s::~HCL_BigMFcnlHessian_s()
{
   HCL_delete( Ate );
   HCL_delete( temp );
   HCL_delete( mask );
   HCL_delete( A );
   HCL_delete( dom );
}

HCL_VectorSpace_s & HCL_BigMFcnlHessian_s::Domain() const
{
   return *dom;
}

HCL_VectorSpace_s & HCL_BigMFcnlHessian_s::Range() const
{
   return *dom;
}

void HCL_BigMFcnlHessian_s::Image( const HCL_Vector_s & xx,
                                         HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_BigMFcnlHessian_s::Image: vector is not in domain"
           << endl;
      exit(1);
   }
   HCL_GenericProductVector_s & x = (HCL_GenericProductVector_s&)xx;
   HCL_RnVector_s & tau1 = (HCL_RnVector_s&)x(2);
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_BigMFcnlHessian_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   HCL_GenericProductVector_s & y = (HCL_GenericProductVector_s&)yy;
   HCL_RnVector_s & tau2 = (HCL_RnVector_s&)y(2);

   A->Image( x(1),*temp );
   temp->DotStar( *mask );
   A->AdjImage( *temp,y(1) );
   y(1).AddScale( -tau1(1),*Ate );
   tau2(1) = (M + msum)*tau1(1) - x(1).Inner( *Ate );
}

ostream & HCL_BigMFcnlHessian_s::Write( ostream & str ) const
{
   str << "HCL_BigMFcnlHessian_s defined by M = " << M << " and" << endl;
   return A->Write( str );
}

HCL_EvalBigMFcnl_s::HCL_EvalBigMFcnl_s()
{
   cerr << "Error: HCL_EvalBigMFcnl_s default constructor called" << endl;
   exit(1);
}

HCL_EvalBigMFcnl_s::HCL_EvalBigMFcnl_s( const HCL_EvalBigMFcnl_s & )
{
   cerr << "Error: HCL_EvalBigMFcnl_s copy constructor called" << endl;
   exit(1);
}

HCL_EvalBigMFcnl_s::HCL_EvalBigMFcnl_s( const HCL_GenericProductVector_s & y,
                                        HCL_LinearOp_s * AA,
                                        HCL_Vector_s * b,
                                        float MM,float ee )
{
   x = y(1).Space().Member();
   x->Copy( y(1) );
   tau = ((HCL_RnVector_s&)(y(2)))(1);
   dom = (HCL_GenericProductSpace_s*)(&y.Space());dom->IncCount();
   A = AA;A->IncCount();
   M = MM;
   eps = ee;

   res = (b->Space().Member());
   A->Image( *x,*res );
   res->Sub( *b );
   res->Add( -(tau-eps) );

   mask = (b->Space().Member());
   mask->Greater( *res,0.0 );
   res->DotStar( *mask );
}
   
HCL_EvalBigMFcnl_s::~HCL_EvalBigMFcnl_s()
{
   HCL_delete( mask );
   HCL_delete( res );
   HCL_delete( A );
   HCL_delete( dom );
   HCL_delete( x );
}

HCL_VectorSpace_s & HCL_EvalBigMFcnl_s::Domain() const
{
   return *dom;
}

float HCL_EvalBigMFcnl_s::Value() const
{
  HCL_Vector_s * res2 = (A->Range().Member());
  res2->DotStar( *res,*res );

  float val = 0.5*(M*tau*tau + res2->Sum());
  HCL_delete( res2 );
  return val;
}

void HCL_EvalBigMFcnl_s::Gradient( HCL_Vector_s & gg ) const
{
   if( gg.Space() != Domain() )
   {
      cerr << "Error in HCL_EvalBigMFcnl_s::Gradient: vector is not in domain"
           << endl;
      exit(1);
   }
   HCL_GenericProductVector_s & g = (HCL_GenericProductVector_s&)gg;
   HCL_RnVector_s & t = (HCL_RnVector_s&)g(2);

   A->AdjImage( *res,g(1) );
   t(1) = M*tau-res->Sum();
}

HCL_LinearOp_s * HCL_EvalBigMFcnl_s::Hessian() const
{
   return new HCL_BigMFcnlHessian_s( dom,A,M,mask );
}

ostream & HCL_EvalBigMFcnl_s::Write( ostream & str ) const
{
   str << "HCL_EvalBigMFcnl_s object with: " << endl;
   str << "tau = " << tau << " M = " << M << endl;
   str << "A = " << endl;
   return A->Write( str );
}

HCL_BigMFcnl_s::HCL_BigMFcnl_s()
{
   cerr << "Error: HCL_BigMFcnl_s default constructor called" << endl;
   exit(1);
}

HCL_BigMFcnl_s::HCL_BigMFcnl_s( const HCL_BigMFcnl_s & )
{
   cerr << "Error: HCL_BigMFcnl_s copy constructor called" << endl;
   exit(1);
}

HCL_BigMFcnl_s::HCL_BigMFcnl_s( HCL_LinearOp_s * AA,
                                HCL_Vector_s * bb,
                                float MM,float eeps )
{
   if( bb->Space() != AA->Range() )
   {
      cerr << "Error in HCL_BigMFcnl_s constructor: vector must lie in "
              "range" << endl;
      exit(1);
   }
   A = AA;A->IncCount();
   b = bb;b->IncCount();
   dom = new HCL_GenericProductSpace_s( 2 );
   HCL_RnSpace_s * R1 = new HCL_RnSpace_s( 1 );
   dom->SetNext( &(A->Domain()) );
   dom->SetNext( R1 );
   HCL_delete( R1 );
   M = MM;
   eps = eeps;
}

HCL_BigMFcnl_s::~HCL_BigMFcnl_s()
{
   HCL_delete( dom );
   HCL_delete( b );
   HCL_delete( A );
}

HCL_VectorSpace_s & HCL_BigMFcnl_s::Domain() const
{
   return *dom;
}

HCL_EvaluateFunctional_s * HCL_BigMFcnl_s::Evaluate(
                               const HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_BigMFcnl_s::Evaluate: vector must lie in "
              "domain" << endl;
      exit(1);
   }
   HCL_GenericProductVector_s & x = (HCL_GenericProductVector_s&)xx;
   return new HCL_EvalBigMFcnl_s( x,A,b,M,eps );
}

ostream & HCL_BigMFcnl_s::Write( ostream & str ) const
{
   str << "HCL_BigMFcnl_s object with: " << endl;
   str << " M = " << M << endl;
   str << "A = " << endl;
   A->Write( str );
   str << "b = " << endl;
   return b->Write( str );
}

