/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_CmpLOp_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_CompLinearOp_s.h"

HCL_CompLinearOp_s::HCL_CompLinearOp_s()
{
   cerr << "Error: HCL_CompLinearOp_s default constructor is not implemented"
        << endl;
   exit(1);
}

HCL_CompLinearOp_s::HCL_CompLinearOp_s( const HCL_CompLinearOp_s & L )
{
   cerr << "Error: HCL_CompLinearOp_s copy constructor is not implemented"
        << endl;
   exit(1);
}

HCL_CompLinearOp_s::HCL_CompLinearOp_s( HCL_VectorSpace_s * d,
                                        HCL_VectorSpace_s * r,int n )
{
   num = n;
   dom = d;d->IncCount();
   range = r;r->IncCount();
   ops = new HCL_LinearOp_s *[num];
   numinit = 0;
}

HCL_CompLinearOp_s::HCL_CompLinearOp_s( HCL_LinearOp_s * op1,
                                        HCL_LinearOp_s * op2 )
{
   if( op1->Range() != op2->Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s constructor: operators are "
              "incompatible" << endl;
      exit(1);
   }
   num = 2;
   numinit = 2;
   ops = new HCL_LinearOp_s*[2];
   ops[0] = op1;op1->IncCount();
   ops[1] = op2;op2->IncCount();
   dom = &(op1->Domain());dom->IncCount();
   range = &(op2->Range());range->IncCount();
}

HCL_CompLinearOp_s::~HCL_CompLinearOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   int i;
   for( i=0;i<numinit;i++ )
      HCL_delete( ops[i] );
   delete[] ops;
}

void HCL_CompLinearOp_s::SetNext( HCL_LinearOp_s * L )
{
   if( numinit == num )
   {
      cerr << "Error in HCL_CompLinearOp_s::SetNext: "
              "too many factors" << endl;
      exit(1);
   }
   if( numinit == 0 )
   {
      if( L->Domain() != Domain() )
      {
         cerr << "Error in HCL_CompLinearOp_s::SetNext: "
                 "Domain and Range do not agree" << endl;
         exit(1);
      }
   }
   else if( L->Domain() != ops[numinit-1]->Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::SetNext: "
              "Domain and Range do not agree" << endl;
      exit(1);
   }
   if( numinit == num-1 && L->Range() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::SetNext: "
              "Domain and Range do not agree" << endl;
      exit(1);
   }
   ops[numinit] = L;L->IncCount();
   numinit++;
}

void HCL_CompLinearOp_s::Image( const HCL_Vector_s & x,
                                      HCL_Vector_s & y ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::Image: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::Image: vector is "
              "not in the Domain" << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::Image: vector is "
              "not in the Range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->Image( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   L->Image( *in,y );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::AdjImage( const HCL_Vector_s & x,
                                         HCL_Vector_s & y ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImage: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImage: vector is "
              "not in the Domain" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImage: vector is "
              "not in the Range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=num-1;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->AdjImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->AdjImage( *in,y );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::NormalImage( const HCL_Vector_s & x,
                                            HCL_Vector_s & y ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImage: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImage: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImage: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( num==1 )
   {
      ops[0]->NormalImage( x,y );
      return;
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->Image( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   out = L->Domain().Member();
   L->NormalImage( *in,*out );
   if( in != &x ) HCL_delete( in );
   in = out;
   for( i=num-2;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->AdjImage( *in,*out );
      HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->AdjImage( *in,y );
   HCL_delete( in );
}

void HCL_CompLinearOp_s::InvImage( const HCL_Vector_s & x,
                                         HCL_Vector_s & y ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImage: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImage: vector is "
              "not in the Domain" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImage: vector is "
              "not in the Range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=num-1;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->InvImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->InvImage( *in,y );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::InvAdjImage( const HCL_Vector_s & x,
                                            HCL_Vector_s & y ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImage: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImage: vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImage: vector is "
              "not in the range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->InvAdjImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   L->InvAdjImage( *in,y );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::ImageAdd( const HCL_Vector_s & x,
                                   const HCL_Vector_s & z,HCL_Vector_s & y,
                                   float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: output vector is "
              "not in the range" << endl;
      exit(1);
   }
   if( z.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: second input vector is "
              "not in the range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->Image( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   L->ImageAdd( *in,z,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::AdjImageAdd( const HCL_Vector_s & x,
                                      const HCL_Vector_s & z,HCL_Vector_s & y,
                                      float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: input vector is "
              "not in the range" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( z.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: second input "
              "vector is not in the domain" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=num-1;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->AdjImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->AdjImageAdd( *in,z,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::NormalImageAdd( const HCL_Vector_s & x,
                                         const HCL_Vector_s & z,
                                         HCL_Vector_s & y,float a,
                                         float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( z.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: second "
           << endl << "output vector is not in the domain" << endl;
      exit(1);
   }
   if( num==1 )
   {
      ops[0]->NormalImageAdd( x,z,y,a,b );
      return;
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->Image( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   out = L->Domain().Member();
   L->NormalImage( *in,*out );
   if( in != &x ) HCL_delete( in );
   in = out;
   for( i=num-2;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->AdjImage( *in,*out );
      HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->AdjImageAdd( *in,z,y,a,b );
   HCL_delete( in );
}

void HCL_CompLinearOp_s::InvImageAdd( const HCL_Vector_s & x,
                                 const HCL_Vector_s & z,
                                 HCL_Vector_s & y,float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: input vector is "
              "not in the range" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( z.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: second input "
              "vector is not in the domain" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=num-1;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->InvImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->InvImageAdd( *in,z,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::InvAdjImageAdd( const HCL_Vector_s & x,
                               const HCL_Vector_s & z,HCL_Vector_s & y,
                               float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: output vector is "
              "not in the range" << endl;
      exit(1);
   }
   if( z.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: second "
           << endl << "output vector is not in the range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->InvAdjImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   L->InvAdjImageAdd( *in,z,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::ImageAdd( const HCL_Vector_s & x,
                                   HCL_Vector_s & y,
                                   float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::ImageAdd: output vector is "
              "not in the range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->Image( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   L->ImageAdd( *in,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::AdjImageAdd( const HCL_Vector_s & x,
                                      HCL_Vector_s & y,
                                      float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: input vector is "
              "not in the range" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::AdjImageAdd: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=num-1;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->AdjImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->AdjImageAdd( *in,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::NormalImageAdd( const HCL_Vector_s & x,
                                         HCL_Vector_s & y,float a,
                                         float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::NormalImageAdd: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( num==1 )
   {
      ops[0]->NormalImageAdd( x,y,a,b );
      return;
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->Image( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   out = L->Domain().Member();
   L->NormalImage( *in,*out );
   if( in != &x ) HCL_delete( in );
   in = out;
   for( i=num-2;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->AdjImage( *in,*out );
      HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->AdjImageAdd( *in,y,a,b );
   HCL_delete( in );
}

void HCL_CompLinearOp_s::InvImageAdd( const HCL_Vector_s & x,
                                 HCL_Vector_s & y,float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: input vector is "
              "not in the range" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvImageAdd: output vector is "
              "not in the domain" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=num-1;i>0;i-- )
   {
      L = ops[i];
      out = L->Domain().Member();
      L->InvImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[0];
   L->InvImageAdd( *in,y,a,b );
   if( in != &x ) HCL_delete( in );
}

void HCL_CompLinearOp_s::InvAdjImageAdd( const HCL_Vector_s & x,
                               HCL_Vector_s & y,
                               float a,float b ) const
{
   if( numinit != num )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: operator has not "
              "been initialized" << endl;
      exit(1);
   }
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: input vector is "
              "not in the domain" << endl;
      exit(1);
   }
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_CompLinearOp_s::InvAdjImageAdd: output vector is "
              "not in the range" << endl;
      exit(1);
   }
   HCL_Vector_s * in = (HCL_Vector_s*)&x;
   HCL_Vector_s * out;
   HCL_LinearOp_s * L;
   int i;
   for( i=0;i<num-1;i++ )
   {
      L = ops[i];
      out = L->Range().Member();
      L->InvAdjImage( *in,*out );
      if( in != &x ) HCL_delete( in );
      in = out;
   }
   L = ops[num-1];
   L->InvAdjImageAdd( *in,y,a,b );
   if( in != &x ) HCL_delete( in );
}

ostream & HCL_CompLinearOp_s::Write( ostream & str ) const
{
   str << "Composition operator with factors"
       << endl;
   int i;
   for( i=0;i<numinit;i++ )
      ops[i]->Write( str );
   return str;
}
