/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_FcnlProdDom_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#include "HCL_FunctionalProductDomain_s.h"

void HCL_EvalFunctionalProductDomain_s::HessianBlockImage( int i,int j,
                                        const HCL_Vector_s & dxj,
                                              HCL_Vector_s & dxi ) const
{
   cerr << "Error: HCL_EvalFunctionalProductDomain_s::HessianBlockImage "
           "is not implemented" << endl;
   exit(1);
}

HCL_EvalFunctionalProductDomain_s::HCL_EvalFunctionalProductDomain_s()
{
   PartialGradFlags = NULL;
}

HCL_EvalFunctionalProductDomain_s::HCL_EvalFunctionalProductDomain_s(
                  const HCL_EvalFunctionalProductDomain_s & f )
{
   if( f.PartialGradFlags )
   {
      PartialGradFlags = new int[f.ProductDomain().Number()];
      int i;
      for( i=0;i<f.ProductDomain().Number();i++ )
         PartialGradFlags[i] = f.PartialGradFlags[i];
   }
   else
      PartialGradFlags = NULL;
}

HCL_EvalFunctionalProductDomain_s::~HCL_EvalFunctionalProductDomain_s()
{
   if( PartialGradFlags )
      delete[] PartialGradFlags;
}

HCL_ProductSpace_s & HCL_EvalFunctionalProductDomain_s::ProductDomain() const
{
   return (HCL_ProductSpace_s&)Domain();
}

void HCL_EvalFunctionalProductDomain_s::Gradient( HCL_Vector_s & gg ) const
{
   if( gg.Space() != Domain() )
   {
      cerr << "Error in HCL_EvalFunctionalProductDomain_s::Gradient: "
              "vector is not in domain" << endl;
      exit(1);
   }
   HCL_ProductVector_s & g = (HCL_ProductVector_s&)gg;
   int i;
   for( i=1;i<=ProductDomain().Number();i++ )
      PartialGradient( i,g(i) );
}

const HCL_Vector_s & HCL_EvalFunctionalProductDomain_s::GradientRef() const
{
   // Casting away const
   HCL_EvalFunctionalProductDomain_s * t =
                    (HCL_EvalFunctionalProductDomain_s*)this;
   int i;
   if( !SavedGradient )
   {
      t->PartialGradFlags = new int[ProductDomain().Number()];
      for( i=0;i<ProductDomain().Number();i++ )
         t->PartialGradFlags[i] = 0;
      t->SavedGradient = ProductDomain().Member();
   }
   HCL_ProductVector_s & g = (HCL_ProductVector_s&)(*SavedGradient);
   for( i=1;i<=ProductDomain().Number();i++ )
      if( !PartialGradFlags[i-1] )
      {
         PartialGradient( i,g(i) );
         t->PartialGradFlags[i-1] = 1;
      }

   return *SavedGradient;
}

const HCL_Vector_s & HCL_EvalFunctionalProductDomain_s::PartialGradientRef(
                                                      int i ) const
{
   // Casting away const
   HCL_EvalFunctionalProductDomain_s * t =
                    (HCL_EvalFunctionalProductDomain_s*)this;
   if( !SavedGradient )
   {
      t->PartialGradFlags = new int[ProductDomain().Number()];
      int j;
      for( j=0;j<ProductDomain().Number();j++ )
         t->PartialGradFlags[j] = 0;
      t->SavedGradient = ProductDomain().Member();
   }
   HCL_ProductVector_s & g = (HCL_ProductVector_s&)(*SavedGradient);
   if( !PartialGradFlags[i-1] )
      PartialGradient( i,g(i) );

   return g(i);
}

HCL_LinearOp_s * HCL_EvalFunctionalProductDomain_s::Hessian() const
{
   HCL_BlockLinearOp_s * HH = new HCL_BlockLinearOp_s( &(ProductDomain()),
                                                       &(ProductDomain()) );
   HCL_BlockLinearOp_s & H = (HCL_BlockLinearOp_s&)(*HH);
   int i,j;
   for( i=1;i<=ProductDomain().Number();i++ )
      for( j=1;j<=ProductDomain().Number();j++ )
      {
         HCL_LinearOp_s * L = HessianBlock( i,j );
         H.Set( i,j,L );
         HCL_delete( L );
      }
   return HH;
}

const HCL_LinearOp_s & HCL_EvalFunctionalProductDomain_s::HessianRef() const
{
   // Casting away const
   HCL_EvalFunctionalProductDomain_s * t =
                    (HCL_EvalFunctionalProductDomain_s*)this;
   if( !SavedHessian )
      t->SavedHessian = new HCL_BlockLinearOp_s( &(ProductDomain()),
                                                 &(ProductDomain()) );
   int i,j;
   HCL_BlockLinearOp_s & H = (HCL_BlockLinearOp_s&)(*SavedHessian);
   for( i=1;i<=ProductDomain().Number();i++ )
      for( j=1;j<=ProductDomain().Number();j++ )
         if( !H.IsSet( i,j ) )
         {
            HCL_LinearOp_s * L = HessianBlock( i,j );
            H.Set( i,j,L );
            HCL_delete( L );
         }
   return *SavedHessian;      
}

HCL_LinearOp_s * HCL_EvalFunctionalProductDomain_s::HessianBlock(
                                   int i,int j ) const
{
   return new HCL_FunctionalDefaultHessianBlock_s( i,j,this );
}

const HCL_LinearOp_s &
      HCL_EvalFunctionalProductDomain_s::HessianBlockRef(int i,int j ) const
{
   // Casting away const
   HCL_EvalFunctionalProductDomain_s * t =
                    (HCL_EvalFunctionalProductDomain_s*)this;
   if( !SavedHessian )
      t->SavedHessian = new HCL_BlockLinearOp_s( &(ProductDomain()),
                                                 &(ProductDomain()) );
   HCL_BlockLinearOp_s & H = (HCL_BlockLinearOp_s&)(*SavedHessian);
   if( !H.IsSet( i,j ) )
   {
      HCL_LinearOp_s * L = HessianBlock( i,j );
      H.Set( i,j,L );
      HCL_delete( L );
   }
   return H(i,j);      
}

float HCL_FunctionalProductDomain_s::Value1( const HCL_Vector_s & x ) const
{
   cerr << "Error: HCL_FunctionalProductDomain_s::Value1 is not implemented"
        << endl;
   exit(1);
   return 0;
}

void HCL_FunctionalProductDomain_s::PartialGradient1( int i,
                                    const HCL_Vector_s & x,
                                          HCL_Vector_s & g ) const
{
   cerr << "Error: HCL_FunctionalProductDomain_s::PartialGradient1 is "
           "not implemented" << endl;
   exit(1);
}

void HCL_FunctionalProductDomain_s::HessianBlockImage( int i,int j,
                                    const HCL_Vector_s & x,
                                    const HCL_Vector_s & dxj,
                                          HCL_Vector_s & dxi ) const
{
   cerr << "Error: HCL_FunctionalProductDomain_s::HessianBlockImage "
           "is not implemented" << endl;
   exit(1);
}

HCL_LinearOp_s * HCL_FunctionalProductDomain_s::HessianBlock1(int i,int j,
                     const HCL_Vector_s & x ) const
{
   return (HCL_LinearOp_s*)NULL;
}

HCL_FunctionalProductDomain_s::HCL_FunctionalProductDomain_s()
{
}

HCL_FunctionalProductDomain_s::HCL_FunctionalProductDomain_s(
                  const HCL_FunctionalProductDomain_s & )
{
}

HCL_FunctionalProductDomain_s::~HCL_FunctionalProductDomain_s()
{
}

HCL_ProductSpace_s & HCL_FunctionalProductDomain_s::ProductDomain() const
{
   return (HCL_ProductSpace_s&)Domain();
}

HCL_EvaluateFunctional_s * HCL_FunctionalProductDomain_s::Evaluate(
                           const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::Evaluate: input vector "
              "is not in domain" << endl;
      cerr << "Domain:" << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector:" << endl;
      x.Space().Write( cerr );
      exit(1);
   }
   return new HCL_FunctionalProductDomainDefaultEval_s( this,x );
}

void HCL_FunctionalProductDomain_s::PartialGradient( int i,
          const HCL_Vector_s & x,HCL_Vector_s & g ) const
{
   HCL_EvalFunctionalProductDomain_s * eval = 
           (HCL_EvalFunctionalProductDomain_s*)Evaluate( x );
   eval->PartialGradient( i,g );
   HCL_delete( eval );
}

HCL_LinearOp_s * HCL_FunctionalProductDomain_s::HessianBlock( int i,int j,
                               const HCL_Vector_s & x ) const
{
   HCL_EvalFunctionalProductDomain_s * eval = 
           (HCL_EvalFunctionalProductDomain_s*)Evaluate( x );
   HCL_LinearOp_s * h = eval->HessianBlock( i,j );
   HCL_delete( eval );
   return h;
}

// This method checks the analytic second derivatives against the
// second order finite-difference formula
//
//     \[D_{ij}f(x)(\delta x_j,\delta x_i) \doteq 
//          f(x+\tilde{\delta x_i}+\tilde{\delta x_j})+
//          f(x-\tilde{\delta x_i}-\tilde{\delta x_j})-
//          f(x+\tilde{\delta x_i})-
//          f(x-\tilde{\delta x_i})-
//          f(x+\tilde{\delta x_j})-
//          f(x-\tilde{\delta x_j})+2f(x)\].
//
//  Here $\tilde{\delta x_i}$ is the vector in the domain of $f$ with every
//  component equal to zero except the $i$th, which equals $\delta x_i$.

int HCL_FunctionalProductDomain_s::CheckHessianBlock( const HCL_Vector_s & y,
                             const HCL_Vector_s & pi,
                             const HCL_Vector_s & pj, int i,int j,
                             ostream & str,int n,float hmin,
                             float hmax ) const
{
   if( i==j )
      return CheckHessianBlock( y,pi,i,str,n,hmin,hmax );
      
   if( i < 1 || i > ProductDomain().Number() || j < 1 ||
       j > ProductDomain().Number() )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::"
              "CheckHessianBlock:" << endl
           << "   invalid index" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::"
              "CheckHessianBlock:" << endl
           << "   vector y is not in Domain" << endl;
      exit(1);
   }
   if( pi.Space() != ProductDomain()(i) )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::"
              "CheckHessianBlock:" << endl
           << "   vector pi is not in Domain" << endl;
      exit(1);
   }
   if( pj.Space() != ProductDomain()(j) )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::"
              "CheckHessianBlock:" << endl
           << "   vector pj is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      float temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   // There are now six directions to check: pi+pj,-pi-pj,pi,-pi,pj,-pj
   HCL_ProductVector_s * yp = (HCL_ProductVector_s*)ProductDomain().Member();
   yp->Zero();
   (*yp)(i).Copy( pi );
   (*yp)(j).Copy( pj );
   float hlimit = MaxStep( y,*yp );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Zero();
   (*yp)(i).Copy( pi );
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Zero();
   (*yp)(j).Copy( pj );
   hlimit = min( MaxStep( y,*yp ), hlimit );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   HCL_delete( yp );

   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::"
              "CheckHessianBlock:" << endl
           << "   direction is not feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_ProductVector_s * x1 = (HCL_ProductVector_s*)(Domain().Member());
   HCL_Vector_s * pi1 = ProductDomain()(i).Member();
   float v0,dv;

   v0 = Value( y );
   HCL_LinearOp_s * D2fy = HessianBlock( i,j,y );
   D2fy->Image( pj,*pi1 );
   HCL_delete( D2fy );
   dv = pi.Inner( *pi1 );
   HCL_delete( pi1 );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   float dvmag = abs(dv);
   int rflag = 1;
   HCL_FPArch_s arch;
   if( dvmag < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_FunctionalProductDomain_s::CheckHessianBlock: norm of "
             "second variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+6) << "2nd variation" << setw(nd+6)
           << "cent. diff." << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+6) << "2nd variation" << setw(nd+6)
           << "cent. diff." << setw(nd+4) << "Error" << endl;
   int ii;
   float hstep = (hmax-hmin)/(n-1);
   for( ii=n-1;ii>=0;ii-- )
   {
      float v = 2.0*v0;
      float h = hmin+ii*hstep;
      x1->Copy( y );
      (*x1)(i).AddScale( h,pi );
      (*x1)(j).AddScale( h,pj );
      v += Value( *x1 );

      x1->Copy( y );
      (*x1)(i).AddScale( -h,pi );
      (*x1)(j).AddScale( -h,pj );
      v += Value( *x1 );

      x1->Copy( y );
      (*x1)(i).AddScale( h,pi );
      v -= Value( *x1 );

      x1->Copy( y );
      (*x1)(i).AddScale( -h,pi );
      v -= Value( *x1 );

      x1->Copy( y );
      (*x1)(j).AddScale( h,pj );
      v -= Value( *x1 );

      x1->Copy( y );
      (*x1)(j).AddScale( -h,pj );
      v -= Value( *x1 );

      v /= (2.0*h*h);
      float n1 = abs(v-dv);

      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << dv << " " << setw(nd+6)
             << v << " " << setw(nd+6) << n1/dvmag << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << dv << " " << setw(nd+6)
             << v << " " << setw(nd+6) << n1 << endl;
   }
   str.precision( oldprecision );
   return 0;
}

int HCL_FunctionalProductDomain_s::CheckHessianBlock( const HCL_Vector_s & y,
                             const HCL_Vector_s & pi,
                             int i,ostream & str,int n,float hmin,
                             float hmax ) const
{
   if( i < 1 || i > ProductDomain().Number() )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::CheckHessianBlock: "
               "invalid index" << endl;
      exit(1);
   }
   if( y.Space() != Domain() )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::CheckHessianBlock: "
               "vector y is not in Domain" << endl;
      exit(1);
   }
   if( pi.Space() != ProductDomain()(i) )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::CheckHessianBlock: "
              "vector pi is not in Domain" << endl;
      exit(1);
   }

   if( hmax <= hmin )
   {
      float temp = hmax;
      hmax = hmin;
      hmin = temp;
   }
   if( hmin <= 0.0 )
   {
      hmin = 0.1;
      hmax = 1.0;
   }
   if( n <= 0 )
      n = 10;

   HCL_ProductVector_s * yp = (HCL_ProductVector_s*)ProductDomain().Member();
   yp->Zero();
   (*yp)(i).Copy( pi );
   float hlimit = MaxStep( y,*yp );
   yp->Neg();
   hlimit = min( MaxStep( y,*yp ), hlimit );
   HCL_delete( yp );

   if( hlimit <= 0.0 )
   {
      cerr << "Error in HCL_FunctionalProductDomain_s::CheckHessianBlock: "
              "direction is not feasible" << endl;
      exit(1);
   }
   if( hmax >= hlimit )
   {
      hmax = 0.99*hlimit;
      if( hmin >= hmax )
         hmin = hmax/n;
   }

   HCL_ProductVector_s * x1 = (HCL_ProductVector_s*)(Domain().Member());
   HCL_Vector_s * pi1 = ProductDomain()(i).Member();
   float v0,dv;

   v0 = Value( y );
   HCL_LinearOp_s * D2fy = HessianBlock( i,i,y );
   D2fy->Image( pi,*pi1 );
   dv = pi.Inner( *pi1 );
   HCL_delete( pi1 );
   HCL_delete( D2fy );

#if SINGLE_PRECISION
   int nd = 8;
#else
   int nd = 16;
#endif
   int oldprecision = str.precision( nd );

   float dvmag = abs(dv);
   int rflag = 1;
   HCL_FPArch_s arch;
   if( dvmag < arch.sfmin )
   {
      rflag = 0;
      str << "HCL_FunctionalProductDomain_s::CheckHessianBlock: norm of "
             "second variation is too "
          << endl << "small; displaying absolute error" << endl;
   }

   if( rflag )
      str << setw(5) << "h" << setw(nd+6) << "2nd variation" << setw(nd+6)
           << "cent. diff." << setw(nd+4) << "Rel. Err." << endl;
   else
      str << setw(5) << "h" << setw(nd+6) << "2nd variation" << setw(nd+6)
           << "cent. diff." << setw(nd+4) << "Error" << endl;
   float hstep = (hmax-hmin)/(n-1);
   int ii;
   for( ii=n-1;ii>=0;ii-- )
   {
      float v = -2.0*v0;
      float h = hmin+ii*hstep;
      x1->Copy( y );
      (*x1)(i).AddScale( h,pi );
      v += Value( *x1 );

      x1->Copy( y );
      (*x1)(i).AddScale( -h,pi );
      v += Value( *x1 );

      v /= (h*h);
      float n1 = abs(v-dv);

      if( rflag )
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << dv << " " << setw(nd+6)
             << v << " " << setw(nd+6) << n1/dvmag << endl;
      else
         str << setprecision(6) << setw(8) << h << " " << setprecision(nd)
             << setw(nd+6) << dv << " " << setw(nd+6)
             << v << " " << setw(nd+6) << n1 << endl;
   }
   str.precision( oldprecision );
   return 0;
}

int HCL_FunctionalProductDomain_s::CheckHessianBlockAdj(
                             const HCL_Vector_s & y,
                             const HCL_Vector_s & pi,
                             const HCL_Vector_s & pj, int i,int j,
                             ostream & str,int n,float hmin,
                             float hmax ) const
{
   CheckHessianBlock( y,pi,pj,i,j,str,n,hmin,hmax );
   HCL_LinearOp_s * L = HessianBlock( i,j,y );
   return L->CheckAdj( 2 );
}

HCL_FunctionalProductDomainDefaultEval_s::HCL_FunctionalProductDomainDefaultEval_s()
{
   cerr << "Error: HCL_FunctionalProductDomainDefaultEval_s default constructor "
           "not implemented" << endl;
   exit(1);
}

HCL_FunctionalProductDomainDefaultEval_s::HCL_FunctionalProductDomainDefaultEval_s(
                           const HCL_FunctionalProductDomainDefaultEval_s & )
{
   cerr << "Error: HCL_FunctionalProductDomainDefaultEval_s copy constructor "
           "not implemented" << endl;
   exit(1);
}

HCL_FunctionalProductDomainDefaultEval_s::HCL_FunctionalProductDomainDefaultEval_s(
                           const HCL_FunctionalProductDomain_s * ff,
                           const HCL_Vector_s & in )
{
   f = ff;f->IncCount();
   x = in.Space().Member();
   x->Copy( in );
}

HCL_FunctionalProductDomainDefaultEval_s::~HCL_FunctionalProductDomainDefaultEval_s()
{
   HCL_delete( x );
   HCL_delete( (HCL_FunctionalProductDomain_s*)f );
}

float HCL_FunctionalProductDomainDefaultEval_s::Value() const
{
   return f->Value1( *x );
}

void HCL_FunctionalProductDomainDefaultEval_s::PartialGradient( int i,
                   HCL_Vector_s & y ) const
{
   f->PartialGradient1( i,*x,y );
}

HCL_LinearOp_s *
HCL_FunctionalProductDomainDefaultEval_s::HessianBlock( int i,int j ) const
{
   HCL_LinearOp_s * H = f->HessianBlock1( i,j,*x );
   if( H )
      return H;
   else
      return new HCL_FunctionalDefaultHessianBlock_s( i,j,this );
}

ostream &
HCL_FunctionalProductDomainDefaultEval_s::Write( ostream & str ) const
{
   str << "HCL_FunctionalProductDomainDefaultEval_s based on the following "
          "functional" << endl;
   return f->Write( str );
}

HCL_FunctionalDefaultHessianBlock_s::HCL_FunctionalDefaultHessianBlock_s()
{
   cerr << "Error: HCL_FunctionalDefaultHessianBlock_s default "
           "constructor not implemented"
        << endl;
   exit(1);
}

HCL_FunctionalDefaultHessianBlock_s::HCL_FunctionalDefaultHessianBlock_s(
              const HCL_FunctionalDefaultHessianBlock_s & L )
{
   cerr << "Error: HCL_FunctionalDefaultHessianBlock_s copy "
           "constructor not implemented"
        << endl;
   exit(1);
}

HCL_FunctionalDefaultHessianBlock_s::HCL_FunctionalDefaultHessianBlock_s(
              int ii,int jj,const HCL_EvalFunctionalProductDomain_s * ev )
{
   int m = ev->ProductDomain().Number();
   if( ii<1 || ii>m || jj<1 || jj>m )
   {
      cerr << "Error: invalid block indices in " << endl
           << "HCL_FunctionalDefaultHessianBlock_s constructor" << endl;
      cerr << "(" << i << "," << j << ") was passed; both indices " << endl
           << "must be beteen 1 and " << m << endl;
      exit(1);
   }
   i = ii;
   j = jj;
   eval = ev;ev->IncCount();
}

HCL_FunctionalDefaultHessianBlock_s::~HCL_FunctionalDefaultHessianBlock_s()
{
   HCL_delete( (HCL_EvalFunctionalProductDomain_s*)eval );
}

HCL_VectorSpace_s & HCL_FunctionalDefaultHessianBlock_s::Domain() const
{
   return eval->ProductDomain()(j);
}

HCL_VectorSpace_s & HCL_FunctionalDefaultHessianBlock_s::Range() const
{
   return eval->ProductDomain()(i);
}

void HCL_FunctionalDefaultHessianBlock_s::Image( const HCL_Vector_s & x,
                                                  HCL_Vector_s & y ) const
{
   eval->HessianBlockImage( i,j,x,y );
}

void HCL_FunctionalDefaultHessianBlock_s::AdjImage( const HCL_Vector_s & y,
                                                    HCL_Vector_s & x ) const
{
   eval->HessianBlockImage( j,i,y,x );
}

void HCL_FunctionalDefaultHessianBlock_s::InvImage(const HCL_Vector_s & y,
                                                    HCL_Vector_s & x) const
{
   cerr << "Error: HCL_FunctionalDefaultHessianBlock_s::InvImage "
           "is not implemented" << endl;
   exit(1);
}

void HCL_FunctionalDefaultHessianBlock_s::InvAdjImage(const HCL_Vector_s & x,
                                                 HCL_Vector_s & y) const
{
   cerr << "Error: HCL_FunctionalDefaultHessianBlock_s::InvAdjImage "
           "is not implemented" << endl;
   exit(1);
}

ostream & HCL_FunctionalDefaultHessianBlock_s::Write( ostream & str ) const
{
   str << "HCL_FunctionalDefaultHessianBlock_s ( " << i << "," << j
       << ")" << endl << "based on the following evaluation object"
       << endl;
   return eval->Write( str );
}

HCL_EvalRestrictedFunctional_s::HCL_EvalRestrictedFunctional_s()
{
   cerr << "Error: HCL_EvalRestrictedFunctional_s default constructor "
           "called" << endl;
   exit(1);
}

HCL_EvalRestrictedFunctional_s::HCL_EvalRestrictedFunctional_s(
                                  const HCL_EvalRestrictedFunctional_s & )
{
   cerr << "Error: HCL_EvalRestrictedFunctional_s copy constructor "
           "called" << endl;
   exit(1);
}

HCL_EvalRestrictedFunctional_s::HCL_EvalRestrictedFunctional_s( int ii,
                        HCL_EvalFunctionalProductDomain_s * ev )
{
   int n = (ev->ProductDomain()).Number();
   if( ii < 1 || ii > n )
   {
      cerr << "Error in HCL_EvalRestrictedFunctional_s constructor: "
              "index must be between 1 and " << n << endl;
      exit(1);
   }
   i = ii;
   eval = ev;ev->IncCount();
}

HCL_EvalRestrictedFunctional_s::~HCL_EvalRestrictedFunctional_s()
{
   HCL_delete( eval );
}

HCL_VectorSpace_s & HCL_EvalRestrictedFunctional_s::Domain() const
{
   return (eval->ProductDomain())(i);
}

HCL_EvalFunctionalProductDomain_s &
            HCL_EvalRestrictedFunctional_s::UnrestrictedEval()
{
      return *eval;
}

float HCL_EvalRestrictedFunctional_s::Value() const
{
   return eval->ValueRef();
}

void HCL_EvalRestrictedFunctional_s::Gradient( HCL_Vector_s & g ) const
{
   if( g.Space() != Domain() )
   {
      cerr << "Error in HCL_EvalRestrictedFunctional_s::Gradient: "
              "vector is not in domain" << endl;
      exit(1);
   }
   g.Copy( eval->PartialGradientRef( i ) );
}

HCL_LinearOp_s * HCL_EvalRestrictedFunctional_s::Hessian() const
{
   HCL_LinearOp_s * t = (HCL_LinearOp_s*)(&(eval->HessianBlockRef(i,i)));
   t->IncCount();
   return t;
}

ostream & HCL_EvalRestrictedFunctional_s::Write( ostream & str ) const
{
   str << "HCL_EvalRestrictedFunctional_s object (i = " << i << ")"
       << endl;
   str << "Underlying HCL_EvalFunctionalProductDomain_s object: " << endl;
   return eval->Write( str );
}

HCL_RestrictedFunctional_s::HCL_RestrictedFunctional_s()
{
   cerr << "Error: HCL_RestrictedFunctional_s default constructor "
           "called" << endl;
   exit(1);
}

HCL_RestrictedFunctional_s::HCL_RestrictedFunctional_s(
                                  const HCL_RestrictedFunctional_s & )
{
   cerr << "Error: HCL_RestrictedFunctional_s copy constructor "
           "called" << endl;
   exit(1);
}

HCL_RestrictedFunctional_s::HCL_RestrictedFunctional_s( 
                        HCL_FunctionalProductDomain_s * ff,
                        const HCL_ProductVector_s & x,int ii )
{
   int n = ff->ProductDomain().Number();
   if( ii < 1 || ii > n )
   {
      cerr << "Error in HCL_RestrictedFunctional_s constructor: "
              "index must be between 1 and " << n << endl;
      exit(1);
   }
   i = ii;
   f = ff;f->IncCount();
   if( x.Space() != f->Domain() )
   {
      cerr << "Error in HCL_RestrictedFunctional_s constructor: "
              "vector is not in domain " << n << endl;
      exit(1);
   }
   y = (HCL_ProductVector_s*)f->Domain().Member();
   y->Copy( x );
}
HCL_RestrictedFunctional_s::HCL_RestrictedFunctional_s( 
                        HCL_FunctionalProductDomain_s * ff,
                        HCL_ProductVector_s * x,int ii )
{
   int n = ff->ProductDomain().Number();
   if( ii < 1 || ii > n )
   {
      cerr << "Error in HCL_RestrictedFunctional_s constructor: "
              "index must be between 1 and " << n << endl;
      exit(1);
   }
   i = ii;
   f = ff;f->IncCount();
   if( x->Space() != f->Domain() )
   {
      cerr << "Error in HCL_RestrictedFunctional_s constructor: "
              "vector is not in domain " << n << endl;
      exit(1);
   }
   y = x;x->IncCount();
}

HCL_RestrictedFunctional_s::~HCL_RestrictedFunctional_s()
{
   HCL_delete( y );
   HCL_delete( f );
}

HCL_VectorSpace_s & HCL_RestrictedFunctional_s::Domain() const
{
   return (f->ProductDomain())(i);
}

HCL_EvaluateFunctional_s * HCL_RestrictedFunctional_s::Evaluate(
                               const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_RestrictedFunctional_s::Evaluate: "
              "vector is not in domain" << endl;
      exit(1);
   }
   (*y)(i).Copy( x );
   HCL_EvalFunctionalProductDomain_s * ev =
        (HCL_EvalFunctionalProductDomain_s*)f->Evaluate( *y );
   HCL_EvaluateFunctional_s * eval = 
               new HCL_EvalRestrictedFunctional_s( i,ev );
   HCL_delete( ev );
   return eval;
}
   
ostream & HCL_RestrictedFunctional_s::Write( ostream & str ) const
{
   str << "HCL_RestrictedFunctional_s object (i = " << i << ")"
       << endl;
   str << "Underlying HCL_FunctionalProductDomain_s: " << endl;
   return f->Write( str );
}
