/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_GProdV_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_GenericProductVector_s.h"

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s()
{
   cerr << "Error: HCL_GenericProductSpace_s default constructor called"
        << endl;
   exit(1);
}

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s(
                               const HCL_GenericProductSpace_s & x)
{
   len = x.Number();
   int i;
   SpaceList = new HCL_VectorSpace_s*[len];
   for( i=0;i<len;i++ )
      SpaceList[i] = x(i+1).Replicate();
}

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s( int n )
{
   len = n;
   SpaceList = new HCL_VectorSpace_s*[n];
   int i;
   for( i=0;i<len;i++ )
      SpaceList[i] = NULL;
}

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s( 
          const HCL_VectorSpace_s & S1,const HCL_VectorSpace_s & S2 )
{
   len = 2;
   SpaceList = new HCL_VectorSpace_s*[2];
   SpaceList[0] = S1.Replicate();
   SpaceList[1] = S2.Replicate();
}

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s( HCL_VectorSpace_s * S1,
                                                    HCL_VectorSpace_s * S2 )
{
   len = 2;
   SpaceList = new HCL_VectorSpace_s*[2];
   SpaceList[0] = S1;S1->IncCount();
   SpaceList[1] = S2;S2->IncCount();
}

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s(
                              const HCL_VectorSpace_s & S,int n )
{
   len = n;
   SpaceList = new HCL_VectorSpace_s*[n];
   SpaceList[0] = S.Replicate();
   int i;
   for( i=1;i<n;i++ )
   {
      SpaceList[i] = SpaceList[0];
      SpaceList[0]->IncCount();
   }
}

HCL_GenericProductSpace_s::HCL_GenericProductSpace_s(
                              HCL_VectorSpace_s * S,int n )
{
   len = n;
   SpaceList = new HCL_VectorSpace_s*[n];
   int i;
   for( i=0;i<n;i++ )
   {
      SpaceList[i] = S;
      S->IncCount();
   }
}

HCL_GenericProductSpace_s::~HCL_GenericProductSpace_s()
{
   for( int i=0;i<len;i++ )
      HCL_delete( SpaceList[i] );
   delete[] SpaceList;
}

int HCL_GenericProductSpace_s::Initialized() const
{
   int i;
   for( i=0;i<len;i++ )
      if( !SpaceList[i] )
         return 0;
   return 1;
}

int HCL_GenericProductSpace_s::IsSet( int i ) const
{
   if( i < 1 || i > len )
   {
      cerr << "Error in HCL_GenericProductSpace_s::IsSet: invalid index"
           << endl;
      exit(1);
   }
   if( SpaceList[i-1] )
      return 1;
   else
      return 0;
}

HCL_VectorSpace_s & HCL_GenericProductSpace_s::operator()( int i ) const
{
   if( i < 1 || i > len )
   {
      cerr << "Error in HCL_GenericProductSpace_s::IsSet: invalid index"
           << endl;
      exit(1);
   }
   if( !SpaceList[i-1] )
   {
      cerr << "Error in HCL_GenericProductSpace_s::operator(): attempt to "
              "access an uninitialized factor" << endl;
      exit(1);
   }
   return *SpaceList[i-1];
}

HCL_Vector_s * HCL_GenericProductSpace_s::Member() const
{
   if( !Initialized() )
   {
      cerr << "Error in HCL_GenericProductSpace_s::Member: attempt to use "
           << "uninitialized object" << endl;
      exit(1);
   }
   return new HCL_GenericProductVector_s( (HCL_GenericProductSpace_s*)this );
}

HCL_VectorSpace_s * HCL_GenericProductSpace_s::Replicate() const
{
   HCL_GenericProductSpace_s * t = (HCL_GenericProductSpace_s*)this;
   t->IncCount();
   return t;
}

void HCL_GenericProductSpace_s::SetNext( HCL_VectorSpace_s * S )
{
   if( Initialized() )
   {
      cerr << "Error in HCL_GenericProductSpace_s::SetNext: too many factors"
           << endl;
      exit(1);
   }
   int i;
   for( i=0;i<len;i++ )
      if( !SpaceList[i] )
      {
         SpaceList[i] = S;
         S->IncCount();
         return;
      }
}

void HCL_GenericProductSpace_s::Set( int i,HCL_VectorSpace_s * S )
{
   if( SpaceList[i-1] )
      HCL_delete( SpaceList[i-1] );
   SpaceList[i-1] = S;
   S->IncCount();
}

ostream & HCL_GenericProductSpace_s::Write( ostream & str ) const
{
   str << "   HCL_GenericProductSpace_s with factors" << endl;
   for(int i=1; i <= Number(); i++)
      if( SpaceList[i-1] )
         (*this)(i).Write(str);
      else
         str << "(This factor not set)" << endl;
   return str;
}

HCL_GenericProductVector_s::HCL_GenericProductVector_s()
{
}

HCL_GenericProductVector_s::HCL_GenericProductVector_s(const HCL_GenericProductVector_s & p)
{
   cerr << "Error: HCL_GenericProductVector_s copy constructor called"
        << endl;
   exit(1);
}

HCL_GenericProductVector_s::HCL_GenericProductVector_s(const HCL_GenericProductSpace_s & p)
{
   sp = new HCL_GenericProductSpace_s( p );
   int i;
   len = p.Number();
   vlist = new HCL_Vector_s*[len];
   for( i=0;i<len;i++ )
      vlist[i] = (*sp)(i+1).Member();
}

HCL_GenericProductVector_s::HCL_GenericProductVector_s( HCL_GenericProductSpace_s * p )
{
   sp = p;sp->IncCount();
   len = sp->Number();
   int i;
   vlist = new HCL_Vector_s*[len];
   for( i=0;i<len;i++ )
      vlist[i] = (*sp)(i+1).Member();
}

HCL_GenericProductVector_s::HCL_GenericProductVector_s( HCL_Vector_s * v1,HCL_Vector_s * v2 )
{
   len = 2;
   sp = new HCL_GenericProductSpace_s( &(v1->Space()),&(v2->Space()) );
   vlist = new HCL_Vector_s*[2];
   vlist[0] = v1;v1->IncCount();
   vlist[1] = v2;v2->IncCount();
}

HCL_GenericProductVector_s::HCL_GenericProductVector_s( int n )
{
   len = n;
   sp = new HCL_GenericProductSpace_s( n );
   vlist = new HCL_Vector_s*[n];
   int i;
   for( i=0;i<len;i++ ) vlist[i] = NULL;
}

HCL_GenericProductVector_s::~HCL_GenericProductVector_s()
{
   for( int i=0;i<len;i++ )
      HCL_delete( vlist[i] );
   delete[] vlist;
   HCL_delete( sp );
}

int HCL_GenericProductVector_s::Initialized() const
{
   int i;
   for( i=0;i<len;i++ )
      if( !vlist[i] )
         return 0;
   return 1;
}

int HCL_GenericProductVector_s::IsSet( int i ) const
{
   if( i < 1 || i > len )
   {
      cerr << "Error in HCL_GenericProductVector_s::IsSet: invalid index"
           << endl;
      exit(1);
   }
   if( vlist[i-1] )
      return 1;
   else
      return 0;
}

void HCL_GenericProductVector_s::SetNext( HCL_Vector_s * x )
{
   if( Initialized() )
   {
      cerr << "Error in HCL_GenericProductVector_s::SetNext: too many factors"
           << endl;
      exit(1);
   }
   int i;
   for( i=0;i<len;i++ )
      if( !vlist[i] )
      {
         vlist[i] = x;
         x->IncCount();
         sp->Set( i+1,&(x->Space()) );
         return;
      }
}

void HCL_GenericProductVector_s::Set( int i,HCL_Vector_s * S )
{
   if( vlist[i-1] )
      HCL_delete( vlist[i-1] );
   vlist[i-1] = S;
   S->IncCount();
   sp->Set( i,&(S->Space()) );
}
