/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_LCbFcnl_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_LinCombFcnl_s.h"

HCL_EvalLinCombFcnl_s::HCL_EvalLinCombFcnl_s()
{
   cerr << "Error: HCL_EvalLinCombFcnl_s default constructor called"
        << endl;
   exit(1);
}

HCL_EvalLinCombFcnl_s::HCL_EvalLinCombFcnl_s( 
                                 const HCL_EvalLinCombFcnl_s & )
{
   cerr << "Error: HCL_EvalLinCombFcnl_s copy constructor called"
        << endl;
   exit(1);
}

HCL_EvalLinCombFcnl_s::HCL_EvalLinCombFcnl_s( HCL_VectorSpace_s * d,int n )
{
   num = n;
   numinit = 0;
   dom = d;d->IncCount();
   evallist = new HCL_EvaluateFunctional_s*[num];
   weights = new float[num];
}

HCL_EvalLinCombFcnl_s::~HCL_EvalLinCombFcnl_s()
{
   delete[] weights;
   for( int i=0;i<numinit;i++ )
      HCL_delete( evallist[i] );
   delete[] evallist;
}

float HCL_EvalLinCombFcnl_s::Value() const
{
   if( numinit < num )
   {
      cerr << "Error in HCL_EvalLinCombFcnl_s::Value: not initialized"
           << endl;
      exit(1);
   }
   float s=0.0;
   for( int i=0;i<num;i++ )
      s += weights[i]*(evallist[i]->Value());
   return s;
}

void HCL_EvalLinCombFcnl_s::Gradient( HCL_Vector_s & g ) const
{
   if( numinit < num )
   {
      cerr << "Error in HCL_EvalLinCombFcnl_s::Gradient: not initialized"
           << endl;
      exit(1);
   }
   evallist[0]->Gradient( g );
   g.Mul( weights[0] );
   HCL_Vector_s * temp = Domain().Member();
   for( int i=1;i<numinit;i++ )
   {
      evallist[i]->Gradient( *temp );
      g.AddScale( weights[i],*temp );
   }
   HCL_delete( temp );
}

HCL_LinearOp_s * HCL_EvalLinCombFcnl_s::Hessian() const
{
   if( numinit < num )
   {
      cerr << "Error in HCL_EvalLinCombFcnl_s::Hessian: not initialized"
           << endl;
      exit(1);
   }
   HCL_LinCombLinearOp_s * temp = new HCL_LinCombLinearOp_s( dom,dom,num );
   for( int i=0;i<numinit;i++ )
   {
      HCL_LinearOp_s * thess = evallist[i]->Hessian();
      temp->SetNext( thess,weights[i] );
      HCL_delete( thess );
   }
   return temp;
}

void HCL_EvalLinCombFcnl_s::SetNext( HCL_EvaluateFunctional_s * eval,
                                         float w )
{
   if( numinit == num )
   {
      cerr << "Error in HCL_EvalLinCombFcnl_s::SetNext: "
              "already initialized" << endl;
      exit(1);
   }
   evallist[numinit] = eval;eval->IncCount();
   weights[numinit] = w;
   numinit++;
}

const HCL_EvaluateFunctional_s & HCL_EvalLinCombFcnl_s::
                                     GetTerm( int n ) const
{
   if( n < 1 || n > numinit )
   {
      cerr << "Error in HCL_EvalLinCombFcnl_s::GetTerm: invalid index"
           << endl;
      exit(1);
   }
   return *evallist[n-1];
}

ostream & HCL_EvalLinCombFcnl_s::Write( ostream & str ) const
{
   str << "HCL_EvalLinCombFcnl_s object; " << numinit << " terms out of "
       << num << " have been set" << endl;
   str << "The weights are " << endl << "   " << endl;
   int i;
   for( i=0;i<numinit;i++ ) str << weights[i] << " ";
   str << endl << endl;
   str << "The evaluation objects are " << endl;
   for( i=0;i<numinit;i++ ) evallist[i]->Write( str );
   return str;
}

HCL_LinCombFcnl_s::HCL_LinCombFcnl_s()
{
   cerr << "Error: HCL_LinCombFcnl_s default constructor called"
        << endl;
   exit(1);
}

HCL_LinCombFcnl_s::HCL_LinCombFcnl_s( const HCL_LinCombFcnl_s & )
{
   cerr << "Error: HCL_LinCombFcnl_s copy constructor called"
        << endl;
   exit(1);
}

HCL_LinCombFcnl_s::HCL_LinCombFcnl_s( HCL_VectorSpace_s * d,int n )
{
   dom = d;d->IncCount();
   num = n;
   numinit = 0;
   flist = new HCL_Functional_s*[num];
   ParamTable = new Table( NULL,NULL,num );
}

HCL_LinCombFcnl_s::HCL_LinCombFcnl_s( HCL_Functional_s * f1,
                 float w1,HCL_Functional_s * f2,float w2 )
{
   if( f1->Domain() != f2->Domain() )
   {
      cerr << "Error in HCL_LinCombFcnl_s constructor: domains must"
              " agree" << endl;
      exit(1);
   }

   dom = &(f1->Domain());dom->IncCount();
   num = 2;
   numinit = 2;
   flist = new HCL_Functional_s*[2];
   flist[0] = f1;f1->IncCount();
   flist[1] = f2;f2->IncCount();
   ParamTable = new Table;
   ParamTable->PutArrayValue( "Weights",1,w1 );
   ParamTable->PutArrayValue( "Weights",2,w2 );
}

HCL_LinCombFcnl_s::~HCL_LinCombFcnl_s()
{
   HCL_delete( ParamTable );
   for( int i=0;i<numinit;i++ )
      HCL_delete( flist[i] );
   delete[] flist;
   HCL_delete( dom );
}

float HCL_LinCombFcnl_s::MaxStep( const HCL_Vector_s & x, 
                                       const HCL_Vector_s &dir) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_LinCombFcnl_s::MaxStep: vector is "
              "not in domain" << endl;
      exit(1);
   }
   if( dir.Space() != Domain() )
   {
      cerr << "Error in HCL_LinCombFcnl_s::MaxStep: vector is "
              "not in domain" << endl;
      exit(1);
   }
   if( numinit < num )
   {
      cerr << "Error in HCL_LinCombFcnl_s::MaxStep: not initialized "
              "yet" << endl;
      exit(1);
   }

   float s = flist[0]->MaxStep( x,dir );
   int i;
   for( i=1;i<numinit;++i )
      s = min( s,flist[i]->MaxStep( x,dir ) );
   return s;
}

HCL_EvaluateFunctional_s * HCL_LinCombFcnl_s::Evaluate(
                               const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_LinCombFcnl_s::Evaluate: vector is "
              "not in domain" << endl;
      exit(1);
   }
   if( numinit < num )
   {
      cerr << "Error in HCL_LinCombFcnl_s::Evaluate: not initialized "
              "yet" << endl;
      exit(1);
   }

   HCL_EvalLinCombFcnl_s * eval = new HCL_EvalLinCombFcnl_s( dom,num );
   for( int i=0;i<num;i++ )
   {
      float w;
      ParamTable->GetArrayValue( "Weights",i+1,w );
      HCL_EvaluateFunctional_s * teval = flist[i]->Evaluate( x );
      eval->SetNext( teval,w );
      HCL_delete( teval );
   }
   return eval;
}

void HCL_LinCombFcnl_s::SetNext( HCL_Functional_s * f,float w )
{
   if( numinit == num )
   {
      cerr << "Error in HCL_LinCombFcnl_s::SetNext: already initialized"
           << endl;
      exit(1);
   }
   if( f->Domain() != Domain() )
   {
      cerr << "Error in HCL_LinCombFcnl_s::SetNext: domains do not agree"
           << endl;
      exit(1);
   }

   flist[numinit] = f;f->IncCount();
   numinit++;
   ParamTable->PutArrayValue( "Weights",numinit,w );
}

ostream & HCL_LinCombFcnl_s::Write( ostream & str ) const
{
   str << "HCL_LinCombFcnl_s object; " << numinit << " terms out of "
       << num << " have been set" << endl;
   str << "The weights are " << endl << "   " << endl;
   int i;
   for( i=0;i<numinit;i++ )
   {
      float w;
      ParamTable->GetArrayValue( "Weights",i+1,w );
      str << w << " ";
   }
   str << endl << endl;
   str << "The functionals are " << endl;
   for( i=0;i<numinit;i++ )
   {
      str << "Term " << i+1 << endl;
      flist[i]->Write( str );
   }
   return str;
}
