/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_LNLOp_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/
#include "HCL_LNLOp_s.h"

HCL_ZeroBiLinearOp_s::HCL_ZeroBiLinearOp_s()
{
   cerr << "Error: HCL_ZeroBiLinearOp_s default constructor called" << endl;
   exit(1);
}

HCL_ZeroBiLinearOp_s::HCL_ZeroBiLinearOp_s( const HCL_ZeroBiLinearOp_s & )
{
   cerr << "Error: HCL_ZeroBiLinearOp_s copy constructor called" << endl;
   exit(1);
}

HCL_ZeroBiLinearOp_s::HCL_ZeroBiLinearOp_s( HCL_VectorSpace_s * d1,
                                            HCL_VectorSpace_s * d2,
                                            HCL_VectorSpace_s * r )
{
   dom1 = d1;dom1->IncCount();
   dom2 = d2;dom2->IncCount();
   range = r;range->IncCount();
}

HCL_ZeroBiLinearOp_s::~HCL_ZeroBiLinearOp_s()
{
   HCL_delete( range );
   HCL_delete( dom1 );
   HCL_delete( dom2 );
}

HCL_VectorSpace_s & HCL_ZeroBiLinearOp_s::Domain1() const
{
   return *dom1;
}

HCL_VectorSpace_s & HCL_ZeroBiLinearOp_s::Domain2() const
{
   return *dom2;
}

HCL_VectorSpace_s & HCL_ZeroBiLinearOp_s::Range() const
{
   return *range;
}

void HCL_ZeroBiLinearOp_s::Image( const HCL_Vector_s & x,
                                  const HCL_Vector_s & y,
                                        HCL_Vector_s & z ) const
{
   if( x.Space() != Domain1() )
   {
      cerr << "Error in HCL_ZeroBiLinearOp_s::Image: vector is not in domain"
           << endl;
      exit(1);
   }
   if( y.Space() != Domain2() )
   {
      cerr << "Error in HCL_ZeroBiLinearOp_s::Image: vector is not in domain"
           << endl;
      exit(1);
   }
   if( z.Space() != Range() )
   {
      cerr << "Error in HCL_ZeroBiLinearOp_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   z.Zero();
}

HCL_LinearOp_s * HCL_ZeroBiLinearOp_s::Op1( const HCL_Vector_s & x ) const
{
   return new HCL_ZeroLinearOp_s( dom2,range );
}

HCL_LinearOp_s * HCL_ZeroBiLinearOp_s::Op2( const HCL_Vector_s & x ) const
{
   return new HCL_ZeroLinearOp_s( dom1,range );
}

HCL_LinearOp_s * HCL_ZeroBiLinearOp_s::Op3( const HCL_Vector_s & x ) const
{
   return new HCL_ZeroLinearOp_s( dom1,dom2 );
}

ostream & HCL_ZeroBiLinearOp_s::Write( ostream & str ) const
{
   str << "HCL_ZeroBiLinearOp_s with domain 1" << endl;
   dom1->Write( str );
   str << "and domain 2" << endl;
   dom2->Write( str );
   str << "and range" << endl;
   return range->Write( str );
}

HCL_EvalLNLOp_s::HCL_EvalLNLOp_s()
{
   cerr << "Error: HCL_EvalLNLOp_s default constructor called" << endl;
   exit(1);
}

HCL_EvalLNLOp_s::HCL_EvalLNLOp_s( const HCL_EvalLNLOp_s & )
{
   cerr << "Error: HCL_EvalLNLOp_s copy constructor called" << endl;
   exit(1);
}

HCL_EvalLNLOp_s::HCL_EvalLNLOp_s( HCL_LinearOp_s * LL,
                                    const HCL_Vector_s & xx )
{
   L = LL;L->IncCount();
   x = LL->Domain().Member();
   x->Copy( xx );
}

HCL_EvalLNLOp_s::~HCL_EvalLNLOp_s()
{
   HCL_delete( L );
   HCL_delete( x );
}

HCL_VectorSpace_s & HCL_EvalLNLOp_s::Domain() const
{
   return L->Domain();
}

HCL_VectorSpace_s & HCL_EvalLNLOp_s::Range() const
{
   return L->Range();
}

void HCL_EvalLNLOp_s::Image( HCL_Vector_s & y ) const
{
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_EvalLNLOp_s::Image: vector is not in range"
           << endl;
      exit(1);
   }
   L->Image( *x,y );
}

void HCL_EvalLNLOp_s::ImageAdd( HCL_Vector_s & y,
                                float a,float b ) const
{
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_EvalLNLOp_s::ImageAdd: output vector "
           << endl << "is not in range" << endl;
      exit(1);
   }
   L->ImageAdd( *x,y,a,b );
}

void HCL_EvalLNLOp_s::ImageAdd( const HCL_Vector_s & z,HCL_Vector_s & y,
                                float a,float b ) const
{
   if( y.Space() != Range() )
   {
      cerr << "Error in HCL_EvalLNLOp_s::ImageAdd: output vector "
           << endl << "is not in range" << endl;
      exit(1);
   }
   if( z.Space() != Range() )
   {
      cerr << "Error in HCL_EvalLNLOp_s::ImageAdd: input vector "
           << endl << "is not in range" << endl;
      exit(1);
   }
   L->ImageAdd( *x,z,y,a,b );
}

HCL_LinearOp_s * HCL_EvalLNLOp_s::Deriv() const
{
   L->IncCount();
   return L;
}

HCL_BiLinearOp_s * HCL_EvalLNLOp_s::SecondDeriv() const
{
   return new HCL_ZeroBiLinearOp_s( &(Domain()),&(Domain()),&(Range()) );
}

ostream & HCL_EvalLNLOp_s::Write( ostream & str ) const
{
   str << "HCL_EvalLNLOp_s defined by the following linear operator:" << endl;
   return L->Write( str );
}

HCL_LNLOp_s::HCL_LNLOp_s()
{
   cerr << "Error: HCL_LNLOp_s default constructor called" << endl;
   exit(1);
}

HCL_LNLOp_s::HCL_LNLOp_s( const HCL_LNLOp_s & )
{
   cerr << "Error: HCL_LNLOp_s copy constructor called" << endl;
   exit(1);
}

HCL_LNLOp_s::HCL_LNLOp_s( const HCL_LinearOp_s * LL )
{
   L = (HCL_LinearOp_s*)LL;L->IncCount();
}

HCL_LNLOp_s::~HCL_LNLOp_s()
{
   HCL_delete( L );
}

HCL_VectorSpace_s & HCL_LNLOp_s::Domain() const
{
   return L->Domain();
}

HCL_VectorSpace_s & HCL_LNLOp_s::Range() const
{
   return L->Range();
}

HCL_EvaluateOp_s * HCL_LNLOp_s::Evaluate( const HCL_Vector_s & x ) const
{
   if( x.Space() != Domain() )
   {
      cerr << "Error in HCL_LNLOp_s::Evaluate: vector is not "
              "in domain" << endl;
      exit(1);
   }
   return new HCL_EvalLNLOp_s( L,x );
}

ostream & HCL_LNLOp_s::Write( ostream & str ) const
{
   str << "HCL_LNLOp_s defined by the following linear operator:" << endl;
   return L->Write( str );
}
