/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_MatrixOps_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

#include "HCL_MatrixOps_s.h"

HCL_SymMatOp_s::HCL_SymMatOp_s()
{
   cerr << "Error: HCL_SymMatOp_s default constructor not implemented" << endl;
   exit(1);
}

HCL_SymMatOp_s::HCL_SymMatOp_s( const HCL_SymMatOp_s & )
{
   cerr << "Error: HCL_SymMatOp_s copy constructor not implemented" << endl;
   exit(1);
}

HCL_SymMatOp_s::HCL_SymMatOp_s( GenSymMatrix_s * AA,int flag,
                                HCL_VectorSpace_s * d )
{
   if( d->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SymMatOp_s constructor: dimension of domain ("
           << d->Dim() << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = d;d->IncCount();
}

HCL_SymMatOp_s::HCL_SymMatOp_s( GenSymMatrix_s * AA,int flag,
                                HCL_VectorSpace_s * d,
                                HCL_VectorSpace_s * r )
{
   if( d->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SymMatOp_s constructor: dimension of domain ("
           << d->Dim() << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   if( r->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SymMatOp_s constructor: dimension of range ("
           << r->Dim() << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = r;r->IncCount();
}

HCL_SymMatOp_s::~HCL_SymMatOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   if( DeleteMat ) delete Matrix;
}

void HCL_SymMatOp_s::Image( const HCL_Vector_s & xx,
                                  HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymMatOp_s::Image: input vector is not in domain"
           << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymMatOp_s::Image: output vector is not in range"
           << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymMatOp_s::Image: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymMatOp_s::Image: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Y.mult( *((GenSymMatrix_s *)Matrix),(GeneralMatrix_s)X );
}

void HCL_SymMatOp_s::AdjImage( const HCL_Vector_s & yy,
                                     HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymMatOp_s::AdjImage: output vector is not in "
              "domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymMatOp_s::AdjImage: input vector is not in range"
           << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymMatOp_s::AdjImage: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymMatOp_s::AdjImage: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   X.mult( *((GenSymMatrix_s *)Matrix),(GeneralMatrix_s)Y );
}

void HCL_SymMatOp_s::InvImage(const HCL_Vector_s & yy,
                                    HCL_Vector_s & xx) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymMatOp_s::InvImage: output vector is not in "
              "domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymMatOp_s::InvImage: input vector is not in range"
           << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymMatOp_s::InvImage: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymMatOp_s::InvImage: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( X,Y );
}

void HCL_SymMatOp_s::InvAdjImage(const HCL_Vector_s & xx,
                                       HCL_Vector_s & yy) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymMatOp_s::InvAdjImage: input vector is not "
              "in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymMatOp_s::InvAdjImage: output vector is not "
              "in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymMatOp_s::InvAdjImage: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymMatOp_s::InvAdjImage: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( Y,X );
}

HCL_UpperTriangularMatOp_s * HCL_SymMatOp_s::Cholesky() const
{
   if( Domain() != Range() )
   {
      cerr << "Error in HCL_SymMatOp_s::Cholesky: Cannot form the Cholesky"
           << endl << "factorization, because the domain and range are not "
              "equal" << endl;
      exit(1);
   }
   UpperTriangle_s * R = new UpperTriangle_s( Matrix->numRows() );
   int flag = Matrix->cholesky( *R );
   if( flag )
   {
      delete R;
      return (HCL_UpperTriangularMatOp_s*)NULL;
   }
   else
   {
      HCL_UpperTriangularMatOp_s * U =
               new HCL_UpperTriangularMatOp_s( R,1,&(Domain()),&(Domain()) );
      return U;
   }
}

ostream & HCL_SymMatOp_s::Write( ostream & str ) const
{
   str << "HCL_SymMatOp_s with domain" << endl;
   Domain().Write( str );
   str << "and range" << endl;
   Range().Write( str );
   str << "The matrix is" << endl << *Matrix << endl;
   return str;
}

HCL_GeneralMatOp_s::HCL_GeneralMatOp_s()
{
   cerr << "Error: HCL_GeneralMatOp_s default constructor not implemented"
        << endl;
   exit(1);
}

HCL_GeneralMatOp_s::HCL_GeneralMatOp_s( const HCL_GeneralMatOp_s & )
{
   cerr << "Error: HCL_GeneralMatOp_s copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_GeneralMatOp_s::HCL_GeneralMatOp_s( GeneralMatrix_s * AA,int flag,
                                        HCL_VectorSpace_s * d,
                                        HCL_VectorSpace_s * r )
{
   if( d->Dim() != AA->numCols() )
   {
      cerr << "Error in HCL_GeneralMatOp_s constructor: dimension of domain ("
           << d->Dim() << ") does not agree with # of columns of matrix ("
           << AA->numCols() << ")" << endl;
      exit(1);
   }
   if( r->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_GeneralMatOp_s constructor: dimension of range ("
           << r->Dim() << ") does not agree with # of rows of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = r;r->IncCount();
}

HCL_GeneralMatOp_s::~HCL_GeneralMatOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   if( DeleteMat ) delete Matrix;
}

void HCL_GeneralMatOp_s::Image( const HCL_Vector_s & xx,
                                      HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::Image: input vector is "
              "not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::Image: output vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::Image: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::Image: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Y.mult( *Matrix,X );
}

void HCL_GeneralMatOp_s::AdjImage( const HCL_Vector_s & yy,
                                         HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::AdjImage: output vector is "
              "not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::AdjImage: input vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::AdjImage: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::AdjImage: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   X.multTrans( *Matrix,Y );
}

void HCL_GeneralMatOp_s::InvImage(const HCL_Vector_s & yy,
                                    HCL_Vector_s & xx) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvImage: output vector is not in "
              "domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvImage: input vector is  "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvImage: output vector has NULL "
              "data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvImage: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( X,Y );
}

void HCL_GeneralMatOp_s::InvAdjImage(const HCL_Vector_s & xx,
                                       HCL_Vector_s & yy) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvAdjImage: input vector is not "
              "in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvAdjImage: output vector is not "
              "in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvAdjImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_GeneralMatOp_s::InvAdjImage: output vector "
              "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->transposeSolve( Y,X );
}

ostream & HCL_GeneralMatOp_s::Write( ostream & str ) const
{
   str << "HCL_GeneralMatOp_s with domain" << endl;
   Domain().Write( str );
   str << "and range" << endl;
   Range().Write( str );
   str << "The matrix is" << endl << *Matrix << endl;
   return str;
}

HCL_SymSparseRCSMatOp_s::HCL_SymSparseRCSMatOp_s()
{
   cerr << "Error: HCL_SymSparseRCSMatOp_s default constructor not "
           "implemented" << endl;
   exit(1);
}

HCL_SymSparseRCSMatOp_s::HCL_SymSparseRCSMatOp_s(
                         const HCL_SymSparseRCSMatOp_s & )
{
   cerr << "Error: HCL_SymSparseRCSMatOp_s copy constructor not "
           "implemented" << endl;
   exit(1);
}

HCL_SymSparseRCSMatOp_s::HCL_SymSparseRCSMatOp_s( SymSparseRCSMatrix_s * AA,
                         int flag,HCL_VectorSpace_s * d )
{
   if( d->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s constructor: dimension of "
              "domain (" << d->Dim()
           << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = d;d->IncCount();
}

HCL_SymSparseRCSMatOp_s::HCL_SymSparseRCSMatOp_s( SymSparseRCSMatrix_s * AA,
                                int flag,
                                HCL_VectorSpace_s * d,
                                HCL_VectorSpace_s * r )
{
   if( d->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s constructor: dimension "
              "of domain (" << d->Dim()
           << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   if( r->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s constructor: dimension "
              "of range ("
           << r->Dim() << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = r;r->IncCount();
}

HCL_SymSparseRCSMatOp_s::~HCL_SymSparseRCSMatOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   if( DeleteMat ) delete Matrix;
}

void HCL_SymSparseRCSMatOp_s::Image( const HCL_Vector_s & xx,
                                           HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::Image: input vector is "
              "not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::Image: output vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::Image: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::Image: output vector has "
              "NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Y.mult( *((SymSparseRCSMatrix_s *)Matrix),(GeneralMatrix_s)X );
}

void HCL_SymSparseRCSMatOp_s::AdjImage( const HCL_Vector_s & yy,
                                              HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::AdjImage: output vector "
              "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::AdjImage: input vector "
              "is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::AdjImage: output vector "
              "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::AdjImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   X.mult( *((SymSparseRCSMatrix_s *)Matrix),(GeneralMatrix_s)Y );
}

void HCL_SymSparseRCSMatOp_s::InvImage(const HCL_Vector_s & yy,
                                             HCL_Vector_s & xx) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvImage: output vector "
              "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvImage: input vector "
              "is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvImage: output vector "
              "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( X,Y );
}

void HCL_SymSparseRCSMatOp_s::InvAdjImage(const HCL_Vector_s & xx,
                                                HCL_Vector_s & yy) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvAdjImage: input "
              "vector is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvAdjImage: output "
              "vector is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvAdjImage: input "
              "vector has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SymSparseRCSMatOp_s::InvAdjImage: output "
              "vector has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( Y,X );
}

ostream & HCL_SymSparseRCSMatOp_s::Write( ostream & str ) const
{
   str << "HCL_SymSparseRCSMatOp_s with domain" << endl;
   Domain().Write( str );
   str << "and range" << endl;
   Range().Write( str );
   str << "The matrix is" << endl << *Matrix << endl;
   return str;
}

HCL_SparseRCSMatOp_s::HCL_SparseRCSMatOp_s()
{
   cerr << "Error: HCL_SparseRCSMatOp_s default constructor not "
           "implemented" << endl;
   exit(1);
}

HCL_SparseRCSMatOp_s::HCL_SparseRCSMatOp_s(
                         const HCL_SparseRCSMatOp_s & )
{
   cerr << "Error: HCL_SparseRCSMatOp_s copy constructor not "
           "implemented" << endl;
   exit(1);
}

HCL_SparseRCSMatOp_s::HCL_SparseRCSMatOp_s( SparseRCSMatrix_s * AA,
                                int flag,
                                HCL_VectorSpace_s * d,
                                HCL_VectorSpace_s * r )
{
   if( d->Dim() != AA->numCols() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s constructor: dimension "
              "of domain (" << d->Dim()
           << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   if( r->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s constructor: dimension "
              "of range ("
           << r->Dim() << ") does not agree with size of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = r;r->IncCount();
}

HCL_SparseRCSMatOp_s::~HCL_SparseRCSMatOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   if( DeleteMat ) delete Matrix;
}

void HCL_SparseRCSMatOp_s::Image( const HCL_Vector_s & xx,
                                           HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::Image: input vector is "
              "not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::Image: output vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::Image: input vector has NULL "
              "data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::Image: output vector has "
              "NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Y.mult( *((SparseRCSMatrix_s *)Matrix),(GeneralMatrix_s)X );
}

void HCL_SparseRCSMatOp_s::AdjImage( const HCL_Vector_s & yy,
                                              HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::AdjImage: output vector "
              "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::AdjImage: input vector "
              "is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::AdjImage: output vector "
              "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::AdjImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   X.multTrans( *Matrix,Y );
}

void HCL_SparseRCSMatOp_s::InvImage(const HCL_Vector_s & yy,
                                             HCL_Vector_s & xx) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvImage: output vector "
              "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvImage: input vector "
              "is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvImage: output vector "
              "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( X,Y );
}

void HCL_SparseRCSMatOp_s::InvAdjImage(const HCL_Vector_s & xx,
                                                HCL_Vector_s & yy) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvAdjImage: input "
              "vector is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvAdjImage: output "
              "vector is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvAdjImage: input "
              "vector has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_SparseRCSMatOp_s::InvAdjImage: output "
              "vector has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   // Need a routine to (a) form the tranpose of the matrix or
   // (b) solve the system with the transposed matrix.
   cerr << "Error: HCL_SparseRCSMatOp_s::InvAdjImage is not implemented"
        << endl;
}

ostream & HCL_SparseRCSMatOp_s::Write( ostream & str ) const
{
   str << "HCL_SparseRCSMatOp_s with domain" << endl;
   Domain().Write( str );
   str << "and range" << endl;
   Range().Write( str );
   str << "The matrix is" << endl << *Matrix << endl;
   return str;
}

HCL_UpperTriangularMatOp_s::HCL_UpperTriangularMatOp_s()
{
   cerr << "Error: HCL_UpperTriangularMatOp_s default constructor "
        << endl << "not implemented" << endl;
   exit(1);
}

HCL_UpperTriangularMatOp_s::HCL_UpperTriangularMatOp_s(
                            const HCL_UpperTriangularMatOp_s & )
{
   cerr << "Error: HCL_UpperTriangularMatOp_s copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_UpperTriangularMatOp_s::HCL_UpperTriangularMatOp_s(
                            UpperTriangle_s * AA,int flag,
                            HCL_VectorSpace_s * d,HCL_VectorSpace_s * r )
{
   if( d->Dim() != AA->numCols() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s constructor: dimension "
           << endl << "of domain ("
           << d->Dim() << ") does not agree with # of columns of matrix ("
           << AA->numCols() << ")" << endl;
      exit(1);
   }
   if( r->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s constructor: dimension "
           << endl << "of range ("
           << r->Dim() << ") does not agree with # of rows of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = r;r->IncCount();
}

HCL_UpperTriangularMatOp_s::~HCL_UpperTriangularMatOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   if( DeleteMat ) delete Matrix;
}

void HCL_UpperTriangularMatOp_s::Image( const HCL_Vector_s & xx,
                                      HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::Image: input vector is "
              "not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::Image: output vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::Image: input vector has "
           << endl << "NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::Image: output vector has "
           << endl << "NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Y.mult( *((UpperTriangle_s *)Matrix),(GeneralMatrix_s)X );
}

void HCL_UpperTriangularMatOp_s::AdjImage( const HCL_Vector_s & yy,
                                         HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::AdjImage: output vector"
           << endl << "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::AdjImage: input vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::AdjImage: output vector "
           << endl << "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::AdjImage: input vector "
           << endl << "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   X.multTrans( *Matrix,Y );
}

void HCL_UpperTriangularMatOp_s::InvImage(const HCL_Vector_s & yy,
                                    HCL_Vector_s & xx) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvImage: output vector "
           << "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvImage: input vector "
           << endl << "is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvImage: output vector"
           << "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvImage: input vector"
           << "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( X,Y );
}

void HCL_UpperTriangularMatOp_s::InvAdjImage(const HCL_Vector_s & xx,
                                       HCL_Vector_s & yy) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvAdjImage: input vector"
           << "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvAdjImage: output"
           << "vector is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvAdjImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_UpperTriangularMatOp_s::InvAdjImage: output vector"
           << endl << "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->transposeSolve( Y,X );
}

ostream & HCL_UpperTriangularMatOp_s::Write( ostream & str ) const
{
   str << "HCL_UpperTriangularMatOp_s with domain" << endl;
   Domain().Write( str );
   str << "and range" << endl;
   Range().Write( str );
   str << "The matrix is" << endl << *Matrix << endl;
   return str;
}

HCL_LowerTriangularMatOp_s::HCL_LowerTriangularMatOp_s()
{
   cerr << "Error: HCL_LowerTriangularMatOp_s default constructor "
        << endl << "not implemented" << endl;
   exit(1);
}

HCL_LowerTriangularMatOp_s::HCL_LowerTriangularMatOp_s(
                            const HCL_LowerTriangularMatOp_s & )
{
   cerr << "Error: HCL_LowerTriangularMatOp_s copy constructor not implemented"
        << endl;
   exit(1);
}

HCL_LowerTriangularMatOp_s::HCL_LowerTriangularMatOp_s(
                            LowerTriangle_s * AA,int flag,
                            HCL_VectorSpace_s * d,HCL_VectorSpace_s * r )
{
   if( d->Dim() != AA->numCols() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s constructor: dimension "
           << endl << "of domain ("
           << d->Dim() << ") does not agree with # of columns of matrix ("
           << AA->numCols() << ")" << endl;
      exit(1);
   }
   if( r->Dim() != AA->numRows() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s constructor: dimension "
           << endl << "of range ("
           << r->Dim() << ") does not agree with # of rows of matrix ("
           << AA->numRows() << ")" << endl;
      exit(1);
   }
   Matrix = AA;
   DeleteMat = flag;
   dom = d;d->IncCount();
   range = r;r->IncCount();
}

HCL_LowerTriangularMatOp_s::~HCL_LowerTriangularMatOp_s()
{
   HCL_delete( range );
   HCL_delete( dom );
   if( DeleteMat ) delete Matrix;
}

void HCL_LowerTriangularMatOp_s::Image( const HCL_Vector_s & xx,
                                      HCL_Vector_s & yy ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::Image: input vector is "
              "not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::Image: output vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::Image: input vector has "
           << endl << "NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::Image: output vector has "
           << endl << "NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Y.mult( *((LowerTriangle_s *)Matrix),(GeneralMatrix_s)X );
}

void HCL_LowerTriangularMatOp_s::AdjImage( const HCL_Vector_s & yy,
                                         HCL_Vector_s & xx ) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::AdjImage: output vector"
           << endl << "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::AdjImage: input vector is "
              "not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::AdjImage: output vector "
           << endl << "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::AdjImage: input vector "
           << endl << "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   X.multTrans( *Matrix,Y );
}

void HCL_LowerTriangularMatOp_s::InvImage(const HCL_Vector_s & yy,
                                    HCL_Vector_s & xx) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvImage: output vector "
           << "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvImage: input vector "
           << endl << "is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvImage: output vector"
           << "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvImage: input vector"
           << "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->solve( X,Y );
}

void HCL_LowerTriangularMatOp_s::InvAdjImage(const HCL_Vector_s & xx,
                                       HCL_Vector_s & yy) const
{
   if( xx.Space() != Domain() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvAdjImage: input vector"
           << "is not in domain" << endl;
      cerr << "Domain is: " << endl;
      Domain().Write( cerr );
      cerr << "Space of input vector is: " << endl;
      xx.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & x = (HCL_Vector_s&)xx; // casting away const
   if( yy.Space() != Range() )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvAdjImage: output"
           << "vector is not in range" << endl;
      cerr << "Range is: " << endl;
      Range().Write( cerr );
      cerr << "Space of output vector is: " << endl;
      yy.Space().Write( cerr );
      exit(1);
   }
   HCL_Vector_s & y = (HCL_Vector_s&)yy; // casting away const
   float * xdat = x.Data();
   if( !xdat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvAdjImage: input vector "
              "has NULL data pointer" << endl;
      cerr << "Input vector is" << endl;
      x.Write( cerr );
      exit(1);
   }
   float * ydat = y.Data();
   if( !ydat )
   {
      cerr << "Error in HCL_LowerTriangularMatOp_s::InvAdjImage: output vector"
           << endl << "has NULL data pointer" << endl;
      cerr << "Output vector is" << endl;
      y.Write( cerr );
      exit(1);
   }
   GeneralMatrix_s X( x.Dim(),xdat ),Y( y.Dim(),ydat );
   Matrix->transposeSolve( Y,X );
}

ostream & HCL_LowerTriangularMatOp_s::Write( ostream & str ) const
{
   str << "HCL_LowerTriangularMatOp_s with domain" << endl;
   Domain().Write( str );
   str << "and range" << endl;
   Range().Write( str );
   str << "The matrix is" << endl << *Matrix << endl;
   return str;
}
