/*********************************************************************
 This file was automatically generated by d2s from
 the file HCL_QuadFcnl_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0 - July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_QuadFcnl_s.h"

HCL_EvalQuadFunctional_s::HCL_EvalQuadFunctional_s()
{
   cerr << "Error: HCL_EvalQuadFunctional_s default "
           "constructor called" << endl;
   exit(1);
}

HCL_EvalQuadFunctional_s::HCL_EvalQuadFunctional_s(
                          const HCL_EvalQuadFunctional_s & )
{
   cerr << "Error: HCL_EvalQuadFunctional_s copy constructor called"
        << endl;
   exit(1);
}

HCL_EvalQuadFunctional_s::HCL_EvalQuadFunctional_s(
                             const HCL_Vector_s & x,HCL_LinearOp_s * a,
                             HCL_Vector_s * bb,float aalpha )
{
   if( a->Domain() != a->Range() )
   {
      cerr << "Error in HCL_EvalQuadFunctional_s constructor: domain and "
              "range of operator must agree" << endl;
      exit(1);
   }
   A = a;a->IncCount();
   b = bb;if( b != NULL ) b->IncCount();
   alpha = aalpha;
   input = A->Domain().Member();
   input->Copy( x );
   Ax = NULL;
}

HCL_EvalQuadFunctional_s::~HCL_EvalQuadFunctional_s()
{
   HCL_delete( Ax );
   HCL_delete( input );
   HCL_delete( b );
   HCL_delete( A );
}

float HCL_EvalQuadFunctional_s::Value() const
{
   // Casting away const
   HCL_EvalQuadFunctional_s * t = (HCL_EvalQuadFunctional_s*)this;
   if( Ax == NULL )
   {
      t->Ax = A->Domain().Member();
      A->Image( *input,*(t->Ax) );
   }
   float v;
   v = 0.5*(input->Inner( *Ax ));
   if( b != NULL ) v += input->Inner( *b );
   v += alpha;
   return v;
}

void HCL_EvalQuadFunctional_s::Gradient( HCL_Vector_s & g ) const
{
   // Casting away const
   HCL_EvalQuadFunctional_s * t = (HCL_EvalQuadFunctional_s*)this;
   if( Ax == NULL )
   {
      t->Ax = A->Domain().Member();
      A->Image( *input,*(t->Ax) );
   }
   if( b != NULL )
      g.Add( *Ax,*b );
   else
      g.Copy( *Ax );
}

HCL_LinearOp_s * HCL_EvalQuadFunctional_s::Hessian() const
{
   A->IncCount();
   return A;
}

ostream & HCL_EvalQuadFunctional_s::Write( ostream & str ) const
{
   str << "HCL_EvalQuadFunctional_s defined by:" << endl;
   str << "A = " << endl;
   A->Write( str );
   if( b != NULL )
   {
      str << "b = " << endl;
      b->Write( str );
   }
   str << "alpha = " << alpha << endl;
   return str;
}

HCL_QuadFunctional_s::HCL_QuadFunctional_s()
{
   cerr << "Error: HCL_QuadFunctional_s default constructor called"
        << endl;
   exit(1);
}

HCL_QuadFunctional_s::HCL_QuadFunctional_s( const HCL_QuadFunctional_s & )
{
   cerr << "Error: HCL_QuadFunctional_s copy constructor called"
        << endl;
   exit(1);
}

HCL_QuadFunctional_s::HCL_QuadFunctional_s( HCL_LinearOp_s * a,
                                            HCL_Vector_s * bb,float aalpha )
{
   if( a->Domain() != a->Range() )
   {
      cerr << "Error in HCL_QuadFunctional_s constructor: domain and "
              "range of operator must agree" << endl;
      exit(1);
   }
   A = a;a->IncCount();
   if( bb != NULL )
   {
      if( bb->Space() != A->Domain() )
      {
         cerr << "Error in HCL_QuadFunctional_s constructor: gradient "
                 "must lie in domain of operator" << endl;
         exit(1);
      }
      b = bb;b->IncCount();
   }
   else
      b = NULL;
   alpha = aalpha;
}

HCL_QuadFunctional_s::~HCL_QuadFunctional_s()
{
   HCL_delete( b );
   HCL_delete( A );
}

HCL_EvaluateFunctional_s * HCL_QuadFunctional_s::Evaluate(
                               const HCL_Vector_s & x ) const
{
   return new HCL_EvalQuadFunctional_s( x,A,b,alpha );
}
ostream & HCL_QuadFunctional_s::Write( ostream & str ) const
{
   str << "HCL_QuadFunctional_s defined by:" << endl;
   str << "A = " << endl;
   A->Write( str );
   if( b != NULL )
   {
      str << "b = " << endl;
      b->Write( str );
   }
   str << "alpha = " << alpha << endl;
   return str;
}
