// Shannon Scott 5/25/1999
// index.H
// Initial rough-draft of an index class, used to simulate
// colon notation in matrix algebra.
// Index is intended for ones-index based matrices.

#ifndef _INDEX_H
#define _INDEX_H

#include <assert.h>
#include "m_error.H"

class Index
{
public:
  Index(void);               // Default corresponds to everything
  Index(int _start, int _step, int _stop); 
  ~Index(void){};

  int getStart(void) const { return Start; };
  int getStop(void) const  { return Stop; };
  int getStep(void) const  { return Step; };

  int get(int i);  // Get the i'th index
  
  int size(void);

  // Must initialize before using (to allow bounds checking, etc.)
  // Returns 0 for no error. 
  // lbound : lower bound of indexes, ubound : upper bound of indexes
  int init(int lbound, int ubound);

  // Get the first index.  Note: this function is really not necessary as
  // getNext() resets to the first index automatically. I just thought
  // this function would make people feel better.
  int getFirst(void);

  // Get the next index value (returns 0 when done)
  int getNext(void); 

protected:
  int Start;
  int Stop;
  int Step;
  int Current;
};

#endif
