// Shannon Scott   6/7/1999
// First-draft of a permutation matrix class
// permute.H

#ifndef PERMUTE_H
#define PERMUTE_H

//#include "matrix.H"


class Permutation : public Matrix_d
{
public:
  Permutation(void);
  Permutation(int _size);
  Permutation(int i, int j);
  Permutation(const Permutation& copy);

  ~Permutation(void);

  int zero(void)         { return 1; };
  int ones(void)         { return 1; };
  int setAll(double val) { return 1; };
  int diag(double val)   { return 1; };
  
  double  operator()(int i, int j) const;
  double& operator()(int i, int j);

  double get(int i, int j) const;
  void   set(int i, int j, double val);
  
  int numRows(void) const { return size; };
  int numCols(void) const { return size; };

  int solve(GeneralMatrix_d& X, const GeneralMatrix_d& B);
  
  friend ostream& operator<< (ostream& os, const Permutation& P);
  friend class GeneralMatrix_d;  
protected:
  int* data;
  int  size;
  double    dummy;
};

//****************************************************************************
inline double Permutation::operator()(int i, int j) const
{
  if( data[i-1] == j )
    return 1.0;
  else
    return 0.0;
};

//****************************************************************************
inline double& Permutation::operator()(int i, int j)
{
  ERROR("This matrix is static");
  return dummy;
};

//****************************************************************************
inline double Permutation::get(int i, int j) const
{
  if( data[i-1] == j )
    return 1.0;
  else
    return 0.0;
};

//****************************************************************************
inline void Permutation::set(int i, int j, double val)
{
  ERROR("This matrix is static");
};

#endif

