// Shannon Scott, 7/2/1999
// Experimental submatrix class.
// Encapsulates another matrix, but only lets you see a portion of it.

#ifndef SUB_MAT_H
#define SUB_MAT_H

//#include "mat_inc.H"

class SubMatrix : public Matrix_d
{
public:
  SubMatrix(Matrix_d& A, Index& rows, Index& cols);

  ~SubMatrix(void);

  double get(int i, int j) const;
  void   set(int i, int j, double val);

  int set(const Matrix_d& B);

  double  operator()(int i, int j) const;
  double& operator()(int i, int j);

  int numRows(void) const { return row.size(); };
  int numCols(void) const { return col.size(); };
  
  int zero(void) { return setAll(0.0); };
  int ones(void) { return setAll(1.0); };
  int setAll(double val);

  int add(const Matrix_d& B);

private:
  Matrix_d& mat;
  Index&  row;
  Index&  col;   
};

//****************************************************************************
inline double SubMatrix::get(int i, int j) const
{
  return mat.get( row.get(i), col.get(j) );
}

//****************************************************************************
inline void SubMatrix::set(int i, int j, double val)
{
  mat.set( row.get(i), col.get(j), val );
}

//****************************************************************************
inline double SubMatrix::operator()(int i, int j) const
{
  return mat.operator()( row.get(i), col.get(j) );
}

//****************************************************************************
inline double& SubMatrix::operator()(int i, int j)
{
  return mat.operator()( row.get(i), col.get(j) );
}

#endif
