// Shannon Scott
// 7/15/1999
// Another experimental sub-matrix class.  This version uses templates
// to encapsulate the matrix to be devided.  (The other submatrix
// class wrapped any matrix of type (or parent-type) Matrix).

#ifndef TEMPLATE_SUBMATRIX_H
#define TEMPLATE_SUBMATRIX_H

template< class mat >
class TemplateSubMatrix : public Matrix_d
{
  TemplateSubMatrix(void){};  
public:
  TemplateSubMatrix(mat& A, Index& rows, Index& cols);

  ~TemplateSubMatrix(void){};
  
  double get(int i, int j) const;
  void   set(int i, int j, double val);

  int set(const Matrix_d& B);
  
  double  operator()(int i, int j) const;
  double& operator()(int i, int j);

  int numRows(void) const { return row.size(); };
  int numCols(void) const { return col.size(); };

  int zero(void)         { return setAll( 0.0 ); };
  int ones(void)         { return setAll( 1.0 ); };
  int setAll(double val);

  int add(const Matrix_d& B);
private:
  mat& matrix;    // The encapsulated matrix
  Index& row;
  Index& col;
};

//****************************************************************************
template<class mat>
inline double TemplateSubMatrix<mat>::get(int i, int j) const
{
  return matrix.get( row.get(i), col.get(j) );
}

template<class mat>
inline void TemplateSubMatrix<mat>::set(int i, int j,
					double val)
{
  matrix.set( row.get(i), col.get(j), val );
}

template<class mat>
inline double TemplateSubMatrix<mat>::operator()(int i, int j) const
{
  return matrix.get( row.get(i), col.get(j) );
}

template<class mat>
inline double& TemplateSubMatrix<mat>::operator()(int i, int j)
{
  return matrix.set( row.get(i), col.get(j) );
}  

#endif
