// Shannon Scott
// 7/16/1999

#include "mat_inc_d.H"

//****************************************************************************
BandedMatrix_d::BandedMatrix_d(int m, int n,
			       int _ku, int _kl)
{
  nrows  = m;
  ncols  = n;
  ku     = _ku;
  kl     = _kl;
  nAlloc = (ku + kl + 1 ) * n;
  data   = new double[ nAlloc ];
}

//****************************************************************************
BandedMatrix_d::BandedMatrix_d(const BandedMatrix_d& copy)
{
  nrows  = copy.nrows;
  ncols  = copy.ncols;
  ku     = copy.ku;
  kl     = copy.kl;
  nAlloc = copy.nAlloc;
  data   = new double[ nAlloc ];

  for(int i=0; i < nAlloc; ++i)
    data[i] = copy.data[i];
}

//****************************************************************************
BandedMatrix_d::~BandedMatrix_d(void)
{
  delete[] data;
}

//****************************************************************************
int BandedMatrix_d::setAll(double val)
{
  for( int i = 0; i < nAlloc; ++i )
    data[i] = val;
  return 0;
}

//****************************************************************************
ostream& operator<< (ostream& os, const BandedMatrix_d& A)
{
  // This is a lazy implementation, you can do better!
  for(int i=1; i <= A.numRows(); ++i)
    {
      for(int j=1; j <= A.numCols(); ++j)
	{
	  os << A(i,j) << '\t';
	}
      os << endl;
    }
  os << endl;
  return os;
}

