// Shannon Scott  6/17/1999
// Test the compressed-row-storage sparse matrix class.

#include "mat_inc_d.H"

int main(void)
{
  //*************************************
  // Quick test of the sparse RCS class
  /*SparseRCSMatrix_d A(5,5);
  A(1,1) = 1;
  A(1,3) = 2;
  A(3,1) = 2;
  A(1,4) = 3;
  A(4,1) = 3;
  A(2,2) = 4;
  A(3,3) = 5;
  A(4,3) = 6;
  A(3,4) = 6;
  A(4,4) = 7;
  A(5,4) = 8;
  A(4,5) = 8;
  A(5,5) = 9;
  cout << "A = " << endl << A << endl;*/
  //A.dump( cout ); cout << endl;

  SparseRCSMatrix_d A(3,3);
  A(1,1) = 1;
  A(1,3) = 2;
  A(2,2) = 3;
  A(3,2) = 4;
  A(3,3) = 5;
  cout << "A = " << endl << A << endl;

  SparseRCSMatrix_d B(3,3);
  B(1,3) = 6;
  B(2,1) = 7;
  B(2,2) = 8;
  B(3,1) = 9;
  B(3,3) = 10;
  cout << "B = " << endl << B << endl;

  SparseRCSMatrix_d C(3,3);
  C.zero();
  C(1,2) = 10;
  C.mult(A, B, 0.5, 0.1);
  cout << "C = A*B = " << endl << C << endl;

  SymSparseRCSMatrix_d M(5,5);
  M(1,1) = 1;
  M(1,3) = 2;
  M(1,4) = 3;
  M(2,2) = 4;
  M(3,3) = 5;
  M(3,4) = 6;
  M(4,4) = 7;
  M(4,5) = 8;
  M(5,5) = 9;
  cout << "M = " << M << endl;

  GeneralMatrix_d X(5,1),b(5,1);
  b(1,1) = 6.0;
  b(2,1) = 4.0;
  b(3,1) = 13.0;
  b(4,1) = 24.0;
  b(5,1) = 17.0;

  M.solve( X,b );
  cout << "X = " << X << endl;
  
  return 0;
}

