// Shannon Scott, 7/2/1999


#include "mat_inc_d.H"

//**************************************************************************
SubMatrix::SubMatrix(Matrix_d& A, Index& rows, Index& cols)
  : mat(A), row(rows), col(cols)
{
  REQUIRE( row.init(1, A.numRows()) == 0, "Error in row index." );
  REQUIRE( col.init(1, A.numCols()) == 0, "Error in column index." );
}

//**************************************************************************
SubMatrix::~SubMatrix(void)
{
}

//**************************************************************************
int SubMatrix::set(const Matrix_d& B)
{
  int ai, aj;
  int bi, bj;
  
  REQUIRE( row.size() == B.numRows(),
	   "Row dimensions do not agree." );
  REQUIRE( col.size() == B.numCols(),
	   "Column dimensions do not agree." );

  for(aj = col.getFirst(), bj = 1;
      bj <= B.numCols();
      aj = col.getNext(), ++bj)
    {
      for(ai = row.getFirst(), bi = 1;
	  bi <= B.numRows();
	  bj = row.getNext(), ++bi)
	{
	  mat.set( ai, aj, B.get( bi, bj ) );
	}
    }
  return 0;
}

//****************************************************************************
int SubMatrix::setAll(double val)
{
  int i, j;

  j = col.getFirst();
  while( j )
    {
      i = row.getFirst();
      while( i )
	{
	  mat.set(i, j, val);
	  i = row.getNext();
	}
      j = col.getNext();
     } 
    
  return 0;
}

//***************************************************************************
int SubMatrix::add(const Matrix_d& B)
{
  int ai, aj;
  int bi, bj;
  
  REQUIRE( row.size() == B.numRows(),
	   "Row dimensions do not agree." );
  REQUIRE( col.size() == B.numCols(),
	   "Column dimensions do not agree." );

  for(aj = col.getFirst(), bj = 1;
      bj <= B.numCols();
      aj = col.getNext(), ++bj)
    {
      for(ai = row.getFirst(), bi = 1;
	  bi <= B.numRows();
	  bj = row.getNext(), ++bi)
	{
	  mat( ai, aj ) += B( bi, bj );
	}
    }
  return 0;
}










