/*********************************************************************
 This file was automatically generated by d2s from
 the file gen_sym_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott
// 7/15/1999
// General symmetric matrix class using the LAPACK packed symmetric
// matrix format.  I arbitrarily chose to store the upper triangle
// (LAPACK supports either choice).  Accessing elements of the upper
// matrix is slightly (slightly) simpler than accessing elements of
// the lower triangle.

#ifndef GENSYMMAT_H
#define GENSYMMAT_H

extern int matrix_rnd_seed[];

class GenSymMatrix_s : public Matrix_s
{
public:
  GenSymMatrix_s(void);
  GenSymMatrix_s(int size);
  GenSymMatrix_s(int i, int j);
  GenSymMatrix_s(const GenSymMatrix_s& copy);
  GenSymMatrix_s(char * fname);

  ~GenSymMatrix_s(void);

  int zero(void)           { return setAll( 0.0 ); };
  int ones(void)           { return setAll( 1.0 ); };
  int setAll(float val);
  int random(void);

  float  operator()(int i, int j) const;
  float& operator()(int i, int j);

  float  get(int i, int j) const;
  void    set(int i, int j, float val);

  int numRows(void) const { return size; };
  int numCols(void) const { return size; };

  float normFrobenius(void) const;
  float normInf(void) const;
  float normOnes(void) const;

  int cholesky(UpperTriangle_s& U);
  int solvePositiveDefinite(GeneralMatrix_s& X, const GeneralMatrix_s& B);
  int solve(GeneralMatrix_s& X, const GeneralMatrix_s& B);

  int eig(float* val) const;                   
  int eig(float* val, GeneralMatrix_s& X ) const;

  float*  data;
  
  friend ostream& operator<< (ostream&, const GenSymMatrix_s&);
private:
  int size;
  int nAlloc;  // This value is not really necessary, but it
		    // speeds up some processes (since the amount of
		    // data stored is not as simple as n*m).
};


// These inline functions seem awfuly redundant (look at how similar
// they are!), but I want them to be inlined, and allow the use of
// methods and operators, so...
inline float GenSymMatrix_s::operator()(int i, int j) const
{
  REQUIRE( i <= size, "Row index out of range." );
  REQUIRE( j <= size, "Column index out of range." );

  if( i <= j )
    return data[ i + j * (j - 1) / 2 - 1 ];
  else
    return data[ j + i * (i - 1) / 2 - 1 ];
}

inline float& GenSymMatrix_s::operator()(int i, int j)
{
  REQUIRE( i <= size, "Row index out of range." );
  REQUIRE( j <= size, "Column index out of range." );

  if( i <= j )
    return data[ i + j * (j - 1) / 2 - 1 ];
  else
    return data[ j + i * (i - 1) / 2 - 1 ];
}

inline float GenSymMatrix_s::get(int i, int j) const
{
  REQUIRE( i <= size, "Row index out of range." );
  REQUIRE( j <= size, "Column index out of range." );

  if( i <= j )
    return data[ i + j * (j - 1) / 2 - 1 ];
  else
    return data[ j + i * (i - 1) / 2 - 1 ];
}

inline void GenSymMatrix_s::set(int i, int j, float val)
{
  REQUIRE( i <= size, "Row index out of range." );
  REQUIRE( j <= size, "Column index out of range." );

  if( i <= j )
    data[ i + j * (j - 1) / 2 - 1 ] = val;
  else
    data[ j + i * (i - 1) / 2 - 1 ] = val;
}

#endif
