/*********************************************************************
 This file was automatically generated by d2s from
 the file general_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott   5/10/1999
// General (dense) matrix class, float precision
// Matrix indexing is one based.
// Everything that does not return a value will return an error-value.
// This is 0 if successful.

#ifndef _GENERAL_MATRIX_S_H
#define _GENERAL_MATRIX_S_H

#ifndef bool
#define bool int
#define false 0
#define true 1
#endif

extern int matrix_rnd_seed[];

class GeneralMatrix_s : public Matrix_s
{
  GeneralMatrix_s(void){};                             
public:
  GeneralMatrix_s(int rows, int cols);      
  GeneralMatrix_s(const GeneralMatrix_s& copy);       
  GeneralMatrix_s(const GeneralMatrix_s& copy, Index rows, Index cols);
  
  GeneralMatrix_s(const Matrix_s& copy);
  GeneralMatrix_s(const Matrix_s& copy, Index rows, Index cols);

  GeneralMatrix_s(const Permutation&          P);
  GeneralMatrix_s(const GenSymMatrix_s&       A);
  GeneralMatrix_s(const BandedMatrix_s&       B);
  GeneralMatrix_s(const UpperTriangle_s&      U);
  GeneralMatrix_s(const LowerTriangle_s&      L);  
  GeneralMatrix_s(const SparseRCSMatrix_s&    A);  
  GeneralMatrix_s(const SymSparseRCSMatrix_s& A);
  
  // Wrap an array to form a vector.  Delete memory when through if
  // delete_mem = true.
  GeneralMatrix_s(int veclen, float* vec, bool delete_mem = false);

  // Wrap an array to form a matrix (column-major order).  Delete
  // memory when through if delete_mem = true.
  GeneralMatrix_s(int rows, int cols,float* mat,
		  bool delete_mem = false);
  // Read a matrix from a file.  The file is plain text, containing the two
  // integers m (number of rows), n (number of columns), followed by the
  // entries of the matrix by columns.
  GeneralMatrix_s( char * fname );

  ~GeneralMatrix_s(void);

  float  get(int i, int j) const;          // Only get value
  void    set(int i, int j, float val);    // Only set value
  float& element(int i, int j);            // Free access to value

  float  operator()(int i, int j) const;
  float& operator()(int i, int j);  

  // Return pointer to internal memory (be careful!)
  float* getData(void){ return data; };

  // Change the flag deciding whether memory is deleted on destruction
  void setDeleteMemFlag(bool _delete_mem)
    { delete_mem = _delete_mem; };
  
  // Memory returned must be deleted!
  GeneralMatrix_s* get(void) const;
  GeneralMatrix_s* get(Index rows, Index cols) const;
  
  // Maybe a better idea.  No need to necessarilly delete memory,
  // but has the overhead of a small copy operation (not much).
  //GeneralMatrix_s get(void) const;
  
  int set(const GeneralMatrix_s& B);
  int set(const GeneralMatrix_s& B, Index rows, Index cols);
  int set(Index rowsA, Index colsA, const GeneralMatrix_s& B,
	  Index rowsB = Index(), Index colsB = Index());

  int set(const Matrix_s&);
  int set(const Matrix_s& B, Index rows, Index cols);
  int set(Index rowsA, Index colsA, const Matrix_s& B,
	  Index rowsB = Index(), Index colsB = Index());

  int zero(void)          { return setAll(0.0); };
  int ones(void)          { return setAll(1.0); };
  int diag(float val);
  int setAll(float val);
  int random(void);

  inline int numRows(void) const { return nRows; };
  inline int numCols(void) const { return nCols; };

  friend ostream& operator<< (ostream&, const GeneralMatrix_s&);

  // Old operations (may be phased out)
  int add(const GeneralMatrix_s& A, const GeneralMatrix_s& B);
  //int add(const Matrix& A, const Matrix& B);
  int mult(const GeneralMatrix_s& B);
  int mult(const GeneralMatrix_s& A, GeneralMatrix_s& B);
  
  // Add a single matrix to this
  int add(const Matrix_s&               B);
  int add(const GenSymMatrix_s&       B);
  int add(const BandedMatrix_s&       B);
  int add(const GeneralMatrix_s&      B);
  int add(const UpperTriangle_s&      U);
  int add(const LowerTriangle_s&      L);
  int add(const SparseRCSMatrix_s&    B);
  int add(const SymSparseRCSMatrix_s& B);

  // Add a single transposed matrix
  int addTrans(const Matrix_s&               B);
  int addTrans(const BandedMatrix_s&       B);
  int addTrans(const GeneralMatrix_s&      B);
  int addTrans(const UpperTriangle_s&      U);
  int addTrans(const LowerTriangle_s&      L);
  int addTrans(const SparseRCSMatrix_s&    B);
  int addTrans(const GenSymMatrix_s&       B){ return add( B ); };
  int addTrans(const SymSparseRCSMatrix_s& B){ return add( B ); };

  // Add matrix to this, C += a * A
  int add(const GenSymMatrix_s&       A, float a);
  int add(const BandedMatrix_s&       A, float a);
  int add(const GeneralMatrix_s&      A, float a);
  int add(const SparseRCSMatrix_s&    A, float a);
  int add(const SymSparseRCSMatrix_s& A, float a);

  // Add transpose of matrix to this, C += a * A'
  int addTrans(const BandedMatrix_s&       A, float a);
  int addTrans(const GeneralMatrix_s&      A, float a);
  int addTrans(const SparseRCSMatrix_s&    A, float a);
  int addTrans(const GenSymMatrix_s&       A, float a)
    { return add( A, a ); };
  int addTrans(const SymSparseRCSMatrix_s& A, float a)
    { return add( A, a ); };
  
  // Multiply two matrices, C = A*B
  int mult(const UpperTriangle_s&      A, const GeneralMatrix_s& B);
  int mult(const LowerTriangle_s&      A, const GeneralMatrix_s& B);
  int mult(const GenSymMatrix_s&       A, const GeneralMatrix_s& B);
  int mult(const GeneralMatrix_s&      A, const GeneralMatrix_s& B);
  int mult(const SymSparseRCSMatrix_s& A, const GeneralMatrix_s& B);
  int mult(const SparseRCSMatrix_s&    A, const GeneralMatrix_s& B);
  int mult(const BandedMatrix_s&       A, const GeneralMatrix_s& B);
  
  // Multiply tranposed matrix A by matrix B
  int multTrans(const GeneralMatrix_s&      A, const GeneralMatrix_s& B);
  int multTrans(const UpperTriangle_s&      A, const GeneralMatrix_s& B);
  int multTrans(const LowerTriangle_s&      A, const GeneralMatrix_s& B);
  int multTrans(const SparseRCSMatrix_s&    A, const GeneralMatrix_s& B);
  int multTrans(const SymSparseRCSMatrix_s& A, const GeneralMatrix_s& B)
    { return mult( A, B ); };
  int multTrans(const GenSymMatrix_s&       A, const GeneralMatrix_s& B)
    { return mult( A, B ); };
  int multTrans(const BandedMatrix_s&       A, const GeneralMatrix_s& B);
  
  // Multiply matrices,  C = a * A * B + b * C
  int mult(const GeneralMatrix_s& A,
	   const GeneralMatrix_s& B,
	         float a, float b);
  
  // Produce image, Y = A * X, where A is this.
  int image(const GeneralMatrix_s& X, GeneralMatrix_s& Y) const;
  
  int solve( GeneralMatrix_s& X, const GeneralMatrix_s& B) const;
  int transposeSolve( GeneralMatrix_s& X, const GeneralMatrix_s& B) const;
  int LU( UpperTriangle_s& U, LowerTriangle_s& L, Permutation& P) const;
  int QR(GeneralMatrix_s& Q, GeneralMatrix_s& R) const;
  int eig(float* val) const;                   
  int eig(float* val, GeneralMatrix_s& X ) const;
  int svd(GeneralMatrix_s& U, GeneralMatrix_s& S, GeneralMatrix_s& V) const;
  
  float condInf(void) const;
  float condOnes(void) const;  
  float normFrobenius(void) const;
  float normInf(void) const;
  float normOnes(void) const;

  int transpose(GeneralMatrix_s& Atrans) const;
  
  // Scalar operations
  int add(float val);
  int mult(float val);

  float* data;

  friend class SparseRCSMatrix_s;
  friend class UpperTriangle_s;
  friend class LowerTriangle_s;
  friend class Permutation;
  friend class GenSymMatrix_s;
  friend class SymSparseRCSMatrix_s;
protected:
  int     nRows;
  int     nCols;
  bool    delete_mem;
};


inline float GeneralMatrix_s::get(int i, int j) const
{
  REQUIRE( i <= nRows, "Row index out of bounds." );
  REQUIRE( j <= nCols, "Column index out of bounds." );
  return data[ (i-1) + (j-1) * nRows ];
};

inline void GeneralMatrix_s::set(int i, int j, float val)
{
  REQUIRE( i <= nRows, "Row index out of bounds." );
  REQUIRE( j <= nCols, "Column index out of bounds." );
  data[ (i-1) + (j-1) * nRows ] = val;
};

inline float& GeneralMatrix_s::element(int i, int j)
{
  REQUIRE( i <= nRows, "Row index out of bounds." );
  REQUIRE( j <= nCols, "Column index out of bounds." );
  return data[i-1 + nRows*(j-1)];
};

inline float GeneralMatrix_s::operator()(int i, int j) const
{
  REQUIRE( i <= nRows, "Row index out of bounds." );
  REQUIRE( j <= nCols, "Column index out of bounds." );
  return data[i-1 + nRows*(j-1)];
};

inline float& GeneralMatrix_s::operator()(int i, int j)
{
  REQUIRE( i <= nRows, "Row index out of bounds." );
  REQUIRE( j <= nCols, "Column index out of bounds." );
  return data[i-1 + nRows*(j-1)];
};

#endif











