/*********************************************************************
 This file was automatically generated by d2s from
 the file lower_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott   5/27/1999
// Initial draft of a lower-triangular matrix class
// Data is stored column wise, starting with the left-most.
// Matrix must be square.
// Matrix indexing is one based.

#ifndef LOWER_H
#define LOWER_H

class LowerTriangle_s : public Matrix_s
{
  LowerTriangle_s(void);
public:
  LowerTriangle_s(int size);
  LowerTriangle_s(int i, int j);
  LowerTriangle_s(const LowerTriangle_s& copy);

  ~LowerTriangle_s(void);

  int zero(void)      { return setAll(0.0); };
  int ones(void)      { return setAll(1.0); };
  int diag(float val);
  int setAll(float val);
  int setDiag(float val);
  int random(void);

  float  operator()(int i, int j) const;
  float& operator()(int i, int j);

  float get(int i, int j) const;
  void   set(int i, int j, float val);
  
  int numRows(void) const { return size; };
  int numCols(void) const { return size; };

  friend ostream& operator<< (ostream&, const LowerTriangle_s&);

  int add(const LowerTriangle_s& B);
  int add(const LowerTriangle_s& A, const LowerTriangle_s& B);

  int solve(GeneralMatrix_s& X, const GeneralMatrix_s& B);
  int transposeSolve(GeneralMatrix_s& X, const GeneralMatrix_s& B);
  
  int extractLower(const Matrix_s& A);

  friend class GeneralMatrix_s;
protected:
  float* data;
  int size;
  int nAlloc;  // Number of floats allocated to data
  float dummy;
};

//****************************************************************************
inline float LowerTriangle_s::operator()(int i, int j) const
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  
  if( i < j )
    return 0.0;
  else
    return data[ i + ((2*size-j)*(j-1))/2 - 1 ];
};

//****************************************************************************
inline float& LowerTriangle_s::operator()(int i, int j)
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  REQUIRE( i >= j, "These values must be zero." );
  
  return data[ i + ((2*size-j)*(j-1))/2 - 1 ];
};

//****************************************************************************
inline float LowerTriangle_s::get(int i, int j) const
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  
  if( i < j )
    return 0.0;
  else
    return data[ i + ((2*size-j)*(j-1))/2 - 1 ];
};

//****************************************************************************
inline void LowerTriangle_s::set(int i, int j, float val)
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  REQUIRE( i >= j, "These values must be zero." );
  
  data[ i + ((2*size-j)*(j-1))/2 - 1 ] = val;
};

#endif
