/*********************************************************************
 This file was automatically generated by d2s from
 the file sparse_rcs_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott  6/18/1999
// Row-compressed sparse matrix class.
// sparse_rcs_s.H

#ifndef SPARSE_RCS_MATRIX_S_H
#define SPARSE_RCS_MATRIX_S_H

// Remember to add resize function

class SparseRCSMatrix_s : public Matrix_s
{
public:
  SparseRCSMatrix_s(void);
  SparseRCSMatrix_s(int i, int j);
  SparseRCSMatrix_s(int i, int j, int _nNonZero);
  SparseRCSMatrix_s(const SparseRCSMatrix_s& copy);

  SparseRCSMatrix_s(const Matrix_s& copy);
  SparseRCSMatrix_s(const Matrix_s& copy, Index rows, Index cols);

  SparseRCSMatrix_s(const GeneralMatrix_s&      A);
  SparseRCSMatrix_s(const UpperTriangle_s&      U);
  SparseRCSMatrix_s(const LowerTriangle_s&      L);
  SparseRCSMatrix_s(const Permutation&          P);
  SparseRCSMatrix_s(const BandedMatrix_s&       A);
  SparseRCSMatrix_s(const SymSparseRCSMatrix_s& A);
  
  ~SparseRCSMatrix_s(void);

  // Data access.  Does not change the dimensions of this.
  // Methods returning pointers allocate memory which must
  // be deleted by the user.
  float get(int i, int j) const;
  void   set(int i, int j, float val);

  float& element(int i, int j) { return operator()(i,j); };
  
  float  operator()(int i, int j) const;
  float& operator()(int i, int j);

  inline int numRows(void) const { return nRows; };
  inline int numCols(void) const { return nCols; };

  int set(const SparseRCSMatrix_s& B);

  int set(const GeneralMatrix_s& B);
  int set(const GeneralMatrix_s& B, Index rows, Index cols);
  int set(Index rowsA, Index colsA, const GeneralMatrix_s& B,
	  Index rowsB = Index(), Index colsB = Index());
  
  int set(const Matrix_s&);
  int set(const Matrix_s& B, Index rows, Index cols);
  int set(Index rowsA, Index colsA, const Matrix_s& B,
	  Index rowsB = Index(), Index colsB = Index());
    
  // Methods specific to sparse matrices
  int numNonZero(void) const { return nNonZero; };
  int numAlloc  (void) const { return nAlloc;   };
  void trim(void);                      // Decrease allocated space to
                                        // minimum possible
  void remove(int i, int j);            // Remove an entry (results
                                        // in the entry equalling zero
  void removeZeros(void);               // Removes any zeros
					// inadvertantly entered in matrix
  
  int ones(void)         { return -1; };
  int zero(void);
  int diag(float val)   { return -1; };
  int setAll(float val) { return -1; };

  // Add a single matrix
  int add(const GeneralMatrix_s&      A);
  int add(const SparseRCSMatrix_s&    A);
  int add(const SymSparseRCSMatrix_s& A);
  int add(const BandedMatrix_s&       A);

  // Add a transposed matrix
  int addTrans(const GeneralMatrix_s&      A);
  int addTrans(const SparseRCSMatrix_s&    A);
  int addTrans(const BandedMatrix_s&       A);

  // Add a scaled matrix to this matrix, C += a * A
  int add(const GeneralMatrix_s&      A, float a);
  int add(const SparseRCSMatrix_s&    A, float a);
  int add(const SymSparseRCSMatrix_s& A, float a);
  int add(const BandedMatrix_s&       A, float a);

  // Add a scaled transposed matrix to this: C += a * A'
  int addTrans(const GeneralMatrix_s&      A, float a);
  int addTrans(const SparseRCSMatrix_s&    A, float a);
  int addTrans(const BandedMatrix_s&       A, float a);

  // Multiply matrix by a scalar
  int mult(float a);
  
  // Add product of matrices to this, C += A * B
  int mult(const SparseRCSMatrix_s& A, const SparseRCSMatrix_s& B);

  // Multiply matrices, C = a*A*B + b*C
  int mult(const SparseRCSMatrix_s& A, const SparseRCSMatrix_s& B,
	   float a, float b);
  
  // Produce the product Y = C*X
  int image(const GeneralMatrix_s&   X, GeneralMatrix_s& Y) const;
  int image(const SparseRCSMatrix_s& X, GeneralMatrix_s& Y) const;

  //int cg(GeneralMatrix_s& X, const GeneralMatrix_s& B,
  // unsigned maxiter, float tol);
  
  int solve(GeneralMatrix_s& X, const GeneralMatrix_s& B);
  
  float normFrobenius(void);
  float normInf(void);
  float normOnes(void);

  void dump(ostream& os);

  float*   data;
  int* column;
  int* rowstart;
  int nAlloc;
  int nNonZero;
  
  friend ostream& operator<< (ostream& os, const SparseRCSMatrix_s& A);
  friend class GeneralMatrix_s;
protected:

  void resize(void);    // Resize the storage space
  
  int nRows;
  int nCols;
};

#endif
