/*********************************************************************
 This file was automatically generated by d2s from
 the file submat_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott, 7/2/1999
// Experimental submatrix class.
// Encapsulates another matrix, but only lets you see a portion of it.

#ifndef SUB_MAT_H
#define SUB_MAT_H

//#include "mat_inc.H"

class SubMatrix : public Matrix_s
{
public:
  SubMatrix(Matrix_s& A, Index& rows, Index& cols);

  ~SubMatrix(void);

  float get(int i, int j) const;
  void   set(int i, int j, float val);

  int set(const Matrix_s& B);

  float  operator()(int i, int j) const;
  float& operator()(int i, int j);

  int numRows(void) const { return row.size(); };
  int numCols(void) const { return col.size(); };
  
  int zero(void) { return setAll(0.0); };
  int ones(void) { return setAll(1.0); };
  int setAll(float val);

  int add(const Matrix_s& B);

private:
  Matrix_s& mat;
  Index&  row;
  Index&  col;   
};

//****************************************************************************
inline float SubMatrix::get(int i, int j) const
{
  return mat.get( row.get(i), col.get(j) );
}

//****************************************************************************
inline void SubMatrix::set(int i, int j, float val)
{
  mat.set( row.get(i), col.get(j), val );
}

//****************************************************************************
inline float SubMatrix::operator()(int i, int j) const
{
  return mat.operator()( row.get(i), col.get(j) );
}

//****************************************************************************
inline float& SubMatrix::operator()(int i, int j)
{
  return mat.operator()( row.get(i), col.get(j) );
}

#endif
