/*********************************************************************
 This file was automatically generated by d2s from
 the file sym_sparse_rcs_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott
// 7/21/1999
// Symmetric sparse matrix class.  This uses the format supported by
// the Yale Sparse MAtrix Package.  It is a row-compressed format, in
// which only the upper triangle is stored.  I have basically copied
// the non-symmetric row-compressed matrix class with appropriate
// modifications
// Note: There is a slight difference in the way Yale Sparse Matrix
// Package stores its row_start array.  (I made the entries
// zero-based, fortran won't like that).  So, this will have to be
// changed to use YSMP.
// 8/10/1999, I have changed the rowstart array to be compatible with YSMP.

#ifndef SYM_SPARSE_RCS_MATRIX_S_H
#define SYM_SPARSE_RCS_MATRIX_S_H

class SymSparseRCSMatrix_s : public Matrix_s
{
  SymSparseRCSMatrix_s(void){};
public:
  SymSparseRCSMatrix_s(int i, int j);
  SymSparseRCSMatrix_s(int i, int j, int _nNonZero);
  SymSparseRCSMatrix_s(const SymSparseRCSMatrix_s& copy);

  SymSparseRCSMatrix_s(const Matrix_s& copy);
  SymSparseRCSMatrix_s(const Matrix_s& copy, Index rows, Index cols);

  SymSparseRCSMatrix_s(const GeneralMatrix_s& A);
  SymSparseRCSMatrix_s(const UpperTriangle_s& U);
  SymSparseRCSMatrix_s(const LowerTriangle_s& L);
  SymSparseRCSMatrix_s(const Permutation&     P);
  
  ~SymSparseRCSMatrix_s(void);

  float  operator()(int i, int j) const;
  float& operator()(int i, int j);

  int numRows(void) const { return nRows; };
  int numCols(void) const { return nCols; };

  float get(int i, int j) const;
  void   set(int i, int j, float val);
  
  int set(const SymSparseRCSMatrix_s& B);
  
  int set(const GeneralMatrix_s& B);
  int set(const GeneralMatrix_s& B, Index rows, Index cols);
  int set(Index rowsA, Index colsA, const GeneralMatrix_s& B,
	  Index rowsB = Index(), Index colsB = Index());
  
  int set(const Matrix_s&);
  int set(const Matrix_s& B, Index rows, Index cols);
  int set(Index rowsA, Index colsA, const Matrix_s& B,
	  Index rowsB = Index(), Index colsB = Index());
  
  // Methods specific to sparse matrices
  int numNonZero(void)       { return nNonZero; };
  int numAlloc  (void)       { return nAlloc;   };
  
  void trim(void);                      // Decrease allocated space to
                                        // minimum possible
  void remove(int i, int j);            // Remove an entry (results
                                        // in the entry equalling zero
  void removeZeros(void);               // Removes any zeros
					// inadvertantly entered in matrix
  
  int ones(void)         { return -1; };
  int zero(void);
  int diag(float val)   { return -1; };
  int setAll(float val) { return -1; };

  int add(const SymSparseRCSMatrix_s& A);

  //int mult(const GeneralMatrix_s& X, GeneralMatrix_s& B);
  //int mult(const SymSparseRCSMatrix_s& X, GeneralMatrix_s& B);

  int solve( GeneralMatrix_s& X, const GeneralMatrix_s& B) const;
  
  //float normFrobenius(void);
  //float normInf(void);
  //float normOnes(void);

  void dump(ostream& os);
  
  float*   data;
  int* column;
  int* rowstart;
  int nAlloc;
  int nNonZero;

  friend ostream& operator<< (ostream& os, const SymSparseRCSMatrix_s& A);
  
  friend class GeneralMatrix_s;
  friend class SparseRCSMatrix_s;
protected:

  void resize(void);    // Resize the storage space
  
  int nRows;
  int nCols;
};

#endif
