/*********************************************************************
 This file was automatically generated by d2s from
 the file template_submatrix_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott
// 7/15/1999
// Another experimental sub-matrix class.  This version uses templates
// to encapsulate the matrix to be devided.  (The other submatrix
// class wrapped any matrix of type (or parent-type) Matrix).

#ifndef TEMPLATE_SUBMATRIX_H
#define TEMPLATE_SUBMATRIX_H

template< class mat >
class TemplateSubMatrix : public Matrix_s
{
  TemplateSubMatrix(void){};  
public:
  TemplateSubMatrix(mat& A, Index& rows, Index& cols);

  ~TemplateSubMatrix(void){};
  
  float get(int i, int j) const;
  void   set(int i, int j, float val);

  int set(const Matrix_s& B);
  
  float  operator()(int i, int j) const;
  float& operator()(int i, int j);

  int numRows(void) const { return row.size(); };
  int numCols(void) const { return col.size(); };

  int zero(void)         { return setAll( 0.0 ); };
  int ones(void)         { return setAll( 1.0 ); };
  int setAll(float val);

  int add(const Matrix_s& B);
private:
  mat& matrix;    // The encapsulated matrix
  Index& row;
  Index& col;
};

//****************************************************************************
template<class mat>
inline float TemplateSubMatrix<mat>::get(int i, int j) const
{
  return matrix.get( row.get(i), col.get(j) );
}

template<class mat>
inline void TemplateSubMatrix<mat>::set(int i, int j,
					float val)
{
  matrix.set( row.get(i), col.get(j), val );
}

template<class mat>
inline float TemplateSubMatrix<mat>::operator()(int i, int j) const
{
  return matrix.get( row.get(i), col.get(j) );
}

template<class mat>
inline float& TemplateSubMatrix<mat>::operator()(int i, int j)
{
  return matrix.set( row.get(i), col.get(j) );
}  

#endif
