/*********************************************************************
 This file was automatically generated by d2s from
 the file upper_d.H.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott   6/3/1999
// First draft of an upper-triangular matrix class
// Data is stored column-wise
// Matrix must be square
// Matrix indexing is ones-based

#ifndef UPPER_S_H
#define UPPER_S_H

//#include "matrix.H"
//#include "m_error.H"

class UpperTriangle_s : public Matrix_s
{
  UpperTriangle_s(void);
public:
  UpperTriangle_s(int size);
  UpperTriangle_s(int i, int j);
  UpperTriangle_s(const UpperTriangle_s& copy);

  ~UpperTriangle_s(void);

  int zero(void)          { return setAll(0.0); };
  int ones(void)          { return setAll(1.0); };
  int setAll(float val);
  int diag(float val);
  int random(void);

  float  operator()(int i, int j) const;
  float& operator()(int i, int j);
  
  float get(int i, int j) const;  
  void   set(int i, int j, float val);
  
  int numRows(void) const { return size; };
  int numCols(void) const { return size; };

  int add(const UpperTriangle_s& B);
  int add(const UpperTriangle_s& A, const UpperTriangle_s& B);

  int solve(GeneralMatrix_s& X, const GeneralMatrix_s& B);
  int transposeSolve(GeneralMatrix_s& X, const GeneralMatrix_s& B);
  
  int extractUpper(const Matrix_s& A);

  void LINPACKSmallestSingularVectorEst( GeneralMatrix_s & x );

  friend ostream& operator<< (ostream& os, const UpperTriangle_s& A);
  
  friend class GeneralMatrix_s;
  friend class GenSymMatrix_s;
protected:
  float* data;
  int size;
  int nAlloc;
  float dummy;
};



inline float UpperTriangle_s::operator()(int i, int j) const
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  if( i > j )
    return 0.0;
  else
    return data[ i + (j * (j-1)) / 2 - 1 ];
};


inline float& UpperTriangle_s::operator()(int i, int j)
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  REQUIRE( i <= j, "Data in the lower triangle is not stored." );
  return data[ i + (j * (j-1)) / 2 - 1];
};


inline float UpperTriangle_s::get(int i, int j) const
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  if( i > j )
    return 0.0;
  else
    return data[ i + (j * (j-1)) / 2 - 1 ];
};


inline void UpperTriangle_s::set(int i, int j, float val)
{
  REQUIRE( i <= size, "Row index beyond matrix bounds." );
  REQUIRE( j <= size, "Column index beyond matrix bounds." );
  REQUIRE( i <= j, "Data in the lower triangle is not stored." );
  data[ i + (j * (j-1)) / 2 - 1] = val;
};

#endif
