/*********************************************************************
 This file was automatically generated by d2s from
 the file gen_sym_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott
// 7/15/1999

#include "mat_inc_s.H"
#include <fstream.h>

//****************************************************************************
GenSymMatrix_s::GenSymMatrix_s(void)
{
  ERROR( "This has not been implemented." );
}

//****************************************************************************
GenSymMatrix_s::GenSymMatrix_s(int _size)
{
  size = _size;
  nAlloc = (size * (size + 1)) / 2;
  data = new float[ nAlloc ];
}

//****************************************************************************
GenSymMatrix_s::GenSymMatrix_s(int i, int j)
{
  REQUIRE( i == j, "Matrix must be square." );
  size = i;
  nAlloc = (size * (size + 1)) / 2;
  data = new float[ nAlloc ];
}

//****************************************************************************
GenSymMatrix_s::GenSymMatrix_s(const GenSymMatrix_s& copy)
{
  size = copy.numRows();
  nAlloc = copy.nAlloc;
  data = new float[ nAlloc ];
  memcpy( data, copy.data, nAlloc * sizeof( float ) );
}

//****************************************************************************
GenSymMatrix_s::GenSymMatrix_s(char * fname)
{
  ifstream in( fname );
  if( !in )
  {
     cerr << "Error in GenSymMatrix_s constructor: cannot open file "
          << fname << endl;
     exit(1);
  }
  in >> size;
  nAlloc = size*(size+1)/2;
  data = new float[nAlloc];
  int i;
  for( i=0;i<nAlloc;i++ ) in >> data[i];
}

//****************************************************************************
GenSymMatrix_s::~GenSymMatrix_s(void)
{
  delete[] data;
}

float GenSymMatrix_s::normFrobenius(void) const
{
  float norm = 0.0;
  int i,j;
  for( i=1; i<= size;i++ )
  {
    for( j=1;j<i;j++ )
      norm += 2*(*this)(i,j);
    norm += (*this)(i,i);
  }
  return sqrt( norm );
}

//********************************************************************
float GenSymMatrix_s::normOnes(void) const
{
  float norm = 0.0;
  int i,j;
  for( j=1; j<=size; ++j)
    {
      float subnorm = 0.0;
      for( i=1; i<=size; ++i )
	{
	  subnorm += fabs( (*this)(i,j) );
	}
      if( subnorm > norm )
	norm = subnorm;
    }
  return norm;
}

//********************************************************************
float GenSymMatrix_s::normInf(void) const
{
  return normOnes();
}

//****************************************************************************
int GenSymMatrix_s::setAll(float val)
{
  for(int i=0; i < nAlloc; ++i)
    {
      data[i] = val;
    }
  return 0;
}

//****************************************************************************
int GenSymMatrix_s::random()
{
  int DIST = 2;  // uniform distribution in (-1,1)
#ifdef SINGLE_PRECISION
  F77NAME(slarnv)(&DIST, matrix_rnd_seed, &nAlloc, data);
#else
  F77NAME(dlarnv)(&DIST, matrix_rnd_seed, &nAlloc, data);
#endif

  return 0;
}


//****************************************************************************
int GenSymMatrix_s::eig( float * val ) const
{
   char jobz = 'N';
   char uplo = 'U';
   GenSymMatrix_s * t = (GenSymMatrix_s*)this;
   int n = t->size;
   float * ap = new float[n*(n+1)/2];
   int i;
   for( i=0;i<n*(n+1)/2;i++ ) ap[i] = data[i];
   float * work = new float[3*n];
   int info;

#ifdef SINGLE_PRECISION
   F77NAME(sspev)( &jobz,&uplo,&n,ap,val,(float*)NULL,&n,work,&info );
#else
   F77NAME(dspev)( &jobz,&uplo,&n,ap,val,(float*)NULL,&n,work,&info );
#endif
   if( info < 0 )
   {
      cerr << "Error in LAPACK routine dspev: info = " << info << endl
           << "(" << info << "-th argument had an illegal value)" << endl;
      exit(1);
   }
   else if( info > 0 )
   {
      cerr << "Error in LAPACK routine dspev: info = " << info << endl
           << "(algorithm failed to converge)" << endl;
      exit(1);
   }
   delete[] work;
   delete[] ap;
   return info;
}

//****************************************************************************
int GenSymMatrix_s::eig( float * val,GeneralMatrix_s & V ) const
{
   char jobz = 'V';
   char uplo = 'U';
   GenSymMatrix_s * t = (GenSymMatrix_s*)this;
   int n = t->size;
   float * ap = new float[n*(n+1)/2];
   int i;
   for( i=0;i<n*(n+1)/2;i++ ) ap[i] = data[i];
   float * work = new float[3*n];
   int info;

#ifdef SINGLE_PRECISION
   F77NAME(sspev)( &jobz,&uplo,&n,ap,val,V.data,&n,work,&info );
#else
   F77NAME(dspev)( &jobz,&uplo,&n,ap,val,V.data,&n,work,&info );
#endif
   if( info < 0 )
   {
      cerr << "Error in LAPACK routine dspev: info = " << info << endl
           << "(" << info << "-th argument had an illegal value)" << endl;
      exit(1);
   }
   else if( info > 0 )
   {
      cerr << "Error in LAPACK routine dspev: info = " << info << endl
           << "(algorithm failed to converge)" << endl;
      exit(1);
   }
   delete[] work;
   delete[] ap;
   return info;
}
   
//****************************************************************************
int GenSymMatrix_s::cholesky(UpperTriangle_s& U)
{
  REQUIRE( U.size == size, "Incorrect size for UpperTriangle_s");
  
  // Copy data from this matrix to U
  for(int i=0; i < nAlloc; ++i)
    U.data[i] = data[i];

  int info;
  int n = size;
  #ifdef SINGLE_PRECISION
  F77NAME(spptrf)( "U", &n, U.data, &info );
  #else
  F77NAME(dpptrf)( "U", &n, U.data, &info );
  #endif
  return info;
}

//****************************************************************************
int GenSymMatrix_s::solvePositiveDefinite(GeneralMatrix_s& X,
                                          const GeneralMatrix_s& B)
{
  REQUIRE( X.numRows() == size,
	   "Row dimension of X does not agree. ");
  REQUIRE( B.numRows() == size,
	   "Row dimension of B does not agree." );
  REQUIRE( B.numCols() == X.numCols(),
	   "Number of columns in X and B do not agree." );
  
  UpperTriangle_s U(size);
  int info;
  int n = size;
  int m = X.numCols();

  // Copy B to X (since B would bo overwritten if sent to LAPACK)
  X.set( B );
  
  info = cholesky(U);
  REQUIRE( info == 0, "Cholesky factorization failed." );

  #ifdef SINGLE_PRECISION
  F77NAME(spptrs)("U", &n, &m, U.data, X.data, &n, &info);
  #else
  F77NAME(dpptrs)("U", &n, &m, U.data, X.data, &n, &info);
  #endif
  
  return info;
}

int GenSymMatrix_s::solve(GeneralMatrix_s& X, const GeneralMatrix_s& B)
{
//  return solvePositiveDefinite( X,B );

  REQUIRE( X.numRows() == size,
	   "Row dimension of X does not agree. ");
  REQUIRE( B.numRows() == size,
	   "Row dimension of B does not agree." );
  REQUIRE( B.numCols() == X.numCols(),
	   "Number of columns in X and B do not agree." );
  
  UpperTriangle_s U(size);
  int info;
  int n = size;
  int m = X.numCols();

  // Copy B to X (since B would be overwritten if sent to LAPACK)
  X.set( B );
  
  int * ipiv = new int[n];
  float * adat = new float[nAlloc];
  for(int i=0; i < nAlloc; ++i)
    adat[i] = data[i];

  #ifdef SINGLE_PRECISION
  F77NAME(ssptrf)( "U", &n, adat, ipiv, &info );
  #else
  F77NAME(dsptrf)( "U", &n, adat, ipiv, &info );
  #endif
  REQUIRE( info == 0, "Factorization failed." );

  #ifdef SINGLE_PRECISION
  F77NAME(ssptrs)("U", &n, &m, adat, ipiv, X.data, &n, &info);
  #else
  F77NAME(dsptrs)("U", &n, &m, adat, ipiv, X.data, &n, &info);
  #endif

  delete[] adat;
  delete[] ipiv;

  return info;
}

//****************************************************************************
ostream& operator<< (ostream& os, const GenSymMatrix_s& A)
{
  int i, j;
  
  for(i=1; i <= A.size; ++i)     // iterate over rows
    {
      for(j=1; j <= A.size; ++j)
	{
	  os << A(i, j) << '\t';
	}
      os << endl;
    }

  return os;
}





