/*********************************************************************
 This file was automatically generated by d2s from
 the file general_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott
// 5/10/1999, 7/16/99

#include "mat_inc_s.H"
#include <fstream.h>

//*******************************************************************
GeneralMatrix_s::GeneralMatrix_s(int rows, int cols)
{
  REQUIRE(rows > 0 && cols > 0, "Non-positive dimensions");

  nRows = rows;
  nCols = cols;  
  data = new float[ rows * cols ];
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const GeneralMatrix_s& copy)
{
  nRows = copy.nRows;
  nCols = copy.nCols;

  data = new float[ nRows*nCols ];

  memcpy(data, copy.data, nRows*nCols*sizeof(float));
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const GeneralMatrix_s& copy,
				 Index rows, Index cols)
{
  REQUIRE( rows.init( 1, copy.nRows ) == 0, "Error in row index." );
  REQUIRE( cols.init( 1, copy.nCols ) == 0, "Error in column index.");

  nRows = rows.size();
  nCols = cols.size();

  data = new float[ nRows * nCols ];

  set( copy, rows, cols );
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const Matrix_s& copy)
{
  nRows = copy.numRows();
  nCols = copy.numCols();

  data = new float[ nRows*nCols ];

  for(int j=1; j <= nCols; ++j)
    {
      for(int i=1; i <= nRows; ++i)
	{
	  element( i, j ) = copy.get( i, j );
	}
    }
  delete_mem = true;
}

//*******************************************************************
GeneralMatrix_s::GeneralMatrix_s(const Matrix_s& copy,
				 Index rows, Index cols)
{
  // Initialize index objects (check bounds)
  REQUIRE( rows.init(1, copy.numRows()) == 0 &&
	   cols.init(1, copy.numCols()) == 0,
	   "Index initialization failed");
  
  nRows = rows.size();
  nCols = cols.size();

  data = new float[ nRows * nCols ];
  
  int i;
  
  for(i=0; i < nRows*nCols; ++i)
    data[i] = 0;
  
  set(copy, rows, cols);
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const UpperTriangle_s& U)
{
  nRows = U.numRows();
  nCols = U.numCols();

  data = new float[ nRows * nCols ];

  for(int j=1; j <= nCols; ++j)
    {
      for(int i=1; i <= nRows; ++i)
	{
	  element( i, j ) = U.get( i, j );
	}
    }
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const LowerTriangle_s& L)
{
  nRows = L.numRows();
  nCols = L.numCols();

  data = new float[ nRows * nCols ];

  for(int j=1; j <= nCols; ++j)
    {
      for(int i=1; i < nRows; ++i)
	{
	  element( i, j ) = L.get( i, j );
	}
    }
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const Permutation& P)
{
  nRows = P.numRows();
  nCols = P.numCols();

  data = new float[ nRows * nCols ];

  for(int j=1; j <= nCols; ++j)
    {
      for(int i=1; i <= nRows; ++i)
	{
	  element( i, j ) = P.get( i, j );
	}
    }
  delete_mem = true;
}

//********************************************************************
GeneralMatrix_s::GeneralMatrix_s(const SparseRCSMatrix_s& A)
{
  int i, j;
  
  nRows = A.numRows();
  nCols = A.numCols();

  data = new float[ nRows * nCols ];

  for(i=0; i < nRows*nCols; ++i)
    data[i] = 0.0;

  for(i=0; i < nRows; ++i)
    {
      for(j = A.rowstart[i]-1; j < A.rowstart[i+1]-1; ++j)
	{
	  element( i, A.column[j] ) = A.data[j];
	}
    }
  delete_mem = true;
}

//****************************************************************************
GeneralMatrix_s::GeneralMatrix_s(const SymSparseRCSMatrix_s& A)
{
  int i, j;
  
  nRows = A.numRows();
  nCols = A.numCols();

  data = new float[ nRows * nCols ];

  for(i=0; i < nRows*nCols; ++i)
    data[i] = 0.0;

  for(i=0; i < nRows; ++i)
    {
      for(j = A.rowstart[i]-1; j < A.rowstart[i+1]-1; ++j)
	{
	  element( i, A.column[j] ) = A.data[j];
	  element( A.column[j], i ) = A.data[j];
	}
    }
  delete_mem = true;
}

//****************************************************************************
GeneralMatrix_s::GeneralMatrix_s(const GenSymMatrix_s& A)
{
  nRows = A.numRows();
  nCols = A.numCols();

  data = new float[ nRows*nCols ];

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  set( i, j, A.get( i, j ) );
	}
    }
  delete_mem = true;
}

//****************************************************************************
GeneralMatrix_s::GeneralMatrix_s(const BandedMatrix_s& A)
{
  nRows = A.numRows();
  nCols = A.numCols();

  data = new float[ nRows*nCols ];

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  set( i, j, A.get( i, j ) );
	}
    }
  delete_mem = true;
}

//*******************************************************************
GeneralMatrix_s::GeneralMatrix_s(int veclen, float* vec, bool _delete_mem)
{
  nRows = veclen;
  nCols = 1;
  data = vec;
  delete_mem = _delete_mem;
}

//************************************************************************
GeneralMatrix_s::GeneralMatrix_s(int rows, int cols,float* mat,
				 bool _delete_mem)
{
  nRows = rows;
  nCols = cols;
  data = mat;
  delete_mem = _delete_mem;
}

//************************************************************************
GeneralMatrix_s::GeneralMatrix_s( char * fname )
{
  ifstream in( fname );
  if( !in )
  {
     cerr << "Error in GeneralMatrix_s constructor: cannot open file "
          << fname << endl;
     exit(1);
  }
  delete_mem = true;
  in >> nRows >> nCols;
  data = new float[nRows*nCols];
  int i;
  for( i=0;i<nRows*nCols;i++ ) in >> data[i];
}

//********************************************************************
GeneralMatrix_s::~GeneralMatrix_s(void)
{
  if( delete_mem )
    delete[] data;
}

//********************************************************************
GeneralMatrix_s* GeneralMatrix_s::get(void) const
{
  return new GeneralMatrix_s( *this );
}

//********************************************************************
GeneralMatrix_s* GeneralMatrix_s::get(Index rows, Index cols) const
{
  return new GeneralMatrix_s( *this, rows, cols );
}

//*********************************************************************
int GeneralMatrix_s::set(const GeneralMatrix_s& B)
{
  REQUIRE( B.nRows == nRows, "Row dimensions do not agree." );
  REQUIRE( B.nCols == nCols, "Column dimensions do not agree." );

  for(int i=0; i < nRows*nCols; ++i)
    data[i] = B.data[i];
  return 0;
}

//************************************************************************
int GeneralMatrix_s::set(const GeneralMatrix_s& B, Index rows, Index cols)
{
  // Initialize index objects (check bounds)
  REQUIRE( rows.init(1, B.nRows) == 0 && cols.init(1, B.nCols) == 0,
	   "Index initialization failed");

  REQUIRE(nRows == rows.size(), "Ranges do not agree");
  REQUIRE(nCols == cols.size(), "Domains do not agree");

  int i, j, m, n;
  for(i=cols.getFirst(), n=1;
      i > 0; 
      i=cols.getNext(), ++n)
    {
      for(j=rows.getFirst(), m=1; 
	  j > 0; 
	  j=rows.getNext(), ++m)
	{
	  element( m, n ) = B.get( i, j );
	}// for rows
    }// for cols

  return 0;
}

//*********************************************************************
int GeneralMatrix_s::set(Index rowsA, Index colsA, 
			  const GeneralMatrix_s& B,
			  Index rowsB, Index colsB)
{
  // Initialize index objects for this matrix
  REQUIRE(rowsA.init(1, nRows) == 0,
	  "Initialization of row index for matrix A failed");
  REQUIRE(colsA.init(1, nCols) == 0,
	  "Initialization of column index for matrix A failed");

  // Initialize index objects for B matrix
  REQUIRE(rowsB.init(1, B.nRows) == 0,
	  "Initialization of row index for matrix B failed");
  REQUIRE(colsB.init(1, B.nCols) == 0,
	  "Initialization of column index for matrix B failed");
  
  // Check that both sub-matrices are the same size
  REQUIRE(rowsA.size() == rowsB.size(), "Ranges do not agree");
  REQUIRE( colsA.size() == colsB.size(), "Domains do not agree");

  int ai, aj, bi, bj;

  for( aj = colsA.getFirst(), bj = colsB.getFirst();
       aj > 0 && bj > 0;
       aj = colsA.getNext(), bj = colsB.getNext())
    {
      for( ai = rowsA.getFirst(), bi = rowsB.getFirst();
	   ai > 0 && bi > 0;
	   ai = rowsA.getNext(), bi = rowsB.getNext())
	{
	  element( ai, aj ) = B.get( bi, bj );
	}// for rows
    }// for columns

  return 0;
}

//*********************************************************************
int GeneralMatrix_s::set(const Matrix_s& B, Index rows, Index cols)
{
  // Initialize index objects (check bounds)
  REQUIRE( rows.init(1, B.numRows()) == 0 && cols.init(1, B.numCols()) == 0,
	   "Index initialization failed");

  REQUIRE(nRows == rows.size(), "Ranges do not agree");
  REQUIRE(nCols == cols.size(), "Domains do not agree");

  int i, j, n, m;

  for(j=cols.getFirst(), n=1;
      j > 0; 
      j=cols.getNext(), ++n)
    {
      for(i=rows.getFirst(), m=1; 
	  i > 0; 
	  i=rows.getNext(), ++m)
	{
	  element( m, n ) = B.get( i, j );
	}// for rows
    }// for cols

  return 0;
}

//*********************************************************************
int GeneralMatrix_s::set(Index rowsA, Index colsA, 
			  const Matrix_s& B,
			  Index rowsB, Index colsB)
{
  // Initialize index objects for this matrix
  REQUIRE(rowsA.init(1, nRows) == 0,
	  "Initialization of row index for matrix A failed");
  REQUIRE(colsA.init(1, nCols) == 0,
	  "Initialization of column index for matrix A failed");

  // Initialize index objects for B matrix
  REQUIRE(rowsB.init(1, B.numRows()) == 0,
	  "Initialization of row index for matrix B failed");
  REQUIRE(colsB.init(1, B.numCols()) == 0,
	  "Initialization of column index for matrix B failed");
  
  // Check that both sub-matrices are the same size
  REQUIRE( rowsA.size() == rowsB.size(), "Ranges do not agree");
  REQUIRE( colsA.size() == colsB.size(), "Domains do not agree");

  int ai, aj, bi, bj;

  for( aj = colsA.getFirst(), bj = colsB.getFirst();
       aj > 0 && bj > 0;
       aj = colsA.getNext(), bj = colsB.getNext())
    {
      for( ai = rowsA.getFirst(), bi = rowsB.getFirst();
	   ai > 0 && bi > 0;
	   ai = rowsA.getNext(), bi = rowsB.getNext())
	{
	  element( ai, aj ) = B.get( bi, bj );
	}// for rows
    }// for columns

  return 0;
}

//********************************************************************
int GeneralMatrix_s::diag(float val)
{
  int i, j;
  
  for(j=1; j <= nCols; ++j)
    for(i=1; i <= nRows; ++i)
      {
	if( i == j )
	  element( i, j ) = val;
	else
	  element( i, j ) = 0;
      }

  return 0;
}

//********************************************************************
int GeneralMatrix_s::setAll(float val)
{
  int i;
  
  for(i=0; i<nRows*nCols; ++i)
    data[i] = val;
  return 0;
}

//********************************************************************
int GeneralMatrix_s::random(void)
{
  int d = nRows*nCols;  
  int DIST = 2;  // uniform distribution in (-1,1)
#ifdef SINGLE_PRECISION
  F77NAME(slarnv)(&DIST, matrix_rnd_seed, &d, data);
#else
  F77NAME(dlarnv)(&DIST, matrix_rnd_seed, &d, data);
#endif

  return 0;
}

  
//*********************************************************************
// Add the contents of matrix B to this matrix
//*********************************************************************
int GeneralMatrix_s::add(const Matrix_s& B)
{
  REQUIRE( B.numRows() == nRows, "Ranges do not agree");
  REQUIRE( B.numCols() == nCols, "Domains do not agree" );

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += B.get( i, j );
	}
    }
  return 0;
}

//*********************************************************************
int GeneralMatrix_s::add(const GeneralMatrix_s& B)
{
  REQUIRE( B.nRows == nRows, "Row dimensions do not agree" );
  REQUIRE( B.nCols == nCols, "Column dimensions do not agree" );

  int i;
  
  for(i=0; i < nRows*nCols; ++i)
    data[i] += B.data[i];

  return 0;
}

//**********************************************************************
int GeneralMatrix_s::add(const GeneralMatrix_s& A, const GeneralMatrix_s& B)
{
  REQUIRE( A.nRows == B.nRows, "Range of A and B do not agree" );
  REQUIRE( A.nCols == B.nCols, "Domain of A and B do not agree"  );
  REQUIRE( A.nRows == nRows, "Range of A and this matrix do not agree" );
  REQUIRE( A.nCols == nCols, "Domain of A and this matrix do not agree" );

  int i;
  
  for(i=0; i < nRows*nCols; ++i)
    data[i] = A.data[i] + B.data[i];

  return 0;
}

//*********************************************************************
int GeneralMatrix_s::add(const UpperTriangle_s& U)
{
  REQUIRE( nRows == nCols, "This matrix must be square");
  REQUIRE( nRows == U.size, "Dimensions do not agree");

  for(int j=1; j < nCols; ++j)
    {
      for(int i=1; i <= j; ++i)
	{
	  element( i, j ) = U.get( i, j );
	}
    }

  return 0;
}

//**********************************************************************
int GeneralMatrix_s::add(const LowerTriangle_s& L)
{
  REQUIRE( nRows == nCols, "This matrix must be square");
  REQUIRE( nRows == L.size, "Dimensions do not agree");

  for(int j=1; j < nCols; ++j)
    {
      for(int i=1; i <= j; ++i)
	{
	  element( i, j ) = L.get( i, j );
	}
    }

  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const SparseRCSMatrix_s& B)
{
  REQUIRE( nRows == B.nRows, "Row dimension of B does not agree." );
  REQUIRE( nCols == B.nCols, "Column dimension of B does not agree." );

  for( int i = 0; i < B.nRows; ++i )
    {
      for( int j = B.rowstart[i]-1; j < B.rowstart[i+1]-1; ++j )
	{
	  element( i+1, B.column[j] ) += data[j];
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const SymSparseRCSMatrix_s& B)
{
  REQUIRE( nRows == B.nRows, "Row dimension of B does not agree." );
  REQUIRE( nCols == B.nCols, "Column dimension of B does not agree." );

  for( int i = 0; i < B.nRows; ++i )
    {
      for( int j = B.rowstart[i]-1; j < B.rowstart[i+1]-1; ++j )
	{
	  element( i+1, B.column[j] ) += B.data[j];
	  element( B.column[j], i+1 ) += B.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const GenSymMatrix_s& B)
{
  REQUIRE( nRows == B.numRows(),
	   "Row dimension of B does not agree." );
  REQUIRE( nCols == B.numCols(),
	   "Column dimension of B does not agree." );

  // Iterate over columns (since this is stored column-wise)
  for( int j = 1; j <= nCols; ++j )
    {
      // Iterate over rows
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += B.get( i, j );
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const BandedMatrix_s& B)
{
  REQUIRE( nRows == B.numRows(),
	   "Row dimension of B does not agree." );
  REQUIRE( nCols == B.numCols(),
	   "Column dimension of B does not agree." );

  // Note: this is rather sloppy in that it does not take advantage of
  // the storage format of the banded matrix.  It probably should be
  // updated in the future.
  
  // Iterate over columns (since this is stored column-wise)
  for( int j = 1; j <= nCols; ++j )
    {
      // Iterate over rows
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += B.get( i, j );
	}
    }
  return 0;
}
  
//*********************************************************************
int GeneralMatrix_s::addTrans(const Matrix_s& B)
{
  REQUIRE( B.numRows() == nCols, "Ranges do not agree");
  REQUIRE( B.numCols() == nRows, "Domains do not agree" );

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += B.get( j, i );
	}
    }
  return 0;
}

//*********************************************************************
int GeneralMatrix_s::addTrans(const GeneralMatrix_s& B)
{
  REQUIRE( B.nRows == nCols, "Row dimensions do not agree" );
  REQUIRE( B.nCols == nRows, "Column dimensions do not agree" );

  // Iterate over columns of this
  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += B.get( j, i );
	}
    }
  return 0;
}

//*********************************************************************
int GeneralMatrix_s::addTrans(const UpperTriangle_s& U)
{
  REQUIRE( nRows == nCols, "This matrix must be square");
  REQUIRE( nRows == U.size, "Dimensions do not agree");

  for(int j=1; j < nCols; ++j)
    {
      for(int i=j; i <= nRows; ++i)
	{
	  element( i, j ) += U.get( j, i );
	}
    }

  return 0;
}

//**********************************************************************
int GeneralMatrix_s::addTrans(const LowerTriangle_s& L)
{
  REQUIRE( nRows == nCols, "This matrix must be square");
  REQUIRE( nRows == L.size, "Dimensions do not agree");

  for(int j=1; j < nCols; ++j)
    {
      for(int i=1; i <= j; ++i)
	{
	  element( i, j ) += L.get( j, i );
	}
    }

  return 0;
}

//****************************************************************************
int GeneralMatrix_s::addTrans(const SparseRCSMatrix_s& B)
{
  REQUIRE( nRows == B.nCols, "Column dimension of B does not agree." );
  REQUIRE( nCols == B.nRows, "Row dimension of B does not agree." );

  for( int i = 0; i < B.nRows; ++i )
    {
      for( int j = B.rowstart[i]-1; j < B.rowstart[i+1]-1; ++j )
	{
	  element( B.column[j], i+1 ) += data[j];
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::addTrans(const BandedMatrix_s& B)
{
  REQUIRE( nRows == B.numRows(),
	   "Row dimension of B does not agree." );
  REQUIRE( nCols == B.numCols(),
	   "Column dimension of B does not agree." );

  // Note: this is rather sloppy in that it does not take advantage of
  // the storage format of the banded matrix.  It probably should be
  // updated in the future.
  
  // Iterate over columns (since this is stored column-wise)
  for( int j = 1; j <= nCols; ++j )
    {
      // Iterate over rows
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += B.get( j, i );
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const GeneralMatrix_s& A, float a)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of A does not agree." );

  for(int i=0; i < nRows*nCols; ++i)
    data[i] += a * A.data[i];

  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const SparseRCSMatrix_s& A, float a)
{
  REQUIRE( nRows == A.nRows, "Row dimension of B does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of B does not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      for( int j = A.rowstart[i]-1; j < A.rowstart[i+1]-1; ++j )
	{
	  element( i+1, A.column[j] ) += a * A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const SymSparseRCSMatrix_s& A, float a)
{
  REQUIRE( nRows == A.nRows, "Row dimension of B does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of B does not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      for( int j = A.rowstart[i]-1; j < A.rowstart[i+1]-1; ++j )
	{
	  element( i+1, A.column[j] ) += a * A.data[j];
	  element( A.column[j], i+1 ) += a * A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const GenSymMatrix_s& A, float a)
{
  REQUIRE( nRows == A.numRows(),
	   "Row dimension of B does not agree." );
  REQUIRE( nCols == A.numCols(),
	   "Column dimension of B does not agree." );

  // Iterate over columns (since this is stored column-wise)
  for( int j = 1; j <= nCols; ++j )
    {
      // Iterate over rows
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += a * A.get( i, j );
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::add(const BandedMatrix_s& A, float a)
{
  REQUIRE( nRows == A.numRows(),
	   "Row dimension of B does not agree." );
  REQUIRE( nCols == A.numCols(),
	   "Column dimension of B does not agree." );

  // Note: this is rather sloppy in that it does not take advantage of
  // the storage format of the banded matrix.  It porbably should be
  // updated in the future.
  
  // Iterate over columns (since this is stored column-wise)
  for( int j = 1; j <= nCols; ++j )
    {
      // Iterate over rows
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += a * A.get( i, j );
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::addTrans(const GeneralMatrix_s& A, float a)
{
  REQUIRE( nCols == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nRows == A.nCols, "Column dimension of A does not agree." );

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += a * A.get( j, i );
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::addTrans(const SparseRCSMatrix_s& A, float a)
{
  REQUIRE( nCols == A.nRows, "Row dimension of B does not agree." );
  REQUIRE( nRows == A.nCols, "Column dimension of B does not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      for( int j = A.rowstart[i]-1; j < A.rowstart[i+1]-1; ++j )
	{
	  element( A.column[j], i+1 ) += a * A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::addTrans(const BandedMatrix_s& A, float a)
{
  REQUIRE( nCols == A.numRows(),
	   "Row dimension of B does not agree." );
  REQUIRE( nRows == A.numCols(),
	   "Column dimension of B does not agree." );

  // Note: this is rather sloppy in that it does not take advantage of
  // the storage format of the banded matrix.  It porbably should be
  // updated in the future.
  
  // Iterate over columns (since this is stored column-wise)
  for( int j = 1; j <= nCols; ++j )
    {
      // Iterate over rows
      for( int i = 1; i <= nRows; ++i )
	{
	  element( i, j ) += a * A.get( j, i );
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const GeneralMatrix_s& A,
			  const GeneralMatrix_s& B,
			  float a, float b )
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == B.nCols, "Column dimension of B does not agree." );
  REQUIRE( A.nCols == B.nRows,
	   "Inner dimensions of A and B do not agree." );

//  zero();

  for( int row = 1; row <= nRows; ++row )
    {
      for( int col = 1; col <= nCols; ++col )
	{
	  float val = 0;
	  for( int i = 1; i <= A.nCols; ++i )
	    {
	      val += A( row, i ) * B( i, col );
	    }
	  element( row, col ) *= b;
	  element( row, col ) += a * val;
	}
    }
  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::image( const GeneralMatrix_s& X,
			          GeneralMatrix_s& Y) const
{
  REQUIRE( nCols == X.nRows, "Row dimension of X does not agree." );
  REQUIRE( nRows == Y.nRows, "Row dimension of Y does not agree." );
  REQUIRE( X.nCols == Y.nCols,
	   "Number of columns of X and Y not equal." );

  Y.zero();     // Just in case, since I'm using an accumulating method
  
  // Iterate over each column of X,Y
  for(int k=1; k <= X.nCols; ++k)
    {
      // Iterate over columns of the coeff. matrix (this)
      for(int j=1; j <= nCols; ++j)
	{
	  // Iterate over rows of coeff. matrix
	  for(int i=1; i <= nRows; ++i)
	    {
	      Y( i, k ) += get( i, j ) * X.get( j, k );
	    }
	}// for j
    }// for k
  
  return 0;
}

//************************************************************************
int GeneralMatrix_s::mult(const GeneralMatrix_s& A, GeneralMatrix_s& B)
{
  REQUIRE( A.nRows == nRows, "Range of A and this matrix do not agree" );
  REQUIRE( B.nCols == nCols, "Domain of B and this matrix do not agree" );
  REQUIRE( A.nCols == B.nRows, "Domain of A and range of B do not agree" );

  zero();

  for( int row = 1; row <= nRows; ++row )
    {
      for( int col = 1; col <= nCols; ++col )
	{
	  float val = 0;
	  for( int i = 1; i <= A.nCols; ++i )
	    {
	      val += A( row, i ) * B( i, col );
	    }
	  element( row, col ) += val;
	}
    }
  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const GenSymMatrix_s& A,
			  const GeneralMatrix_s& X)
{
  REQUIRE( A.numRows() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numCols() == X.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( X.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  int row, col, i;
  
  for(row = 1; row <= nRows; ++row)
    {
      for(col = 1; col <= nCols; ++col)
	{
	  float val = 0;
	  for(i = 1; i <= A.numCols(); ++i)
	    {
	      val += A(row, i) * X(i, col);
	    }
//	  element( row, col ) += val;
	  element( row, col ) = val;
	}
    }
  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const UpperTriangle_s& A,
			  const GeneralMatrix_s& X)
{
  REQUIRE( A.numRows() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numCols() == X.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( X.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  int row, col, i;
  
  for(row = 1; row <= nRows; ++row)
    {
      for(col = 1; col <= nCols; ++col)
	{
	  float val = 0;
	  for(i = row; i <= A.numCols(); ++i)
	    {
	      val += A(row, i) * X(i, col);
	    }
	  element( row, col ) = val;
	}
    }
  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const LowerTriangle_s& A,
			  const GeneralMatrix_s& X)
{
  REQUIRE( A.numRows() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numCols() == X.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( X.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  int row, col, i;
  
  for(row = 1; row <= nRows; ++row)
    {
      for(col = 1; col <= nCols; ++col)
	{
	  float val = 0;
	  for(i = 1; i <= row; ++i)
	    {
	      val += A(row, i) * X(i, col);
	    }
	  element( row, col ) = val;
	}
    }
  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const SymSparseRCSMatrix_s& A,
			  const GeneralMatrix_s& X)
{
  REQUIRE( A.numRows() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numCols() == X.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( X.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  int i, j, k;

  zero();
  
  // I'm going to try to do this in the most efficient manner I can
  // find.  We'll see how it works.  The ideas is: since the data in
  // the symmetric sparse matrix is stored as only the upper triangle
  // in a row-compressed format, it would be faster to multiply the
  // upper and lower triangles seperately, keeping in mind the fastest
  // way to access each.

  // Multiply upper triangle
  for(j=1; j <= nCols; ++j)          // Iterate over columns of this
    {
      for(i=1; i <= nRows; ++i)      // Iterate over rows of this
	{
	  float val = 0;
	  for(k = A.rowstart[i-1]-1; k < A.rowstart[i]-1; ++k)
	    {
	      val += A.data[k] * X( A.column[k], j );
	    }
	  //set( i, j, val );
	  element( i, j ) += val;
	}
    }

  // Multiply lower triangle
  for(j=1; j <= nCols; ++j)           // Iterate over columns
    {
      for(i=1; i <= A.numCols(); ++i)
	{
	  // Find the first "column" entry in the sparse matrix
	  // greater than i
	  /*for(k = A.rowstart[i-1]; k < A.rowstart[i]; ++k)
	    {
	      if( A.column[k] > i )
		break;
	    }*/

	  // Alternate, possibly faster, version.  We just want to
	  // skip the diagonal element (if there is one), because it
	  // was taken care of by multiplying the upper triangle.
	  if( A.column[ A.rowstart[i-1]-1 ] == i )
	    k = A.rowstart[i-1];
	  else
	    k = A.rowstart[i-1]-1;
	  
	  for(; k < A.rowstart[i]-1; ++k)
	    {
	      float val = get( A.column[k], j );
	      val += A.data[k] * X( i, j );
              set( A.column[k], j, val );
//	      element( A.column[k], j ) += val;
	    }
	}
    }
  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const SparseRCSMatrix_s& A,
			  const GeneralMatrix_s& B)
{
  REQUIRE( A.numRows() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numCols() == B.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( B.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  zero();
  for(int j=1; j <= nCols; ++j)          // Iterate over columns of this
    {
      for(int i=1; i <= nRows; ++i)      // Iterate over rows of this
	{
	  float val = 0;
	  for(int k = A.rowstart[i-1]-1; k < A.rowstart[i]-1; ++k)
	    {
	      val += A.data[k] * B.get( A.column[k], j );
	    }
	  element( i, j ) = val;
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::mult(const BandedMatrix_s& A, const GeneralMatrix_s& B)
{
  REQUIRE( A.numRows() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numCols() == B.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( B.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  zero();

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++ i )
	{
	  float val = 0.0;
	  int left  = macroMax( 1, i - A.numSubDiag() );
	  int right = macroMin( A.numCols(), i + A.numSuperDiag() );

	  for( int k = left; k <= right; ++k )
	    {
	      val += A.get( i, k ) * B.get( k, j );
	    }
	  element( i, j ) += val;
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::multTrans(const GeneralMatrix_s& A,
			       const GeneralMatrix_s& B)
{
  REQUIRE( A.nCols == nRows, "Column dimension of A does not agree." );
  REQUIRE( A.nRows == B.nRows,
	   "Inner dimensions of A and B do not agree." );
  REQUIRE( B.nCols == nCols, "Column dimension of B does not agree." );

  zero();

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  float val = 0.0;
	  for( int k = 1; k <= B.nRows; ++k )
	    {
	      val += A( k, i ) * B( k, j );
	    }
	  element( i, j ) += val;
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::multTrans(const UpperTriangle_s& A,
			       const GeneralMatrix_s& B)
{
  REQUIRE( A.size == nRows, "Column dimension of A does not agree." );
  REQUIRE( A.size == B.nRows,
	   "Inner dimensions of A and B do not agree." );
  REQUIRE( B.nCols == nCols, "Column dimension of B does not agree." );

  zero();

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  float val = 0.0;
	  for( int k = 1; k <= i; ++k )
	    {
	      val += A( k, i ) * B( k, j );
	    }
	  element( i, j ) += val;
	}
    }
  return 0;
}

int GeneralMatrix_s::multTrans(const LowerTriangle_s& A,
			       const GeneralMatrix_s& B)
{
  REQUIRE( A.size == nRows, "Column dimension of A does not agree." );
  REQUIRE( A.size == B.nRows,
	   "Inner dimensions of A and B do not agree." );
  REQUIRE( B.nCols == nCols, "Column dimension of B does not agree." );

  zero();

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  float val = 0.0;
	  for( int k = i; k <= B.nRows; ++k )
	    {
	      val += A( k, i ) * B( k, j );
	    }
	  element( i, j ) += val;
	}
    }
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::multTrans(const SparseRCSMatrix_s& A,
			       const GeneralMatrix_s& B)
{
  REQUIRE( A.nCols == nRows, "Column dimension of A does not agree." );
  REQUIRE( A.nRows == B.nRows,
	   "Inner dimensions of A and B do not agree." );
  REQUIRE( B.nCols == nCols, "Column dimension of B does not agree." );

  zero();
  for( int j = 1; j <= nCols; ++j )
    {
      for( int k = 1; k <= B.nRows; ++k )
	{
	  int lower = A.rowstart[ k-1 ] - 1;
	  int upper = A.rowstart[  k  ] - 1;

	  for( int i = lower; i < upper; ++i )
	    {
	      element( A.column[ i ], j ) +=
		A.data[i] * B.get( k, j );
	    }
	}
    }

  
  return 0;
}

//****************************************************************************
int GeneralMatrix_s::multTrans(const BandedMatrix_s& A,
			       const GeneralMatrix_s& B)
{
  REQUIRE( A.numCols() == numRows(),
	   "Row dimension of A does not agree." );
  REQUIRE( A.numRows() == B.numRows(),
	   "Inner dimensions of A and X do not agree." );
  REQUIRE( B.numCols() == numCols(),
	   "Column dimension of X does not agree." );

  zero();

  for( int j = 1; j <= nCols; ++j )
    {
      for( int i = 1; i <= nRows; ++ i )
	{
	  float val = 0.0;
	  int lower  = macroMax( 1, i - A.numSuperDiag() );
	  int upper  = macroMin( A.numRows(), i + A.numSubDiag() );

	  for( int k = lower; k <= upper; ++k )
	    {
	      val += A.get( k, i ) * B.get( k, j );
	    }
	  element( i, j ) += val;
	}
    }
  return 0;
}

//*********************************************************************
int GeneralMatrix_s::solve(      GeneralMatrix_s& X,
			   const GeneralMatrix_s& B) const
{
  REQUIRE( nRows == nCols, "Coefficient matrix is not square");
  REQUIRE( X.nRows == nRows, "Range of X does not agree");
  REQUIRE( B.nRows == nRows, "Range of B does not agree");
  REQUIRE( X.nCols == B.nCols, "Dimensions of X and B do not agree");

  int i;
  
  int info;
  int n = nRows;
  
  float* factors = new float[ nRows*nCols ];
  int*    pivots  = new int[ nRows ];

  for(i=0; i < nRows*nCols; ++i)
    factors[i] = data[i];
  
  // Factor the coefficient matrix
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrf)( &n, &n, factors, &n, pivots, &info );
  #else
  F77NAME(dgetrf)( &n, &n, factors, &n, pivots, &info );
  #endif

  REQUIRE( info == 0, "Factorization of system failed");

  // Copy B to X (may encapsulate this in a function later)
  if( &X != &B )
    {
      for(i=0; i < B.nRows*B.nCols; ++i)
	X.data[i] = B.data[i];
    }
  
  // Solve the system
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrs)("N", &n, (int*)&X.nCols, factors,
		  &n, pivots, X.data, &n, &info);
  #else
  F77NAME(dgetrs)("N", &n, (int*)&X.nCols, factors,
		  &n, pivots, X.data, &n, &info);
  #endif

  REQUIRE( info == 0, "Solution of system failed");
  
  delete[] factors;
  delete[] pivots;

  return info;
}

//*********************************************************************
int GeneralMatrix_s::transposeSolve( GeneralMatrix_s& X,
			   const GeneralMatrix_s& B) const
{
  REQUIRE( nRows == nCols, "Coefficient matrix is not square");
  REQUIRE( X.nRows == nRows, "Range of X does not agree");
  REQUIRE( B.nRows == nRows, "Range of B does not agree");
  REQUIRE( X.nCols == B.nCols, "Dimensions of X and B do not agree");

  int i;
  
  int info;
  int n = nRows;
  
  float* factors = new float[ nRows*nCols ];
  int*    pivots  = new int[ nRows ];

  for(i=0; i < nRows*nCols; ++i)
    factors[i] = data[i];
  
  // Factor the coefficient matrix
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrf)( &n, &n, factors, &n, pivots, &info );
  #else
  F77NAME(dgetrf)( &n, &n, factors, &n, pivots, &info );
  #endif

  REQUIRE( info == 0, "Factorization of system failed");

  // Copy B to X (may encapsulate this in a function later)
  if( &X != &B )
    {
      for(i=0; i < B.nRows*B.nCols; ++i)
	X.data[i] = B.data[i];
    }
  
  // Solve the system
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrs)("T", &n, (int*)&X.nCols, factors,
		  &n, pivots, X.data, &n, &info);
  #else
  F77NAME(dgetrs)("T", &n, (int*)&X.nCols, factors,
		  &n, pivots, X.data, &n, &info);
  #endif

  REQUIRE( info == 0, "Solution of system failed");
  
  delete[] factors;
  delete[] pivots;

  return info;
}

//*********************************************************************
int GeneralMatrix_s::LU(UpperTriangle_s& U,
			LowerTriangle_s& L,
			Permutation& P) const
{
  REQUIRE( nRows == nCols, "Coefficient matrix is not square" );

  int info;
  int n = nRows;
  
  // Create a temporary dense-matrix to pass to the F77 function.
  GeneralMatrix_s Factored( *this );

  // Call the F77 LAPACK factor function dgetrf
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrf)( &n, &n, Factored.data, &n, (int*)P.data, &info);
  #else
  F77NAME(dgetrf)( &n, &n, Factored.data, &n, (int*)P.data, &info);
  #endif

  // Extract the lower and upper portions from the factor matrix
  U.extractUpper( Factored );
  L.extractLower( Factored );
  L.setDiag(1.0); 
  
  return info;
}

//*********************************************************************
float GeneralMatrix_s::condInf(void) const
{
  REQUIRE( nRows == nCols, "Coefficient matrix is not square" );

  int info = 0;
  int n = nRows;
  float norm = normInf();
  float rcond = 0;
  
  // Create a temporary dense-matrix to pass to the F77 function.
  GeneralMatrix_s Factored( *this );
  Permutation P( nRows );

  // Call the F77 LAPACK factor function dgetrf
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrf)( &n, &n, Factored.data, &n, (int*)P.data, &info);
  #else
  F77NAME(dgetrf)( &n, &n, Factored.data, &n, (int*)P.data, &info);
  #endif
  
  REQUIRE( info == 0, "LU factorization failed.");
  
  // Create some working space for the condition number function
  int*    iwork = new int   [ n ];
  float* dwork = new float[ 4 * n ];
  
  // Call the F77 LAPACK condition number function
  #ifdef SINGLE_PRECISION
  F77NAME(sgecon)("I", &n, Factored.data, &n, &norm,
		  &rcond, dwork, iwork, &info);
  #else
  F77NAME(dgecon)("I", &n, Factored.data, &n, &norm,
		  &rcond, dwork, iwork, &info);
  #endif

  REQUIRE( info == 0, "Estimation of condition number failed." );

  delete[] iwork;
  delete[] dwork;
  
  return 1/rcond;
}

//*********************************************************************
float GeneralMatrix_s::condOnes(void) const
{
  REQUIRE( nRows == nCols, "Coefficient matrix is not square" );

  int info = 0;
  int n = nRows;
  float norm = normOnes();
  float rcond = 0;
  
  // Create a temporary dense-matrix to pass to the F77 function.
  GeneralMatrix_s Factored( *this );
  Permutation P( nRows );

  // Call the F77 LAPACK factor function dgetrf
  #ifdef SINGLE_PRECISION
  F77NAME(sgetrf)( &n, &n, Factored.data, &n, (int*)P.data, &info);
  #else
  F77NAME(dgetrf)( &n, &n, Factored.data, &n, (int*)P.data, &info);
  #endif
  
  REQUIRE( info == 0, "LU factorization failed.");
  
  // Create some working space for the condition number function
  int*    iwork = new int   [ n ];
  float* dwork = new float[ 4 * n ];
  
  // Call the F77 LAPACK condition number function
  #ifdef SINGLE_PRECISION
  F77NAME(sgecon)("1", &n, Factored.data, &n, &norm,
		  &rcond, dwork, iwork, &info);
  #else
  F77NAME(dgecon)("1", &n, Factored.data, &n, &norm,
		    &rcond, dwork, iwork, &info);
  #endif

  REQUIRE( info == 0, "Estimation of condition number failed." );

  delete[] iwork;
  delete[] dwork;
  
  return 1/rcond;
}

//*********************************************************************
int GeneralMatrix_s::QR(GeneralMatrix_s& Q, GeneralMatrix_s& R) const
{
  REQUIRE( nRows == Q.nRows, "Dimensions of Q do not agree." );
  REQUIRE( nCols == Q.nCols, "Dimensions of Q do not agree." );
  REQUIRE( nRows == R.nRows, "Dimensions of R do not agree." );
  REQUIRE( nCols == R.nCols, "Dimensions of R do not agree." );

  int info = 0;
  int m = nRows;
  int n = nCols;
  int k = macroMin(m,n);
  int i, j;
  
  // Create some working space
  float* work = new float[ n ];
  float* tau  = new float[ k ];

  // Copy A to Q
  for(i=0; i < n*m; ++i)
    Q.data[i] = data[i];

  // Call the f77 function to get R and a strange form of Q
  #ifdef SINGLE_PRECISION
  F77NAME(sgeqr2)(&m, &n, Q.data, &m, tau, work, &info);
  #else
  F77NAME(dgeqr2)(&m, &n, Q.data, &m, tau, work, &info);
  #endif

  REQUIRE( info == 0, "QR decomposition failed." );
  // Extract R
  for(j=0; j < n; ++j)
    {
      for(i=0; i <= j; ++i)
	{
	  R.data[ i + nRows * j ] = Q.data[ i + nRows * j ];
	}
    }

  // Call another f77 function to get the actual Q
  #ifdef SINGLE_PRECISION
  F77NAME(sorgqr)(&m, &n, &k, Q.data, &m, tau, work, &n, &info);
  #else
  F77NAME(dorgqr)(&m, &n, &k, Q.data, &m, tau, work, &n, &info);
  #endif

  REQUIRE( info == 0, "Extraction of Q failed." );

  delete[] work;
  delete[] tau;

  return info;
}

//****************************************************************************
int GeneralMatrix_s::svd(GeneralMatrix_s& U,
			 GeneralMatrix_s& S,
			 GeneralMatrix_s& V) const
{
  /*int info;
  int m     = numRows();
  int n     = numCols();
  int lwork = m + n;

  float* d = new float[ macroMin( m, n ) ];
  float* e = new float[ macroMin( m, n ) - 1 ];
  float* tauq = new float[ macroMin( m, n ) ];
  float* taup = new float[ macroMin( m, n ) ];
  float* work = new float[ lwork ];

  
  // Reduce matrix to bi-diagonal form
  F77NAME(dgebrd)(&m, &n, S.data, &m, d, e, tauq,
		  taup, work, &lwork, &info);
  REQUIRE( info == 0, "Reduction to bidiagonal form failed." );

  // Generate the orthogonal matrices from their reflectors
  // Generate Q
  F77NAME(dorgbr)("Q", &m, &m, &n, S.data, &m,
		  tauq, work, &lwork, &info);
  REQUIRE( info == 0, "Generation of Q failed." );

  // Generate P

  // Obviously not finished
  
  return info;*/
  return -1;
}

//*********************************************************************
float GeneralMatrix_s::normFrobenius(void) const
{
  float norm = 0.0;
  for(int i=0; i < nRows*nCols; ++i)
    norm += data[i] * data[i];
  return sqrt( norm );
}

//********************************************************************
float GeneralMatrix_s::normOnes(void) const
{
  float norm = 0.0;
  for(int j=0; j < nCols; ++j)
    {
      float subnorm = 0.0;
      for(int i=0; i < nRows; ++i)
	{
	  subnorm += fabs( data[ i + nRows * j ] );
	}
      if( subnorm > norm )
	norm = subnorm;
    }
  return norm;
}

//********************************************************************
float GeneralMatrix_s::normInf(void) const
{
  float norm = 0.0;
  for(int i=0; i < nRows; ++i)
    {
      float subnorm = 0.0;
      for(int j=0; j < nCols; ++j)
	{
	  subnorm += fabs( data[ i + nRows * j ] );
	}
      if( subnorm > norm )
	norm = subnorm;
    }
  return norm;
}

//*********************************************************************
int GeneralMatrix_s::transpose(GeneralMatrix_s& Atrans) const
{
  REQUIRE( this != &Atrans, "Atrans may not be this matrix.");
  REQUIRE( nRows == Atrans.nCols, "Dimensions do not agree.");
  REQUIRE( nCols == Atrans.nRows, "Dimensions do not agree.");

  int i, j;
  
  for(j=1; j <= nCols; ++j)
    {
      for(i=1; i <= nRows; ++i)
	{
	  Atrans(j,i) = get(i,j);
	}
    }
  return 0;
}

//*********************************************************************
int GeneralMatrix_s::add(float val)
{
  for(int i=0; i < nRows*nCols; ++i)
    data[i] += val;
  return 0;
}

//*********************************************************************
int GeneralMatrix_s::mult(float val)
{
  for(int i=0; i < nRows*nCols; ++i)
    data[i] *= val;
  return 0;
}

//*********************************************************************
ostream& operator<< (ostream& os, const GeneralMatrix_s& A)
{
  int i;
  for(i=0; i < A.nRows; ++i)
    {
      for(int j=0; j < A.nCols; ++j)
	os << A.data[j*A.nRows + i] << '\t';
      os << endl;
    }

  /*for(i=0; i < nRows*nCols; ++i)
    os << data[i] << "  ";
  os << endl;*/
  
  return os;
}

