/*********************************************************************
 This file was automatically generated by d2s from
 the file permute_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott   6/7/1999
// First-draft of a permutation matrix class
// permute.cxx

#include "mat_inc_s.H"

//********************************************************
Permutation::Permutation(void)
{
  ERROR("This has not been implemented");
}

//*********************************************************
Permutation::Permutation(int _size)
{
  size = _size;
  data = new int[ size ];
}

//***********************************************************
Permutation::Permutation(int i, int j)
{
  REQUIRE( i == j, "Permutation matrix must be square.");
  size = i;
  data = new int[ size ];
}

//*********************************************************
Permutation::Permutation(const Permutation& copy)
{
  size = copy.size;
  data = new int[ size ];
  memcpy(data, copy.data, size * sizeof(int));
}

//***********************************************************
Permutation::~Permutation(void)
{
  delete[] data;
}

//**************************************************************
int Permutation::solve(GeneralMatrix_s& X, const GeneralMatrix_s& B)
{
  REQUIRE( size == X.nRows,    "Range of X does not agree." );
  REQUIRE( size == B.nRows,    "Range of B does not agree." );
  REQUIRE( X.nCols == B.nCols, "Dimensions of X and B do not agree." );
  REQUIRE( &X != &B,           "X and B must be seperate objects.");
  
  for(int i=0; i < size; ++i)
    {
      for(int j=0; j < X.nCols; ++j)
	{
	  X.data[ i+j*X.nRows ] = B.data[ data[i]-1 + j*B.nRows ];
	}
    }

  return 0;
}

//**************************************************************
ostream& operator<< (ostream& os, const Permutation& P)
{
  int i, j;

  for(i=0; i < P.size; ++i)
    {
      for(j=1; j <= P.size; ++j)
	{
	  if( P.data[i] == j )
	    os << "1\t";
	  else
	    os << "0\t";
	}
      os << endl;
    }

  return os;
}

