/*********************************************************************
 This file was automatically generated by d2s from
 the file sparse_rcs_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott
// 6/18/1999, 7/16/99
// Row-compressed sparse matrix class.
// sparse_rcs_s.H
// 8/2/1999, converted to fortran style ones-based indexing.  Note:
// externally, the matrix has always been ones-based.  Now, for
// compatibility with fortran routines, the rowstart array (and only
// the rowstart array) will be converted to ones-based indexing.  This
// is a little complicated, but will work as the zero-based c arrays
// will be read as ones-based fortran arrays, and only the indexing
// into these arrays (by rowstart) will cause problems.

#include "mat_inc_s.H"

//************************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(void)
{
  ERROR( "This has not been implemented, yet.");
}

//*************************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(int i, int j)
{
  nRows = i;
  nCols = j;

  nAlloc = nCols;    // Just a guess to start with.
  nNonZero = 0;

  data   = new float  [ nAlloc ];
  column = new int[ nAlloc ];

  rowstart = new int[ nRows + 1 ];

  for(int k=0; k < nRows+1; ++k)
    rowstart[k] = 1;
}

//************************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(int i, int j, int _nNonZero)
{
  nRows = i;
  nCols = j;

  nAlloc = _nNonZero;
  nNonZero = 0;

  data   = new float  [ nAlloc ];
  column = new int[ nAlloc ];

  rowstart = new int[ nRows+1 ];

  for(int k=0; k < nRows+1; ++k)
    rowstart[k] = 1;
}

//*************************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(const SparseRCSMatrix_s& copy)
{
  nRows = copy.nRows;
  nCols = copy.nCols;
  nNonZero = copy.nNonZero;
  nAlloc = copy.nAlloc;

  data = new float[ nAlloc ];
  column = new int[ nAlloc ];
  rowstart = new int[ nRows + 1 ];

  int i;
  for(i=0; i < nAlloc; ++i)
    {
      data[i] = copy.data[i];
      column[i] = copy.column[i];
    }
  for(i=0; i < nRows+1; ++i)
    rowstart[i] = copy.rowstart[i];
}

//*********************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(const Matrix_s& copy)
{
  nRows = copy.numRows();
  nCols = copy.numCols();
  nNonZero = 0;
  nAlloc = nRows;
  
  data = new float[ nAlloc ];
  column = new int[ nAlloc ];
  rowstart = new int[ nRows + 1 ];

  int i,j;

  for(i=0; i < nRows+1; ++i)
    rowstart[i] = 1;
  
  for(j=1; j <= nCols; ++j)
    {
      for(i=1; i <= nRows; ++i)
	{
	  float val = copy.get(i,j);
	  if( val )
	    set(i, j, val);
	}
    }
}

//*********************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(const Matrix_s& copy,
				     Index rows, Index cols)
{
  nRows = copy.numRows();
  nCols = copy.numCols();
  nNonZero = 0;
  nAlloc = nRows;
  
  data = new float[ nAlloc ];
  column = new int[ nAlloc ];
  rowstart = new int[ nRows + 1 ];

  for(int i=0; i < nRows+1; ++i)
    rowstart[i] = 1;
  
  set(copy, rows, cols);
}

//**********************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(const GeneralMatrix_s& A)
{
  nRows = A.numRows();
  nCols = A.numCols();
  nNonZero = 0;
  nAlloc = nRows;
  
  data = new float[ nAlloc ];
  column = new int[ nAlloc ];
  rowstart = new int[ nRows + 1 ];

  for(int i=0; i < nRows+1; ++i)
    rowstart[i] = 1;
  
  for(int j=0; j < nCols; ++j)
    {
      for(int i=0; i < nRows; ++i)
	{
	  //float val = A.data[ i + nRows * j ];
	  float val = A( i, j );
	  set(i+1, j+1, val);
	}
    }
}

//****************************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(const BandedMatrix_s& A)
{
  nRows = A.numRows();
  nCols = A.numCols();
  nNonZero = 0;
  nAlloc = nRows;
  
  data = new float[ nAlloc ];
  column = new int[ nAlloc ];
  rowstart = new int[ nRows + 1 ];

  // Iterate over rows
  for( int i = 1; i <= nRows; ++i )
    {
      // Iterate over columns
      int lower = macroMax( 1,           i - A.numSubDiag()   );
      int upper = macroMin( A.numCols(), i + A.numSuperDiag() );
      
      for( int j = lower; j <= upper; ++ j )
	{
	  float val = A.get( i, j );
	  set( i, j, val );
	}
    }
}

//****************************************************************************
SparseRCSMatrix_s::SparseRCSMatrix_s(const SymSparseRCSMatrix_s& A)
{
  nRows = A.numRows();
  nCols = A.numCols();
  nNonZero = 0;
  nAlloc = nRows;
  
  data = new float[ nAlloc ];
  column = new int[ nAlloc ];
  rowstart = new int[ nRows + 1 ];

  for( int i = 0; i < A.nRows; ++i )
    {
      int lower = A.rowstart[ i ] - 1;
      int upper = A.rowstart[ i + 1 ] - 1;
      for( int j = lower; j < upper; ++j )
	{
	  set( i, A.column[ j ], A.data[ j ] );
	  set( A.column[ j ], i, A.data[ j ] );
	}
    }
}

//************************************************************************
SparseRCSMatrix_s::~SparseRCSMatrix_s(void)
{
  delete[] data;
  delete[] column;
  delete[] rowstart;
}

//*********************************************************************
float SparseRCSMatrix_s::get(int i, int j) const
{
  REQUIRE( i <= nRows, "Row index out of bounds.");
  REQUIRE( j <= nCols, "Column index out of bounds.");

  // Note: this, and all related methods for this class, use a linear
  // search technique.  But, since the bounds of each row are known,
  // you could use a binary search to speed things up.  I decided
  // against this for this first version.
  int k;
  for(k=rowstart[i-1]-1; k < rowstart[i]-1; ++k)
    {
      if( column[k] == j )
	return data[k];
    }
  return 0.0;
}

//***********************************************************************
void SparseRCSMatrix_s::set(int i, int j, float val)
{
  REQUIRE( i <= nRows, "Row index out of bounds.");
  REQUIRE( j <= nCols, "Column index out of bounds.");
  
  int k, n;

  // We need to find the correct index at which to place the new
  // value.  If there is already a non-zero value at this location,
  // return a reference to it, otherwise find the place to insert it
  // (the value of k at the end).
  for(k=rowstart[i-1]-1; k < rowstart[i]-1; ++k)
    {
      if( column[k] == j )
	{
	  data[k] = val;
	  return;
	}
      else if( column[k] > j )
	break;
    }

  // Is the value non-zero?
  if( val == 0.0 )
    return;
  
  // Is there enough room to add another entry?
  if( nAlloc <= nNonZero )
    resize();
  
  // Shift the data down to make room for the new value.
  for( n = nNonZero; n > k; --n )
    {
      data  [n] = data  [n-1];
      column[n] = column[n-1];
    }

  // Adjust the values of rowstart
  for(n=i; n < nRows+1; ++n)
    ++ rowstart[n];

  // Increment nNonZero
  ++ nNonZero;

  // Set the value
  column[k] = j;
  data[k] = val;
}

//************************************************************************
int SparseRCSMatrix_s::set(const SparseRCSMatrix_s& B)
{
  REQUIRE( nRows == B.nRows, "Row dimensions do not agree." );
  REQUIRE( nCols == B.nCols, "Column dimensions do not agree." );

  if( nAlloc < B.nNonZero )
    {
      delete[] data;
      delete[] column;
      data = new float[ B.nAlloc ];
      column = new int[ B.nAlloc ];
      nAlloc = B.nAlloc;
    }
  
  int i;

  for(i=0; i <= nRows; ++i)
    rowstart[i] = B.rowstart[i];

  nNonZero = B.nNonZero;
  for(i=0; i < nNonZero; ++i)
    {
      data[i]   = B.data[i];
      column[i] = B.column[i];
    }

  return 0;
}

/*//*************************************************************************
int SparseRCSMatrix_s::set(const SparseRCSMatrix_s& B,
			   Index rows, Index cols)
{
  // Initialize index objects (check bounds)
  REQUIRE( rows.init(1, B.numRows()) == 0,
	   "Row index initialization failed." );
  
  REQUIRE( cols.init(1, B.numCols()) == 0,
	   "Column index initialization failed");
  
  REQUIRE( nRows == B.nRows, "Row dimensions do not agree." );
  REQUIRE( nCols == B.nCols, "Column dimensions do not agree." );

  int i, j, n, m;

  // Iterate through columns submatrix
  for(j=cols.getFirst(), m=0;    j > 0;   j=cols.getNext(), ++m)
    {
      // Iterate through rows of submatrix
      for(i=rows.getFirst(), n=0;   i > 0;   i=rows.getNext(), ++n)
	{
	  if( B(i,j) )
	    set(n, m, B(i,j));
	}// for rows
    }// for cols

}*/

//*************************************************************************
int SparseRCSMatrix_s::set(const GeneralMatrix_s& B)
{
  REQUIRE( nRows == B.nRows, "Row dimensions do not agree." );
  REQUIRE( nCols == B.nCols, "Column dimensions do not agree." );

  int i,j;

  // Clean out this matrix
  nNonZero = 0;
  for(i=0; i <= nRows; ++i)
    rowstart[i] = 1;

  for(j=1; j <= nCols; ++j)
    {
      for(i=1; i <= nRows; ++i)
	{
	  if( B(i,j) )
	    set(i,j, B(i,j));
	}
    }
  return 0;
}

//*********************************************************************
int SparseRCSMatrix_s::set(const GeneralMatrix_s& B,
				 Index rows, Index cols)
{
  // Initialize index objects (check bounds)
  REQUIRE( rows.init(1, B.numRows()) == 0 && cols.init(1, B.numCols()) == 0,
	   "Index initialization failed");

  REQUIRE(nRows == rows.size(), "Ranges do not agree");
  REQUIRE(nCols == cols.size(), "Domains do not agree");
  
  int i, j, n, m;

  // Iterate through columns submatrix
  for(j=cols.getFirst(), m=1;
              j > 0; 
      j=cols.getNext(), ++m)
    {

      // Iterate through rows of submatrix
      for(i=rows.getFirst(), n=1; 
	         i > 0; 
	  i=rows.getNext(), ++n)
	{
	  if( B(i,j) )
	    set(n, m, B(i,j));
	  else
	    remove(n, m);
	}// for rows
    }// for cols

  return 0;
}

//*********************************************************************
int SparseRCSMatrix_s::set(Index rowsA, Index colsA, 
			   const GeneralMatrix_s& B,
			   Index rowsB, Index colsB)
{
  // Initialize index objects for this matrix
  REQUIRE(rowsA.init(1, nRows) == 0,
	  "Initialization of row index for matrix A failed");
  REQUIRE(colsA.init(1, nCols) == 0,
	  "Initialization of column index for matrix A failed");

  // Initialize index objects for B matrix
  REQUIRE(rowsB.init(1, B.nRows) == 0,
	  "Initialization of row index for matrix B failed");
  REQUIRE(colsB.init(1, B.nCols) == 0,
	  "Initialization of column index for matrix B failed");
  
  // Check that both sub-matrices are the same size
  REQUIRE( rowsA.size() == rowsB.size(), "Ranges do not agree" );
  REQUIRE( colsA.size() == colsB.size(), "Domains do not agree" );

  int ai, aj, bi, bj;

  // Iterate over columns of sub-matrices
  for( aj = colsA.getFirst(), bj = colsB.getFirst();
       aj > 0 && bj > 0;
       aj = colsA.getNext(), bj = colsB.getNext())
    {

      // Iterate over rows of sub-matrices
      for( ai = rowsA.getFirst(), bi = rowsB.getFirst();
	   ai > 0 && bi > 0;
	   ai = rowsA.getNext(), bi = rowsB.getNext())
	{
	  if( B(bi, bj) )
	    set(ai, aj, B(bi, bj));
	  else
	    remove(ai, aj);
	}// for rows
    }// for columns

  return 0;
}

//*********************************************************************
int SparseRCSMatrix_s::set(const Matrix_s& B, 
			   Index rows, Index cols)
{
  // Initialize index objects (check bounds)
  REQUIRE( rows.init(1, B.numRows()) == 0 && cols.init(1, B.numCols()) == 0,
	   "Index initialization failed");

  REQUIRE(nRows == rows.size(), "Ranges do not agree");
  REQUIRE(nCols == cols.size(), "Domains do not agree");

  int i, j, n, m;

  for(j=cols.getFirst(), m=1;
             j > 0; 
      j=cols.getNext(), ++m)
    {
      for(i=rows.getFirst(), n=1; 
	      i > 0; 
	  i=rows.getNext(), ++n)
	{
	  float val = B.get(i, j);
	  if( val )
	    set(n, m, val);
	  else
	    remove(n, m);
	}// for rows
    }// for cols

  return 0;
}

//*********************************************************************
int SparseRCSMatrix_s::set(Index rowsA, Index colsA, 
			   const Matrix_s& B,
			   Index rowsB, Index colsB)
{
  // Initialize index objects for this matrix
  REQUIRE(rowsA.init(1, nRows) == 0,
	  "Initialization of row index for matrix A failed");
  REQUIRE(colsA.init(1, nCols) == 0,
	  "Initialization of column index for matrix A failed");

  // Initialize index objects for B matrix
  REQUIRE(rowsB.init(1, B.numRows()) == 0,
	  "Initialization of row index for matrix B failed");
  REQUIRE(colsB.init(1, B.numCols()) == 0,
	  "Initialization of column index for matrix B failed");
  
  // Check that both sub-matrices are the same size
  REQUIRE( rowsA.size() == rowsB.size(), "Ranges do not agree");
  REQUIRE( colsA.size() == colsB.size(), "Domains do not agree");

  int ai, aj, bi, bj;

  for( aj = colsA.getFirst(), bj = colsB.getFirst();
       aj > 0 && bj > 0;
       aj = colsA.getNext(), bj = colsB.getNext())
    {
      for( ai = rowsA.getFirst(), bi = rowsB.getFirst();
	   ai > 0 && bi > 0;
	   ai = rowsA.getNext(), bi = rowsB.getNext())
	{
	  float val = B.get(bi, bj);
	  if( val )
	    set(ai, aj, val);
	  else
	    remove(ai, aj);
	}// for rows
    }// for columns

  return 0;
}

//***********************************************************************
float SparseRCSMatrix_s::operator()(int i, int j) const
{
  REQUIRE( i <= nRows, "Row index out of bounds.");
  REQUIRE( j <= nCols, "Column index out of bounds.");

  // Note: this, and all related methods for this class, use a linear
  // search technique.  But, since the bounds of each row are known,
  // you could use a binary search to speed things up.  I decided
  // against this for this first version.
  int k;
  for(k=rowstart[i-1]-1; k < rowstart[i]-1; ++k)
    {
      if( column[k] == j )
	return data[k];
    }
  return 0.0;
}

//************************************************************************
float& SparseRCSMatrix_s::operator()(int i, int j)
{
  REQUIRE( i <= nRows, "Row index out of bounds.");
  REQUIRE( j <= nCols, "Column index out of bounds.");
  
  int k, n;

  // We need to find the correct index at which to place the new
  // value.  If there is already a non-zero value at this location,
  // return a reference to it, otherwise find the place to insert it
  // (the value of k at the end).
  for(k=rowstart[i-1]-1; k < rowstart[i]-1; ++k)
    {
      if( column[k] == j )
	return data[k];
      else if( column[k] > j )
	break;
    }

  // Is there enough room to add another entry?
  if( nAlloc <= nNonZero )
    resize();
  
  // Shift the data down to make room for the new value.
  for( n = nNonZero; n > k; --n )
    {
      data  [n] = data  [n-1];
      column[n] = column[n-1];
    }

  // Adjust the values of rowstart
  for(n=i; n < nRows+1; ++n)
    ++ rowstart[n];

  // Increment nNonZero
  ++ nNonZero;

  // Zero the new location (this turns out to be important)
  data[k] = 0.0;
  
  // Return the new location
  column[k] = j;
  return data[k];
}

//****************************************************************************
int SparseRCSMatrix_s::add(const GeneralMatrix_s& A)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of A does not agree." );

  // Iterate over columns
  for( int j = 1; j <= nRows; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  float val = A.get( i, j );
	  if( val != 0.0 )
	    element( i, j ) += val;
	}
    }
  return 0;
}

//************************************************************************
int SparseRCSMatrix_s::add(const SparseRCSMatrix_s& A)
{
  REQUIRE( nRows == A.nRows, "Ranges do not agree." );
  REQUIRE( nCols == A.nCols, "Domains do not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      int lower = A.rowstart[ i ]     - 1;
      int upper = A.rowstart[ i + 1 ] - 1;

      for( int j = lower; j < upper; ++j )
	{
	  element( i+1, A.column[j] ) += A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::add(const SymSparseRCSMatrix_s& A)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of A does not agree." );

  // Run through the elements of A
  // Iterate over the rows
  for( int i = 0; i <= nRows; ++i )
    {
      int lower = A.rowstart[i] - 1;   // Minus 1 since it's a Fortran array
      int upper = A.rowstart[i+1] - 1;
      for( int j = lower; j < upper; ++j )
	{
	  float val = A.data[ j ];
	  element( i, A.column[ j ] ) += val;
	  element( A.column[ j ], i ) += val;
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::add(const BandedMatrix_s& A)
{
  REQUIRE( nRows == A.numRows(), "Row dimension of A does not agree." );
  REQUIRE( nCols == A.numCols(), "Column dimension of A does not agree." );

  // Iterate over rows
  for( int i = 1; i <= nRows; ++i )
    {
      // Iterate over columns
      int lower = macroMax( 1,           i - A.numSubDiag() );
      int upper = macroMin( A.numCols(), i + A.numSuperDiag() );
      
      for( int j = lower; j <= upper; ++ j )
	{
	  float val = A.get( i, j );
	  element( i, j ) += val;
	}
    }
  return 0;
}


//****************************************************************************
int SparseRCSMatrix_s::addTrans(const GeneralMatrix_s& A)
{
  REQUIRE( nCols == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nRows == A.nCols, "Column dimension of A does not agree." );

  // Iterate over columns of A
  for( int j = 1; j <= A.nRows; ++j )
    {
      for( int i = 1; i <= A.nRows; ++i )
	{
	  float val = A.get( i, j );
	  if( val != 0.0 )
	    element( j, i ) += val;
	}
    }
  return 0;
}

//************************************************************************
int SparseRCSMatrix_s::addTrans(const SparseRCSMatrix_s& A)
{
  REQUIRE( nCols == A.nRows, "Ranges do not agree." );
  REQUIRE( nRows == A.nCols, "Domains do not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      int lower = A.rowstart[ i ]     - 1;
      int upper = A.rowstart[ i + 1 ] - 1;

      for( int j = lower; j < upper; ++j )
	{
	  element( A.column[j], i+1 ) += A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::addTrans(const BandedMatrix_s& A)
{
  REQUIRE( nRows == A.numRows(), "Row dimension of A does not agree." );
  REQUIRE( nCols == A.numCols(), "Column dimension of A does not agree." );

  // Iterate over columns of A
  for( int j = 1; j <= A.numCols(); ++j )
    {
      int lower = macroMax( 1,           j - A.numSuperDiag() );
      int upper = macroMin( A.numRows(), j + A.numSubDiag() );

      for( int i = lower; i <= upper; ++i )
	{
	  float val = A.get( i, j );
	  element( j, i ) += val;
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::add(const GeneralMatrix_s& A, float a)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of A does not agree." );

  // Iterate over columns
  for( int j = 1; j <= nRows; ++j )
    {
      for( int i = 1; i <= nRows; ++i )
	{
	  float val = A.get( i, j );
	  if( val != 0.0 )
	    element( i, j ) += a * val;
	}
    }
  return 0;
}

//************************************************************************
int SparseRCSMatrix_s::add(const SparseRCSMatrix_s& A, float a)
{
  REQUIRE( nRows == A.nRows, "Ranges do not agree." );
  REQUIRE( nCols == A.nCols, "Domains do not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      int lower = A.rowstart[ i ]     - 1;
      int upper = A.rowstart[ i + 1 ] - 1;

      for( int j = lower; j < upper; ++j )
	{
	  element( i+1, A.column[j] ) += a * A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::add(const SymSparseRCSMatrix_s& A, float a)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == A.nCols, "Column dimension of A does not agree." );

  // Run through the elements of A
  // Iterate over the rows
  for( int i = 0; i <= nRows; ++i )
    {
      int lower = A.rowstart[i] - 1;   // Minus 1 since it's a Fortran array
      int upper = A.rowstart[i+1] - 1;
      for( int j = lower; j < upper; ++j )
	{
	  float val = A.data[ j ];
	  element( i, A.column[ j ] ) += a * val;
	  element( A.column[ j ], i ) += a * val;
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::add(const BandedMatrix_s& A, float a)
{
  REQUIRE( nRows == A.numRows(), "Row dimension of A does not agree." );
  REQUIRE( nCols == A.numCols(), "Column dimension of A does not agree." );

  // Iterate over rows
  for( int i = 1; i <= nRows; ++i )
    {
      // Iterate over columns
      int lower = macroMax( 1,           i - A.numSubDiag() );
      int upper = macroMin( A.numCols(), i + A.numSuperDiag() );
      
      for( int j = lower; j <= upper; ++ j )
	{
	  float val = A.get( i, j );
	  element( i, j ) += a * val;
	}
    }
  return 0;
}


//****************************************************************************
int SparseRCSMatrix_s::addTrans(const GeneralMatrix_s& A, float a)
{
  REQUIRE( nCols == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nRows == A.nCols, "Column dimension of A does not agree." );

  // Iterate over columns of A
  for( int j = 1; j <= A.nRows; ++j )
    {
      for( int i = 1; i <= A.nRows; ++i )
	{
	  float val = A.get( i, j );
	  if( val != 0.0 )
	    element( j, i ) += a * val;
	}
    }
  return 0;
}

//************************************************************************
int SparseRCSMatrix_s::addTrans(const SparseRCSMatrix_s& A, float a)
{
  REQUIRE( nCols == A.nRows, "Ranges do not agree." );
  REQUIRE( nRows == A.nCols, "Domains do not agree." );

  for( int i = 0; i < A.nRows; ++i )
    {
      int lower = A.rowstart[ i ]     - 1;
      int upper = A.rowstart[ i + 1 ] - 1;

      for( int j = lower; j < upper; ++j )
	{
	  element( A.column[j], i+1 ) += a * A.data[j];
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::addTrans(const BandedMatrix_s& A, float a)
{
  REQUIRE( nRows == A.numRows(), "Row dimension of A does not agree." );
  REQUIRE( nCols == A.numCols(), "Column dimension of A does not agree." );

  // Iterate over columns of A
  for( int j = 1; j <= A.numCols(); ++j )
    {
      int lower = macroMax( 1,           j - A.numSuperDiag() );
      int upper = macroMin( A.numRows(), j + A.numSubDiag() );

      for( int i = lower; i <= upper; ++i )
	{
	  float val = A.get( i, j );
	  element( j, i ) += a * val;
	}
    }
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::mult(float a)
{
  for( int i = 0; i < nNonZero; ++i )
    data[ i ] *= a;
  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::mult(const SparseRCSMatrix_s& A,
			    const SparseRCSMatrix_s& B)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == B.nCols, "Column dimension of B does not agree." );
  REQUIRE( A.nCols == B.nRows,
	   "Inner dimensions of A and B do not agree." );

  // This may look strange, but I think it is the fastest way to
  // calculate this product. It is actaully simple in concept.  I am
  // simply iterating first over the rows of A, then the columns of A,
  // then the columns of B.  It's just that each loop is optimized
  // for the sparse format.
  
  // Iterate through every row of A.
  for( int i = 0; i < A.nRows; ++i )
    {
      int A_row_start = A.rowstart[ i ]     - 1;
      int A_row_stop  = A.rowstart[ i + 1 ] - 1;

      // Iterate over the row A(i,:)
      for( int j = A_row_start; j < A_row_stop; ++j )
	{
	  // Now, the value of a stored at A(i,column[j]) is
	  // multiplied by everything in B(column[j],:).
	  int B_row = A.column[ j ];
	  int B_row_start = B.rowstart[ B_row-1 ] - 1;
	  int B_row_stop  = B.rowstart[ B_row ]   - 1;

	  for( int k = B_row_start; k < B_row_stop; ++k )
	    {
	      float val = A.data[ j ] * B.data[ k ];
	      element( i+1, B.column[ k ] ) += val;
	    }
	}
    }

  return 0;
}

//****************************************************************************
int SparseRCSMatrix_s::mult(const SparseRCSMatrix_s& A,
			    const SparseRCSMatrix_s& B,
			    float a, float b)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( nCols == B.nCols, "Column dimension of B does not agree." );
  REQUIRE( A.nCols == B.nRows,
	   "Inner dimensions of A and B do not agree." );

  // Multiply this matrix by b
  mult( b );
  
  // Make a temporary
  SparseRCSMatrix_s C( nRows, nCols );

  // Calculate C = A*B
  C.mult( A, B );

  // Add a*C to this matrix
  add( C, a );
  
  return 0;
}

//************************************************************************
int SparseRCSMatrix_s::image(const GeneralMatrix_s& X,
		         	   GeneralMatrix_s& B) const
{
  REQUIRE( nCols == X.numRows(), "Domain does not agree." );
  REQUIRE( nRows == B.numRows(), "Range does not agree." );
  REQUIRE( X.numCols() == B.numCols(), "Dimensions of X and B do not agree." );

  int i, j, k;

  for(k=1; k <= X.numCols(); ++k)
    {
      for(i=1; i <= nRows; ++i)
	{
	  float sum = 0;
	  for(j = rowstart[i-1]-1; j < rowstart[i]-1; ++j)
	    {
	      sum += data[j] * X( column[j], k );
	    }
	  B( i, k ) = sum;
	}
    }
  
  return 0;
}

//************************************************************************
int SparseRCSMatrix_s::image(const SparseRCSMatrix_s& X,
			           GeneralMatrix_s& B) const
{
  REQUIRE( nCols == X.nRows, "Domain does not agree." );
  REQUIRE( nRows == B.numRows(), "Range does not agree." );
  REQUIRE( X.nCols == B.numCols(), "Dimensions of X and B do not agree." );

  int i, j, k;

  for(k=1; k <= X.numCols(); ++k)
    {
      for(i=1; i <= nRows; ++i)
	{
	  float sum = 0;
	  for(j = rowstart[i-1]-1; j < rowstart[i]-1; ++j)
	    {
	      sum += data[j] * X( column[j], k );
	    }
	  B( i, k ) = sum;
	}
    }
  
  return 0;
}

/*//****************************************************************************
int SparseRCSMatrix_s::mult(const GeneralMatrix_s& A,
			    const GeneralMatrix_s& B,
			    float x, float y)
{
  REQUIRE( nRows == A.nRows, "Row dimension of A does not agree." );
  REQUIRE( A.nCols == B.nRows,
	   "Inner dimensions of A and B do not agree." );
  REQUIRE( nCols == B.nCols, "Column dimension of B does not agree." );

  
}*/

//****************************************************************************
/*int SparseRCSMatrix_s::cg(GeneralMatrix_s& X, const GeneralMatrix_s& B,
			  unsigned maxiter, float tol)
{
  REQUIRE( nCols == X.nRows, "Row dimension of X does not agree." );
  REQUIRE( nRows == B.nRows, "Row dimension of B does not agree." );
  REQUIRE( X.nCols == B.nCols,
	   "Column dimension of x and B do not agree." );

  int i, j, k;

  GeneralMatrix_s R( B.nRows, 1 );    // Residual vector
  GeneralMatrix_s V( B.nRows, 1 );    // Gradient vector
  GeneralMatrix_s Z( B.nrows, 1 );    // Temporary vector

  // Iterate over each right-hand-side column
  for(i=1; i <= B.nCols; ++i)
    {
      // Need to calculate R = B - A*X, but it is turning out to be
      // rather difficult.
      // This is wrong?
      mult( GeneralMatrix_s( X, Index(), Index(i,1,i) ), R );
      R.negate();
      R.add( GeneralMatrix_s( B, Index(), Index(i,1,i) ), -1 );

      set( V, R );

      float c = 0.0;
      for(j=1; j <= R.nRows; ++j)
	c += R(j,1) * R(j,1);

      // Begin the iterations
      for(k=0; k < maxiter; ++k)
	{
	  // Check to see that V is not too small
	  float vn = 0.0;
	  for(j=1; j <= V.nRows; ++j)
	    vn += V(j,1) * V(j,1);
	  if( vn < (tol * tol) )
	    return 0;

	  mult( V, Z );       // Z = A*V

	  float t = 0;
	  for(j=1; j <= V.nRows; ++j)
	    t += V(j,1) * Z(j,1);
	  t = c / t;

	  // Need to multiply t*V and accumulate to X
	  X.add( V, t );   // This won't work

	  R.add( Z, -t );

	  float d = 0;
	  for(j=1; j <= R.nRows; ++j)
	    d += R(j,1) * R(j,1);

	  if( d < tol )
	    return 0;

	  V.mult( d/c );
	  V.add( R );

	  c = d;
	}
    }
  return 1;
}*/

//****************************************************************************
int SparseRCSMatrix_s::solve(GeneralMatrix_s& X, const GeneralMatrix_s& B)
{
  REQUIRE( nRows == nCols, "Coefficient matrix is not square");
  REQUIRE( X.nRows == nRows, "Range of X does not agree");
  REQUIRE( B.nRows == nRows, "Range of B does not agree");
  REQUIRE( X.nCols == B.nCols, "Dimensions of X and B do not agree");
  REQUIRE( X.nCols == 1,"Only a single right hand side is currently allowed");

  // Note: YSMP appears to be a very poorly documented set of
  // functions.  I hope what I have done here is correct, but I doubt
  // it.
  
  int n = nCols;
  int i, k;
  int flag;        // Return value from YSMP function
  int path = 1;    // Tells the YSMP driver what to do
  int esp;         // Amount of excess storage provided
  
  int nsp = 8 * n + 2 + 2 * nNonZero; // Amount of work space
  nsp *= 4;                           // Fudge factor

  int*    isp = new int[ 2 * nsp ];      // Working space

  // The following arrays tell the function the ordering of the rows
  // and columns of the system array.
  int* r  = new int[ nRows ];
  int* c  = new int[ nCols ];
  int* ic = new int[ n ];

  for(i=0;i<n;++i)
    {
      r[i] = c[i] = ic[i] = i+1;
    }
  
  // Iterate over each column of X,B
  for(k=0; k < X.nCols; ++k)
    {
      #ifdef SINGLE_PRECISION
      flag = 0;  // No single precision version
      #else
      F77NAME(cdrv)(&n, r, c, ic, rowstart, column,
		    data, B.data, X.data,
		    &nsp, isp, (float*)isp, &esp, &path, &flag);
      #endif
      REQUIRE( flag == 0, "Factorization failed." );
    }

  delete[] isp;
  delete[] r;
  delete[] c;
  delete[] ic;
  
  return 0;
}
//************************************************************************
float SparseRCSMatrix_s::normFrobenius(void)
{
  float normval = 0.0;
  for(int i=0; i < nNonZero; ++i)
    normval += data[i] * data[i];
  return sqrt( normval );
}

//************************************************************************
float SparseRCSMatrix_s::normInf(void)
{
  float normval = 0.0;

  // Iterate over rows
  for(int i=0; i < nRows; ++i)     
    {
      float subnorm = 0.0;
      
      // Iterate over non-zero columns
      for(int j = rowstart[i]-1; j < rowstart[j+1]-1; ++j)
	{
	  subnorm += fabs( data[j] );
	}
      if( subnorm > normval)
	normval = subnorm;
    }
  return normval;
}

//***********************************************************************
float SparseRCSMatrix_s::normOnes(void)
{
  float normval = 0.0;

  // Iterate over columns
  for(int j=1; j <= nCols; ++j)    
    {
      float subnorm = 0.0;

      // Iterate over rows
      for(int i=0; i < nRows; ++i)
	{
	  // Find the correct entry
	  for(int k = rowstart[i]-1; k < rowstart[i+1]-1; ++k)
	    {
	      if( column[k] == j )
		{
		  subnorm += fabs( data[k] );
		  break;
		}
	      else if( column[k] > j )
		break;
	    }// for k
	}// for i

      if( subnorm > normval )
	normval = subnorm;
    }// for j
  
  return normval;
}

//************************************************************************
ostream& operator<< (ostream& os, const SparseRCSMatrix_s& A)
{
  int i, j;

  for(i=1; i <= A.nRows; ++i)
    {
      for(j=1; j <= A.nCols; ++j)
	{
	  os << A(i,j) << '\t';
	}
      os << endl;
    }
  os << endl;
  return os;
}

//****************************************************************************
void SparseRCSMatrix_s::dump(ostream& os)
{
  int k;

  os << "data:     ";
  for(k=0; k < nNonZero; ++k)
    os << data[k] << '\t';
  os << endl;

  os << "column:   ";
  for(k=0; k < nNonZero; ++k)
    os << column[k] << '\t';
  os << endl;

  os << "rowstart: ";
  for(k=0; k < nRows+1; ++k)
    os << rowstart[k] << '\t';
  os << endl;
}

//*************************************************************************
void SparseRCSMatrix_s::resize(void)
{
  float*   tData    = new float  [ nAlloc * 2 ];
  int* tColumn  = new int[ nAlloc * 2 ];

  for(int i=0; i < nNonZero; ++i)
    {
      tData  [i] = data  [i];
      tColumn[i] = column[i];
    }

  delete[] data;
  delete[] column;

  data = tData;
  column  = tColumn;

  nAlloc *= 2;
}

//************************************************************************
void SparseRCSMatrix_s::trim(void)
{
  nAlloc = nNonZero;

  float*   temp_data = new float[ nAlloc ];
  int* temp_column = new int[ nAlloc ];

  int i;
  for(i=0; i < nAlloc; ++i)
    {
      temp_data[i] = data[i];
      temp_column[i] = column[i];
    }

  delete[] data;
  delete[] column;

  data = temp_data;
  column = temp_column;

  // Some error checking
  #ifdef _DEBUG_
  for(i=0; i <= nRows; ++i)
    REQUIRE( rowstart[i] <= nAlloc+1, "Invalid rowstart index." );
  #endif
}

//**************************************************************************
void SparseRCSMatrix_s::remove(int i, int j)
{
  int k, m;
  
  // Find the entry, if it exists
  for( k = rowstart[i-1]-1; k < rowstart[i]-1; ++k )
    {
      if( column[k] == j )
	{
	  nNonZero --;
	  for(m = k; m < nNonZero; ++m)
	    {
	      data[m] = data[m+1];
	      column[m] = column[m+1];
	    }
	  for(m = i; m <= nRows; ++m)
	    -- rowstart[m];
	  return;
	}
      else if( column[k] > j )
	return;
    }
}

//***************************************************************************
void SparseRCSMatrix_s::removeZeros(void)
{
  int i, j, k;

  // Look for zero values
  for(i=0; i < nRows; ++i)
    {
      for(j = rowstart[i]-1; j < rowstart[i+1]-1; ++j)
	{
	  // Remove the zero values
	  if( data[j] == 0 )
	    {
	      nNonZero --;
	      for(k = j; k < nNonZero; ++k)
		{
		  data[k] = data[k+1];
		  column[k] = column[k+1];
		}
	      for(k = i+1; k <= nRows; ++k)
		-- rowstart[k];
	    }
	}
    }
}

//****************************************************************************
int SparseRCSMatrix_s::zero(void)
{
  nNonZero = 0;
  for(int k=0; k < nRows+1; ++k)
    rowstart[k] = 1;
  return 0;
}





