/*********************************************************************
 This file was automatically generated by d2s from
 the file upper_d.C.  Do not edit. 
*********************************************************************/

#define SINGLE_PRECISION 1

// Shannon Scott   6/3/1999
// First draft of an upper-triangular matrix class
// Data is stored column-wise
// Matrix must be square
// Matrix indexing is ones-based

#include "mat_inc_s.H"

//********************************************************************
UpperTriangle_s::UpperTriangle_s(void)
{
  ERROR("This has not been implemented");
}

//********************************************************************
UpperTriangle_s::UpperTriangle_s(int _size)
{
  size = _size;
  nAlloc = (size * (size + 1)) / 2;
  data = new float[ nAlloc ];
}

//********************************************************************
UpperTriangle_s::UpperTriangle_s(int i, int j)
{
  REQUIRE( i == j, "Upper Triangular matrix must be square.");
  size = i;
  nAlloc = (size * (size + 1)) / 2;
  data = new float[ nAlloc ];
}

//**********************************************************************
UpperTriangle_s::UpperTriangle_s(const UpperTriangle_s& copy)
{
  size = copy.size;
  nAlloc = copy.nAlloc;
  data = new float[ nAlloc ];
  memcpy(data, copy.data, nAlloc * sizeof(float));
}

//***********************************************************************
UpperTriangle_s::~UpperTriangle_s(void)
{
  delete[] data;
}

//***********************************************************************
int UpperTriangle_s::setAll(float val)
{
  int i;
  for(i=0; i < nAlloc; ++i)
    data[i] = val;

  return 0;
}

//**********************************************************************
int UpperTriangle_s::diag(float val)
{
  ERROR("This has not been implemented");
  return 1;
}

//****************************************************************************
int UpperTriangle_s::random()
{
  int DIST = 2;  // uniform distribution in (-1,1)
#ifdef SINGLE_PRECISION
  F77NAME(slarnv)(&DIST, matrix_rnd_seed, &nAlloc, data);
#else
  F77NAME(dlarnv)(&DIST, matrix_rnd_seed, &nAlloc, data);
#endif

  return 0;
}

//**********************************************************************
ostream& operator<< (ostream& os, const UpperTriangle_s& A)
{
  int i, j;
  
  for(i=1; i <= A.size; ++i)
    {
      for(j=1; j < i; ++j)
	os << "0\t";
      
      for(; j <= A.size; ++j)
	os << A.data[ i + (j * (j-1)) / 2 - 1 ] << '\t';

      os << endl;
    }

  //for(int i=0; i < (A.size*(A.size+1))/2; ++i)
  //  cout << A.data[i] << '\t';
  //cout << endl;

  return os;
}

//**********************************************************************
int UpperTriangle_s::add(const UpperTriangle_s& B)
{
  REQUIRE( B.size == size, "Dimensions do not agree" );
  
  for(int i=0; i < size; ++i)
    data[i] += B.data[i];

  return 0;
}

//**********************************************************************
int UpperTriangle_s::add(const UpperTriangle_s& A, const UpperTriangle_s& B)
{
  REQUIRE( A.size == B.size, "Dimensions of A and B do not agree." );
  REQUIRE( A.size == size, "Dimensions do not agree." );

  for(int i=0; i < nAlloc ; ++i)
    {
      data[i] = A.data[i] + B.data[i];
    }
  return 0;
}

//***********************************************************************
int UpperTriangle_s::solve(GeneralMatrix_s& X, const GeneralMatrix_s& B)
{
  REQUIRE( X.nRows == size, "Range of X does not agree.");
  REQUIRE( B.nRows == size, "Range of B does not agree.");
  REQUIRE( X.nCols == B.nCols, "Domain of X and B do not agree.");

  int info = 0;
  int n = size;
  
  // Copy B to X (may encapsulate this in a function later)
  if( &X != &B )
    {
      for(int i=0; i < B.nRows*B.nCols; ++i)
	X.data[i] = B.data[i];
    }

  // Solve the system
  #ifdef SINGLE_PRECISION
  F77NAME(stptrs)("U", "N", "N", &n, (int*)&(X.nCols),
		  data, X.data, &n, &info);
  #else
  F77NAME(dtptrs)("U", "N", "N", &n, (int*)&(X.nCols),
		  data, X.data, &n, &info);
  #endif

  REQUIRE( info == 0, "Solution of system failed");
  return info;
}

//***********************************************************************
int UpperTriangle_s::transposeSolve(GeneralMatrix_s& X,
                                    const GeneralMatrix_s& B)
{
  REQUIRE( X.nRows == size, "Range of X does not agree.");
  REQUIRE( B.nRows == size, "Range of B does not agree.");
  REQUIRE( X.nCols == B.nCols, "Domain of X and B do not agree.");

  int info = 0;
  int n = size;
  
  // Copy B to X (may encapsulate this in a function later)
  if( &X != &B )
    {
      for(int i=0; i < B.nRows*B.nCols; ++i)
	X.data[i] = B.data[i];
    }

  // Solve the system
  #ifdef SINGLE_PRECISION
  F77NAME(stptrs)("U", "T", "N", &n, (int*)&(X.nCols),
		  data, X.data, &n, &info);
  #else
  F77NAME(dtptrs)("U", "T", "N", &n, (int*)&(X.nCols),
		  data, X.data, &n, &info);
  #endif

  REQUIRE( info == 0, "Solution of system failed");
  return info;
}

//**************************************************************************
int UpperTriangle_s::extractUpper(const Matrix_s& A)
{
  REQUIRE( A.numRows() == A.numCols(), "A is not square");
  REQUIRE( A.numRows() == size, "Dimensions do not agree");

  int i, j;

  for(j=1; j <= size; ++j)       // Iterate over columns
    {
      for(i=1; i <= j; ++i)      // Iterate over rows
	{
	  data[ i + (j * (j-1)) / 2 - 1 ] = A.get(i,j);
	}
    }
  
  return 0;
}

void UpperTriangle_s::LINPACKSmallestSingularVectorEst( GeneralMatrix_s & x )
{
  REQUIRE( x.numCols() == 1, "Input matrix must be a column vector");
  REQUIRE( x.numRows() == size, "Input matrix has wrong number of rows");

   int i,j,n = size;
   float * w = new float[size];

   w[0] = 1.0/get(1,1);
   for( j=2;j<=n;j++ )
   {
      float s = 0.0;
      for( i=1;i<=j-1;i++ ) s += w[i-1]*get(i,j);
      float e = (s>=0?-1.0:1.0);
      w[j-1] = (e-s)/get(j,j);
   }

   GeneralMatrix_s y( size,w );
   solve( x,y );
   x.mult( 1.0/x.normFrobenius() );

   delete[] w;
}
