# copyright Stanford Exploration Project.  See GNU public license.
#
# This file is part of SEP's set of GNU make rules for painless compilation
# This file overrides defaults that are incorrect for the RS6000 architecture
#
${RULES}/Prg.defs.RS6K: ;

# shortfor folds long FORTRAN lines at column 72
FIXNULL = |shortfort

# system libs to link with
SYSLIB = -lm -lc

### C DEFINITIONS ###

# C compiler
CC = gcc

# Flags for C compiler
ifdef DEBUG
  OCFLAGS  = -g
else
  OCFLAGS  = -O2
endif

# C loader     
CLD = gcc

### C++ DEFINITIONS ###

# C++ compiler
C++ = g++

# C++ loader
C++LD = xlf

# enable f77 to load c++
F77LDC++ =  -L/usr/local/lib -lg++ -L/usr/local/lib/gcc-lib/rs6000-ibm-aix3.2.5/2.6.3 -lgcc

# C++ linking libraries
C++LDOPTS = ${UC++LDFLAGS} ${OC++LDFLAGS} $(addprefix -L,${UC++LIBDIR} ${OC++LIBDIR}) ${OC++LIB} ${UC++LIB} ${SYSLIB} ${F77LDC++}

# F77 Compiler
F77 = xlf

# Flags for F77 compiler
ifdef DEBUG
  OF77FLAGS = -g -qextname
else
  OF77FLAGS = -O2 -qextname
endif

# F77 loader
F77LD = xlf

F77LIB  = -lc -lxlf
F77LIB2 = -lc -lxlf -ll -lm
F77LIB3 = -lc -lxlf     -lm
F77LIB4 =     -lxlf -ll -lm
### F90 DEFS ###
F90 = xlf90

#Flags for f90 compiler
ifdef DEBUG 
	OF77FLAGS = -g 
else
	OF77FLAGS = -O2
endif

F90LIB  =  -lc  -lxlf 
F90LIB2 =  -lc  -lxlf -ll -lm
F90LIB3 =  -lc  -lxlf     -lm
F90LIB4 =       -lxlf -ll -lm
