/*
                 THE HILBERT CLASS LIBRARY                        
                  Release 1.0, July 2000

                  copyright (C) 1995-2000
           Mark S. Gockenbach and William W. Symes                 
                                                                  
The source code contained in this file is FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#ifndef LJ_H__
#define LJ_H__

#include "HCL_Functional_d.h"
#include "HCL_Rn_d.h"
#include "HCL_MatrixOps_d.h"

extern "C" void F77NAME(fnlj)( int &,double *,double & );
extern "C" void F77NAME(gradlj)( int &,double *,double * );
extern "C" void F77NAME(hesslj)( int &,double *,double * );

class LennardJonesEnergy_d: public HCL_Functional_d
{
   private:
      HCL_RnSpace_d * dom;

   protected:

      virtual double Value1( const HCL_Vector_d & x ) const;
      virtual void Gradient1( const HCL_Vector_d & x,HCL_Vector_d & y ) const;
      virtual HCL_LinearOp_d * Hessian1( const HCL_Vector_d & x ) const;

   public:  

   // Default constructor---disabled.
      LennardJonesEnergy_d();
   // Copy constructor---disabled.
      LennardJonesEnergy_d( const LennardJonesEnergy_d & );
   /// Usual constructor; just needs the number of particles.
      LennardJonesEnergy_d( int n );
   // destructor
      virtual ~LennardJonesEnergy_d();

   /** Domain space access.  Returns a reference to the
       {\bf HCL\_VectorSpace\_d} which forms the domain of the functional. */
      virtual HCL_VectorSpace_d & Domain() const;

      /** Debugging information. */
      virtual ostream & Write( ostream & str ) const;
};

#endif
